//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>

#ifndef __CMD_MS_Utility__
#define __CMD_MS_Utility__
#include <command.h>
#include <ShareType.h>

struct smc_param {
	U32 a0;
	U32 a1;
	U32 a2;
	U32 a3;
	U32 a4;
	U32 a5;
	U32 a6;
	U32 a7;
};

int do_mscompress7 (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
int do_mdelay(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
int do_showVersion(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);

#if ((CONFIG_TV_CHIP == 1) || (ENABLE_RESERVED_CHUNK_HEADER == 1))
int do_showBoard(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
#endif

#if defined(CONFIG_MMC)
int get_mmc_part_number(const char* partition, int *partNum);
#endif

//-------------------------------------------------------------------------------------------------
/// Check TEE binary before programming it
//-------------------------------------------------------------------------------------------------
#if defined(CONFIG_MSTAR_TOOL_CHECK_TEE)
int do_checkTEE(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
#endif

#if ((ENABLE_MODULE_USB == 1)&&(ENABLE_MODULE_FAT==1))
int do_spi2usb ( cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
int do_usb2spi ( cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
#endif

#if ((ENABLE_MODULE_USB == 1)&&(ENABLE_MODULE_EEPROM==1))
int do_usb2eeprom ( cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
int do_eeprom2usb ( cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
#endif

#if defined(CONFIG_MSTAR_TOOL_ROM_PROGRAM_NAND_BIN) && defined (CONFIG_MSTAR_TOOL_PROGRAM)
int do_nandprogramforrom ( cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
#endif

#if defined(CONFIG_MSTAR_TOOL_ROM_PROGRAM_NAND_BIN) && defined (CONFIG_MSTAR_TOOL_CMDLINE)
int do_skipnandprogramforrom ( cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
#endif

#if (ENABLE_UTEST == 1)
int appInitUsbDisk_Single(char idx);
#endif

//-------------------------------------------------------------------------------------------------
/// Jump to uboot's console from anywhere
//-------------------------------------------------------------------------------------------------
void jump_to_console(void);


#if (ENABLE_MODULE_USB == 1)
//-------------------------------------------------------------------------------------------------
/// Init usb storage in application layer
/// @return  int                              \b OUT: 0: successful. -1: fail
//-------------------------------------------------------------------------------------------------
int appInitUsbDisk(void);
#endif

//-------------------------------------------------------------------------------------------------
/// get next line in script, and the input data will be modified in this function
/// @return  char*                            \b OUT: a string in the script
//-------------------------------------------------------------------------------------------------
char *get_script_next_line(char **line_buf_ptr);

//-------------------------------------------------------------------------------------------------
/// load entire script to return buffer.
/// @return  char*                            \b OUT: script content.
/// remember free the memory when use vfsfile_loadscript load some script
/// ex:  char *script = vfsfile_loadscript("/config/set_env");
///      free(script);
//-------------------------------------------------------------------------------------------------
char* loadscript(char *filedir,U32 *filesize);

//-------------------------------------------------------------------------------------------------
/// load entire script to "get next line in script"
/// @return  void                            \b OUT: NULL
//-------------------------------------------------------------------------------------------------
void runscript_linebyline(char *scriptdir);


//-------------------------------------------------------------------------------------------------
/// searc the specific pattern in a specific buffer
/// @param buf                                  \b IN: buffer addres
/// @param bus_size                           \b IN: The size of input buffer
/// @param pattern                             \b IN: pattern that you want to find out
/// @return char *                              \b OUT: NULL:FAIL, non-null:Sucess
//-------------------------------------------------------------------------------------------------
char *pattern_search(char *buf, unsigned int buf_size, char *pattern);

void tee_smc_call(struct smc_param *param);

int do_lz4 ( cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);

// temp for usb secure upgrade used
void Reset_System();

#if defined(CONFIG_MCU_ARM)
void get_temp_used_addr(unsigned int *temp_addr);
#endif

#endif

