//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
//-------------------------------------------------------------------------------------------------
// Includes
//-------------------------------------------------------------------------------------------------
#include <MsProjectID.h>

#if defined(CONFIG_ONESN_ENABLE)
#include <drv_eMMC.h>
#include <eMMC_err_codes.h>
#endif
#include <MsDebug.h>
#include <CusConfig.h>
#include <MsTypes.h>


//-------------------------------------------------------------------------------------------------
//  Debug Functions
//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
//  Local Defines
//-------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------
//  Global Variables
//-------------------------------------------------------------------------------------------------
static mstar_project_ID_t ProjectID;
static MS_BOOL bIsInit = FALSE; 

//-------------------------------------------------------------------------------------------------
//  Local Variables
//-------------------------------------------------------------------------------------------------
#if defined(CONFIG_MSTAR_M7332)
typedef enum _INSIDE_DDR_SIZE_TYPE
{
    DDR_SIZE_DDR0_D3_256M_256M_DDR1_D3_512M_NANYA20_INSIDE,         //1G
    DDR_SIZE_DDR0_D3_256M_256M_DDR1_D3_512M_SAMSUNG_INSIDE,         //1G
    DDR_SIZE_DDR0_D3_256M_256M_DDR1_D3_512M_WINBOND_INSIDE,         //1G
    DDR_SIZE_DDR0_D3_512M_256M_DDR1_D3_512M_NANYA20_INSIDE=4,       //1.25G
    DDR_SIZE_DDR0_D3_512M_256M_DDR1_D3_512M_SAMSUNG_INSIDE,         //1.25G
    DDR_SIZE_DDR0_D3_512M_256M_DDR1_D3_512M_WINBOND_INSIDE,         //1.25G
    DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_NANYA20_INSIDE=8,       //1.5G
    DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_SAMSUNG_INSIDE,         //1.5G
    DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_WINBOND_INSIDE,         //1.5G
    DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_512M_NANYA20_INSIDE=12, //2G
    DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_512M_SAMSUNG_INSIDE,    //2G
    DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_512M_WINBOND_INSIDE,    //2G
    DDR_SIZE_DDR0_D4_512M_512M_DDR1_D4_512M_NANYA_INSIDE=16,        //1.5G
    DDR_SIZE_DDR0_D4_512M_512M_DDR1_D4_512M_SAMSUNG_INSIDE,         //1.5G
    DDR_SIZE_DDR0_D4_512M_512M_DDR1_D4_1G_NANYA_INSIDE=20,          //2G
    DDR_SIZE_DDR0_D4_512M_512M_DDR1_D4_1G_SAMSUNG_INSIDE,           //2G
    DDR_SIZE_DDR0_D4_512M_512M_NANYA20_INSIDE=24,                   //1G
    DDR_SIZE_DDR0_D4_512M_512M_SAMSUNG_INSIDE,                      //1G
    DDR_SIZE_DDR0_D3_512M_256M_NANYA20_INSIDE=28,                   //756M
    DDR_SIZE_DDR0_D3_512M_256M_SAMSUNG_INSIDE,                      //756M
    DDR_SIZE_DDR0_D3_512M_512M_NANYA20_INSIDE,                      //1G
    DDR_SIZE_DDR0_D3_512M_512M_SAMSUNG_INSIDE,                      //1G
    DDR_SIZE_MAX_INSIDE,
} INSIDE_DDR_SIZE_TYPE;
#endif

//-------------------------------------------------------------------------------------------------
//  Extern Functions
//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
//  Private Functions
//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
//  Public Functions
//-------------------------------------------------------------------------------------------------
int do_Multi2Optee (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	  char *partitionNamePtr = NULL;
	  const MultiImageHeader_t* multiOpteeHeaderPtr;
	  char cmdBuffer[256];
	  int ret = -1;
	  unsigned int filesize = 0;
    if (argc < 4)
        return cmd_usage(cmdtp);
    
    UBOOT_TRACE("IN\n");
    multiOpteeHeaderPtr = simple_strtoul(argv[1], NULL, 16);
    partitionNamePtr = argv[2];
    filesize = simple_strtoul(argv[3], NULL, 16);

    printf("MultiOptee image version = %u\n", (unsigned int)multiOpteeHeaderPtr->version);
    
    if(!strncmp(multiOpteeHeaderPtr->magic,MULTIBIN_MAG,strlen(MULTIBIN_MAG)) && multiOpteeHeaderPtr->version==0 ) //multiOptee image
    {
    	  uint16_t totalnumber=multiOpteeHeaderPtr->number;
    	  mstar_project_ID_t projectID = GetProjectID();
    	  int i = 0;
    	  MS_BOOL bIsFound = FALSE;
        printf("MultiOptee image detected.\n");
        for (i=0;i<totalnumber;i++)
        {
            if(multiOpteeHeaderPtr->info[i].id == projectID.Model_ID)
            {
                bIsFound = TRUE;
                break;
            }
        }
        
        if(bIsFound == TRUE)
        {
            //mmc erase partition
            snprintf(cmdBuffer, sizeof(cmdBuffer), "mmc erase.p %s", partitionNamePtr);
            UBOOT_DEBUG("%s\n",cmdBuffer);
            ret=run_command(cmdBuffer,0);
            if(ret==-1)
            {
                UBOOT_ERROR("command failed:%s\n",cmdBuffer);
                return ret;
            }
            //mmc write partition
            UBOOT_DEBUG("ImageInfo matched,i=%d,offset=0x%x,size=0x%x.\n",i,multiOpteeHeaderPtr->info[i].offset,multiOpteeHeaderPtr->info[i].size);
            snprintf(cmdBuffer, sizeof(cmdBuffer), "mmc write.p 0x%x %s 0x%x", (unsigned int)multiOpteeHeaderPtr+multiOpteeHeaderPtr->info[i].offset,partitionNamePtr,multiOpteeHeaderPtr->info[i].size);
            UBOOT_DEBUG("%s\n",cmdBuffer);
            ret=run_command(cmdBuffer,0);
            if(ret==-1)
            {
                UBOOT_ERROR("command failed:%s\n",cmdBuffer);
                return ret;
            }
        }
        else
        {
            UBOOT_ERROR("No ImageInfo_t ID matches the ModelID:%02d\n",projectID.Model_ID);
            return ret;
        }
        
    }
    else//Not the multiOptee image
    {
        printf("MultiOptee: MagicId or version mismatched: flash the whole image\n");
        //mmc erase partition
        snprintf(cmdBuffer, sizeof(cmdBuffer), "mmc erase.p %s", partitionNamePtr);
        UBOOT_DEBUG("%s\n",cmdBuffer);
        ret=run_command(cmdBuffer,0);
        if(ret==-1)
        {
            UBOOT_ERROR("command failed:%s\n",cmdBuffer);
            return ret;
        }
        //mmc write partition
        snprintf(cmdBuffer, sizeof(cmdBuffer), "mmc write.p 0x%x %s 0x%x", multiOpteeHeaderPtr, partitionNamePtr, filesize);
        UBOOT_DEBUG("%s\n",cmdBuffer);
        ret=run_command(cmdBuffer,0);
        if(ret==-1)
        {
            UBOOT_ERROR("command failed:%s\n",cmdBuffer);
            return ret;
        }
    }
    UBOOT_TRACE("OK\n");
	  return 0;
}
#if defined(CONFIG_ONESN_ENABLE)
int ReadProjectIdFromBoot()
{
    unsigned char *temp = NULL;
    char* pTconPanelEnv = NULL;

    UBOOT_TRACE("IN\n");

    temp = (unsigned char *)malloc(256*1024);
    if (temp == NULL) {
        UBOOT_ERROR("malloc fail.\n");
    }

    memset(&ProjectID,0,sizeof(ProjectID));
#if defined(CONFIG_ONEBIN_GPIO_ENABLE) // read model ID from GPIO and CHIP info
    ProjectID.Model_ID = MsDrv_OneSN_Get_model_ID_by_gpio();
#else // read model ID from Model_ID.bin in boot1 partition
    if(eMMC_ST_SUCCESS != eMMC_ReadBootPart(temp, 256*1024, 0, 1))
    {
        UBOOT_ERROR("eMMC_ReadBootPart read fail\n");
        return -1;
    }
    UBOOT_DUMP(temp+PROJECTID_OFFSET,0x20);
    memcpy(&ProjectID,temp+PROJECTID_OFFSET,sizeof(ProjectID));
#endif
    bIsInit = TRUE;

    if (((pTconPanelEnv = getenv("enable_tcon_panel")) != NULL) && (strcmp(pTconPanelEnv,"1") == 0))
    {
        ProjectID.Model_ID += 8;  // tcon panel case, model_id + 8
    }

    snprintf(temp, 256*1024, "%d\0", ProjectID.Model_ID);
    setenv("modelID", temp);
    snprintf(temp, 256*1024, "/%s/config/onebin/model_%d/Customer_1.ini\0", CONFIG, ProjectID.Model_ID);
    setenv("customer_ini_path", temp);
    saveenv();

    UBOOT_DEBUG("ProjectID.Model_ID=0X%X\n",ProjectID.Model_ID);
    UBOOT_DEBUG("ProjectID.Board_ID=0X%X\n",ProjectID.Board_ID);
    UBOOT_DEBUG("ProjectID.Package_ID=0X%X\n",ProjectID.Package_ID);
    UBOOT_DEBUG("ProjectID.DDR0_ID=0X%X\n",ProjectID.DDR0_ID);
    UBOOT_DEBUG("ProjectID.DDR0_Size=0X%X\n",ProjectID.DDR0_Size);
    UBOOT_DEBUG("ProjectID.DDR1_ID=0X%X\n",ProjectID.DDR1_ID);
    UBOOT_DEBUG("ProjectID.DDR1_Size=0X%X\n",ProjectID.DDR1_Size);
    UBOOT_DEBUG("ProjectID.DDR2_ID=0X%X\n",ProjectID.DDR2_ID);
    UBOOT_DEBUG("ProjectID.DDR2_Size=0X%X\n",ProjectID.DDR2_Size);
    UBOOT_DEBUG("ProjectID.Mmap_ID=0X%X\n",ProjectID.Mmap_ID);
    UBOOT_DEBUG("ProjectID.Keypad_ID=0X%X\n",ProjectID.Keypad_ID);
    UBOOT_TRACE("OK\n");
    return 0;
}
#else
int ReadProjectIdFromBoot()
{
    char* pTconPanelEnv = NULL;
    char* pOneBinEnv = NULL;
    char str[12];

    UBOOT_TRACE("IN\n");

    {
        memset(&ProjectID,0,sizeof(ProjectID));
#if defined(CONFIG_ONEBIN_GPIO_ENABLE) // read model ID from GPIO and CHIP info
        ProjectID.Model_ID = MsDrv_OneSN_Get_model_ID_by_gpio();
#else // read model ID from Model_ID.bin in boot1 partition

#if defined(CONFIG_MSTAR_M7332)
        unsigned int chip_id=0;
        chip_id = (Read2Byte(0x101ec0)>>9)&0x1F;    //0x101E_60[13~9]
        printf("chip_id:0x%x\n",chip_id);
        switch(chip_id)
        {
            case DDR_SIZE_DDR0_D3_512M_256M_NANYA20_INSIDE:
            case DDR_SIZE_DDR0_D3_512M_256M_SAMSUNG_INSIDE:
                //756M
                ProjectID.Model_ID = 0;
                break;
            case DDR_SIZE_DDR0_D3_256M_256M_DDR1_D3_512M_NANYA20_INSIDE:
            case DDR_SIZE_DDR0_D3_256M_256M_DDR1_D3_512M_SAMSUNG_INSIDE:
            case DDR_SIZE_DDR0_D3_256M_256M_DDR1_D3_512M_WINBOND_INSIDE:
                //1G
                ProjectID.Model_ID = 1;
                break;
            case DDR_SIZE_DDR0_D4_512M_512M_NANYA20_INSIDE:
            case DDR_SIZE_DDR0_D4_512M_512M_SAMSUNG_INSIDE:
            case DDR_SIZE_DDR0_D3_512M_512M_NANYA20_INSIDE:
            case DDR_SIZE_DDR0_D3_512M_512M_SAMSUNG_INSIDE:
                //1G no ddr1
                ProjectID.Model_ID = 2;
                break;
            case DDR_SIZE_DDR0_D3_512M_256M_DDR1_D3_512M_NANYA20_INSIDE:
            case DDR_SIZE_DDR0_D3_512M_256M_DDR1_D3_512M_SAMSUNG_INSIDE:
            case DDR_SIZE_DDR0_D3_512M_256M_DDR1_D3_512M_WINBOND_INSIDE:
                //1.25G
                ProjectID.Model_ID = 3;
                break;
            case DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_NANYA20_INSIDE:
            case DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_SAMSUNG_INSIDE:
            case DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_WINBOND_INSIDE:
            case DDR_SIZE_DDR0_D4_512M_512M_DDR1_D4_512M_NANYA_INSIDE:
            case DDR_SIZE_DDR0_D4_512M_512M_DDR1_D4_512M_SAMSUNG_INSIDE:
                //1.5G
                ProjectID.Model_ID = 4;
                break;
            case DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_512M_NANYA20_INSIDE:
            case DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_512M_SAMSUNG_INSIDE:
            case DDR_SIZE_DDR0_D3_512M_512M_DDR1_D3_512M_512M_WINBOND_INSIDE:
            case DDR_SIZE_DDR0_D4_512M_512M_DDR1_D4_1G_NANYA_INSIDE:
            case DDR_SIZE_DDR0_D4_512M_512M_DDR1_D4_1G_SAMSUNG_INSIDE:
                //2G
                ProjectID.Model_ID = 5;
                break;
            case DDR_SIZE_MAX_INSIDE:
                ProjectID.Model_ID = 4;
                break;
        }
#else
        ProjectID.Model_ID = 0;
#endif

#endif
        printf("MODEL_ID =%d \n",ProjectID.Model_ID);
        snprintf(str, sizeof(str), "%d", ProjectID.Model_ID);
        setenv("MODEL_ID",str);
        saveenv();
        bIsInit = TRUE;
    }

    UBOOT_TRACE("OK\n");
    return 0;
}

#endif
mstar_project_ID_t GetProjectID()
{
    if (bIsInit == FALSE)
    {
        ReadProjectIdFromBoot();
    }
    return ProjectID;
}
