//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>

#include <common.h>
#include <malloc.h>
#include <ShareType.h>
#include <MsApiJpd.h>
#include <MsApiGEGOP.h>
#include <MsVfs.h>
#include <MsSystem.h>
#include <MsUboot.h>
#include <MsDebug.h>
#include <MsRawIO.h>
#include <CusConfig.h>
#include <MsMmap.h>
#include <drvGPIO.h>
#include <MsBoot.h>
#include <miu/MsDrvMiu.h>
#include <MsEnvironment.h>
#include "MsTypes.h"
#include "MsOS.h"
#include "../bootlogo_lite/ScriptTypes.h"
#include "../bootlogo_lite/ScriptBootLogo.h"
#include "../../../MstarCore/src/hal/k5ap/bootlogo_lite/ScriptXC.h"
#include "../../../MstarCore/src/hal/k5ap/bootlogo_lite/ScriptGEGOP.h"
#include "stdio.h"
#include "../../../MstarCore/src/hal/k5ap/upgrade_ui/ScriptDrawRectAndJPG.h"



#define BOOT_LOGO_FLASH_BASE_ADDR 0x94000000//+0x60000
#define BOOT_LOGO_FLASH_DEFAULT_OFFSET 0x60000
#define BOOT_LOGO_DEFAULT_SIZE 0xC7C3
#define BOOT_LOGO_MAX_WIDTH 1920
#define BOOT_LOGO_MAX_HEIGHT 1080
#define BOOT_LOGO_MAX_SIZE 0x100000 // 1M
//*********************global*******************************//
EN_OUTPUT_TIMING_TYPE genOutputTiming;
MS_PHYADDR gphyInputAddr_Upgrade = 0;
MS_U16 gu16Width = 0;
MS_U16 gu16Height = 0;
MS_U16 gu16GOPPipeDelay = 0;





int  do_bootupgrade_init(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    UBOOT_TRACE("\nStart bootupgrade init\n");
    
    char *pEnv = NULL;
    MS_U32 u32Addr = 0;
    ST_RectInfo stRectInfoSrc = {0, 0};
    MS_U8 resolution_lite = 0;
    
    pEnv = getenv("resolution");
    if(pEnv == NULL)
    {
        resolution_lite = E_OUTPUT_TIMING_1920X1080_50P;
    }
    else
    {
        resolution_lite = (MS_U8)simple_strtoull(pEnv, NULL, 16);
    }
    UBOOT_TRACE("\n resolution 0x%x\n",resolution_lite);
    
    if (get_map_addr_from_env(E_DFB_FRAMEBUFFER, MMAP_E_DFB_FRAMEBUFFER_ADDR, &gphyInputAddr_Upgrade)!=0)
    {
        UBOOT_ERROR("get %s mmap fail\n",E_DFB_FRAMEBUFFER_ADR);
        return -1;
    }   


    
    genOutputTiming = resolution_lite;//E_OUTPUT_TIMING_1280X720_50P;//E_OUTPUT_TIMING_1920X1080_60P;//E_OUTPUT_TIMING_1920X1080_50P;//E_OUTPUT_TIMING_1920X1080_50I;//_BootLogo_GetOutputTiming();
    EN_HDMI_COLOR_FORMAT enHdmiColorFormat = E_HDMI_COLOR_FORMAT_RGB;//E_HDMI_COLOR_FORMAT_YUV;//_BootLogo_GetColorFormat();

    _Script_GEGOP_GetDstInfo(genOutputTiming, &gu16Width, &gu16Height, &gu16GOPPipeDelay);

    Script_XC_Init(genOutputTiming);
    Script_VE_Init(genOutputTiming);
    if(enHdmiColorFormat == E_HDMI_COLOR_FORMAT_RGB)
    {
        Script_XC_HDMI_YUV2RGB();
    }
    

    
    UBOOT_TRACE("\n End bootupgrade init\n");
    return 0;
}



int do_bootupgrade(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    UBOOT_TRACE("\nStart bootupgrade\n");
    
    char *pEnv = NULL;
    MS_U32 u32Addr = 0;
    ST_RectInfo stRectInfoSrc = {0, 0};
    MS_U8 resolution_lite = 0;
    
    pEnv = getenv("resolution");
    if(pEnv == NULL)
    {
        resolution_lite = E_OUTPUT_TIMING_1920X1080_50P;
    }
    else
    {
        resolution_lite = (MS_U8)simple_strtoull(pEnv, NULL, 16);
    }
    UBOOT_TRACE("\n resolution 0x%x\n",resolution_lite);
    
    if (get_map_addr_from_env(E_DFB_FRAMEBUFFER, MMAP_E_DFB_FRAMEBUFFER_ADDR, &gphyInputAddr_Upgrade)!=0)
    {
        UBOOT_ERROR("get %s mmap fail\n",E_DFB_FRAMEBUFFER_ADR);
        return -1;
    }   


    
    genOutputTiming = resolution_lite;//E_OUTPUT_TIMING_1280X720_50P;//E_OUTPUT_TIMING_1920X1080_60P;//E_OUTPUT_TIMING_1920X1080_50P;//E_OUTPUT_TIMING_1920X1080_50I;//_BootLogo_GetOutputTiming();
    EN_HDMI_COLOR_FORMAT enHdmiColorFormat = E_HDMI_COLOR_FORMAT_RGB;//E_HDMI_COLOR_FORMAT_YUV;//_BootLogo_GetColorFormat();

    _Script_GEGOP_GetDstInfo(genOutputTiming, &gu16Width, &gu16Height, &gu16GOPPipeDelay);

    Script_XC_Init(genOutputTiming);
    Script_VE_Init(genOutputTiming);
    if(enHdmiColorFormat == E_HDMI_COLOR_FORMAT_RGB)
    {
        Script_XC_HDMI_YUV2RGB();
    }
    

    Script_Upgrade_WindowClean();
    
    Script_Upgrade_ShowUI();
    Script_Upgrade_ShowProgress(1);
    Script_Upgrade_ShowProgress(2);
    Script_Upgrade_ShowProgress(3);
    //Sboot_Upgrade_ShowProgress(0);

    
    UBOOT_TRACE("\n End bootupgrade \n");
    return 0;
}

int do_bootupgrade_progress(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{

    
    MS_U8 u8Flage = 0;
    
    u8Flage = (MS_U8)simple_strtoull(argv[1], NULL, 16);
    Script_Upgrade_ShowProgress(u8Flage);
    return 0;
}
int do_bootupgrade_clean(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{

    Script_Upgrade_WindowClean();
    return 0;
}
int do_bootupgrade_ui(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{

    Script_Upgrade_ShowUI();
    return 0;

}


