//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
////////////////////////////////////////////////////////////////////////////////

#ifndef _API_DMS_COMM_H_
#define _API_DMS_COMM_H_
#include "UFO.h"
////////////////////////////////////////////////////////////////////////////////
/// @file drvDMS.h
/// @author MStar Semiconductor Inc.
/// @brief DMS control driver
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Header Files
////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
extern "C"
{
#endif


//-------------------------------------------------------------------------------------------------
//  Debug
//-------------------------------------------------------------------------------------------------
#ifdef API_DMS_C
#define API_DMS_COMM_INTERFACE
#else
#define API_DMS_COMM_INTERFACE extern
#endif

#define DMS_DBGL_ERR       (0x0001)
#define DMS_DBGL_WARNING  (0x0002)
#define DMS_DBGL_NOTICE  (0x0004)
#define DMS_DBGL_INFO       (0x0008)
#define DMS_DBGL_FLIP       (0x0010)
#define DMS_DBGL_BUF_CTRL  (0x0020)
#define DMS_DBGL_API_FLOW  (0x0040)
#define DMS_DBGL_TIME  (0x0080)
#define DMS_DBGL_ALL  (0xFFFF)

#ifndef ANDROID
#if defined(MSOS_TYPE_LINUX_KERNEL)
#define sysprint printk
#else
#define sysprint printf
#endif
//don't use DMS_PRINF in you code, use DMS_LEVEL_PRINTF instead.
#define DMS_PRINTF sysprint
#else
#include <sys/mman.h>
#include <cutils/ashmem.h>
#include <cutils/log.h>
//don't use DMS_PRINF in you code, use DMS_LEVEL_PRINTF instead.
#define DMS_PRINTF ALOGD
#endif

API_DMS_COMM_INTERFACE MS_U16 gu16DMSDbgSwitch_InternalUseOnly;

#define DMS_LEVEL_PRINTF(_dbgSwitch_,_fmt, _args...)\
{\
    if( (_dbgSwitch_ & gu16DMSDbgSwitch_InternalUseOnly) != 0 )  \
    {\
        if (_dbgSwitch_ & DMS_DBGL_ERR)                \
        {\
            DMS_PRINTF("[DMS] DMS_ERROR [%s,%d]: " _fmt, __FUNCTION__,__LINE__,##_args);  \
        }\
        else if(_dbgSwitch_ & DMS_DBGL_WARNING)\
        {\
            DMS_PRINTF("[DMS] DMS_WARNING [%s,%d]: " _fmt, __FUNCTION__,__LINE__,##_args);  \
        }\
        else if(_dbgSwitch_ & DMS_DBGL_INFO)\
        {\
            DMS_PRINTF("[DMS] DMS_INFO [%s,%d]: " _fmt, __FUNCTION__,__LINE__,##_args);  \
        }\
        else if (_dbgSwitch_ & DMS_DBGL_FLIP)                \
        {\
            DMS_PRINTF("[DMS] DMS_FLIP [%s,%d]: " _fmt, __FUNCTION__,__LINE__,##_args);  \
        }\
        else if(_dbgSwitch_ & DMS_DBGL_BUF_CTRL)\
        {\
            DMS_PRINTF("[DMS] DMS_BUFCTRL [%s,%d]: " _fmt, __FUNCTION__,__LINE__,##_args);  \
        }\
        else if(_dbgSwitch_ & DMS_DBGL_API_FLOW)\
        {\
            DMS_PRINTF("[DMS] DMS_FLOW [%s,%d]: " _fmt, __FUNCTION__,__LINE__,##_args);  \
        }\
        else if(_dbgSwitch_ & DMS_DBGL_TIME)\
        {\
            DMS_PRINTF("[DMS] DMS_TIME [%s,%d]: " _fmt, __FUNCTION__,__LINE__,##_args);  \
        }\
        else if(_dbgSwitch_ & DMS_DBGL_NOTICE)\
        {\
            DMS_PRINTF("[DMS] DMS_NOTICE [%s,%d]: " _fmt, __FUNCTION__,__LINE__,##_args);  \
        }\
    }\
}

#endif //end _API_DMS_COMM_H_
