//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
////////////////////////////////////////////////////////////////////////////////

#ifndef _APIGOP_PRIV_H_
#define _APIGOP_PRIV_H_

////////////////////////////////////////////////////////////////////////////////
/// @file drvBDMA.h
/// @author MStar Semiconductor Inc.
/// @brief Byte DMA control driver
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Header Files
////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
extern "C"
{
#endif

//Local define
#define PATCH_T3_SCK_FAIL 1 //[2009.07.02]T3/U3 GE HW issue:set source alpha is max for filtering the background color

#define GFX_DEBUGINFO_LEVEL(a, x)           if (g_apiGFXLocal.u32dbglvl <= a) {MS_DEBUG_MSG(x);}
#define GFX_DBG_HDR     "[GFXDBG]"

#define GFX_DEBUGINFO(x)                    //MS_DEBUG_MSG(x)

#undef GFX_ASSERT
#ifdef GFX_DEBUG
#define GFX_ASSERT(_bool, _f)                 if (!(_bool)) { MS_CRITICAL_MSG(_f); while (1); }
#else
#define GFX_ASSERT(_bool, _f)                 while (0)
#endif // #ifdef SCL_DEBUG

#include "ULog.h"

// Debug Logs, level form low(INFO) to high(FATAL, always show)
// Function information, ex function entry
#define GFX_INFO(x, args...) ULOGI("GE API", x, ##args)
// Warning, illegal paramter but can be self fixed in functions
#define GFX_WARN(x, args...) ULOGW("GE API", x, ##args)
//  Need debug, illegal paramter.
#define GFX_DBUG(x, args...) ULOGD("GE API", x, ##args)
// Error, function will be terminated but system not crash
#define GFX_ERR(x, args...) ULOGE("GE API", x, ##args)
// Critical, system crash. (ex. assert)
#define GFX_FATAL(x, args...) ULOGF("GE API", x, ##args)

typedef struct
{
    GFX_Set_Colorkey*           pColorKey;              //////////ColorKey
    GFX_Set_ROP*                pROP;                   //////////ROP
}GFX_Function;

typedef struct _GFX_SetConfig
{
    MS_BOOL                     bOnePixelMode;          //////////OnePixelMode
    MS_BOOL                     bDither;                //////////Dither
    MS_BOOL                     bVQEnable;              //////////Virual Cmd Queue
    MS_BOOL                     bABLEnable;             //////////Alpha Blending Enable
    GFX_RotateAngle             eRotate;                //////////Rotate
    GFX_Set_Mirror*             pMirror;                //////////Mirror
    MS_U32                      u32TagID;               //////////TagID
    GFX_Set_Clip_Property*      pClip;                  //////////Clip
}GFX_SetConfig;
#ifndef MSOS_TYPE_OPTEE
typedef struct
{
    GFX_FireInfo*               pFireInfo;
    GFX_OvalFillInfo*           pDrawOvalInfo;
}GFX_Set_DrawOvalInfo;

typedef struct
{
    GFX_FireInfo*               pFireInfo;
    MS_S32                      fHandle;
    MS_U8                       charArray[256];
    MS_U32                      u32StrWidth;
    GFX_TextOutInfo*            pTextInfo;
    GFX_FontInfo *              pFonttable;
}GFX_TextOut_V2;
#endif

void            GFXRegisterToUtopia                 (FUtopiaOpen ModuleType);
MS_U32          GFXOpen                             (void** ppInstance, const void* const pAttribute);
MS_U32          GFXClose                            (void* pInstance);
MS_U32          GFXIoctl                            (void* pInstance, MS_U32 u32Cmd, void* pArgs);
#ifdef CONFIG_GFX_UTOPIA10
MS_U16 Ioctl_GFX_Init(void* pInstance, void* pArgs);
MS_U16 Ioctl_GFX_GetCaps(void* pInstance, void* pArgs);
MS_U16 Ioctl_GFX_GetInfo(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_LineDraw(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_RectFill(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_TriFill(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_SpanFill(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_BitBlt(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_TwoSrcBitBlt(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_SetABL(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_SetConfig(void* pInstance, void* pArgs);
MS_U16 Ioctl_GFX_GetConfig(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_Bitmap(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_Font(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_PowerState(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_CB(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_MISC(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_TLB(void* pInstance, void* pArgs);
MS_S32 Ioctl_GFX_DrawOval(void* pInstance, void* pArgs);
#endif

GFX_Result _MApi_GE_GetCRC(MS_U32* pu32CRCvalue);
GFX_Result _MApi_GE_ConfigCRC(EN_GE_ConfigCRC enConfigCRC , void* pArgs);

#ifdef CONFIG_UTOPIA_PROC_DBG_SUPPORT
MS_U32          GFXMdbIoctl                         (MS_U32 u32Cmd, const void* const pArgs);
#endif

#ifdef __cplusplus
}
#endif
#endif
