//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
///
/// @file   drvDMD_EXTERN_DVBS.h
/// @brief  DVBS Driver Interface
/// @author MStar Semiconductor Inc.
///////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _EXTERN_DVBS_H
#include "MsCommon.h"
#include "drvDMD_common.h"

#define _EXTERN_DVBS_H

#ifdef __cplusplus
extern "C"
{
#endif

typedef enum
{
    Pre_LDPC = 0x00,
    Post_Viterbi,
    Post_LDPC,
}E_BER_type;

typedef enum
{
/*Fundmental Info*/
    E_S2_TS_SERIAL= 0x00,
    E_S2_FW_VERSION_L,
    E_S2_FW_VERSION_H,
    E_S2_CHIP_VERSION,
    E_S2_MANUAL_TUNE_SYMBOLRATE_0,
    E_S2_MANUAL_TUNE_SYMBOLRATE_1,
    E_S2_MANUAL_TUNE_SYMBOLRATE_2,

/*DIRECTV Info*/    
    SCR_X_SEED_0,
    SCR_X_SEED_1,
    SCR_X_SEED_2,
    PLHeader_Seq_0,
    PLHeader_Seq_1,
    PLHeader_Seq_2,
    PLHeader_Seq_3,
    PLHeader_Seq_4,
    PLHeader_Seq_5,
    PLHeader_Seq_6,
    PLHeader_Seq_7,
    PLHeader_Seq_8,
    PLHeader_Seq_9,
    PLHeader_Seq_10,
    PLHeader_Seq_11,

/*Diseqc*/
    E_S2_DISEQC_RX_LENGTH,
    E_S2_DISEQC_INTERRUPT_FLAG,
    E_S2_DISEQC_RX_FLAG,
    E_S2_DISEQC_INTERRUPT_STATUS,
    E_S2_DISEQC_STATUS_FLAG,

/*TP Info*/
    E_S2_SYSTEM_TYPE,    
    E_S2_MOD_TYPE,    
    E_S2_CODE_RATE,
    E_S2_FEC_TYPE,
    E_S2_PILOT_FLAG,
    E_S2_SNR_0,
    E_S2_SNR_1,

/*Blind Scan*/
    E_S2_NARROW_STEP_FLAG,
    E_S2_NO_SIGNAL_FLAG,    
    E_S2_BLINDSCAN_CHECK,
    E_S2_BLINDSCAN_DBG,    
    E_S2_TF_LOCKED0,
    E_S2_TF_LOCKED1,
    E_S2_TF_LOCKED2,
    E_S2_SR_LOCKED0,
    E_S2_SR_LOCKED1,
    E_S2_SR_LOCKED2,        
}E_DVBS2_PARAM;

typedef enum
{
    E_DMD_DVBS_DEMOD_I2C_DYNAMIC_SLAVE_ID_1,
    E_DMD_DVBS_DEMOD_I2C_DYNAMIC_SLAVE_ID_2,
    E_DMD_DVBS_DEMOD_I2C_DYNAMIC_SLAVE_ID_3,
    E_DMD_DVBS_DEMOD_I2C_DYNAMIC_SLAVE_ID_4
} eDMD_DVBS_DemodI2CSlaveID;

typedef enum
{
    E_DMD_DVBS_DEMOD_I2C_READ_BYTES,
    E_DMD_DVBS_DEMOD_I2C_WRITE_BYTES
} eDMD_DVBS_DemodI2CMethod;

/// For demod init
typedef struct
{
    MS_BOOL bPreloadDSPCodeFromMainCHIPI2C;
    MS_BOOL (*fpDVBS_I2C_Access)(eDMD_DVBS_DemodI2CSlaveID eSlaveID, eDMD_DVBS_DemodI2CMethod eMethod, MS_U8 u8AddrSize, MS_U8 *pu8Addr, MS_U16 u16Size, MS_U8 *pu8Data);
    MS_BOOL bEnableSPILoadCode;
    void (*fpDVBS_SPIPAD_En)(MS_BOOL bOnOff);
} sDMD_EXTERN_DVBS_InitData;

#if 0
/*================================================
DVBS External DEMOD fundmental function
=================================================*/
#endif
MS_BOOL MDrv_DMD_EXTERN_DVBS_Init(sDMD_EXTERN_DVBS_InitData *pDMD_DVBS_EXTERN_InitData, MS_U32 u32InitDataLen);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Exit(void);
MS_BOOL MDrv_DMD_EXTERN_DVBS_LoadDSPCodeToSram(void);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_FW_Version(MS_U16* ver);
MS_BOOL MDrv_DMD_EXTERN_DVBS_AGC_PAD_SEL(MS_BOOL sel);
MS_BOOL MDrv_DMD_EXTERN_DVBS_SetCurrentDemodulatorType(void);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_Lock(MS_U8 *lock_type, MS_BOOL *lock_status);
MS_BOOL MDrv_DMD_EXTERN_DVBS_TS_Enable(MS_BOOL bTsEnable);
MS_BOOL MDrv_DMD_EXTERN_DVBS_DEMOD_Restart(MS_U32 u32SymbolRate);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Driving_Control(MS_BOOL bEnable);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Serial_Control(MS_BOOL serial);
MS_BOOL MDrv_DMD_EXTERN_DVBS_IIC_Bypass_Mode(MS_BOOL enable);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Demod_ClearStatus(void);

#if 0
/*================================================
DVBS External DEMOD Get information function
=================================================*/
#endif
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_SNR(MS_FLOAT_ST *snr);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_BER(E_BER_type ber_type, MS_FLOAT_ST *ber);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_AGC_Info(MS_U8 u8dbg_mode, MS_U16 *pu16Data);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_IQ_Mode(MS_BOOL *iq);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_SYS_Type(MS_U8 *sys_type);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_ModulationType(MS_U8 *mod_type);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_CodeRate(MS_U8 *CR);
MS_BOOL MDrv_DMD_EXTERN_DVBS_Get_RollOff(MS_U8 *roll_off);

#if 0
/*================================================
DVBS External DEMOD Diseqc function
=================================================*/
#endif
MS_BOOL MDrv_DMD_EXTERN_DVBS_DiSEqC_Init(MS_BOOL IsMCPDMD, MS_BOOL Tx22kOff);
MS_BOOL MDrv_DMD_EXTERN_DVBS_DiSEqC_SetLNBOut(MS_BOOL bLow);
MS_BOOL MDrv_DMD_EXTERN_DVBS_DiSEqC_GetLNBOut(MS_BOOL* bLNBOutLow);
MS_BOOL MDrv_DMD_EXTERN_DVBS_DiSEqC_Set22kOnOff(MS_BOOL b22kOn);
MS_BOOL MDrv_DMD_EXTERN_DVBS_DiSEqC_Get22kOnOff(MS_BOOL* b22kOn);
MS_BOOL MDrv_DMD_EXTERN_DVBS_DiSEqC_SendCmd(MS_U8* pCmd,MS_U8 u8CmdSize);
MS_BOOL MDrv_DMD_EXTERN_DVBS_DiSEqC_SetTone(MS_BOOL bTone1);

#if 0
/*================================================
DVBS External DEMOD Blind Scan function
=================================================*/
#endif
MS_BOOL MDrv_DMD_EXTERN_DVBS_BlindScan_Start(MS_U16 u16StartFreq,MS_U16 u16EndFreq);
MS_BOOL MDrv_DMD_EXTERN_DVBS_BlindScan_NextFreq(MS_BOOL* bBlindScanEnd);
MS_BOOL MDrv_DMD_EXTERN_DVBS_BlindScan_GetTunerFreq(MS_U32 *u32TunerCenterFreq, MS_U32 *u32TunerCutOffFreq);
MS_BOOL MDrv_DMD_EXTERN_DVBS_BlindScan_WaitCurFreqFinished(MS_U8* u8Progress,MS_U8 *u8FindNum);
MS_BOOL MDrv_DMD_EXTERN_DVBS_BlindScan_Cancel(void);
MS_BOOL MDrv_DMD_EXTERN_DVBS_BlindScan_End(void);
MS_BOOL MDrv_DMD_EXTERN_DVBS_BlindScan_GetChannel(MS_U16 *u16ChannelInfoIndex, MS_U16 ptable[2][1000]);
MS_BOOL MDrv_DMD_EXTERN_DVBS_BlindScan_GetCurrentFreq(MS_U32 *u32CurrentFeq);

#if 0
/*================================================
DVBS External DEMOD read/write register
=================================================*/
#endif
MS_BOOL MDrv_DMD_EXTERN_DVBS_WriteReg(MS_U16 u16Addr, MS_U8 u8Data);
MS_BOOL MDrv_DMD_EXTERN_DVBS_WriteReg2Bytes(MS_U16 u16Addr, MS_U16 u16Data);
MS_BOOL MDrv_DMD_EXTERN_DVBS_ReadReg(MS_U16 u16Addr, MS_U8 *pu8Data);
MS_BOOL MDrv_DMD_EXTERN_DVBS_WriteDspReg(MS_U16 u16Addr, MS_U8 u8Data);
MS_BOOL MDrv_DMD_EXTERN_DVBS_ReadDspReg(MS_U16 u16Addr, MS_U8* pData);
#endif
