/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#include <command.h>
#include <MsApiAesdma.h>

U_BOOT_CMD(
    // name
	aesdma,
    // maxargs
    AES_MAX_ARGS,
    // rep
    1,	
    // cmd
    do_run_aesdma_cmd,
    // usuage
	"aesdma - do the aesdma command.\n",
	"aesdma performance - do the aesdma performance test.\n"
    // help
    "command: aesdma <cmd type>\n\n"

    "command: aesdma performance <algo> <cipher mode> #default: (byte) = (128, 256, 512, 1024, etc).\n"
    "command: aesdma performance <algo> <cipher mode> 0.\n"
    "         aesdma performance aes  cbc  \n"
    "         aesdma performance des  ctr  \n"
    "         aesdma performance taes ecb  \n"
    "         aesdma performance aes  ctr 0\n"
    "         aesdma performance aes  ecb 0\n"

	"command: aesdma performance <algo> <cipher mode> <byte>.\n"
	"         aesdma performance aes ctr     128\n"
	"         aesdma performance aes cts_cbc 256\n"
	"         aesdma performance aes cts_ecb 512\n"

	"command: aesdma performance <algo> <cbcs/cens>.\n"
	"command: aesdma performance <algo> <cbcs/cens> <byte>. #default: (crypted block, skipped block) = (1:9)\n"
	"command: aesdma performance <algo> <cbcs/cens> <byte> <crypted block> <skipped block>.\n"
	"         aesdma performance aes cbcs         \n"
	"         aesdma performance aes cens 0       \n"
	"         aesdma performance aes cbcs 400     \n"
	"         aesdma performance aes cbcs 0    2 1\n"
	"         aesdma performance aes cens 1024 2 5\n"
);


