/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
 //wjq20100112>>>
#include <common.h>
#include <Amplifier_TI5711.h>
#include <linux/types.h>
#include <apiSWI2C.h>
#include <drvIIC.h>


#define TAS5711_ADDR     0x36
#define TAS5711_BUSID     (((MS_U16) E_I2C_BUS_SYS << 8) | TAS5711_ADDR)


MAPI_U8  g_ucTas5711RegAddr;

MAPI_U8 AmpInitTbl[]=
{
    //DataLength        Address     DataN       DataN+1...
    // I2C Configuration file for TAS5700x
    1, 0x1B, 0x00,
    1, 0x06, 0x00,
    1, 0x0A, 0xff,
    1, 0x09, 0x30,
    1, 0x09, 0x29,
    1, 0x08, 0x29,
    1, 0x14, 0x54,
    1, 0x13, 0xAC,
    1, 0x11, 0xAC,
    1, 0x0E, 0xD1,
    1, 0x1A, 0x95,
    4, 0x20, 0x00, 0x01, 0x77, 0x72,//modify data[20][16] for LR channel config
    4, 0x21, 0x00, 0x00, 0x42, 0x03,
    1, 0x10, 0x02,
    1, 0x0B, 0x00,
    1, 0x10, 0x02,
    1, 0x1C, 0x02,
    1, 0x19, 0x30,
    4, 0x25, 0x01, 0x01, 0x32, 0x45,

    // Biquads
    4, 0x50, 0x00, 0x00, 0x00, 0x00,
    20, 0x29,0x00,0x80,0x4F,0xD0,0xFF,0x03,0xBF,0x07,0x00,0x7C,0x61,0x5B,0x00,0xFC,0x40,0xF9,0xFF,0x83,0x4E,0xD4,
    20, 0x2A,0x00,0x80,0x19,0x16,0xFF,0x04,0x16,0x3F,0x00,0x7C,0x98,0x15,0x00,0xFB,0xE9,0xC1,0xFF,0x83,0x4E,0xD4,
    20, 0x2B,0x00,0x80,0x77,0x6E,0xFF,0x11,0xCD,0x6B,0x00,0x6F,0xC9,0x54,0x00,0xEE,0x32,0x95,0xFF,0x8F,0xBF,0x3D,
    20, 0x2C,0x00,0x83,0xDB,0x0D,0xFF,0x2F,0x00,0x81,0x00,0x5E,0x5C,0xB7,0x00,0xD0,0xFF,0x7F,0xFF,0x9D,0xC8,0x3B,
    20, 0x2D,0x00,0x85,0x7F,0xA9,0xFF,0x56,0x99,0x07,0x00,0x50,0x07,0x36,0x00,0xA9,0x66,0xF9,0xFF,0xAA,0x79,0x20,
    20, 0x2E,0x00,0x85,0x7F,0xA9,0xFF,0x95,0x3C,0x90,0x00,0x50,0x07,0x36,0x00,0x6A,0xC3,0x70,0xFF,0xAA,0x79,0x20,
    20, 0x2F,0x00,0x80,0x6D,0xA1,0xFF,0x03,0x69,0xA7,0x00,0x7C,0x43,0x8A,0x00,0xFC,0x96,0x59,0xFF,0x83,0x4E,0xD4,

    20, 0x30,0x00,0x80,0x4F,0xD0,0xFF,0x03,0xBF,0x07,0x00,0x7C,0x61,0x5B,0x00,0xFC,0x40,0xF9,0xFF,0x83,0x4E,0xD4,
    20, 0x31,0x00,0x80,0x19,0x16,0xFF,0x04,0x16,0x3F,0x00,0x7C,0x98,0x15,0x00,0xFB,0xE9,0xC1,0xFF,0x83,0x4E,0xD4,
    20, 0x32,0x00,0x80,0x77,0x6E,0xFF,0x11,0xCD,0x6B,0x00,0x6F,0xC9,0x54,0x00,0xEE,0x32,0x95,0xFF,0x8F,0xBF,0x3D,
    20, 0x33,0x00,0x83,0xDB,0x0D,0xFF,0x2F,0x00,0x81,0x00,0x5E,0x5C,0xB7,0x00,0xD0,0xFF,0x7F,0xFF,0x9D,0xC8,0x3B,
    20, 0x34,0x00,0x85,0x7F,0xA9,0xFF,0x56,0x99,0x07,0x00,0x50,0x07,0x36,0x00,0xA9,0x66,0xF9,0xFF,0xAA,0x79,0x20,
    20, 0x35,0x00,0x85,0x7F,0xA9,0xFF,0x95,0x3C,0x90,0x00,0x50,0x07,0x36,0x00,0x6A,0xC3,0x70,0xFF,0xAA,0x79,0x20,
    20, 0x36,0x00,0x80,0x6D,0xA1,0xFF,0x03,0x69,0xA7,0x00,0x7C,0x43,0x8A,0x00,0xFC,0x96,0x59,0xFF,0x83,0x4E,0xD4,

    20, 0x5A,0x00,0x00,0x05,0x83,0x00,0x00,0x0B,0x06,0x00,0x00,0x05,0x83,0x00,0xFB,0x42,0xC1,0x0F,0x84,0xA7,0x33,
    20, 0x5B,0x00,0x00,0x05,0x83,0x00,0x00,0x0B,0x06,0x00,0x00,0x05,0x83,0x00,0xFB,0x42,0xC1,0x0F,0x84,0xA7,0x33,
    // DRCs
    8, 0x3A, 0x00,0x05,0x39,0x47,0x00,0x7A,0xC6,0xB8,
    8, 0x3B, 0x00,0x05,0x39,0x47,0x00,0x7A,0xC6,0xB8,
    8, 0x3C, 0x00,0x00,0x00,0xF9,0x00,0x7F,0xFF,0x06,
    4, 0x40, 0xFD,0xA2,0x14,0x90,//0xFD,0xc1,0xf8,0x89,//0xFC, 0x83, 0x10, 0xD4,   //4, 0x40, 0xFD, 0xe1, 0xdc, 0x81,//
    4,0x41,0x0F,0x81,0x47,0xAF,   //쨰
    4, 0x42, 0x00, 0x08, 0x42, 0x10,
    4, 0x46, 0x00, 0x00, 0x00, 0x03,
    8, 0x39, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    8, 0x3D, 0x00,0x05,0x39,0x47,0x00,0x7A,0xC6,0xB8,
    8, 0x3E, 0x00,0x05,0x39,0x47,0x00,0x7A,0xC6,0xB8,
    8, 0x3F, 0x00,0x00,0x00,0xF9,0x00,0x7F,0xFF,0x06,
    4, 0x43, 0xFD,0x82,0x30,0x98,//0xFC, 0x83, 0x10, 0xD4,
    4, 0x44, 0x0F, 0x83, 0x33, 0x34,
    4, 0x45, 0x00, 0x08, 0x42, 0x10,
    4, 0x46, 0x00, 0x00, 0x00, 0x03,//0x03,
    //12, 0x52, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    //8, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
    //4, 0x56, 0x00, 0x80, 0x00, 0x00,
    //4, 0x57, 0x00, 0x02, 0x00, 0x00,
    //16, 0x53, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
    //16, 0x54, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
    //12, 0x55, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    //12, 0x51, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    1, 0x07, 0xFF,
    1, 0x05, 0x84,
    1,0x0D,0x35,
    0x00,
};

MAPI_BOOL Amplifier_TI5711_Init(void)
{
    MAPI_U8 * Pstr=NULL;
    MAPI_U8 DataLength = 0;
    //   printf("******** Amplifier_TI5711_Init\n");

    Amplifier_TI5711_Reset(FALSE);
    MsOS_DelayTask(2);
    Amplifier_TI5711_StandBy(FALSE);

    MsOS_DelayTask(10);
    Amplifier_TI5711_Reset(TRUE);

    MsOS_DelayTask(50);

    Pstr = AmpInitTbl;

    do
    {
        DataLength = *Pstr;
        if(DataLength>20)
        {
            printf("5711 set command error!!\n");
            break;
        }
        g_ucTas5711RegAddr = *(++Pstr);
        Pstr++;

        if (MApi_SWI2C_WriteBytes(TAS5711_BUSID,1,&g_ucTas5711RegAddr,DataLength, Pstr) == FALSE)
            printf("5711write fail = %d\n",g_ucTas5711RegAddr);

        if (g_ucTas5711RegAddr==0x1B)
        {
            MsOS_DelayTask(50);
        }
        else
        {
            MsOS_DelayTask(1);
        }

        Pstr = Pstr + DataLength;
    }while(*Pstr != 0);

    return MAPI_TRUE;
}


MAPI_U8 AmpmasterSWMute[]=
{
    1,0x06,0x07,
    0x00,
};
MAPI_U8 AmpmasterSWUnMute[]=
{
    1,0x06,0x00,
    0x00,
};

MAPI_U8 AmpmasterMuteVolume[]=
{
    1,0x07,0xFF,
    0x00,
};
MAPI_U8 AmpmasterVolume_ATV[]=
{
    1,0x07,0xF0,
    1,0x07,0x7C,
    1,0x07,0x37,
    0x00,
};
MAPI_U8 AmpmasterVolume_OTHER[]=
{
    1,0x07,0xF0,
    1,0x07,0x7C,
    1,0x07,0x37,
    1,0x07,0x06,
    0x00,
};

MAPI_BOOL Amplifier_TI5711_SWMute(MAPI_BOOL bMute)
{
    MAPI_U8 * Pstr;
    MAPI_U8 DataLength = 0;

    printf("******Amplifier_TI5711_SWMute(%d)\n",bMute);
    if(bMute)
    {
	Pstr=AmpmasterMuteVolume;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5711 set command error!!\n");
                break;
            }
            g_ucTas5711RegAddr = *(++Pstr);
            Pstr++;

            if (MApi_SWI2C_WriteBytes(TAS5711_BUSID,1, &g_ucTas5711RegAddr, DataLength, Pstr) == FALSE)
		        printf("5711write fail = %d\n",g_ucTas5711RegAddr);

            MsOS_DelayTask(2);
            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);

	Pstr=AmpmasterSWMute;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5711 set command error!!\n");
                break;
            }
            g_ucTas5711RegAddr = *(++Pstr);
            Pstr++;
            #if 0
            if(iptr->WriteBytes(1, &g_ucTas5711RegAddr, DataLength, Pstr) == MAPI_FALSE)
                printf("5711write fail = %d\n",g_ucTas5711RegAddr);
            #else
            if (MApi_SWI2C_WriteBytes(TAS5711_BUSID,1, &g_ucTas5711RegAddr, DataLength, Pstr) == FALSE)
		        printf("5711write fail = %d\n",g_ucTas5711RegAddr);
            #endif
            MsOS_DelayTask(2);
            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);
    }
    else
    {
	Pstr=AmpmasterVolume_OTHER;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5711 set command error!!\n");
                break;
            }
            g_ucTas5711RegAddr = *(++Pstr);
            Pstr++;
            #if 0
            if(iptr->WriteBytes(1, &g_ucTas5711RegAddr, DataLength, Pstr) == MAPI_FALSE)
                printf("5711write fail = %d\n",g_ucTas5711RegAddr);
            #else
            if (MApi_SWI2C_WriteBytes(TAS5711_BUSID,1, &g_ucTas5711RegAddr, DataLength, Pstr) == FALSE)
		        printf("5711write fail = %d\n",g_ucTas5711RegAddr);
            #endif
            MsOS_DelayTask(2);

            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);

	Pstr=AmpmasterSWUnMute;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5711 set command error!!\n");
                break;
            }
            g_ucTas5711RegAddr = *(++Pstr);
            Pstr++;
            #if 0
            if(iptr->WriteBytes(1, &g_ucTas5711RegAddr, DataLength, Pstr) == MAPI_FALSE)
                printf("5711write fail = %d\n",g_ucTas5711RegAddr);
            #else
            if (MApi_SWI2C_WriteBytes(TAS5711_BUSID,1, &g_ucTas5711RegAddr, DataLength, Pstr) == FALSE)
		        printf("5711write fail = %d\n",g_ucTas5711RegAddr);
            #endif
            MsOS_DelayTask(2);

            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);
    }
    return TRUE;
}
//#endif
 //wjq20100112<<<

MAPI_BOOL Amplifier_TI5711_Mute(MAPI_BOOL bMute)
{
    // TODO: HW no use
    return TRUE;
}

MAPI_BOOL Amplifier_TI5711_StandBy(MAPI_U8 u8Para)
{
    if(u8Para == FALSE)
    {
        Audio_Amplifier_OFF();
    }
    else
    {
        Audio_Amplifier_ON();
    }
    return TRUE;
}

MAPI_BOOL Amplifier_TI5711_Reset(MAPI_U8 u8Para)
{
    if(u8Para == FALSE)
    {
        Audio_Amplifier_RST_OFF();
    }
    else
    {
        Audio_Amplifier_RST_ON();
    }
    return TRUE;
}

