/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
 //zpc 20181116>>>
#include <common.h>
#include <Amplifier_TI5719_changhong.h>
#include <linux/types.h>
#include <apiSWI2C.h>
#include <drvIIC.h>


#define TAS5719_ADDR     0x56

#ifndef I2C_BUS_IDX
#define I2C_BUS_IDX         2
#endif
#define TAS5719_I2C_BUS_IDX         2

//#define TAS5719_BUSID     (((MS_U16) I2C_BUS_IDX << 8) | TAS5719_ADDR)
#define TAS5719_BUSID     (((MS_U16) TAS5719_I2C_BUS_IDX << 8) | TAS5719_ADDR)

MAPI_U8  g_ucTas5719RegAddr;

MAPI_U8 AmpInitTbl[]=
{
        //DataLength        Address     DataN       DataN+1...
        1,27,0,
        4,70,0,2,0,3,
        1,27,0,
        1,3,128,
        1,6,7,
        1,17,128,
        1,18,124,
        1,19,128,
        1,20,124,
        1,28,7,
        1,10,48,
        1,14,241,
        1,0,108,
        4,80,15,112,128,16,
        4,37,1,2,19,69,
        4,112,0,128,0,0,
        4,113,0,0,0,0,
        4,116,0,128,0,0,
        4,117,0,0,0,0,
        4,70,0,0,0,3,
        1,5,8,
        1,17,128,
        1,18,124,
        1,19,128,
        1,20,124,
        4,32,0,137,119,114,
        1,5,8,
        1,6,0,
        4,86,0,64,0,0,
        4,87,0,2,0,0,
        2,7,0,79,
        2,7,3,255,
        8,64,16,157,0,0,16,176,255,255,
        2,7,3,255,
        2,7,3,255,
        8,59,0,43,158,0,0,84,97,255,
        2,7,3,255,
        2,7,3,255,
        8,60,0,0,3,242,255,255,255,160,
        2,7,3,255,
        2,7,3,255,
        8,67,16,157,0,0,16,176,255,255,
        2,7,3,255,
        2,7,3,255,
        8,62,0,43,158,0,0,84,97,255,
        2,7,3,255,
        2,7,3,255,
        8,63,0,0,3,242,255,255,255,160,
        2,7,3,255,
        8,81,0,128,0,0,0,0,0,0,
        8,82,0,128,0,0,0,0,0,0,
        20,88,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,89,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,90,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,91,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,38,0,126,149,255,15,2,212,1,0,126,149,255,0,253,39,255,15,130,208,1,
        20,48,0,126,149,255,15,2,212,1,0,126,149,255,0,253,39,255,15,130,208,1,
        4,115,0,128,0,0,
        4,114,0,0,0,0,
        4,118,0,0,0,0,
        4,119,0,128,0,0,
        4,79,0,0,0,8,
        8,106,0,12,204,204,0,115,51,52,
        20,39,0,123,142,5,15,36,101,228,0,108,90,200,0,219,154,28,15,152,23,50,
        20,40,0,143,119,86,15,128,0,0,0,37,141,156,0,128,0,0,15,202,251,13,
        20,41,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,42,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,43,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,44,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,45,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,46,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,47,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,49,0,123,142,5,15,36,101,228,0,108,90,200,0,219,154,28,15,152,23,50,
        20,50,0,143,119,86,15,128,0,0,0,37,141,156,0,128,0,0,15,202,251,13,
        20,51,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,52,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,53,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,54,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,55,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,56,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        20,57,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        2,7,0,79,
        0,
        };

MAPI_BOOL Amplifier_TI5719_changhong_Init(void)
{
    MAPI_U8 * Pstr=NULL;
    MAPI_U8 DataLength = 0;
    printf("******** Amplifier_TI5719_changhong_Init ****TAS5719_I2C_BUS_IDX=%d\n",TAS5719_I2C_BUS_IDX);
    //printf("******** Amplifier_TI5719_changhong_Init ****TAS5719_ADDR=%d\n",TAS5719_ADDR);
    //printf("******** Amplifier_TI5719_changhong_Init ****TAS5719_BUSID=%d\n",TAS5719_BUSID);
    Amplifier_TI5719_changhong_Reset(TRUE);
    MsOS_DelayTask(2);
    Amplifier_TI5719_changhong_StandBy(TRUE);

    MsOS_DelayTask(10);
    Amplifier_TI5719_changhong_Reset(FALSE);

    MsOS_DelayTask(50);

    Pstr = AmpInitTbl;

    do
    {
        DataLength = *Pstr;
        if(DataLength>20)
        {
            printf("5719 set command error!!\n");
            break;
        }
        g_ucTas5719RegAddr = *(++Pstr);
        Pstr++;

        if (MApi_SWI2C_WriteBytes(TAS5719_BUSID,1,&g_ucTas5719RegAddr,DataLength, Pstr) == FALSE)
             printf("5719write fail = %d\n",g_ucTas5719RegAddr);
	 //else
		//printf("5719 write ok = %d\n",g_ucTas5719RegAddr);
        if (g_ucTas5719RegAddr==0x1B)
        {
            MsOS_DelayTask(50);
        }
        else
        {
            MsOS_DelayTask(1);
        }

        Pstr = Pstr + DataLength;
    }while(*Pstr != 0);

    return MAPI_TRUE;
}


MAPI_U8 AmpmasterSWMute[]=
{
    1,0x06,0x07,
    0x00,
};
MAPI_U8 AmpmasterSWUnMute[]=
{
    1,0x06,0x00,
    0x00,
};

MAPI_U8 AmpmasterMuteVolume[]=
{
    1,0x07,0xFF,
    0x00,
};
MAPI_U8 AmpmasterVolume_ATV[]=
{
    1,0x07,0xF0,
    1,0x07,0x7C,
    1,0x07,0x37,
    0x00,
};
MAPI_U8 AmpmasterVolume_OTHER[]=
{
    1,0x07,0xF0,
    1,0x07,0x7C,
    1,0x07,0x37,
    1,0x07,0x06,
    0x00,
};

MAPI_BOOL Amplifier_TI5719_changhong_SWMute(MAPI_BOOL bMute)
{
    MAPI_U8 * Pstr;
    MAPI_U8 DataLength = 0;

    printf("******Amplifier_TI5719_changhong_SWMute(%d)\n",bMute);
    if(bMute)
    {
	Pstr=AmpmasterMuteVolume;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5719 set command error!!\n");
                break;
            }
            g_ucTas5719RegAddr = *(++Pstr);
            Pstr++;

            if (MApi_SWI2C_WriteBytes(TAS5719_BUSID,1, &g_ucTas5719RegAddr, DataLength, Pstr) == FALSE)
		        printf("5719write fail = %d\n",g_ucTas5719RegAddr);

            MsOS_DelayTask(2);
            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);

	Pstr=AmpmasterSWMute;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5719 set command error!!\n");
                break;
            }
            g_ucTas5719RegAddr = *(++Pstr);
            Pstr++;
            #if 0
            if(iptr->WriteBytes(1, &g_ucTas5719RegAddr, DataLength, Pstr) == MAPI_FALSE)
                printf("5719write fail = %d\n",g_ucTas5719RegAddr);
            #else
            if (MApi_SWI2C_WriteBytes(TAS5719_BUSID,1, &g_ucTas5719RegAddr, DataLength, Pstr) == FALSE)
		        printf("5719write fail = %d\n",g_ucTas5719RegAddr);
            #endif
            MsOS_DelayTask(2);
            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);
    }
    else
    {
	Pstr=AmpmasterVolume_OTHER;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5719 set command error!!\n");
                break;
            }
            g_ucTas5719RegAddr = *(++Pstr);
            Pstr++;
            #if 0
            if(iptr->WriteBytes(1, &g_ucTas5719RegAddr, DataLength, Pstr) == MAPI_FALSE)
                printf("5719write fail = %d\n",g_ucTas5719RegAddr);
            #else
            if (MApi_SWI2C_WriteBytes(TAS5719_BUSID,1, &g_ucTas5719RegAddr, DataLength, Pstr) == FALSE)
		        printf("5719write fail = %d\n",g_ucTas5719RegAddr);
            #endif
            MsOS_DelayTask(2);

            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);

	Pstr=AmpmasterSWUnMute;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5719 set command error!!\n");
                break;
            }
            g_ucTas5719RegAddr = *(++Pstr);
            Pstr++;
            #if 0
            if(iptr->WriteBytes(1, &g_ucTas5719RegAddr, DataLength, Pstr) == MAPI_FALSE)
                printf("5719write fail = %d\n",g_ucTas5719RegAddr);
            #else
            if (MApi_SWI2C_WriteBytes(TAS5719_BUSID,1, &g_ucTas5719RegAddr, DataLength, Pstr) == FALSE)
		        printf("5719write fail = %d\n",g_ucTas5719RegAddr);
            #endif
            MsOS_DelayTask(2);

            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);
    }
    return TRUE;
}
//#endif
 //wjq20100112<<<

MAPI_BOOL Amplifier_TI5719_changhong_Mute(MAPI_BOOL bMute)
{
    // TODO: HW no use
    return TRUE;
}

MAPI_BOOL Amplifier_TI5719_changhong_StandBy(MAPI_U8 u8Para)
{
    if(u8Para == FALSE)
    {
        Adj_Volume_Off();
    }
    else
    {
        Adj_Volume_On();
    }
    return TRUE;
}


MAPI_BOOL Amplifier_TI5719_changhong_Reset(MAPI_U8 u8Para)
{
    if(u8Para == FALSE)
    {
        Audio_Amplifier_OFF();
    }
    else
    {
        Audio_Amplifier_ON();
    }
    return TRUE;
}

