/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
 //wjq20100112>>>
#include <common.h>
#include <Amplifier_TI5727_hisense.h>
#include <linux/types.h>
#include <apiSWI2C.h>
#include <MsUboot.h>


#define TAS5727_ADDR       0x54
#define TAS5727_BUSID     (((MS_U16) E_I2C_BUS_SYS << 8) | TAS5727_ADDR)
//#define TAS5727_BUSID     (((MS_U16) E_I2C_BUS_DDCD2 << 8) | TAS5727_ADDR)


#define TAS5727_ADDR2     0x56
#define TAS5727_BUSID2     (((MS_U16) E_I2C_BUS_SYS << 8) | TAS5727_ADDR2)
//#define TAS5727_BUSID2     (((MS_U16) E_I2C_BUS_DDCD2 << 8) | TAS5727_ADDR2)



MAPI_U8  g_ucTas5727RegAddr;

MAPI_U8 AmpInitTbl[]=
{
    //DataLength        Address     DataN       DataN+1...
    // I2C Configuration file for TAS5700x
    0x02,  0x07, 0x00, 0x20,
    0x02,  0x08, 0x00, 0xC0,
    0x02,  0x09, 0x00, 0xC0,
    0x04,  0x20, 0x00, 0x98, 0x77, 0x72,
    0x04,  0x25, 0x01, 0x02, 0x31, 0x45,
    0x14,  0x27,  0x00,  0x7E, 0xF0, 0x1F, 0x0F, 0x02, 0x1F, 0xC2, 0x00, 0x7E, 0xF0, 0x1F, 0x00, 0xFD, 0xDD, 0xFD, 0x0F, 0x82, 0x1D, 0x80,
    0x14,  0x28,  0x00,  0x7F, 0x2D, 0x4C, 0x0F, 0x03, 0x90, 0xB2, 0x00, 0x7D, 0x85, 0xE3, 0x00, 0xFC, 0x6F, 0x4E, 0x0F, 0x83, 0x4C, 0xD0,
    0x14,  0x29,  0x00,  0x7F, 0xD3, 0xF7, 0x0F, 0x02, 0x19, 0x8A, 0x00, 0x7E, 0xFE, 0x7C, 0x00, 0xFD, 0xE6, 0x76, 0x0F, 0x81, 0x2D, 0x8D,
    0x14,  0x2A,  0x00,  0x7F, 0x92, 0xBB, 0x0F, 0x0E, 0x85, 0x93, 0x00, 0x7C, 0x46, 0xBA, 0x00, 0xF1, 0x7A, 0x6D, 0x0F, 0x84, 0x26, 0x8A,
    0x14,  0x2B,  0x00,  0xDA, 0xD3, 0x62, 0x0E, 0xF1, 0xB0, 0x0C, 0x00, 0x63, 0xB1, 0x5B, 0x00, 0x7B, 0x74, 0x42, 0x0F, 0xD4, 0x56, 0xF3,
    0x14,  0x2C,  0x00,  0x5A, 0xA6, 0x50, 0x00, 0x12, 0x75, 0x8E, 0x00, 0x10, 0x37, 0xE7, 0x00, 0x19, 0x89, 0x28, 0x0F, 0xE9, 0x23, 0x12,
    0x14,  0x2D,  0x00,  0x82, 0x8A, 0xC5, 0x0F, 0x0C, 0xAF, 0x10, 0x00, 0x76, 0xEC, 0xE6, 0x00, 0xF3, 0x50, 0xF0, 0x0F, 0x86, 0x88, 0x55,
    0x14,  0x2E,  0x00,  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x14,  0x2F,  0x00,  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x14,  0x31,  0x00,  0x7E, 0xF0, 0x1F, 0x0F, 0x02, 0x1F, 0xC2, 0x00, 0x7E, 0xF0, 0x1F, 0x00, 0xFD, 0xDD, 0xFD, 0x0F, 0x82, 0x1D, 0x80,
    0x14,  0x32,  0x00,  0x7F, 0x2D, 0x4C, 0x0F, 0x03, 0x90, 0xB2, 0x00, 0x7D, 0x85, 0xE3, 0x00, 0xFC, 0x6F, 0x4E, 0x0F, 0x83, 0x4C, 0xD0,
    0x14,  0x33,  0x00,  0x7F, 0xD3, 0xF7, 0x0F, 0x02, 0x19, 0x8A, 0x00, 0x7E, 0xFE, 0x7C, 0x00, 0xFD, 0xE6, 0x76, 0x0F, 0x81, 0x2D, 0x8D,
    0x14, 0x34,  0x00,  0x7F, 0x92, 0xBB, 0x0F, 0x0E, 0x85, 0x93, 0x00, 0x7C, 0x46, 0xBA, 0x00, 0xF1, 0x7A, 0x6D, 0x0F, 0x84, 0x26, 0x8A,
    0x14, 0x35,  0x00,  0xDA, 0xD3, 0x62, 0x0E, 0xF1, 0xB0, 0x0C, 0x00, 0x63, 0xB1, 0x5B, 0x00, 0x7B, 0x74, 0x42, 0x0F, 0xD4, 0x56, 0xF3,
    0x14, 0x36,  0x00,  0x5A, 0xA6, 0x50, 0x00, 0x12, 0x75, 0x8E, 0x00, 0x10, 0x37, 0xE7, 0x00, 0x19, 0x89, 0x28, 0x0F, 0xE9, 0x23, 0x12,
    0x14, 0x37,  0x00,  0x82, 0x8A, 0xC5, 0x0F, 0x0C, 0xAF, 0x10, 0x00, 0x76, 0xEC, 0xE6, 0x00, 0xF3, 0x50, 0xF0, 0x0F, 0x86, 0x88, 0x55,
    0x14, 0x38,  0x00,  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x39,  0x00,  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x40, 0x07, 0xB7, 0x00, 0x00,
    0x04, 0x43, 0x07, 0xB7, 0x00, 0x00,
    0x04, 0x46, 0x00, 0x02, 0x00, 0x03,
    0x08, 0x51, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
    0x08, 0x52, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
    0x14, 0x58, 0x00, 0x7C, 0x56, 0x40, 0x0F, 0x83, 0xA9, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xAC, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x5A, 0x00, 0x03, 0xA9, 0xBF, 0x00, 0x03, 0xA9, 0xBF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xAC, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x5C, 0x00, 0x7C, 0x56, 0x40, 0x0F, 0x83, 0xA9, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xAC, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x5E, 0x00, 0x03, 0xA9, 0xBF, 0x00, 0x03, 0xA9, 0xBF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xAC, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x70, 0x00, 0x80, 0x00, 0x00,
    0x04, 0x72, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x73, 0x00, 0x80, 0x00, 0x00,
    0x04, 0x74, 0x00, 0x80, 0x00, 0x00,
    0x04, 0x76, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x77, 0x00, 0x80, 0x00, 0x00,
    0x00,
};

/****************************
        amp init regs
****************************/
MAPI_U8 AMP_INIT_TBL[] =
{
    //DataLength        Address     DataN       DataN+1...
    // I2C Configuration file for TAS5700x
    1, 0x03, 0x80,
    1, 0x04, 0x05,
	1, 0x05, 0x02,
    1,0x06,0x00,
    1, 0x0E, 0x91,
    1,0x10,0x02,
    1, 0x1A, 0x0F,
    1,0x1C,0x02,
    1, 0x11, 0xB8,
    1, 0x12, 0x60,
    1, 0x13, 0xA0,
    1, 0x14, 0x48,
	1, 0x1B, 0x00,
	8, 0x3B, 0x00, 0x00, 0x05, 0xF8, 0x00, 0x7F, 0xFA, 0x08,
	8, 0x3E, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x7F, 0xFE, 0x01,
	8, 0x3C, 0x00, 0x06, 0xB2, 0x1C, 0xFF, 0xFB, 0x49, 0x4C,
	8, 0x3F, 0x00, 0x06, 0xB2, 0x1C, 0xFF, 0xFB, 0x49, 0x4C,
	4, 0x50, 0x0F, 0x70, 0x80, 0x00,
	4, 0x56, 0x00, 0x59, 0x00, 0x00,
    0x00,
};

/****************************
        amp2 init regs
****************************/
MAPI_U8 AMP2_INIT_TBL[] =
{
    //DataLength        Address     DataN       DataN+1...
    // I2C Configuration file for TAS5700x
    1, 0x1B, 0x00,
    2, 0x07, 0x00, 0x20,
    4, 0x40, 0x0B, 0x25, 0x00, 0x00,///wjs modify
    4, 0x43, 0x0B, 0x25, 0x00, 0x00,///wjs modify
    8, 0x3B, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x7F, 0xFE, 0x01,
    8, 0x3E, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x7F, 0xFE, 0x01,
    8, 0x3C, 0x00, 0x06, 0xB2, 0x1C, 0xFF, 0xFB, 0x49, 0x4C,
    8, 0x3F, 0x00, 0x06, 0xB2, 0x1C, 0xFF, 0xFB, 0x49, 0x4C,
    4, 0x46, 0x00, 0x02, 0x00, 0x01,
    4, 0x50, 0x0F, 0x70, 0x80, 0x00,
    4, 0x20, 0x00, 0x98, 0x77, 0x72,
    4, 0x25, 0x01, 0x02, 0x31, 0x45,
    20, 0x27, 0x00, 0x7F, 0x86, 0xE2, 0x0F, 0x00, 0xF2, 0x3B, 0x00, 0x7F, 0x86, 0xE2, 0x00, 0xFF, 0x0D, 0x52, 0x0F, 0x80, 0xF1, 0xC8,
    20, 0x28, 0x00, 0x00, 0x03, 0x1D, 0x00, 0x00, 0x06, 0x3A, 0x00, 0x00, 0x03, 0x1D, 0x00, 0xFC, 0x72, 0x05, 0x0F, 0x83, 0x81, 0x85,
    20, 0x29, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x2A, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x2B, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x2C, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x2D, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x2E, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x2F, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x31, 0x00, 0x7F, 0x86, 0xE2, 0x0F, 0x00, 0xF2, 0x3B, 0x00, 0x7F, 0x86, 0xE2, 0x00, 0xFF, 0x0D, 0x52, 0x0F, 0x80, 0xF1, 0xC8,
    20, 0x32, 0x00, 0x00, 0x03, 0x1D, 0x00, 0x00, 0x06, 0x3A, 0x00, 0x00, 0x03, 0x1D, 0x00, 0xFC, 0x72, 0x05, 0x0F, 0x83, 0x81, 0x85,
    20, 0x33, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x34, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x35, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x36, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x37, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x38, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    20, 0x39, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	4, 0x72, 0x00, 0x40, 0x00, 0x00,
    4, 0x73, 0x00, 0x40, 0x00, 0x00,
    4, 0x76, 0x00, 0x40, 0x00, 0x00,
    4, 0x77, 0x00, 0x40, 0x00, 0x00,
    4, 0x56, 0x00, 0x59, 0x00, 0x00,
    4, 0x70, 0x00, 0x80, 0x00, 0x00,
    4, 0x74, 0x00, 0x80, 0x00, 0x00,
    8, 0x51, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    8, 0x52, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    2, 0x08, 0x00, 0xC0,
    2, 0x09, 0x00, 0xC0,
    1, 0x06, 0x00,
    1, 0x03, 0x80,
    1, 0x04, 0x05,
    1, 0x0E, 0x91,
    1, 0x10, 0x02,
    1, 0x1A, 0x0F,
    1, 0x1C, 0x02,
    1, 0x11, 0xB8,
    1, 0x12, 0x60,
    1, 0x13, 0xA0,
    1, 0x14, 0x48,
    1, 0x05, 0x02,
    0x00,
};

MAPI_U8 AMP_INIT_ARRAY[] =
{
    //DataLength        Address     DataN       DataN+1...
    // I2C Configuration file for TAS5700x
    0x02,  0x07, 0x00, 0x20,
    0x02,  0x08, 0x00, 0xC0,
    0x02,  0x09, 0x00, 0xC0,
    0x04,  0x20, 0x00, 0x98, 0x77, 0x72,
    0x04,  0x25, 0x01, 0x02, 0x31, 0x45,
    0x14, 0x27,  0x00,  0x7E, 0xF0, 0x1F, 0x0F, 0x02, 0x1F, 0xC2, 0x00, 0x7E, 0xF0, 0x1F, 0x00, 0xFD, 0xDD, 0xFD, 0x0F, 0x82, 0x1D, 0x80,
    0x14, 0x28,  0x00,  0x7F, 0x2D, 0x4C, 0x0F, 0x03, 0x90, 0xB2, 0x00, 0x7D, 0x85, 0xE3, 0x00, 0xFC, 0x6F, 0x4E, 0x0F, 0x83, 0x4C, 0xD0,
    0x14, 0x29,  0x00,  0x7F, 0xD3, 0xF7, 0x0F, 0x02, 0x19, 0x8A, 0x00, 0x7E, 0xFE, 0x7C, 0x00, 0xFD, 0xE6, 0x76, 0x0F, 0x81, 0x2D, 0x8D,
    0x14, 0x2A,  0x00,  0x7F, 0x92, 0xBB, 0x0F, 0x0E, 0x85, 0x93, 0x00, 0x7C, 0x46, 0xBA, 0x00, 0xF1, 0x7A, 0x6D, 0x0F, 0x84, 0x26, 0x8A,
    0x14, 0x2B,  0x00,  0xDA, 0xD3, 0x62, 0x0E, 0xF1, 0xB0, 0x0C, 0x00, 0x63, 0xB1, 0x5B, 0x00, 0x7B, 0x74, 0x42, 0x0F, 0xD4, 0x56, 0xF3,
    0x14, 0x2C,  0x00,  0x5A, 0xA6, 0x50, 0x00, 0x12, 0x75, 0x8E, 0x00, 0x10, 0x37, 0xE7, 0x00, 0x19, 0x89, 0x28, 0x0F, 0xE9, 0x23, 0x12,
    0x14, 0x2D,  0x00,  0x82, 0x8A, 0xC5, 0x0F, 0x0C, 0xAF, 0x10, 0x00, 0x76, 0xEC, 0xE6, 0x00, 0xF3, 0x50, 0xF0, 0x0F, 0x86, 0x88, 0x55,
    0x14, 0x2E,  0x00,  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x2F,  0x00,  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x31,  0x00,  0x7E, 0xF0, 0x1F, 0x0F, 0x02, 0x1F, 0xC2, 0x00, 0x7E, 0xF0, 0x1F, 0x00, 0xFD, 0xDD, 0xFD, 0x0F, 0x82, 0x1D, 0x80,
    0x14, 0x32,  0x00,  0x7F, 0x2D, 0x4C, 0x0F, 0x03, 0x90, 0xB2, 0x00, 0x7D, 0x85, 0xE3, 0x00, 0xFC, 0x6F, 0x4E, 0x0F, 0x83, 0x4C, 0xD0,
    0x14, 0x33,  0x00,  0x7F, 0xD3, 0xF7, 0x0F, 0x02, 0x19, 0x8A, 0x00, 0x7E, 0xFE, 0x7C, 0x00, 0xFD, 0xE6, 0x76, 0x0F, 0x81, 0x2D, 0x8D,
    0x00,
};

MAPI_U8 AMP_INIT_ARRAY2[] =
{
    0x14, 0x34,  0x00,  0x7F, 0x92, 0xBB, 0x0F, 0x0E, 0x85, 0x93, 0x00, 0x7C, 0x46, 0xBA, 0x00, 0xF1, 0x7A, 0x6D, 0x0F, 0x84, 0x26, 0x8A,
    0x14, 0x35,  0x00,  0xDA, 0xD3, 0x62, 0x0E, 0xF1, 0xB0, 0x0C, 0x00, 0x63, 0xB1, 0x5B, 0x00, 0x7B, 0x74, 0x42, 0x0F, 0xD4, 0x56, 0xF3,
    0x14, 0x36,  0x00,  0x5A, 0xA6, 0x50, 0x00, 0x12, 0x75, 0x8E, 0x00, 0x10, 0x37, 0xE7, 0x00, 0x19, 0x89, 0x28, 0x0F, 0xE9, 0x23, 0x12,
    0x14, 0x37,  0x00,  0x82, 0x8A, 0xC5, 0x0F, 0x0C, 0xAF, 0x10, 0x00, 0x76, 0xEC, 0xE6, 0x00, 0xF3, 0x50, 0xF0, 0x0F, 0x86, 0x88, 0x55,
    0x14, 0x38,  0x00,  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x39,  0x00,  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x40, 0x07, 0xB7, 0x00, 0x00,
    0x04, 0x43, 0x07, 0xB7, 0x00, 0x00,
    0x04, 0x46, 0x00, 0x02, 0x00, 0x03,
    0x08, 0x51, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
    0x08, 0x52, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
    0x14, 0x58, 0x00, 0x7C, 0x56, 0x40, 0x0F, 0x83, 0xA9, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xAC, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x5A, 0x00, 0x03, 0xA9, 0xBF, 0x00, 0x03, 0xA9, 0xBF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xAC, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x5C, 0x00, 0x7C, 0x56, 0x40, 0x0F, 0x83, 0xA9, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xAC, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x14, 0x5E, 0x00, 0x03, 0xA9, 0xBF, 0x00, 0x03, 0xA9, 0xBF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xAC, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x70, 0x00, 0x80, 0x00, 0x00,
    0x04, 0x72, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x73, 0x00, 0x80, 0x00, 0x00,
    0x04, 0x74, 0x00, 0x80, 0x00, 0x00,
    0x04, 0x76, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x77, 0x00, 0x80, 0x00, 0x00,
    0x00,
};

MAPI_BOOL Amplifier_TI5727_hisense_Init(void)
{
        MAPI_U8 * Pstr=NULL;
        MAPI_U8 DataLength = 0;
//        printf("********Amplifier_Init\n");

		Amplifier_TI5727_hisense_Reset(1);
		MsOS_DelayTask(2);
		Amplifier_TI5727_hisense_StandBy(FALSE);

    	MsOS_DelayTask(10);
		Amplifier_TI5727_hisense_Reset(0);

    	MsOS_DelayTask(40);

       Pstr = AMP_INIT_TBL;

        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5727 set command error!!\n");
                break;
            }
            g_ucTas5727RegAddr = *(++Pstr);
            Pstr++;

            if (MApi_SWI2C_WriteBytes(TAS5727_BUSID,1,&g_ucTas5727RegAddr,DataLength, Pstr) == FALSE)
		        printf("5727write fail = %d\n",g_ucTas5727RegAddr);

            if (g_ucTas5727RegAddr==0x1B)
            {
                MsOS_DelayTask(50);
            }
            else
            {
                MsOS_DelayTask(1);
            }

            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);


		Pstr = AMP_INIT_ARRAY;
		do
		  {
				DataLength = *Pstr;
				if(DataLength>20)
					{
						printf("5727 set command error!!\n");
						break;
					}
					g_ucTas5727RegAddr = *(++Pstr);
					Pstr++;

					if (MApi_SWI2C_WriteBytes(TAS5727_BUSID,1,&g_ucTas5727RegAddr,DataLength, Pstr) == FALSE)
						printf("5727write fail = %d\n",g_ucTas5727RegAddr);

					if (g_ucTas5727RegAddr==0x1B)
					{
						MsOS_DelayTask(50);
					}
					else
					{
						MsOS_DelayTask(1);
					}

					Pstr = Pstr + DataLength;
				}while(*Pstr != 0);

		Pstr = AMP_INIT_ARRAY2;
		do
		  {
				DataLength = *Pstr;
				if(DataLength>20)
					{
						printf("5727 set command error!!\n");
						break;
					}
					g_ucTas5727RegAddr = *(++Pstr);
					Pstr++;

					if (MApi_SWI2C_WriteBytes(TAS5727_BUSID,1,&g_ucTas5727RegAddr,DataLength, Pstr) == FALSE)
						printf("5727write fail = %d\n",g_ucTas5727RegAddr);

					if (g_ucTas5727RegAddr==0x1B)
					{
						MsOS_DelayTask(50);
					}
					else
					{
						MsOS_DelayTask(1);
					}

					Pstr = Pstr + DataLength;
				}while(*Pstr != 0);

	return MAPI_TRUE;
}


MAPI_U8 AmpmasterSWMute[]=
{
    1,0x06,0x03,
    0x00,
};
MAPI_U8 AmpmasterSWUnMute[]=
{
    1,0x06,0x00,
    0x00,
};

MAPI_U8 AmpmasterMuteVolume[]=
{
    1,0x07,0xFF,
    0x00,
};
MAPI_U8 AmpmasterVolume_ATV[]=
{
	1, 0x07, 0xCE,
	1, 0x07, 0x67,
    1,0x07,0x37,
	1, 0x07, 0x06,
    0x00,
};

MAPI_U8 AmpmasterVolume_OTHER[]=
{
	1, 0x07, 0xCE,
	1, 0x07, 0x67,
    1,0x07,0x37,
    1,0x07,0x06,
    0x00,
};


MAPI_BOOL Amplifier_TI5727_hisense_SWMute(MAPI_BOOL bMute)
{
    MAPI_U8 * Pstr;
    MAPI_U8 DataLength = 0;

    printf("******Amplifier_TI5727_hisense_SWMute(%d)\n",bMute);
    if(bMute)
    {
	Pstr=AmpmasterMuteVolume;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5727 set command error!!\n");
                break;
            }
            g_ucTas5727RegAddr = *(++Pstr);
            Pstr++;

            if (MApi_SWI2C_WriteBytes(TAS5727_BUSID,1, &g_ucTas5727RegAddr, DataLength, Pstr) == FALSE)
		        printf("5727write fail = %d\n",g_ucTas5727RegAddr);

            MsOS_DelayTask(2);
            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);

	Pstr=AmpmasterSWMute;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5727 set command error!!\n");
                break;
            }
            g_ucTas5727RegAddr = *(++Pstr);
            Pstr++;
            #if 0
            if(iptr->WriteBytes(1, &g_ucTas5727RegAddr, DataLength, Pstr) == MAPI_FALSE)
                printf("5727write fail = %d\n",g_ucTas5727RegAddr);
            #else
            if (MApi_SWI2C_WriteBytes(TAS5727_BUSID,1, &g_ucTas5727RegAddr, DataLength, Pstr) == FALSE)
		        printf("5727write fail = %d\n",g_ucTas5727RegAddr);
            #endif
            MsOS_DelayTask(2);
            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);
    }
    else
    {
	Pstr=AmpmasterVolume_OTHER;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5727 set command error!!\n");
                break;
            }
            g_ucTas5727RegAddr = *(++Pstr);
            Pstr++;
            #if 0
            if(iptr->WriteBytes(1, &g_ucTas5727RegAddr, DataLength, Pstr) == MAPI_FALSE)
                printf("5727write fail = %d\n",g_ucTas5727RegAddr);
            #else
            if (MApi_SWI2C_WriteBytes(TAS5727_BUSID,1, &g_ucTas5727RegAddr, DataLength, Pstr) == FALSE)
		        printf("5727write fail = %d\n",g_ucTas5727RegAddr);
            #endif
            MsOS_DelayTask(2);

            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);

	Pstr=AmpmasterSWUnMute;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5727 set command error!!\n");
                break;
            }
            g_ucTas5727RegAddr = *(++Pstr);
            Pstr++;
            #if 0
            if(iptr->WriteBytes(1, &g_ucTas5727RegAddr, DataLength, Pstr) == MAPI_FALSE)
                printf("5727write fail = %d\n",g_ucTas5727RegAddr);
            #else
            if (MApi_SWI2C_WriteBytes(TAS5727_BUSID,1, &g_ucTas5727RegAddr, DataLength, Pstr) == FALSE)
		        printf("5727write fail = %d\n",g_ucTas5727RegAddr);
            #endif
            MsOS_DelayTask(2);

            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);
    }
    return TRUE;
}
//#endif
 //wjq20100112<<<

MAPI_BOOL Amplifier_TI5727_hisense_Mute(MAPI_BOOL bMute)
{
    // TODO: HW no use
    return TRUE;
}

MAPI_BOOL Amplifier_TI5727_hisense_StandBy(MAPI_U8 u8Para)
{
    if(u8Para == FALSE)
    {
        Audio_Amplifier_ON();
    }
    else
    {
        Audio_Amplifier_OFF();
    }
    return TRUE;
}

MAPI_BOOL Amplifier_TI5727_hisense_Reset(MAPI_U8 u8Para)
{
    if(u8Para == FALSE)
    {
        Audio_Amplifier_RST_OFF();
    }
    else
    {
        Audio_Amplifier_RST_ON();
    }
    return TRUE;
}

