/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
 //wjq20100112>>>
#include <common.h>
#include <Amplifier_TI5733.h>
#include <linux/types.h>
#include <apiSWI2C.h>
#include <drvIIC.h>

#ifndef I2C_BUS_IDX
#define I2C_BUS_IDX         0
#endif

#define TAS5733_ADDR     0x56
#define TAS5733_BUSID     (((MS_U16) I2C_BUS_IDX << 8) | TAS5733_ADDR)


MAPI_U8  g_ucTas5733RegAddr;

MAPI_U8 AmpInitTbl[]=
{
    //DataLength        Address     DataN       DataN+1...
    // I2C Configuration file for TAS5700x
    1, 0x06, 0x07,
    1, 0x05, 0x40,
    1, 0x03, 0xa0,
    1, 0x04, 0x05,
    2, 0x07, 0x00, 0x40,
    2, 0x08, 0x00, 0xc0,
    2, 0x09, 0x00, 0xc0,
    2, 0x0a, 0x00, 0xc0,
    1, 0x0e, 0xf0,
    1, 0x10, 0x01,
    1, 0x11, 0xb8,
    1, 0x12, 0x60,
    1, 0x13, 0xa0,
    1, 0x14, 0x48,
    1, 0x19, 0x30,
    1, 0x1a, 0x68,
    1, 0x1b, 0x00,
    1, 0x1c, 0x57,
    4, 0x20, 0x00,0x89,0x77,0x72,
    4, 0x25, 0x01,0x02,0x13,0x45,
    20, 0x26,0x00,0x7f,0xf0,0xd7,0x07,0x00,0x1e,0x53,0x00,0x7f,0xf0,0xd7,0x00,0xff,0xe1,0xab,0x07,0x80,0x1e,0x51,
    20, 0x27,0x00,0x7b,0x58,0xf9,0x07,0x09,0x4e,0x0d,0x00,0x7b,0x58,0xf9,0x00,0xf6,0x86,0xa5,0x07,0x89,0x22,0xbf,
    20, 0x28,0x00,0x7b,0x58,0xf9,0x07,0x09,0x4e,0x0d,0x00,0x7b,0x58,0xf9,0x00,0xf6,0x86,0xa5,0x07,0x89,0x22,0xbf,
    20, 0x29,0x00,0x7b,0x58,0xf9,0x07,0x09,0x4e,0x0d,0x00,0x7b,0x58,0xf9,0x00,0xf6,0x86,0xa5,0x07,0x89,0x22,0xbf,
    20, 0x2a,0x00,0x7e,0x1e,0x3b,0x07,0x0d,0x39,0xa0,0x00,0x77,0xae,0xdb,0x00,0xf2,0xc6,0x60,0x07,0x8a,0x32,0xea,
    20, 0x2b,0x00,0x80,0xa5,0xd4,0x07,0x02,0xbb,0x49,0x00,0x7d,0xb0,0x07,0x00,0xfd,0x44,0xb7,0x07,0x81,0xaa,0x25,
    20, 0x2c,0x00,0x80,0xa5,0xd4,0x07,0x03,0x6d,0x74,0x00,0x7d,0xb0,0x07,0x00,0xfc,0x92,0x8c,0x07,0x81,0xaa,0x25,
    20, 0x2d,0x00,0xa0,0x7d,0x79,0x07,0x8e,0x32,0x18,0x00,0x2a,0x08,0x72,0x00,0x43,0x9c,0xa8,0x07,0xe3,0xab,0x55,
    20, 0x2e,0x00,0x7b,0x2e,0xcf,0x07,0x3e,0xdd,0xb2,0x00,0x63,0xd4,0x3f,0x00,0xc1,0x22,0x4e,0x07,0xa0,0xfc,0xf1,
    20, 0x2f,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    20, 0x30,0x00,0x7f,0xf0,0xd7,0x07,0x00,0x1e,0x53,0x00,0x7f,0xf0,0xd7,0x00,0xff,0xe1,0xab,0x07,0x80,0x1e,0x51,
    20, 0x31,0x00,0x7b,0x58,0xf9,0x07,0x09,0x4e,0x0d,0x00,0x7b,0x58,0xf9,0x00,0xf6,0x86,0xa5,0x07,0x89,0x22,0xbf,
    20, 0x32,0x00,0x7b,0x58,0xf9,0x07,0x09,0x4e,0x0d,0x00,0x7b,0x58,0xf9,0x00,0xf6,0x86,0xa5,0x07,0x89,0x22,0xbf,
    20, 0x33,0x00,0x7b,0x58,0xf9,0x07,0x09,0x4e,0x0d,0x00,0x7b,0x58,0xf9,0x00,0xf6,0x86,0xa5,0x07,0x89,0x22,0xbf,
    20, 0x34,0x00,0x7e,0x1e,0x3b,0x07,0x0d,0x39,0xa0,0x00,0x77,0xae,0xdb,0x00,0xf2,0xc6,0x60,0x07,0x8a,0x32,0xea,
    20, 0x35,0x00,0x80,0xa5,0xd4,0x07,0x02,0xbb,0x49,0x00,0x7d,0xb0,0x07,0x00,0xfd,0x44,0xb7,0x07,0x81,0xaa,0x25,
    20, 0x36,0x00,0x80,0xa5,0xd4,0x07,0x03,0x6d,0x74,0x00,0x7d,0xb0,0x07,0x00,0xfc,0x92,0x8c,0x07,0x81,0xaa,0x25,
    20, 0x37,0x00,0xa0,0x7d,0x79,0x07,0x8e,0x32,0x18,0x00,0x2a,0x08,0x72,0x00,0x43,0x9c,0xa8,0x07,0xe3,0xab,0x55,
    20, 0x38,0x00,0x7b,0x2e,0xcf,0x07,0x3e,0xdd,0xb2,0x00,0x63,0xd4,0x3f,0x00,0xc1,0x22,0x4e,0x07,0xa0,0xfc,0xf1,
    20, 0x39,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    8, 0x3b, 0x00,0x00,0xe2,0xc4,0x00,0x7f,0x1d,0x3b,
    8, 0x3c, 0x00,0x00,0x02,0xc5,0xff,0xff,0xfe,0xef,
    8, 0x3e, 0x00,0x07,0x60,0x53,0x00,0x78,0x9f,0xac,
    8, 0x3f, 0x00,0x00,0x00,0x6d,0xff,0xff,0xff,0xe5,
    4, 0x40, 0x04,0x02,0x6e,0x73,
    4, 0x41, 0x05,0xa9,0xdf,0x7a,
    8, 0x42, 0x00,0x00,0x00,0xf5,0xff,0xff,0xff,0xf3,
    4, 0x43, 0x08,0x00,0x00,0x00,
    4, 0x44, 0x02,0x87,0xa2,0x6c,
    8, 0x45, 0x00,0x00,0x00,0x6d,0xff,0xff,0xff,0xe5,
    4, 0x46, 0x00,0x02,0x00,0x0f,
    8, 0x47, 0x00,0x07,0x60,0x53,0x00,0x78,0x9f,0xac,
    8, 0x48, 0x00,0x02,0xa3,0x9a,0x00,0x7d,0x5c,0x65,
    4, 0x4f, 0x00,0x00,0x00,0x08,
    4, 0x50, 0x0f,0x70,0x80,0x00,
    12,0x51, 0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x07,0x80,0x00,0x00,
    12,0x52, 0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x07,0x80,0x00,0x00,
    4, 0x56, 0x00,0xff,0x64,0xc1,
    4, 0x57, 0x00,0x02,0x00,0x00,
    20,0x58, 0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    20,0x59, 0x00,0x00,0x0c,0x27,0x00,0x00,0x18,0x4f,0x00,0x00,0x0c,0x27,0x00,0xf6,0x23,0xa6,0x07,0x89,0xab,0xbc,
    20,0x5a, 0x00,0x59,0x0c,0xdc,0x07,0x4d,0xe6,0x47,0x00,0x59,0x0c,0xdc,0x00,0xab,0x0d,0xc1,0x07,0xc6,0xda,0x4f,
    20,0x5b, 0x00,0x03,0x85,0xfc,0x00,0x07,0x0b,0xf8,0x00,0x03,0x85,0xfc,0x00,0xab,0x0d,0xc1,0x07,0xc6,0xda,0x4f,
    20,0x5c, 0x00,0x7b,0x1d,0xfa,0x07,0x09,0xc4,0x0b,0x00,0x7b,0x1d,0xfa,0x00,0xf6,0x23,0xa6,0x07,0x89,0xab,0xbc,
    20,0x5d, 0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    20,0x5e, 0x00,0x00,0x0c,0x27,0x00,0x00,0x18,0x4f,0x00,0x00,0x0c,0x27,0x00,0xf6,0x23,0xa6,0x07,0x89,0xab,0xbc,
    20,0x5f, 0x00,0x59,0x0c,0xdc,0x07,0x4d,0xe6,0x47,0x00,0x59,0x0c,0xdc,0x00,0xab,0x0d,0xc1,0x07,0xc6,0xda,0x4f,
    20,0x60, 0x00,0x03,0x85,0xfc,0x00,0x07,0x0b,0xf8,0x00,0x03,0x85,0xfc,0x00,0xab,0x0d,0xc1,0x07,0xc6,0xda,0x4f,
    20,0x61, 0x00,0x7b,0x1d,0xfa,0x07,0x09,0xc4,0x0b,0x00,0x7b,0x1d,0xfa,0x00,0xf6,0x23,0xa6,0x07,0x89,0xab,0xbc,
    4, 0x70, 0x00,0x80,0x00,0x00,
    4, 0x71, 0x00,0x00,0x00,0x00,
    4, 0x72, 0x00,0x00,0x00,0x00,
    4, 0x73, 0x00,0x80,0x00,0x00,
    4, 0x74, 0x00,0x80,0x00,0x00,
    4, 0x75, 0x00,0x00,0x00,0x00,
    4, 0x76, 0x00,0x00,0x00,0x00,
    4, 0x77, 0x00,0x80,0x00,0x00,
    1, 0x05, 0x00,
    1, 0x06, 0x00,
    0x00,
};

MAPI_BOOL Amplifier_TI5733_Init(void)
{
    MAPI_U8 * Pstr=NULL;
    MAPI_U8 DataLength = 0;
    printf("******** Amplifier_TI5733_Init\n");

    Amplifier_TI5733_Reset(FALSE);
    MsOS_DelayTask(2);
    Amplifier_TI5733_StandBy(FALSE);

    MsOS_DelayTask(10);
    Amplifier_TI5733_Reset(TRUE);

    MsOS_DelayTask(20);

    Pstr = AmpInitTbl;

    do
    {
        DataLength = *Pstr;
        if(DataLength>20)
        {
            printf("5733 set command error!!\n");
            break;
        }
        g_ucTas5733RegAddr = *(++Pstr);
        Pstr++;

        if (MApi_SWI2C_WriteBytes(TAS5733_BUSID,1,&g_ucTas5733RegAddr,DataLength, Pstr) == FALSE)
            printf("5733write fail = %d\n",g_ucTas5733RegAddr);

        MsOS_DelayTask(1);

        Pstr = Pstr + DataLength;
    }while(*Pstr != 0);

    return MAPI_TRUE;
}


MAPI_U8 AmpmasterSWMute[]=
{
    1,0x06,0x07,
    0x00,
};
MAPI_U8 AmpmasterSWUnMute[]=
{
    1,0x06,0x00,
    0x00,
};

MAPI_BOOL Amplifier_TI5733_SWMute(MAPI_BOOL bMute)
{
    MAPI_U8 * Pstr;
    MAPI_U8 DataLength = 0;

    printf("******Amplifier_TI5733_SWMute(%d)\n",bMute);
    if(bMute)
    {
        Pstr=AmpmasterSWMute;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5733 set command error!!\n");
                break;
            }
            g_ucTas5733RegAddr = *(++Pstr);
            Pstr++;

            if (MApi_SWI2C_WriteBytes(TAS5733_BUSID,1, &g_ucTas5733RegAddr, DataLength, Pstr) == FALSE)
                printf("5733write fail = %d\n",g_ucTas5733RegAddr);

            MsOS_DelayTask(2);
            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);
    }
    else
    {
        Pstr=AmpmasterSWUnMute;
        do
        {
            DataLength = *Pstr;
            if(DataLength>20)
            {
                printf("5733 set command error!!\n");
                break;
            }
            g_ucTas5733RegAddr = *(++Pstr);
            Pstr++;

            if (MApi_SWI2C_WriteBytes(TAS5733_BUSID,1, &g_ucTas5733RegAddr, DataLength, Pstr) == FALSE)
                printf("5733write fail = %d\n",g_ucTas5733RegAddr);

            MsOS_DelayTask(2);
            Pstr = Pstr + DataLength;
        }while(*Pstr != 0);
    }
    return TRUE;
}


MAPI_BOOL Amplifier_TI5733_Mute(MAPI_BOOL bMute)
{
    // TODO: HW no use
    return TRUE;
}

MAPI_BOOL Amplifier_TI5733_StandBy(MAPI_U8 u8Para)
{
    if(u8Para == FALSE)
    {
        Adj_Volume_Off();
    }
    else
    {
        Adj_Volume_On();
    }
    return TRUE;
}

MAPI_BOOL Amplifier_TI5733_Reset(MAPI_U8 u8Para)
{
    if(u8Para == FALSE)
    {
        Audio_Amplifier_OFF();
    }
    else
    {
        Audio_Amplifier_ON();
    }
    return TRUE;
}

