/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

//****************************************************
// TCON Drive Chip           : Panasonic_TCON_Driver
// TCON Excel CodeGen Version: 1.05
// TCON Excel SW      Version: 1.00
// TCON Excel update date    : 2013-11-7 16:49
//****************************************************

#ifndef _DRVTCON_TBL_C_
#define _DRVTCON_TBL_C_
//****************************************************
// Init  Eagle_Skyworth_T420HVD01
//****************************************************
MS_U8 MST_TCON_Init_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_Init_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_CLK_GEN_53_L), 0x0F, 0x0C/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_53_H), 0x0F, 0x0C/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_5B_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_5B_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_5E_L), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_5E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_57_L), 0x0F, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_LPLL_00_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_LPLL_04_L), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_LPLL_04_H), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_L), 0xFF, 0x70/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_01_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_01_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_02_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_02_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_03_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_03_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_04_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_04_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_05_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_05_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_06_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_06_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_07_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_07_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_08_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_08_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_09_L), 0xFF, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_09_H), 0xFF, 0x30/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0A_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0C_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0E_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0F_L), 0xFF, 0x20/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_10_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_10_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_11_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_11_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_12_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_12_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_13_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_13_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_14_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_14_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_15_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_15_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_16_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_16_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_17_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_17_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_18_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_18_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_19_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_19_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1A_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1C_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1C_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1E_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1E_H), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_20_L), 0xFF, 0xE2/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_20_H), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_21_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_21_H), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_22_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_22_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_23_L), 0xFF, 0xF0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_23_H), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_24_L), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_24_H), 0xFF, 0x50/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_25_L), 0xFF, 0x4A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_25_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_26_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_26_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_27_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_27_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_28_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_28_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_29_L), 0xFF, 0x80/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_29_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2A_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2A_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2B_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2B_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2C_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2C_H), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2D_L), 0xFF, 0x0A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_30_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_30_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_31_L), 0xFF, 0xA0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_31_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_32_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_32_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_33_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_33_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_34_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_34_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_35_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_35_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_36_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_36_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_37_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_37_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_38_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_38_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_39_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_39_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3A_L), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3A_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3B_L), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3B_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3C_L), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3C_H), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3D_L), 0xFF, 0x4E/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3D_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_40_L), 0xFF, 0xD0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_40_H), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_41_L), 0xFF, 0xD0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_41_H), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_42_L), 0xFF, 0xD0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_42_H), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_43_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_43_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_44_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_44_H), 0xFF, 0x50/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_45_L), 0xFF, 0x3F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_45_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_46_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_46_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_47_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_47_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_48_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_48_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_49_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_49_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4A_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4C_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4C_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4D_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4E_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4F_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_50_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_50_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_51_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_51_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_52_L), 0xFF, 0x41/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_52_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_53_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_53_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_54_L), 0xFF, 0xE2/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_54_H), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_55_L), 0xFF, 0xC5/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_55_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_56_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_56_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_57_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_57_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_58_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_58_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_59_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_59_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5A_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5A_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5B_L), 0xFF, 0x11/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5B_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5C_L), 0xFF, 0xD0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5C_H), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5D_L), 0xFF, 0xD0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5D_H), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5E_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5E_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5F_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5F_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_60_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_60_H), 0xFF, 0xF1/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_61_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_61_H), 0xFF, 0xF1/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_62_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_62_H), 0xFF, 0x80/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_63_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_63_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_64_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_64_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_65_L), 0xFF, 0x60/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_65_H), 0xFF, 0xF1/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_66_L), 0xFF, 0x60/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_66_H), 0xFF, 0xF1/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_67_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_67_H), 0xFF, 0x80/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_68_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_68_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_69_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_69_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6A_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6A_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6B_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6B_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6C_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6C_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6D_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6D_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6E_L), 0xFF, 0x6A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6E_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6F_L), 0xFF, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6F_H), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_70_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_70_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_71_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_71_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_72_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_72_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_73_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_73_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_74_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_74_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_75_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_75_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_76_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_76_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_77_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_77_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_78_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_78_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_79_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_79_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7C_H), 0xFF, 0x20/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7F_L), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_01_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_01_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_02_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_02_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_03_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_03_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_04_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_04_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_05_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_05_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_06_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_06_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_07_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_07_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_08_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_08_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_09_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_09_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0A_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0B_L), 0xFF, 0x4A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0B_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0D_L), 0xFF, 0x26/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0E_L), 0xFF, 0x20/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0E_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0F_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0F_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_10_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_10_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_11_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_11_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_12_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_12_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_13_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_13_H), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_14_L), 0xFF, 0x0A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_14_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_15_L), 0xFF, 0x1F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_15_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_16_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_16_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_17_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_17_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_18_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_18_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_19_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_19_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1A_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1A_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1B_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1B_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1C_H), 0xFF, 0x80/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1E_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_20_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_20_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_21_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_21_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_22_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_22_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_23_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_23_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_24_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_24_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_25_L), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_25_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_26_L), 0xFF, 0x4A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_26_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_27_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_27_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_28_L), 0xFF, 0xE9/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_28_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_29_L), 0xFF, 0x33/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_29_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2A_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2A_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2B_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2B_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2C_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2C_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2D_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2D_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_30_L), 0xFF, 0x0A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_30_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_31_L), 0xFF, 0x4D/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_31_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_32_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_32_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_33_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_33_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_34_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_34_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_35_L), 0xFF, 0x80/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_35_H), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_36_L), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_36_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_37_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_37_H), 0xFF, 0x32/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_38_L), 0xFF, 0xE0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_38_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_39_L), 0xFF, 0xC2/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_39_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3B_H), 0xFF, 0x0C/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_40_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_40_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_41_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_41_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_42_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_42_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_43_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_43_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_44_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_44_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_45_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_45_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_46_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_46_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_47_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_47_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_48_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_48_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_49_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_49_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_50_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_50_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_51_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_51_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_52_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_52_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_53_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_53_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_54_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_54_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_55_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_55_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_56_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_56_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_57_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_57_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_58_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_58_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_59_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_59_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5C_L), 0xFF, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5C_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5D_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5D_H), 0xFF, 0xC6/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5E_L), 0xFF, 0x7F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5F_L), 0xFF, 0x14/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5F_H), 0xFF, 0xC8/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_60_L), 0xFF, 0x20/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_60_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_61_L), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_61_H), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_62_L), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_62_H), 0xFF, 0x20/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_63_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_63_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_64_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_64_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_65_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_65_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_66_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_66_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_67_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_67_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_68_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_68_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_69_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_69_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6F_H), 0xFF, 0xE0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_70_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_70_H), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_71_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_71_H), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_72_L), 0xFF, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_72_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_73_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_73_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_74_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_74_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_75_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_75_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_76_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_76_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_77_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_77_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_78_L), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_78_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_79_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_79_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TABLE_END)   , 0x00, 0x00,  }
};

//****************************************************
// Init_GPIO  Eagle_Skyworth_T420HVD01
//****************************************************
MS_U8 MST_TCON_Init_GPIO_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_Init_GPIO_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_CHIP_TOP_5C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TABLE_END)   , 0x00, 0x00,  }
};

//****************************************************
// Init_SC  Eagle_Skyworth_T420HVD01
//****************************************************
MS_U8 MST_TCON_Init_SC_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_Init_SC_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_SC_BK10_21_H), 0x01, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_10_H), 0x80, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_02_L), 0xFF, 0x75/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_02_H), 0x07, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_03_L), 0xFF, 0x77/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_03_H), 0x0F, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_06_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_06_H), 0x0F, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_07_L), 0xFF, 0x37/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_07_H), 0x0F, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0A_H), 0x0F, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0B_L), 0xFF, 0x37/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0B_H), 0x0F, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0C_L), 0xFF, 0x97/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0C_H), 0x0F, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0D_L), 0xFF, 0x7D/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0D_H), 0x0F, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00 }
};

//****************************************************
// Init_MOD  Eagle_Skyworth_T420HVD01
//****************************************************
MS_U8 MST_TCON_Init_MOD_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_Init_MOD_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_MOD_BK00_7F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_01_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_01_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_02_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_02_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_03_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_03_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_04_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_04_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_05_L), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_05_H), 0xFF, 0x60/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_06_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_06_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_07_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_07_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_08_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_08_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_09_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_09_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0A_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0B_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0B_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_0F_H), 0xFF, 0xE8/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_10_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_10_H), 0xFF, 0x50/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_11_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_11_H), 0xFF, 0x64/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_12_L), 0xFF, 0x55/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_12_H), 0xFF, 0x61/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_13_L), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_13_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_14_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_14_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_15_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_15_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_16_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_16_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_17_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_17_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_18_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_18_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_19_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_19_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1D_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1D_H), 0xFF, 0x20/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_1F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_20_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_20_H), 0xFF, 0x80/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_21_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_21_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_22_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_22_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_23_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_23_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_24_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_24_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_25_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_25_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_26_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_26_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_27_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_27_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_28_L), 0xFF, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_28_H), 0xFF, 0x30/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_29_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_29_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_30_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_30_H), 0xFF, 0xE0/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_31_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_31_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_32_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_32_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_33_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_33_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_34_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_34_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_35_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_35_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_36_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_36_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_37_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_37_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_38_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_38_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_39_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_39_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3B_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3B_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3E_L), 0xFF, 0x0D/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3E_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_40_L), 0xFF, 0x4D/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_40_H), 0xFF, 0xD3/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_41_L), 0xFF, 0x34/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_41_H), 0xFF, 0x4D/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_42_L), 0xFF, 0xD3/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_42_H), 0xFF, 0x34/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_43_L), 0xFF, 0x4D/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_43_H), 0xFF, 0xD3/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_44_L), 0xFF, 0x34/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_44_H), 0xFF, 0x4D/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_45_L), 0xFF, 0xD3/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_45_H), 0xFF, 0x34/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_46_L), 0xFF, 0x4D/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_46_H), 0xFF, 0xD3/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_47_L), 0xFF, 0x34/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_47_H), 0xFF, 0x4D/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_48_L), 0xFF, 0xD3/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_48_H), 0xFF, 0x34/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_49_L), 0xFF, 0x4D/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_49_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_50_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_50_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_51_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_51_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_52_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_52_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_53_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_53_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_54_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_54_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_55_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_55_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_56_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_56_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_57_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_57_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_58_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_58_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_59_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_59_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5A_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5A_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5B_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5B_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5C_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_5F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_60_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_60_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_61_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_61_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_62_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_62_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_63_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_63_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_64_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_64_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_65_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_65_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_66_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_66_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_67_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_67_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_68_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_68_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_69_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_69_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_70_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_70_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_71_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_71_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_72_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_72_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_73_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_73_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_74_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_74_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_75_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_75_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_76_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_76_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_77_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_77_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_78_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_78_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_79_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_79_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_7E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_00_L), 0x01, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_00_H), 0x01, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_00_L), 0x01, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_00_H), 0x01, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00 }
};

//****************************************************
// Gamma  Eagle_Skyworth_T420HVD01
//****************************************************
MS_U8 MST_TCON_Gamma_TBL[][4] =
{               // Reg           Value  Value
 { DRV_TCON_REG(REG_GAMMA_00), 0xCF, 0x83, },
 { DRV_TCON_REG(REG_GAMMA_01), 0xB6, 0x83, },
 { DRV_TCON_REG(REG_GAMMA_02), 0x2F, 0x83, },
 { DRV_TCON_REG(REG_GAMMA_03), 0xC3, 0x82, },
 { DRV_TCON_REG(REG_GAMMA_04), 0x86, 0x82, },
 { DRV_TCON_REG(REG_GAMMA_05), 0x24, 0x82, },
 { DRV_TCON_REG(REG_GAMMA_06), 0x23, 0x82, },
 { DRV_TCON_REG(REG_GAMMA_07), 0xF4, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_08), 0xF6, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_09), 0x50, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_0A), 0x14, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_0B), 0xBA, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_0C), 0x2D, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_0D), 0x13, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_0E), 0x28, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_0F), 0x0E, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_10), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_11), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_12), 0xB1, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_13), 0xB1, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_14), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_15), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_16), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_17), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_18), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_19), 0x00, 0x80, },
 {  DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00  }
};

//****************************************************
// Power_Sequence_On  Eagle_Skyworth_T420HVD01
//****************************************************
MS_U8 MST_TCON_Power_Sequence_On_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_Power_Sequence_On_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_TCON_61_L), 0xB9, 0x00/*ALL*/,
                                         1/*Delay_Ready*/,
                                         5/*Delay_Time*/,
                                         TCON_SIGNAL_POL_YOE_OE2_YCLK_STB/*Signal_Type*/, },
 { DRV_TCON_REG(REG_TCON_61_L), 0x06, 0x00/*ALL*/,
                                         0/*Delay_Ready*/,
                                         0/*Delay_Time*/,
                                         TCON_SIGNAL_YDIO1_YDIO2/*Signal_Type*/, },
 { DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00, TCON_SIGNAL_NUMS }
};

//****************************************************
// Power_Sequence_Off  Eagle_Skyworth_T420HVD01
//****************************************************
MS_U8 MST_TCON_Power_Sequence_Off_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_Power_Sequence_Off_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_TCON_61_L), 0x06, 0x06/*ALL*/,
                                         0/*Delay_Ready*/,
                                         0/*Delay_Time*/,
                                         TCON_SIGNAL_YDIO1_YDIO2/*Signal_Type*/, },
 { DRV_TCON_REG(REG_TCON_61_L), 0xB9, 0xB9/*ALL*/,
                                         0/*Delay_Ready*/,
                                         0/*Delay_Time*/,
                                         TCON_SIGNAL_POL_YOE_OE2_YCLK_STB/*Signal_Type*/, },
 { DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00, TCON_SIGNAL_NUMS }
};
//****************************************************
// Init  AUO_T420HVN06
//****************************************************
MS_U8 MST_TCON_AUO_T420HVN06_Init_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_AUO_T420HVN06_Init_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_CLK_GEN_53_L), 0xFF, 0x1C/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_53_H), 0xFF, 0x1C/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_57_L), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_57_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_CLK_GEN_7E_H), 0x03, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_01_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_01_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_02_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_02_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_03_L), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_03_H), 0xFF, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_04_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_04_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_05_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_05_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_06_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_06_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_07_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_07_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_08_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_08_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_09_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_09_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0A_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0A_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0B_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0B_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0D_L), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0E_L), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0F_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_10_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_10_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_11_L), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_11_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_12_L), 0xFF, 0x0B/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_12_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_13_L), 0xFF, 0x7E/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_13_H), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_14_L), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_14_H), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_15_L), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_15_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_16_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_16_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_17_L), 0xFF, 0x3A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_17_H), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_18_L), 0xFF, 0x72/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_18_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_19_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_19_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1A_L), 0xFF, 0x55/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1A_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1B_L), 0xFF, 0xA4/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1B_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1C_L), 0xFF, 0x87/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1C_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1D_L), 0xFF, 0x56/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1D_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1E_L), 0xFF, 0x57/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1E_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1F_L), 0xFF, 0x95/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1F_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_20_L), 0xFF, 0x75/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_20_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_21_L), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_21_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_22_L), 0xFF, 0x44/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_22_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_23_L), 0xFF, 0x58/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_23_H), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_24_L), 0xFF, 0x1E/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_24_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_25_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_25_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_26_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_26_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_27_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_27_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_28_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_28_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_29_L), 0xFF, 0x09/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_29_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2A_L), 0xFF, 0x0A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2A_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2B_L), 0xFF, 0x75/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2B_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2C_L), 0xFF, 0x75/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2C_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2D_L), 0xFF, 0x55/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2D_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2E_L), 0xFF, 0x56/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2E_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_2F_H), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_30_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_30_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_31_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_31_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_32_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_32_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_33_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_33_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_34_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_34_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_35_L), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_35_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_36_L), 0xFF, 0x3D/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_36_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_37_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_37_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_38_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_38_H), 0xFF, 0x26/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_39_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_39_H), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3A_H), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3C_L), 0xFF, 0x18/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3E_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3E_H), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_3F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_40_L), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_40_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_41_L), 0xFF, 0x3E/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_41_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_42_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_42_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_43_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_43_H), 0xFF, 0x26/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_44_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_44_H), 0xFF, 0xF0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_45_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_45_H), 0xFF, 0xD0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_46_L), 0xFF, 0x70/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_46_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_47_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_47_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_48_L), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_48_H), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_49_L), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_49_H), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4A_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4B_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4C_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4C_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4F_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_4F_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_50_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_50_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_51_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_51_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_52_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_52_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_53_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_53_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_54_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_54_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_55_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_55_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_56_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_56_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_57_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_57_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_58_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_58_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_59_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_59_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5A_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5A_H), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5B_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5B_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5C_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5C_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5D_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5D_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5E_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5E_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5F_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_5F_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_60_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_60_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_61_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_61_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_62_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_62_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_63_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_63_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_64_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_64_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_65_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_65_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_66_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_66_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_67_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_67_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_68_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_68_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_69_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_69_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6A_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6A_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6B_L), 0xFF, 0x90/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6B_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6C_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6C_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6D_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6D_H), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_6F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_70_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_70_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_71_L), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_71_H), 0xFF, 0x30/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_72_L), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_72_H), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_73_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_73_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_74_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_74_H), 0xFF, 0x3F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_75_L), 0xFF, 0x18/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_75_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_76_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_76_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_77_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_77_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_78_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_78_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_79_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_79_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7C_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7C_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7D_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7E_L), 0xFF, 0xE4/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7F_L), 0xFF, 0xFE/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_7F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_L), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_01_L), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_01_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_02_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_02_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_03_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_03_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_04_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_04_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_05_L), 0xFF, 0x80/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_05_H), 0xFF, 0x07/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_06_L), 0xFF, 0x0F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_06_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_07_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_07_H), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_08_L), 0xFF, 0xE0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_08_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_09_L), 0xFF, 0xC2/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_09_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0D_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0D_H), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0E_L), 0xFF, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0E_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0F_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_0F_H), 0xFF, 0xC3/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_10_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_10_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_11_L), 0xFF, 0x14/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_11_H), 0xFF, 0xC8/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_12_L), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_12_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_13_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_13_H), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_14_L), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_14_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_15_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_15_H), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_16_L), 0xFF, 0x20/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_16_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_17_L), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_17_H), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_18_L), 0xFF, 0x12/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_18_H), 0xFF, 0x20/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_19_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_19_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1B_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1B_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1E_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1E_H), 0xFF, 0x80/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1F_L), 0xFF, 0x4A/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_1F_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_20_L), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_20_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_21_L), 0xFF, 0x7F/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_21_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_26_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_26_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_27_L), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_27_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_28_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_28_H), 0xFF, 0x60/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_29_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_29_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TCON_00_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_LPLL_04_L), 0x1F, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_LPLL_04_H), 0x1F, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_TABLE_END)   , 0x00, 0x00,  }
};

//****************************************************
// Init_GPIO  AUO_T420HVN06
//****************************************************
MS_U8 MST_TCON_AUO_T420HVN06_Init_GPIO_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_AUO_T420HVN06_Init_GPIO_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_CHIP_TOP_79_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_CHIP_TOP_79_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_CHIP_TOP_7A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_CHIP_TOP_7A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_TABLE_END)   , 0x00, 0x00,  }
};

//****************************************************
// Init_SC  AUO_T420HVN06
//****************************************************
MS_U8 MST_TCON_AUO_T420HVN06_Init_SC_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_AUO_T420HVN06_Init_SC_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_SC_BK10_21_L), 0x01, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_21_H), 0x01, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_10_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_10_H), 0xFF, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_02_L), 0xFF, 0xFE/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_02_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_03_L), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_03_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_06_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_06_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_07_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_07_H), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0B_L), 0xFF, 0xF2/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0B_H), 0xFF, 0x02/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0C_L), 0xFF, 0xC7/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0C_H), 0xFF, 0x06/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0D_L), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_SC_BK10_0D_H), 0xFF, 0x04/*ALL*/, },
 { DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00 }
};

//****************************************************
// Init_MOD  AUO_T420HVN06
//****************************************************
MS_U8 MST_TCON_AUO_T420HVN06_Init_MOD_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_AUO_T420HVN06_Init_MOD_NUMS]=
{                 // Reg           Mask  Value
{ DRV_TCON_REG(REG_MOD_BK00_20_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_20_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_29_L), 0xFF, 0xF0/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_29_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2A_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2A_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2B_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2B_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2C_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2C_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2D_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2D_H), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2E_L), 0xFF, 0xFF/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2E_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2F_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_2F_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_30_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_30_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_31_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_31_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_32_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_32_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_33_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_33_H), 0xFF, 0xC0/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_34_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_34_H), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_37_L), 0xFF, 0x40/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_37_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_38_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_38_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3E_L), 0xFF, 0x08/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_3E_H), 0xFF, 0x44/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_40_L), 0xFF, 0x28/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_40_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_42_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_42_H), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_45_L), 0xFF, 0x3F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_45_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_48_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_48_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_49_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_49_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4A_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_4A_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6D_L), 0xFF, 0x95/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6D_H), 0xFF, 0x55/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6E_L), 0xFF, 0x65/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_6E_H), 0xFF, 0x05/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_73_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_73_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_77_L), 0xFF, 0x1F/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_77_H), 0xFF, 0x03/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_78_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_78_H), 0xFF, 0x01/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_42_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_42_H), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_42_L), 0xFF, 0x00/*ALL*/, },
 { DRV_TCON_REG(REG_MOD_BK00_42_H), 0xFF, 0x10/*ALL*/, },
 { DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00 }
};

//****************************************************
// Gamma  AUO_T420HVN06
//****************************************************
MS_U8 MST_TCON_AUO_T420HVN06_Gamma_TBL[][4] =
{               // Reg           Value  Value
 { DRV_TCON_REG(REG_GAMMA_00), 0xA8, 0x83, },
 { DRV_TCON_REG(REG_GAMMA_01), 0x6D, 0x83, },
 { DRV_TCON_REG(REG_GAMMA_02), 0xFF, 0x82, },
 { DRV_TCON_REG(REG_GAMMA_03), 0xCA, 0x82, },
 { DRV_TCON_REG(REG_GAMMA_04), 0x98, 0x82, },
 { DRV_TCON_REG(REG_GAMMA_05), 0x0E, 0x82, },
 { DRV_TCON_REG(REG_GAMMA_06), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_07), 0xFA, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_08), 0xA9, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_09), 0x27, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_0A), 0xF0, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_0B), 0xAD, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_0C), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_0D), 0x42, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_0E), 0xD6, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_0F), 0xFF, 0x83, },
 { DRV_TCON_REG(REG_GAMMA_10), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_11), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_12), 0x82, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_13), 0x82, 0x81, },
 { DRV_TCON_REG(REG_GAMMA_14), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_15), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_16), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_17), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_18), 0x00, 0x80, },
 { DRV_TCON_REG(REG_GAMMA_19), 0x00, 0x80, },
 {  DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00  }
};

//****************************************************
// Power_Sequence_On  AUO_T420HVN06
//****************************************************
MS_U8 MST_TCON_AUO_T420HVN06_Power_Sequence_On_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_AUO_T420HVN06_Power_Sequence_On_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_TCON_61_L), 0x33, 0x00/*ALL*/,
                                         1/*Delay_Ready*/,
                                         5/*Delay_Time*/,
                                         TCON_SIGNAL_AUO_T420HVN06_POLL_POLR_CPV_TP1/*Signal_Type*/, },
 { DRV_TCON_REG(REG_TCON_61_L), 0x08, 0x00/*ALL*/,
                                         0/*Delay_Ready*/,
                                         0/*Delay_Time*/,
                                         TCON_SIGNAL_AUO_T420HVN06_STV/*Signal_Type*/, },
 { DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00, TCON_SIGNAL_AUO_T420HVN06_NUMS }
};

//****************************************************
// Power_Sequence_Off  AUO_T420HVN06
//****************************************************
MS_U8 MST_TCON_AUO_T420HVN06_Power_Sequence_Off_TBL[][REG_ADDR_SIZE+REG_MASK_SIZE+TCON_TAB_AUO_T420HVN06_Power_Sequence_Off_NUMS]=
{                 // Reg           Mask  Value
 { DRV_TCON_REG(REG_TCON_61_L), 0x08, 0x08/*ALL*/,
                                         0/*Delay_Ready*/,
                                         0/*Delay_Time*/,
                                         TCON_SIGNAL_AUO_T420HVN06_STV/*Signal_Type*/, },
 { DRV_TCON_REG(REG_TCON_61_L), 0x33, 0x33/*ALL*/,
                                         0/*Delay_Ready*/,
                                         0/*Delay_Time*/,
                                         TCON_SIGNAL_AUO_T420HVN06_POLL_POLR_CPV_TP1/*Signal_Type*/, },
 { DRV_TCON_REG(REG_TABLE_END) , 0x00, 0x00, TCON_SIGNAL_AUO_T420HVN06_NUMS }
};

TCON_TAB_INFO TConMAP_Main[TCON_PANEL_NUMS]=
{
{
*MST_TCON_AUO_T420HVN06_Init_TBL, TCON_TABTYPE_GENERAL,
*MST_TCON_AUO_T420HVN06_Init_GPIO_TBL, TCON_TABTYPE_GPIO,
*MST_TCON_AUO_T420HVN06_Init_SC_TBL, TCON_TABTYPE_SCALER,
*MST_TCON_AUO_T420HVN06_Init_MOD_TBL, TCON_TABTYPE_MOD,
*MST_TCON_AUO_T420HVN06_Gamma_TBL, TCON_TABTYPE_GAMMA,
*MST_TCON_AUO_T420HVN06_Power_Sequence_On_TBL, TCON_TABTYPE_POWER_SEQUENCE_ON,
*MST_TCON_AUO_T420HVN06_Power_Sequence_Off_TBL, TCON_TABTYPE_POWER_SEQUENCE_OFF,
},
{
*MST_TCON_Init_TBL, TCON_TABTYPE_GENERAL,
*MST_TCON_Init_GPIO_TBL, TCON_TABTYPE_GPIO,
*MST_TCON_Init_SC_TBL, TCON_TABTYPE_SCALER,
*MST_TCON_Init_MOD_TBL, TCON_TABTYPE_MOD,
*MST_TCON_Gamma_TBL, TCON_TABTYPE_GAMMA,
*MST_TCON_Power_Sequence_On_TBL, TCON_TABTYPE_POWER_SEQUENCE_ON,
*MST_TCON_Power_Sequence_Off_TBL, TCON_TABTYPE_POWER_SEQUENCE_OFF,
},
};

#endif
