/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef _DRVTCON_VCOM_C_
#define _DRVTCON_VCOM_C_

#include "panel/pnl_tcon_vcom.h"

#include <MsTypes.h>
#include <apiSWI2C.h>
#include <common.h>
#include <MsDebug.h>
#include <mstarstr.h>


#if defined(CONFIG_UPDATE_VCOM_DATA_ENABLE)

#if ENABLE_RT6919C
//****************************************************
// Init  RT6919C
//****************************************************

MS_BOOL CompareGammaIC(MS_U8 *pdata, int size)
{
    UBOOT_TRACE("IN\n");

    MS_U8 u8Addr;
    MS_U8 u8DataBufR;

    u8Addr = 0xFF;
    u8DataBufR = 0x01;
    MApi_SWI2C_ReadBytes(I2C_DEV_GAMMA_IC, 1, &u8Addr, 1, &u8DataBufR);

    u8Addr = 0x00;
    MS_U8 tmpDAC[size];

    MApi_SWI2C_ReadBytes(I2C_DEV_GAMMA_IC, 1, &u8Addr, size, tmpDAC);

    int i;
    for (i=0; i<size; i++)
    {
        if(tmpDAC[i] == pdata[i])
            continue;
        else
            return FALSE;
    }

    UBOOT_TRACE("OK\n");
    return TRUE;
}
void devPanel_InitGammaIC(U8 *pData, int size)
{
    UBOOT_TRACE("IN\n");

    MS_U8 u8Addr;
    MS_U8 u8DataBufW;
    u8Addr = 0x00;
    MApi_SWI2C_WriteBytes(I2C_DEV_GAMMA_IC, 1, &u8Addr, size, pData);

    u8Addr = 0xFF;
    u8DataBufW = 0x80;
    MApi_SWI2C_WriteBytes(I2C_DEV_GAMMA_IC, 1, &u8Addr, size, &u8DataBufW);

    UBOOT_TRACE("OK\n");
}
#else
//other vcom add here
#endif
#endif
#endif
