//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>

#ifndef __DRV_URSA_20_H__
#define __DRV_URSA_20_H__

#include <MsTypes.h>
#include <apiSWI2C.h>
#include <common.h>
#include <MsDebug.h>

#define MFC_CMD_DATA_SUM      7
#define URSA_IMG_SCM_VERSION_LEN 3
//-------------------------------------------------------------------------------------------------
//  struction define
//-------------------------------------------------------------------------------------------------
typedef struct ursa_img_header {
    MS_U32     u32StartMagic;                          // Start Magic number
    MS_U16     u16PackInfoFlashBankNo;                 // Flash bank No of pack information
    MS_U16     u16PackInfoFlashOffset;                 // Flash offset of pack information
    MS_U32     u32Length;
    MS_U32     u32OUI;                                  // OUI or manufacturer id
    MS_U16     u16HW_Model;                             // HW Model
    MS_U16     u16HW_Version;                           // HW Version
    MS_U16     u16SW_Model;                             // SW Model
    MS_U16     u16SW_Version;                           // SW Version
    // 24
    MS_U8      au8SCM_Version[URSA_IMG_SCM_VERSION_LEN];     // 3  // SCM Version, Majaor, Minor, Minor_2
} ursa_img_header_t;

#if defined(CONFIG_URSA20_SYSBIN)
typedef struct
{
    MS_U32 u32ID;
    MS_U32 u32Value;
} SysBin_DataFormat;

typedef enum
{
    E_URSA_SYS_BIN_U7_BIN_VERSION = 1,
    E_URSA_SYS_BIN_BACKLIGHT_PWM_CH_SEL,
    E_URSA_SYS_BIN_BACKLIGHT_PWM_POLARITY,
    E_URSA_SYS_BIN_BACKLIGHT_PWM_DUTY,
    E_URSA_SYS_BIN_BACKLIGHT_PWM_SHIFT,
    E_URSA_SYS_BIN_3D_GLASSES_USE_PWM_CH,
    E_URSA_SYS_BIN_3D_GLASSES_USE_PWM_PERIOD_N_VSYNC,
    E_URSA_SYS_BIN_3D_GLASSES_USE_PWM_SHIFT,

    E_URSA_SYS_BIN_RX_MODE_SEL = 500,
    E_URSA_SYS_BIN_LVDS_RX_TYPE,
    E_URSA_SYS_BIN_LVDS_RX_CHCONNECT,
    E_URSA_SYS_BIN_LVDS_RX_DATASEL,
    E_URSA_SYS_BIN_LVDS_RX_BIT_NUM,
    E_URSA_SYS_BIN_LVDS_RX_TI_MODE,
    E_URSA_SYS_BIN_LVDS_RX_SWAP_ODD_EVEN,
    E_URSA_SYS_BIN_LVDS_RX_SWAP_MSB_LSB,
    E_URSA_SYS_BIN_LVDS_RX_SWAP_P_N,
    E_URSA_SYS_BIN_LVDS_RX_HSLVDS_SWAP_P_N,
    E_URSA_SYS_BIN_LVDS_PIN_SEQ_SWAP,

    E_URSA_SYS_BIN_VBY1_RX_VIDEO_LANE_NUM = 520,
    E_URSA_SYS_BIN_VBY1_RX_VIDEO_H_SYNC_REVERSE,
    E_URSA_SYS_BIN_VBY1_RX_VIDEO_V_SYNC_REVERSE,

    E_URSA_SYS_BIN_VBY1_RX_OSD_LANE_NUM = 525,
    E_URSA_SYS_BIN_VBY1_RX_OSD_H_SYNC_REVERSE,
    E_URSA_SYS_BIN_VBY1_RX_OSD_V_SYNC_REVERSE,

    E_URSA_SYS_BIN_VBY1_RX_DATA_SEL_1 = 530,
    E_URSA_SYS_BIN_VBY1_RX_DATA_SEL_2,
    E_URSA_SYS_BIN_VBY1_RX_DATA_SEL_3,
    E_URSA_SYS_BIN_VBY1_RX_DATA_SEL_4,
    E_URSA_SYS_BIN_VBY1_RX_DATA_SEL_5,

    E_URSA_SYS_BIN_VBY1_RX_DATA_SWAP = 540,
    E_URSA_SYS_BIN_VBY1_RX_DATA_REVERSE,
    E_URSA_SYS_BIN_VBY1_RX_BYTE_MODE,
    E_URSA_SYS_BIN_VBY1_RX_VIDEO_BYTE_MODE,
    E_URSA_SYS_BIN_VBY1_RX_OSD_BYTE_MODE,
    E_URSA_SYS_BIN_RX_LR_MODE,
    E_URSA_SYS_BIN_HDMI_DEFAULT_EQ,
    E_URSA_SYS_BIN_OSD_DATA_FORMAT,

    E_URSA_SYS_BIN_MEMC_LEVEL = 560,
    E_URSA_SYS_BIN_MIU_SSC_ENABLE,
    E_URSA_SYS_BIN_MIU_SSC_SPAN_DEFAULT,
    E_URSA_SYS_BIN_MIU_SSC_STEP_DEFAULT,
    E_URSA_SYS_BIN_MFC_ENABLE_LVDS_SSC,
    E_URSA_SYS_BIN_MFC_LVDS_SSC_SPAN_DEFAULT,
    E_URSA_SYS_BIN_MFC_LVDS_SSC_STEP_DEFAULT,
    E_URSA_SYS_BIN_MOD_POWER_ON_MODE,

    E_URSA_SYS_BIN_CUS_GPIO_SETTING1 = 570,
    E_URSA_SYS_BIN_CUS_GPIO_SETTING2,
    E_URSA_SYS_BIN_CUS_GPIO_SETTING3,

    E_URSA_SYS_BIN_RGB_BYPASS_EN = 580,
    E_URSA_SYS_BIN_OSD_COLOR_KEY_ENABLE,
    E_URSA_SYS_BIN_OSD_COLOR_KEY_RGBA,
    E_URSA_SYS_BIN_OSD_COLOR_KEY_ENABLE2,
    E_URSA_SYS_BIN_OSD_COLOR_KEY_RGBA2,

    E_URSA_SYS_BIN_OSD_ENABLE = 590,
    E_URSA_SYS_BIN_INPUT_OSD_TIMMING_HACTIVE,
    E_URSA_SYS_BIN_INPUT_OSD_TIMMING_VACTIVE,
    E_URSA_SYS_BIN_INPUT_VIDEO_TIMMING_HACTIVE,
    E_URSA_SYS_BIN_INPUT_VIDEO_TIMMING_VACTIVE,

    E_URSA_SYS_BIN_CUS_HDCP22_KEY_SIZE = 600,

    E_URSA_SYS_BIN_3D_PANEL_TYPE = 1000,

    E_URSA_SYS_BIN_LVDS_TX_PANEL_TYPE = 1002,

    E_URSA_SYS_BIN_MASK_HS = 1004,
    E_URSA_SYS_BIN_MASK_VS,
    E_URSA_SYS_BIN_MASK_DE,
    E_URSA_SYS_BIN_PANEL_INV_HSYNC,
    E_URSA_SYS_BIN_PANEL_INV_VSYNC,
    E_URSA_SYS_BIN_PANEL_INV_DE,
    E_URSA_SYS_BIN_LVDS_TX_BIT_NUMBER,
    E_URSA_SYS_BIN_LVDS_TX_CHANNEL_NUMBER,
    E_URSA_SYS_BIN_CUS_ODCLK_DIV_2_MODE,
    E_URSA_SYS_BIN_LVDS_TX_CHANNEL_SWAP_CHANNEL,
    E_URSA_SYS_BIN_DITHER_EN,
    E_URSA_SYS_BIN_DITHER_8BITS,
    E_URSA_SYS_BIN_LVDS_TX_TI_MODE,
    E_URSA_SYS_BIN_LVDS_TX_SWAP_PAIR,
    E_URSA_SYS_BIN_LVDS_TX_SHIFT_PAIR,
    E_URSA_SYS_BIN_SWAP_LR,
    E_URSA_SYS_BIN_LVDS_TX_SWAP_POL,
    E_URSA_SYS_BIN_PANEL_SEQ_TYPE,

    E_URSA_SYS_BIN_PANEL_CHANNEL_CONNECT_00_03 = 1030,
    E_URSA_SYS_BIN_PANEL_CHANNEL_CONNECT_04_07,
    E_URSA_SYS_BIN_PANEL_CHANNEL_CONNECT_08_11,
    E_URSA_SYS_BIN_PANEL_CHANNEL_CONNECT_12_15,
    E_URSA_SYS_BIN_PANEL_CHANNEL_CONNECT_16_19,
    E_URSA_SYS_BIN_PANEL_CHANNEL_CONNECT_20_23,
    E_URSA_SYS_BIN_PANEL_CHANNEL_CONNECT_24_27,
    E_URSA_SYS_BIN_PANEL_CHANNEL_CONNECT_28_31,

    E_URSA_SYS_BIN_LVDS_TX_HSTART = 1100,
    E_URSA_SYS_BIN_LVDS_TX_VSTART,
    E_URSA_SYS_BIN_LVDS_TX_HACTIVE, //WIDTH
    E_URSA_SYS_BIN_LVDS_TX_VACTIVE, //HEIGHT
    E_URSA_SYS_BIN_LVDS_TX_HTOTAL,
    E_URSA_SYS_BIN_LVDS_TX_VTOTAL,
    E_URSA_SYS_BIN_LVDS_TX_PANEL_VFREQ,
    E_URSA_SYS_BIN_LVDS_TX_VTOTAL_MAX,
    E_URSA_SYS_BIN_LVDS_TX_VTOTAL_MIN,

    E_URSA_SYS_BIN_PANEL_HSTART_SPECIAL = 1120,
    E_URSA_SYS_BIN_PANEL_VSTART_SPECIAL,
    E_URSA_SYS_BIN_PANEL_HACTIVE_SPECIAL, //WIDTH
    E_URSA_SYS_BIN_PANEL_VACTIVE_SPECIAL, //HEIGHT
    E_URSA_SYS_BIN_PANEL_HTOTAL_SPECIAL,
    E_URSA_SYS_BIN_PANEL_VTOTAL_SPECIAL,
    E_URSA_SYS_BIN_PANEL_VFREQ_SPECIAL,
    E_URSA_SYS_BIN_PANEL_VTOTAL_MAX_SPECIAL,
    E_URSA_SYS_BIN_PANEL_VTOTAL_MIN_SPECIAL,

    E_URSA_SYS_BIN_LVDS_TX_INCREASE_VTOTAL_FOR_50HZ = 1150,
    E_URSA_SYS_BIN_PASSIVE_FIRST_LINE,
    E_URSA_SYS_BIN_PASSIVE_LINE_ORDER,
    E_URSA_SYS_BIN_ENABLE_MST_MIRROR_FUNC,
    E_URSA_SYS_BIN_DITHER_TAIL_CUT,
    E_URSA_SYS_BIN_CUS_PANEL_SWING_DATA,
    E_URSA_SYS_BIN_PANEL_ID,

    E_URSA_SYS_BIN_TYPE_MAX
}EN_URSA_SYS_BIN_TYPE;
#endif

//-------------------------------------------------------------------------------------------------
//  Function declare
//-------------------------------------------------------------------------------------------------
void MDrv_Ursa_20_SWI2C_Init(void);
MS_BOOL MDrv_Ursa_20_Set_Lane_VB1_per_init(MS_U8 u8OsdLane, MS_U8 u8VideoLane);
MS_BOOL MDrv_Ursa_20_Set_Lane_VB1(MS_U16 u16OsdWidth, MS_U16 u16VideoWidth);
#if defined(CONFIG_URSA_TXRX_SUPPORT)
MS_BOOL MDrv_Ursa_20_Panel_Initialize(void);
#endif
MS_BOOL MDrv_Ursa_20_SetModPowerOn(void);
MS_BOOL MDrv_Ursa_20_SetUrsaGpio(MS_U8 u8gpioID, MS_BOOL bOnOff);
MS_BOOL MDrv_Ursa_20_ReadUrsaGpio(MS_U8 u8gpioId);
void MDrv_Ursa_20_SetUrsaHardReset(void);
MS_BOOL ReadUrsaImageHeader(const uint8_t *image_addr, size_t image_size, ursa_img_header_t *image_header);
MS_U32 GetUrsa20VersionInfo(void);


#if defined(CONFIG_URSA20_SYSBIN) && defined(CONFIG_URSA_TXRX_SUPPORT)
MS_U32 MDrv_Ursa_20_GetMFCBinAddress(MS_U8 u8BinType);
MS_U16 MDrv_Ursa_20_GetMFCSysBinLen(); // unit: byte
MS_S32 MDrv_Ursa_20_GenMFCSysBin(MS_U8 *pu8Data);
#endif

#endif //__DRV_URSA_20_H__
