//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all 
// or part of MStar Software is expressly prohibited, unless prior written 
// permission has been granted by MStar. 
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.  
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software. 
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s 
//    confidential information in strictest confidence and not disclose to any
//    third party.  
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.  
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or 
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.  
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>

#ifndef __CUS_CONFIG_H__
#define __CUS_CONFIG_H__

//******** This part is for boot ********
#if(ENABLE_MODULE_ANDROID_BOOT == 1)
#define KL_PARTITION "boot"
#else
#define KL_PARTITION "KL"
#endif
#define TEE_PARTITION "tee"
#define SECKL_PARTITION "secKL"
//***************************************

#if (ENABLE_MODULE_ANDROID_BOOT == 1)
#define UBIPART  "ubi"
/*******************************************************************************
* 1,if CONFIG_PATH is null, you should put "boot0.mp3, boot0.jpg, boot.ini" to 
*   /tvconfig; otherwise, you should put these files to /tvconfig/CONFIG_PATH.
*
* 2,if CUSTOMER_PATH is null, you should put "sys.ini, mmap.ini" to /tvconfig
*   otherwise, you should put these files to /tvconfig/CUSTOMER_PATH.
*******************************************************************************/
#define CONFIG   "tvconfig"
#define CUSTOMER "tvconfig"
//#define CONFIG_PATH   ""
#define CONFIG_PATH   "/config"
#define CONFIG_PM_PATH   "/config/pm"
#define CUSTOMER_PATH  ""
#define CHECK_FLASH_EMPTY "tvconfig"
#define SET_ENV_PATITION "system"
#define SET_ENV_FILE "/etc/set_env"
//#define CUSTOMER_PATH  "/Customer"
#elif(ENABLE_STB_CONFIG_PARTITION==1)	// STB Partition Cfg.
  #define UBIPART               "UBI"
  #define CONFIG                "CON"
  #define CUSTOMER              "CON"
  #define CONFIG_PATH           ""
  #define CONFIG_PM_PATH        "/config/pm"
  #define CUSTOMER_PATH         "customer"
  #define CHECK_FLASH_EMPTY     "CON"
  #define SET_ENV_PATITION      "system"
  #define SET_ENV_FILE          "/etc/set_env"
#elif(CONFIG_MI_CONFIG_PARTITION==1)  //MI pure linux cfg
  #define UBIPART  "UBI"
  #define CONFIG   "tvconfig"
  #define CUSTOMER "tvconfig"
  #define CONFIG_PATH   "/config"
  #define CONFIG_PM_PATH "/config/pm"
  #define CUSTOMER_PATH  ""
  #define CHECK_FLASH_EMPTY "customerbackup"
  #define SET_ENV_PATITION "tvconfig"
  #define SET_ENV_FILE "/set_env"
#elif(ENABLE_CAST_CONFIG_PARTITION==1)  //Cast TV Partition Cfg
  #define UBIPART  "UBI"
  #define CONFIG   "CONFIG"
  #define CUSTOMER "CONFIG"
  #define CONFIG_PATH   ""
  #define CONFIG_PM_PATH "/config/pm"
  #define CUSTOMER_PATH  ""
  #define CHECK_FLASH_EMPTY "customerbackup"
  #define SET_ENV_PATITION "CONFIG"
  #define SET_ENV_FILE "/set_env"
#else
#define UBIPART  "UBI"
#define CONFIG   "CONFIG"
#define CUSTOMER "customer"
#define CONFIG_PATH   ""
#define CONFIG_PM_PATH "/config/pm"
#define CUSTOMER_PATH  ""
#define CHECK_FLASH_EMPTY "customerbackup"
#define SET_ENV_PATITION "CONFIG"
#define SET_ENV_FILE "/set_env"

#endif
#define CUSDATA   "cusdata"
#define CUSDATA_CUSTOMER_PATH  "Customer"
#define CUSDATA_CONFIG_PATH  "config"
#define ENV_CUSDATA  "E_CUSDATA_PATH"
#define ENV_CUSDATA_CUSTOMER_PATH  "E_CUSDATA_CUSTOMER_PATH"
#define ENV_CUSDATA_CONFIG_PATH  "E_CUSDATA_CONFIG_PATH"
#define ENV_PROJECTID_PARTITION "E_PROJECTID_PARTITION"

#if(ENABLE_MODULE_ANDROID_BOOT == 1)
#define CERTIFICATE                 "tvcertificate"
#else
#define CERTIFICATE                 "certificate"
#endif
#define CERTIFICATE_CONFIG_PATH     "config"

#if(ENABLE_MODULE_ANDROID_BOOT == 1)
#define OAD            "3rd_rw" //3rd_rw
#else
#define OAD            "oad"
#endif
#endif

