/*
 * idme_default_table.h
 *
 * Copyright 2011-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 */

/*!
 * @file idme_default_table.h
 * @brief This file contains idme default table values
 *  in the userstore partition
 *
 */

#ifndef __IDME_DEFAULT_TABLE_H__
#define __IDME_DEFAULT_TABLE_H__

#ifdef UFBL_PROJ_ARIEL
#include "idme_default_table_ariel.h"
#endif

#ifdef UFBL_PROJ_FORD
#include "idme_default_table_ford.h"
#endif

#ifdef UFBL_PROJ_AUSTIN
#include "idme_default_table_austin.h"
#endif

#ifdef UFBL_PROJ_TANK
#include "idme_default_table_tank.h"
#endif

#ifdef UFBL_PROJ_THEBES
#include "idme_default_table_thebes.h"
#endif

#ifdef UFBL_PROJ_MONTOYA
#include "idme_default_table_montoya.h"
#endif

#ifdef UFBL_PROJ_DRNO
#include "idme_default_table_drno.h"
#endif

#ifdef UFBL_PROJ_GIZA
#include "idme_default_table_giza.h"
#endif

#ifdef UFBL_PROJ_DOUGLAS
#include "idme_default_table_douglas.h"
#endif

#ifdef UFBL_PROJ_COGNAC
#include "idme_default_table_cognac.h"
#endif

#ifdef UFBL_PROJ_MARGO
#include "idme_default_table_margo.h"
#endif

#ifdef UFBL_PROJ_ALISON
#include "idme_default_table_alison.h"
#endif

#ifdef UFBL_PROJ_LEELA
#include "idme_default_table_leela.h"
#endif

#ifdef UFBL_PROJ_CLARA
#include "idme_default_table_clara.h"
#endif

#ifdef UFBL_PROJ_SOPHIA
#include "idme_default_table_sophia.h"
#endif

#ifdef UFBL_PROJ_SONAR
#include "idme_default_table_sonar.h"
#endif

#ifdef UFBL_PROJ_BISCUIT
#include "idme_default_table_biscuit.h"
#endif

#ifdef UFBL_PROJ_COOKIE
#include "idme_default_table_cookie.h"
#endif

#ifdef UFBL_PROJ_RADAR
#include "idme_default_table_radar.h"
#endif

#if defined(UFBL_PROJ_PIE) || defined(UFBL_PROJ_SHANNON)
/* Shannon is a prototype for Pie. It uses the same IDME table */
#include "idme_default_table_pie.h"
#endif

#ifdef UFBL_PROJ_FRANK
#include "idme_default_table_frank.h"
#endif

#if defined(UFBL_PROJ_NEEDLE) || defined(UFBL_PROJ_STARK)
#include "idme_default_table_needle.h"
#endif

#if defined(UFBL_PROJ_RAVEN)
#include "idme_default_table_raven.h"
#endif

#if defined(UFBL_PROJ_MANTIS)
#include "idme_default_table_mantis.h"
#endif


#if defined(UFBL_PROJ_BLANCHE)
#include "idme_default_table_blanche.h"
#endif

#ifdef UFBL_TESTS
#include "idme_default_table_tests.h"
#endif

#ifdef UFBL_PROJ_SUEZ
#include "idme_default_table_suez.h"
#endif

#ifdef UFBL_PROJ_KARNAK
#include "idme_default_table_karnak.h"
#endif

#ifdef UFBL_PROJ_MUSTANG
#include "idme_default_table_mustang.h"
#endif

#ifdef UFBL_PROJ_CHECKERS
#include "idme_default_table_checkers.h"
#endif

#ifdef UFBL_PROJ_DOLPHIN
#include "idme_default_table_dolphin.h"
#endif

#ifdef UFBL_PROJ_ROOK
#include "idme_default_table_rook.h"
#endif

#ifdef UFBL_PROJ_A113X
#include "idme_default_table_a113x.h"
#endif

#ifdef UFBL_PROJ_MT8516
#include "idme_default_table_mt8516.h"
#endif

#ifdef UFBL_PROJ_NEPTUNE
#include "idme_default_table_neptune.h"
#endif

#ifdef UFBL_PROJ_MAVERICK
#include "idme_default_table_maverick.h"
#endif

#endif /* __IDME_DEFAULT_TABLE_H__ */
