//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all 
// or part of MStar Software is expressly prohibited, unless prior written 
// permission has been granted by MStar. 
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.  
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software. 
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s 
//    confidential information in strictest confidence and not disclose to any
//    third party.  
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.  
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or 
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.  
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>

#include <command.h>
#include <common.h>
#include <idme/CusIDME.h>
#include <idme/idme.h>
#include <mstarstr.h>



#define DEFAULT_IP_ADDR "192.168.1.101"

char *str_replace(char *orig, char *rep, char *with) 
{
    char *result; // the return string
    char *ins;    // the next insert point
    char *tmp;    // varies
    int len_rep;  // length of rep (the string to remove)
    int len_with; // length of with (the string to replace rep with)
    int len_front; // distance between rep and end of last rep
    int count;    // number of replacements

    // sanity checks and initialization
    if (!orig || !rep)
        return NULL;
    len_rep = strlen(rep);
    if (len_rep == 0)
        return NULL; // empty rep causes infinite loop during count
    if (!with)
        with = "";
    len_with = strlen(with);

    // count the number of replacements needed
    ins = orig;
    for (count = 0; tmp = strstr(ins, rep); ++count) {
        ins = tmp + len_rep;
    }

    if (!count)   // nothing to be done
        return NULL;

    tmp = result = malloc(strlen(orig) + (len_with - len_rep) * count + 1);

    if (!result)
        return NULL;

    // first time through the loop, all the variable are set correctly
    // from here on,
    //    tmp points to the end of the result string
    //    ins points to the next occurrence of rep in orig
    //    orig points to the remainder of orig after "end of rep"
    while (count--) {
        ins = strstr(orig, rep);
        len_front = ins - orig;
        tmp = strncpy(tmp, orig, len_front) + len_front;
        tmp = strcpy(tmp, with) + len_with;
        orig += len_front + len_rep; // move to next "end of rep"
    }
    strcpy(tmp, orig);
    return result;
}


void CusIDME()
{

    char serialno[18] = {0};
    int bNeedToSave = 0;

    char idmeipaddr[32] = {0};
    char ipaddrcmd[64] = {0};
    char *ipToUse = NULL;
    char *ipInEnv = NULL;
    char idmemacaddr[32] = {0};
    char addrwithsep[48] = {0};
    char macaddrcmd[64] = {0};
    char *macInEnv = NULL;
    char bootmode_buf[6] = {0};
    char bootmode_cmd[64] = {0};
    int bootmode = 1;
    char *bootmodeInEnv = NULL;
    char dev_flags_buf[8] = {0};
    char dev_flags_cmd[64] = {0};
    unsigned dev_flags = 0;
    char *devflagsInEnv = NULL;
    char usr_flags_buf[8] = {0};
    char usr_flags_cmd[64] = {0};
    unsigned usr_flags = 0;
    char *usrflagsInEnv = NULL;
    idme_initialize();
    //  boot_mode = idme_boot_mode();

    // updating idme/env
    //if (!is_str_resume()) 
    //{   // no need to do this if str resume
        // update product_name and productid in IDME based on HW ID

        // T22 porting TODO
        //  const char* prod_name = amzn_target_device_name();
    char* prod_name = "duckie";
    char* region = "GB";
    unsigned int name_len = strlen(prod_name);
    unsigned int region_len = strlen(region);

    if (idme_update_var_ex("product_name", prod_name, name_len))
    {
        printf("error updating product_name\n");
    }
    if (idme_update_var_ex("productid", prod_name, name_len))
    {
        printf("error updating productid\n");
    }
    if (idme_update_var_ex("region", region, region_len))
    {
        printf("error updating region\n");
    }

    if (!idme_get_var_external("eth_ip_addr", idmeipaddr, sizeof(idmeipaddr)-1) &&
        strchr((const char*)idmeipaddr, '.')) {
       ipToUse = idmeipaddr;
    } else {
       ipToUse = DEFAULT_IP_ADDR; // 192.168.1.101
    }
    ipInEnv = getenv("ipaddr");
    /* Need to update env variable ipaddr? */
    if ((!ipInEnv) || (strcmp(ipToUse, ipInEnv))) {
       snprintf(ipaddrcmd, sizeof(ipaddrcmd), "setenv ipaddr %s", ipToUse);
       run_command(ipaddrcmd, 0);
       bNeedToSave = 1;
    }
    
    if (!idme_get_var_external("eth_mac_addr", idmemacaddr, sizeof(idmemacaddr)-1) &&
        strlen((const char*)idmemacaddr) == 12) {
       snprintf(addrwithsep, sizeof(addrwithsep), "%c%c:%c%c:%c%c:%c%c:%c%c:%c%c",
                      idmemacaddr[0], idmemacaddr[1], idmemacaddr[2], idmemacaddr[3],
                      idmemacaddr[4], idmemacaddr[5], idmemacaddr[6], idmemacaddr[7],
                      idmemacaddr[8], idmemacaddr[9], idmemacaddr[10], idmemacaddr[11]);
       macInEnv = getenv("macaddr");
       /* Need to update env variable macaddr? */
       if ((!macInEnv) || (strcmp(addrwithsep, macInEnv))) {
          snprintf(macaddrcmd, sizeof(macaddrcmd), "setenv macaddr %s", addrwithsep);
          run_command(macaddrcmd, 0);
          bNeedToSave = 1;
       }
    }

    //bootmode set for diag/normal boot separation
    
    if (!idme_get_var_external("bootmode", bootmode_buf, sizeof(bootmode_buf)-1)) 
    {
        bootmode = atoi(bootmode_buf);
        printf("idme bootmode read [%d]\n",bootmode);
    }else 
    {
        printf("idme bootmode failed");
        bootmode = 1;
    }
    if(bootmode < 0 || bootmode > IDME_BOOTMODE_MAX)
            bootmode = 1;
    bootmodeInEnv = getenv("bootmode");
    /* Need to update env variabel bootmode? */
    if ((!bootmodeInEnv) || (atoi(bootmodeInEnv) != bootmode)) 
    {
       snprintf(bootmode_cmd, sizeof(bootmode_cmd), "setenv bootmode %d", bootmode);
       run_command(bootmode_cmd, 0);
       bNeedToSave = 1;
    }

    
    /* treat dev_flags as an unsigned integer in hex */
    if (!idme_get_var_external("dev_flags", dev_flags_buf, sizeof(dev_flags_buf)-1)) 
    {
        dev_flags = simple_strtoul(dev_flags_buf, NULL, 16);
        printf("idme dev_flags read [0x%x]\n",dev_flags);
    }
    else 
    {
        printf("idme dev_flags read failed");
    }
    devflagsInEnv = getenv("dev_flags");
    /* Need to update env variabel dev_flags? */
    if ((!devflagsInEnv) || (simple_strtoul(getenv("dev_flags"), NULL, 16) != dev_flags)) 
    {
       snprintf(dev_flags_cmd, sizeof(dev_flags_cmd), "setenv dev_flags %x",dev_flags);
       run_command(dev_flags_cmd, 0);
       bNeedToSave = 1;
    }

    
    /* treat usr_flags as an unsigned integer in hex */
    if (!idme_get_var_external("usr_flags", usr_flags_buf, sizeof(usr_flags_buf)-1)) 
    {
        usr_flags = simple_strtoul(usr_flags_buf, NULL, 16);
        printf("idme usr_flags read [0x%x]\n",usr_flags);
    }else 
    {
        printf("idme usr_flags read failed");
    }
    usrflagsInEnv = getenv("usr_flags");
    /* Need to update env variabel usr_flags? */
    if ((!usrflagsInEnv) || (simple_strtoul(getenv("usr_flags"), NULL, 16) != usr_flags))
    {
       snprintf(usr_flags_cmd, sizeof(usr_flags_cmd), "setenv usr_flags %x",usr_flags);
       run_command(usr_flags_cmd, 0);
       bNeedToSave = 1;
    }

    if (!idme_get_var_external("serial", serialno, sizeof(serialno)-1)) 
    {
            printf("idme serial read [%s]\n", serialno);
    }
    else 
    {
            printf("idme serial read failed\n");
    }

    /* saveenv after done loading ip and mac addr from idme */
    if (bNeedToSave)
    {
       run_command("saveenv", 0);
    }
        //} // !is_str_resume()
}
int is_lockdown()
{
    char* __bootmodestr = getenv ("bootmode");
    int ibootmode = atoi(__bootmodestr);
#if UFBL_FEATURE_SECURE_BOOT
   /* locked production device in normal mode */
   if ( (!amzn_device_is_unlocked()) &&
        (target_is_production()) &&
        (ibootmode == 1) )
      return 1;
   else
      return 0;
 #else
      return 0;
 #endif
}

int chk_cmd_lockdown(const char* command)
{
   if ( (is_lockdown()) &&
        (strncmp("fastboot", command, strlen("fastboot"))) &&
        (strncmp("reset", command, strlen("reset"))) &&
        (strncmp("usb", command, strlen("usb"))) &&
        (strncmp("estar", command, strlen("estar"))) &&
        (strncmp("secflash", command, strlen("secflash"))) &&
        (strncmp("uupdate", command, strlen("uupdate"))))
      return 0;
   else
      return 1;
}


