#<MStar Software>
#******************************************************************************
# MStar Software
# Copyright (c) 2010 - 2018 MStar Semiconductor, Inc. All rights reserved.
# All software, firmware and related documentation herein ("MStar Software") are
# intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
# law, including, but not limited to, copyright law and international treaties.
# Any use, modification, reproduction, retransmission, or republication of all
# or part of MStar Software is expressly prohibited, unless prior written
# permission has been granted by MStar.
#
# By accessing, browsing and/or using MStar Software, you acknowledge that you
# have read, understood, and agree, to be bound by below terms ("Terms") and to
# comply with all applicable laws and regulations:
#
# 1. MStar shall retain any and all right, ownership and interest to MStar
#    Software and any modification/derivatives thereof.
#    No right, ownership, or interest to MStar Software and any
#    modification/derivatives thereof is transferred to you under Terms.
#
# 2. You understand that MStar Software might include, incorporate or be
#    supplied together with third party's software and the use of MStar
#    Software may require additional licenses from third parties.
#    Therefore, you hereby agree it is your sole responsibility to separately
#    obtain any and all third party right and license necessary for your use of
#    such third party's software.
#
# 3. MStar Software and any modification/derivatives thereof shall be deemed as
#    MStar's confidential information and you agree to keep MStar's
#    confidential information in strictest confidence and not disclose to any
#    third party.
#
# 4. MStar Software is provided on an "AS IS" basis without warranties of any
#    kind. Any warranties are hereby expressly disclaimed by MStar, including
#    without limitation, any warranties of merchantability, non-infringement of
#    intellectual property rights, fitness for a particular purpose, error free
#    and in conformity with any international standard.  You agree to waive any
#    claim against MStar for any loss, damage, cost or expense that you may
#    incur related to your use of MStar Software.
#    In no event shall MStar be liable for any direct, indirect, incidental or
#    consequential damages, including without limitation, lost of profit or
#    revenues, lost or damage of data, and unauthorized system use.
#    You agree that this Section 4 shall still apply without being affected
#    even if MStar Software has been modified by MStar in accordance with your
#    request or instruction for your use, except otherwise agreed by both
#    parties in writing.
#
# 5. If requested, MStar may from time to time provide technical supports or
#    services in relation with MStar Software to you for your use of
#    MStar Software in conjunction with your or your customer's product
#    ("Services").
#    You understand and agree that, except otherwise agreed by both parties in
#    writing, Services are provided on an "AS IS" basis and the warranty
#    disclaimer set forth in Section 4 above shall apply.
#
# 6. Nothing contained herein shall be construed as by implication, estoppels
#    or otherwise:
#    (a) conferring any license or right to use MStar name, trademark, service
#        mark, symbol or any other identification;
#    (b) obligating MStar or any of its affiliates to furnish any person,
#        including without limitation, you and your customers, any assistance
#        of any kind whatsoever, or any information; or
#    (c) conferring any license or right under any intellectual property right.
#
# 7. These terms shall be governed by and construed in accordance with the laws
#    of Taiwan, R.O.C., excluding its conflict of law rules.
#    Any and all dispute arising out hereof or related hereto shall be finally
#    settled by arbitration referred to the Chinese Arbitration Association,
#    Taipei in accordance with the ROC Arbitration Law and the Arbitration
#    Rules of the Association by three (3) arbitrators appointed in accordance
#    with the said Rules.
#    The place of arbitration shall be in Taipei, Taiwan and the language shall
#    be English.
#    The arbitration award shall be final and binding to both parties.
#
#******************************************************************************
#<MStar Software>

ifeq ($(BUILD_WITH_MBOOT), true)


MBOOT_SRC_TOP := $(ANDROID_BUILD_TOP)/vendor/mstar/mboot/MBoot
SBOOT_TOP := $(MBOOT_SRC_TOP)/sboot
DOT_CONFIG := $(SBOOT_TOP)/.config
TOOLCHAIN_1 := /tools/arm/Linaro/gcc-linaro-aarch64-none-elf-4.9-2014.09_linux
TOOLCHAIN_2 := /tools/arm/arm_eabi-2011.03
MBOOT_TARGET_OUT := $(SBOOT_TOP)/out/mboot.bin
ROM_BOOT_TARGET_OUT := $(SBOOT_TOP)/out/rom_emmc_boot.bin


# mainz
ifneq ($(filter bennet, $(TARGET_DEVICE)),)
    CONFIG_DIR := configs/mainz
    MBOOT_CONFIG := .config.mainz.android.142b.rom_emmc.64bit.kernel.optee.20x20

# maserati
else ifneq ($(filter plum, $(TARGET_DEVICE)),)
    CONFIG_DIR := configs/maserati
    MBOOT_CONFIG := .config.maserati.android.114d.rom_emmc.64bit.optee.kernel.onebin

# m7221
else ifneq ($(filter sugarcane, $(TARGET_DEVICE)),)
    CONFIG_DIR := configs/M7221
    MBOOT_CONFIG := .config.m7221.android.140B.rom_emmc_64bit.optee.kdrv

# maxim - china
else ifneq ($(filter synsepalum, $(TARGET_DEVICE)),)
    CONFIG_DIR := configs/maxim
    MBOOT_CONFIG := .config.maxim.android.111d_vby1.rom_emmc.64bit.optee.kernel

# maxim - sri
else ifneq ($(filter denali, $(TARGET_DEVICE)),)
    CONFIG_DIR := configs/maxim
    MBOOT_CONFIG := .config.maxim.android.107b.rom_emmc.64bit.optee.kernel

else
    $(error Not a supported TARGET_DEVICE: $(TARGET_DEVICE))

endif


MBOOT_BINARY := $(PRODUCT_OUT)/images/prebuilts/mboot.bin

$(DOT_CONFIG): $(SBOOT_TOP)/$(CONFIG_DIR)/$(MBOOT_CONFIG)
	cd $(SBOOT_TOP); \
	cp $(SBOOT_TOP)/$(CONFIG_DIR)/$(MBOOT_CONFIG) .config; \
	cp $(SBOOT_TOP)/$(CONFIG_DIR)/$(MBOOT_CONFIG) scripts/defconfig;

$(MBOOT_BINARY): $(DOT_CONFIG)
	cd $(SBOOT_TOP); \
	export PATH=$(TOOLCHAIN_1)/bin:$(TOOLCHAIN_2)/bin:$(PATH); \
	make defconfig; make clean; make;
	@mkdir -p $(PRODUCT_OUT)/images/prebuilts
	@cp $(MBOOT_TARGET_OUT) $@
	@cp $(ROM_BOOT_TARGET_OUT) $(PRODUCT_OUT)/images/prebuilts

mboot_clean: $(DOT_CONFIG)
	cd $(SBOOT_TOP); \
	export PATH=$(TOOLCHAIN_1)/bin:$(TOOLCHAIN_2)/bin:$(PATH); \
	make defconfig; make clean;
	@rm -f $(MBOOT_BINARY)
	@rm -f $(PRODUCT_OUT)/images/prebuilts/rom_emmc_boot.bin

droid: $(MBOOT_BINARY)


endif #ifeq ($(BUILD_WITH_MBOOT), true)

# ==============================================================================
#include $(call all-subdir-makefiles)
