LOCAL_PATH := $(call my-dir)
include $(CLEAR_VARS)

INSTALLED_MBOOT_TARGET := $(PRODUCT_OUT)/mboot.bin

MBOOT_OUT := $(abspath $(PRODUCT_OUT))/obj/MBOOT_OBJ
TARGET_MBOOT_CONFIG := $(MBOOT_OUT)/.config
TARGET_BUILT_MBOOT := $(MBOOT_OUT)/out/mboot.bin

MAKE_SBOOT = make -j1

MBOOT_CC := $(ROOTDIR)/prebuilts/mtk_toolchain/gcc-4.5.2-arm-eabi-2011.03_x86_64/bin/arm-none-eabi-gcc
ARCH := arm
MBOOT_CROSS_COMPILE := $(ROOTDIR)/prebuilts/mtk_toolchain/gcc-4.5.2-arm-eabi-2011.03_x86_64/bin/arm-none-eabi-

export BOARD_UFBL_PROJECT BOARD_KERNEL_SEPARATED_DT

$(TARGET_MBOOT_CONFIG): $(MBOOT_DIR)/$(MBOOT_DEFCONFIG) | $(ACP)
	@echo "Building defconfig for mboot"
	mkdir -p $(MBOOT_OUT)
	$(ACP) $(MBOOT_DIR)/$(MBOOT_DEFCONFIG) $(MBOOT_DIR)/scripts/defconfig
	$(MAKE_SBOOT) -C $(MBOOT_DIR) ARCH=$(ARCH) CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) UBOOT_CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) CC=$(MBOOT_CC) defconfig

$(TARGET_BUILT_MBOOT): $(TARGET_MBOOT_CONFIG)
	@echo "Building mboot from $(MBOOT_DIR)"
	$(MAKE_SBOOT) -C $(MBOOT_DIR) ARCH=$(ARCH) CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) UBOOT_CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) CC=$(MBOOT_CC) clean
	$(MAKE_SBOOT) -C $(MBOOT_DIR) ARCH=$(ARCH) CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) UBOOT_CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) CC=$(MBOOT_CC) PRODUCT_OUT=$(abspath $(PRODUCT_OUT))
	mkdir -p $(MBOOT_OUT)/out
	$(ACP) $(MBOOT_DIR)/out/rom_emmc_boot.bin $(MBOOT_OUT)/out/rom_emmc_boot.bin
	$(ACP) $(MBOOT_DIR)/out/mboot.bin $(MBOOT_OUT)/out/mboot.bin
	@rm -Rf $(MBOOT_DIR)/include
	@rm $(MBOOT_DIR)/.config

ifeq ($(wildcard $(TARGET_PREBUILT_SBOOT)),)
TARGET_PREBUILT_SBOOT := $(MBOOT_OUT)/out/rom_emmc_boot.bin
endif

INSTALLED_SBOOT_TARGET := $(foreach s, $(TARGET_PREBUILT_SBOOT), \
	$(addprefix $(PRODUCT_OUT)/, $(notdir $(s))))

$(INSTALLED_SBOOT_TARGET): $(INSTALLED_MBOOT_TARGET)

$(INSTALLED_MBOOT_TARGET): $(TARGET_BUILT_MBOOT) | $(ACP)
ifeq ($(wildcard $(TARGET_PREBUILT_MBOOT)),)
	@echo Copies the built mboot to $(PRODUCT_OUT)
	$(ACP) $(MBOOT_OUT)/out/mboot.bin $(PRODUCT_OUT)/mboot.bin
else
	@echo Copies the prebuilt mboot to $(PRODUCT_OUT)
	$(ACP) $(TARGET_PREBUILT_MBOOT) $(PRODUCT_OUT)/mboot.bin
endif
	@echo Copies the prebuilt sboot to $(PRODUCT_OUT)
	$(foreach f, $(TARGET_PREBUILT_SBOOT), \
		$(ACP) $(f) $(PRODUCT_OUT))

droidcore: $(INSTALLED_MBOOT_TARGET)

mbootclean:
	@echo "Doing mbootclean"
	@rm -rf $(MBOOT_OUT)
	@rm -rf $(PRODUCT_OUT)/mboot.bin
	@rm -rf $(PRODUCT_OUT)/rom_emmc_boot.bin

# This is for developer to only build mboot.
# when make any change above, please make chanege to this section as well if needed
mboot: | $(ACP)
	@echo "Doing mbootclean"
	@rm -rf $(MBOOT_OUT)
	@rm -rf $(PRODUCT_OUT)/mboot.bin
	@rm -rf $(PRODUCT_OUT)/rom_emmc_boot.bin
	@echo "Building defconfig for mboot"
	mkdir -p $(MBOOT_OUT)
	$(ACP) $(MBOOT_DIR)/$(MBOOT_DEFCONFIG) $(MBOOT_DIR)/scripts/defconfig
	$(MAKE_SBOOT) -C $(MBOOT_DIR) ARCH=$(ARCH) CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) UBOOT_CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) CC=$(MBOOT_CC) defconfig
	$(MAKE_SBOOT) -C $(MBOOT_DIR) ARCH=$(ARCH) CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) UBOOT_CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) CC=$(MBOOT_CC) clean
	@echo "Building mboot from $(MBOOT_DIR)"
	$(MAKE_SBOOT) -C $(MBOOT_DIR) ARCH=$(ARCH) CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) UBOOT_CROSS_COMPILE=$(MBOOT_CROSS_COMPILE) CC=$(MBOOT_CC) PRODUCT_OUT=$(abspath $(PRODUCT_OUT))
	mkdir -p $(MBOOT_OUT)/out
	$(ACP) $(MBOOT_DIR)/out/rom_emmc_boot.bin $(MBOOT_OUT)/out/rom_emmc_boot.bin
	$(ACP) $(MBOOT_DIR)/out/mboot.bin $(MBOOT_OUT)/out/mboot.bin
ifeq ($(wildcard $(TARGET_PREBUILT_MBOOT)),)
	@echo Copies the built mboot to $(PRODUCT_OUT)
	$(ACP) $(MBOOT_OUT)/out/mboot.bin $(PRODUCT_OUT)/mboot.bin
else
	@echo Copies the prebuilt mboot to $(PRODUCT_OUT)
	$(ACP) $(TARGET_PREBUILT_MBOOT) $(PRODUCT_OUT)/mboot.bin
endif
	@echo Copies the prebuilt sboot to $(PRODUCT_OUT)
	$(foreach f, $(TARGET_PREBUILT_SBOOT), \
		$(ACP) $(f) $(PRODUCT_OUT))

.PHONY: mboot mbootclean

