/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

// This file is generated by script file, please do not edit it directly
#ifndef _FPGA_M7332_H_
#define _FPGA_M7332_H_

#define PAD_NC   9999
#define PAD_GND  0

#define BALL_U4 PAD_CEC
#define PAD_CEC 6
#define GPIO_PAD_6 GPIO5
#ifndef BALL_U4_IS_GPIO
#define BALL_U4_IS_GPIO 0
#endif
#ifndef PAD_CEC_IS_GPIO
#define PAD_CEC_IS_GPIO BALL_U4_IS_GPIO
#endif

#define BALL_K5 PAD_DDCA_DA
#define PAD_DDCA_DA 10
#define GPIO_PAD_10 GPIO9
#ifndef BALL_K5_IS_GPIO
#define BALL_K5_IS_GPIO 0
#endif
#ifndef PAD_DDCA_DA_IS_GPIO
#define PAD_DDCA_DA_IS_GPIO BALL_K5_IS_GPIO
#endif

#define BALL_K4 PAD_DDCA_CK
#define PAD_DDCA_CK 9
#define GPIO_PAD_9 GPIO8
#ifndef BALL_K4_IS_GPIO
#define BALL_K4_IS_GPIO 0
#endif
#ifndef PAD_DDCA_CK_IS_GPIO
#define PAD_DDCA_CK_IS_GPIO BALL_K4_IS_GPIO
#endif

#define BALL_F1 PAD_IRIN
#define PAD_IRIN 5
#define GPIO_PAD_5 GPIO4
#ifndef BALL_F1_IS_GPIO
#define BALL_F1_IS_GPIO 0
#endif
#ifndef PAD_IRIN_IS_GPIO
#define PAD_IRIN_IS_GPIO BALL_F1_IS_GPIO
#endif

#define BALL_N5 PAD_DDCDD_CK
#define PAD_DDCDD_CK 34
#define GPIO_PAD_34 GPIO33
#ifndef BALL_N5_IS_GPIO
#define BALL_N5_IS_GPIO 0
#endif
#ifndef PAD_DDCDD_CK_IS_GPIO
#define PAD_DDCDD_CK_IS_GPIO BALL_N5_IS_GPIO
#endif

#define BALL_M5 PAD_DDCDD_DA
#define PAD_DDCDD_DA 35
#define GPIO_PAD_35 GPIO34
#ifndef BALL_M5_IS_GPIO
#define BALL_M5_IS_GPIO 0
#endif
#ifndef PAD_DDCDD_DA_IS_GPIO
#define PAD_DDCDD_DA_IS_GPIO BALL_M5_IS_GPIO
#endif

#define PAD_AV_LNK 9999
#ifndef PAD_AV_LNK_IS_GPIO
#define PAD_AV_LNK_IS_GPIO 0
#endif

#define BALL_U6 PAD_HOTPLUGA
#define PAD_HOTPLUGA 24
#define GPIO_PAD_24 GPIO23
#ifndef BALL_U6_IS_GPIO
#define BALL_U6_IS_GPIO 0
#endif
#ifndef PAD_HOTPLUGA_IS_GPIO
#define PAD_HOTPLUGA_IS_GPIO BALL_U6_IS_GPIO
#endif

#define PAD_HOTPLUGB 9999
#ifndef PAD_HOTPLUGB_IS_GPIO
#define PAD_HOTPLUGB_IS_GPIO 0
#endif

#define BALL_L5 PAD_HOTPLUGD
#define PAD_HOTPLUGD 27
#define GPIO_PAD_27 GPIO26
#ifndef BALL_L5_IS_GPIO
#define BALL_L5_IS_GPIO 0
#endif
#ifndef PAD_HOTPLUGD_IS_GPIO
#define PAD_HOTPLUGD_IS_GPIO BALL_L5_IS_GPIO
#endif

#define BALL_M4 PAD_ARC0
#define PAD_ARC0 43
#define GPIO_PAD_43 GPIO42
#ifndef BALL_M4_IS_GPIO
#define BALL_M4_IS_GPIO 0
#endif
#ifndef PAD_ARC0_IS_GPIO
#define PAD_ARC0_IS_GPIO BALL_M4_IS_GPIO
#endif

#define BALL_AD7 PAD_HOTPLUGC
#define PAD_HOTPLUGC 26
#define GPIO_PAD_26 GPIO25
#ifndef BALL_AD7_IS_GPIO
#define BALL_AD7_IS_GPIO 0
#endif
#ifndef PAD_HOTPLUGC_IS_GPIO
#define PAD_HOTPLUGC_IS_GPIO BALL_AD7_IS_GPIO
#endif

#define BALL_AD6 PAD_DDCDC_CK
#define PAD_DDCDC_CK 32
#define GPIO_PAD_32 GPIO31
#ifndef BALL_AD6_IS_GPIO
#define BALL_AD6_IS_GPIO 0
#endif
#ifndef PAD_DDCDC_CK_IS_GPIO
#define PAD_DDCDC_CK_IS_GPIO BALL_AD6_IS_GPIO
#endif

#define BALL_AC6 PAD_DDCDC_DA
#define PAD_DDCDC_DA 33
#define GPIO_PAD_33 GPIO32
#ifndef BALL_AC6_IS_GPIO
#define BALL_AC6_IS_GPIO 0
#endif
#ifndef PAD_DDCDC_DA_IS_GPIO
#define PAD_DDCDC_DA_IS_GPIO BALL_AC6_IS_GPIO
#endif

#define BALL_AF3 PAD_TGPIO3
#define PAD_TGPIO3 157
#define GPIO_PAD_157 GPIO156
#ifndef BALL_AF3_IS_GPIO
#define BALL_AF3_IS_GPIO 0
#endif
#ifndef PAD_TGPIO3_IS_GPIO
#define PAD_TGPIO3_IS_GPIO BALL_AF3_IS_GPIO
#endif

#define BALL_AE3 PAD_TGPIO2
#define PAD_TGPIO2 156
#define GPIO_PAD_156 GPIO155
#ifndef BALL_AE3_IS_GPIO
#define BALL_AE3_IS_GPIO 0
#endif
#ifndef PAD_TGPIO2_IS_GPIO
#define PAD_TGPIO2_IS_GPIO BALL_AE3_IS_GPIO
#endif

#define BALL_AG2 PAD_TGPIO1
#define PAD_TGPIO1 155
#define GPIO_PAD_155 GPIO154
#ifndef BALL_AG2_IS_GPIO
#define BALL_AG2_IS_GPIO 0
#endif
#ifndef PAD_TGPIO1_IS_GPIO
#define PAD_TGPIO1_IS_GPIO BALL_AG2_IS_GPIO
#endif

#define BALL_AG6 PAD_TGPIO0
#define PAD_TGPIO0 154
#define GPIO_PAD_154 GPIO153
#ifndef BALL_AG6_IS_GPIO
#define BALL_AG6_IS_GPIO 0
#endif
#ifndef PAD_TGPIO0_IS_GPIO
#define PAD_TGPIO0_IS_GPIO BALL_AG6_IS_GPIO
#endif

#define BALL_AE7 PAD_PCM_D0
#define PAD_PCM_D0 132
#define GPIO_PAD_132 GPIO131
#ifndef BALL_AE7_IS_GPIO
#define BALL_AE7_IS_GPIO 0
#endif
#ifndef PAD_PCM_D0_IS_GPIO
#define PAD_PCM_D0_IS_GPIO BALL_AE7_IS_GPIO
#endif

#define BALL_AD9 PAD_PCM_D1
#define PAD_PCM_D1 133
#define GPIO_PAD_133 GPIO132
#ifndef BALL_AD9_IS_GPIO
#define BALL_AD9_IS_GPIO 0
#endif
#ifndef PAD_PCM_D1_IS_GPIO
#define PAD_PCM_D1_IS_GPIO BALL_AD9_IS_GPIO
#endif

#define BALL_AC8 PAD_PCM_D2
#define PAD_PCM_D2 134
#define GPIO_PAD_134 GPIO133
#ifndef BALL_AC8_IS_GPIO
#define BALL_AC8_IS_GPIO 0
#endif
#ifndef PAD_PCM_D2_IS_GPIO
#define PAD_PCM_D2_IS_GPIO BALL_AC8_IS_GPIO
#endif

#define BALL_AE8 PAD_PCM_D3
#define PAD_PCM_D3 104
#define GPIO_PAD_104 GPIO103
#ifndef BALL_AE8_IS_GPIO
#define BALL_AE8_IS_GPIO 0
#endif
#ifndef PAD_PCM_D3_IS_GPIO
#define PAD_PCM_D3_IS_GPIO BALL_AE8_IS_GPIO
#endif

#define BALL_AD8 PAD_PCM_D4
#define PAD_PCM_D4 105
#define GPIO_PAD_105 GPIO104
#ifndef BALL_AD8_IS_GPIO
#define BALL_AD8_IS_GPIO 0
#endif
#ifndef PAD_PCM_D4_IS_GPIO
#define PAD_PCM_D4_IS_GPIO BALL_AD8_IS_GPIO
#endif

#define BALL_AC10 PAD_PCM_D5
#define PAD_PCM_D5 106
#define GPIO_PAD_106 GPIO105
#ifndef BALL_AC10_IS_GPIO
#define BALL_AC10_IS_GPIO 0
#endif
#ifndef PAD_PCM_D5_IS_GPIO
#define PAD_PCM_D5_IS_GPIO BALL_AC10_IS_GPIO
#endif

#define BALL_AC9 PAD_PCM_D6
#define PAD_PCM_D6 107
#define GPIO_PAD_107 GPIO106
#ifndef BALL_AC9_IS_GPIO
#define BALL_AC9_IS_GPIO 0
#endif
#ifndef PAD_PCM_D6_IS_GPIO
#define PAD_PCM_D6_IS_GPIO BALL_AC9_IS_GPIO
#endif

#define BALL_AD10 PAD_PCM_D7
#define PAD_PCM_D7 108
#define GPIO_PAD_108 GPIO107
#ifndef BALL_AD10_IS_GPIO
#define BALL_AD10_IS_GPIO 0
#endif
#ifndef PAD_PCM_D7_IS_GPIO
#define PAD_PCM_D7_IS_GPIO BALL_AD10_IS_GPIO
#endif

#define BALL_AE10 PAD_PCM_A8
#define PAD_PCM_A8 116
#define GPIO_PAD_116 GPIO115
#ifndef BALL_AE10_IS_GPIO
#define BALL_AE10_IS_GPIO 0
#endif
#ifndef PAD_PCM_A8_IS_GPIO
#define PAD_PCM_A8_IS_GPIO BALL_AE10_IS_GPIO
#endif

#define BALL_AC25 PAD_PCM2_CD_N
#define PAD_PCM2_CD_N 103
#define GPIO_PAD_103 GPIO102
#ifndef BALL_AC25_IS_GPIO
#define BALL_AC25_IS_GPIO 0
#endif
#ifndef PAD_PCM2_CD_N_IS_GPIO
#define PAD_PCM2_CD_N_IS_GPIO BALL_AC25_IS_GPIO
#endif

#define BALL_AC11 PAD_PCM_A9
#define PAD_PCM_A9 114
#define GPIO_PAD_114 GPIO113
#ifndef BALL_AC11_IS_GPIO
#define BALL_AC11_IS_GPIO 0
#endif
#ifndef PAD_PCM_A9_IS_GPIO
#define PAD_PCM_A9_IS_GPIO BALL_AC11_IS_GPIO
#endif

#define BALL_AD18 PAD_PCM2_IRQA_N
#define PAD_PCM2_IRQA_N 100
#define GPIO_PAD_100 GPIO99
#ifndef BALL_AD18_IS_GPIO
#define BALL_AD18_IS_GPIO 0
#endif
#ifndef PAD_PCM2_IRQA_N_IS_GPIO
#define PAD_PCM2_IRQA_N_IS_GPIO BALL_AD18_IS_GPIO
#endif

#define BALL_AD11 PAD_PCM_A10
#define PAD_PCM_A10 110
#define GPIO_PAD_110 GPIO109
#ifndef BALL_AD11_IS_GPIO
#define BALL_AD11_IS_GPIO 0
#endif
#ifndef PAD_PCM_A10_IS_GPIO
#define PAD_PCM_A10_IS_GPIO BALL_AD11_IS_GPIO
#endif

#define BALL_AF10 PAD_TS0_VLD
#define PAD_TS0_VLD 166
#define GPIO_PAD_166 GPIO165
#ifndef BALL_AF10_IS_GPIO
#define BALL_AF10_IS_GPIO 0
#endif
#ifndef PAD_TS0_VLD_IS_GPIO
#define PAD_TS0_VLD_IS_GPIO BALL_AF10_IS_GPIO
#endif

#define BALL_AE11 PAD_PCM_A11
#define PAD_PCM_A11 112
#define GPIO_PAD_112 GPIO111
#ifndef BALL_AE11_IS_GPIO
#define BALL_AE11_IS_GPIO 0
#endif
#ifndef PAD_PCM_A11_IS_GPIO
#define PAD_PCM_A11_IS_GPIO BALL_AE11_IS_GPIO
#endif

#define BALL_AF11 PAD_TS0_CLK
#define PAD_TS0_CLK 168
#define GPIO_PAD_168 GPIO167
#ifndef BALL_AF11_IS_GPIO
#define BALL_AF11_IS_GPIO 0
#endif
#ifndef PAD_TS0_CLK_IS_GPIO
#define PAD_TS0_CLK_IS_GPIO BALL_AF11_IS_GPIO
#endif

#define BALL_AC12 PAD_PCM_A12
#define PAD_PCM_A12 121
#define GPIO_PAD_121 GPIO120
#ifndef BALL_AC12_IS_GPIO
#define BALL_AC12_IS_GPIO 0
#endif
#ifndef PAD_PCM_A12_IS_GPIO
#define PAD_PCM_A12_IS_GPIO BALL_AC12_IS_GPIO
#endif

#define BALL_AG10 PAD_TS0_SYNC
#define PAD_TS0_SYNC 167
#define GPIO_PAD_167 GPIO166
#ifndef BALL_AG10_IS_GPIO
#define BALL_AG10_IS_GPIO 0
#endif
#ifndef PAD_TS0_SYNC_IS_GPIO
#define PAD_TS0_SYNC_IS_GPIO BALL_AG10_IS_GPIO
#endif

#define BALL_AD12 PAD_PCM_A13
#define PAD_PCM_A13 117
#define GPIO_PAD_117 GPIO116
#ifndef BALL_AD12_IS_GPIO
#define BALL_AD12_IS_GPIO 0
#endif
#ifndef PAD_PCM_A13_IS_GPIO
#define PAD_PCM_A13_IS_GPIO BALL_AD12_IS_GPIO
#endif

#define BALL_AH11 PAD_TS0_D0
#define PAD_TS0_D0 158
#define GPIO_PAD_158 GPIO157
#ifndef BALL_AH11_IS_GPIO
#define BALL_AH11_IS_GPIO 0
#endif
#ifndef PAD_TS0_D0_IS_GPIO
#define PAD_TS0_D0_IS_GPIO BALL_AH11_IS_GPIO
#endif

#define BALL_AE13 PAD_PCM_A14
#define PAD_PCM_A14 118
#define GPIO_PAD_118 GPIO117
#ifndef BALL_AE13_IS_GPIO
#define BALL_AE13_IS_GPIO 0
#endif
#ifndef PAD_PCM_A14_IS_GPIO
#define PAD_PCM_A14_IS_GPIO BALL_AE13_IS_GPIO
#endif

#define BALL_AH10 PAD_TS0_D1
#define PAD_TS0_D1 159
#define GPIO_PAD_159 GPIO158
#ifndef BALL_AH10_IS_GPIO
#define BALL_AH10_IS_GPIO 0
#endif
#ifndef PAD_TS0_D1_IS_GPIO
#define PAD_TS0_D1_IS_GPIO BALL_AH10_IS_GPIO
#endif

#define BALL_AD13 PAD_PCM_OE_N
#define PAD_PCM_OE_N 111
#define GPIO_PAD_111 GPIO110
#ifndef BALL_AD13_IS_GPIO
#define BALL_AD13_IS_GPIO 0
#endif
#ifndef PAD_PCM_OE_N_IS_GPIO
#define PAD_PCM_OE_N_IS_GPIO BALL_AD13_IS_GPIO
#endif

#define BALL_AF12 PAD_TS0_D2
#define PAD_TS0_D2 160
#define GPIO_PAD_160 GPIO159
#ifndef BALL_AF12_IS_GPIO
#define BALL_AF12_IS_GPIO 0
#endif
#ifndef PAD_TS0_D2_IS_GPIO
#define PAD_TS0_D2_IS_GPIO BALL_AF12_IS_GPIO
#endif

#define BALL_AC14 PAD_PCM_CE_N
#define PAD_PCM_CE_N 109
#define GPIO_PAD_109 GPIO108
#ifndef BALL_AC14_IS_GPIO
#define BALL_AC14_IS_GPIO 0
#endif
#ifndef PAD_PCM_CE_N_IS_GPIO
#define PAD_PCM_CE_N_IS_GPIO BALL_AC14_IS_GPIO
#endif

#define BALL_AG11 PAD_TS0_D3
#define PAD_TS0_D3 161
#define GPIO_PAD_161 GPIO160
#ifndef BALL_AG11_IS_GPIO
#define BALL_AG11_IS_GPIO 0
#endif
#ifndef PAD_TS0_D3_IS_GPIO
#define PAD_TS0_D3_IS_GPIO BALL_AG11_IS_GPIO
#endif

#define BALL_AC13 PAD_PCM_IORD_N
#define PAD_PCM_IORD_N 113
#define GPIO_PAD_113 GPIO112
#ifndef BALL_AC13_IS_GPIO
#define BALL_AC13_IS_GPIO 0
#endif
#ifndef PAD_PCM_IORD_N_IS_GPIO
#define PAD_PCM_IORD_N_IS_GPIO BALL_AC13_IS_GPIO
#endif

#define BALL_AD14 PAD_PCM_IOWR_N
#define PAD_PCM_IOWR_N 115
#define GPIO_PAD_115 GPIO114
#ifndef BALL_AD14_IS_GPIO
#define BALL_AD14_IS_GPIO 0
#endif
#ifndef PAD_PCM_IOWR_N_IS_GPIO
#define PAD_PCM_IOWR_N_IS_GPIO BALL_AD14_IS_GPIO
#endif

#define BALL_AF13 PAD_TS0_D4
#define PAD_TS0_D4 162
#define GPIO_PAD_162 GPIO161
#ifndef BALL_AF13_IS_GPIO
#define BALL_AF13_IS_GPIO 0
#endif
#ifndef PAD_TS0_D4_IS_GPIO
#define PAD_TS0_D4_IS_GPIO BALL_AF13_IS_GPIO
#endif

#define BALL_AE14 PAD_PCM_IRQA_N
#define PAD_PCM_IRQA_N 120
#define GPIO_PAD_120 GPIO119
#ifndef BALL_AE14_IS_GPIO
#define BALL_AE14_IS_GPIO 0
#endif
#ifndef PAD_PCM_IRQA_N_IS_GPIO
#define PAD_PCM_IRQA_N_IS_GPIO BALL_AE14_IS_GPIO
#endif

#define BALL_AG12 PAD_TS0_D5
#define PAD_TS0_D5 163
#define GPIO_PAD_163 GPIO162
#ifndef BALL_AG12_IS_GPIO
#define BALL_AG12_IS_GPIO 0
#endif
#ifndef PAD_TS0_D5_IS_GPIO
#define PAD_TS0_D5_IS_GPIO BALL_AG12_IS_GPIO
#endif

#define BALL_AC15 PAD_PCM_WE_N
#define PAD_PCM_WE_N 119
#define GPIO_PAD_119 GPIO118
#ifndef BALL_AC15_IS_GPIO
#define BALL_AC15_IS_GPIO 0
#endif
#ifndef PAD_PCM_WE_N_IS_GPIO
#define PAD_PCM_WE_N_IS_GPIO BALL_AC15_IS_GPIO
#endif

#define BALL_AH13 PAD_TS0_D6
#define PAD_TS0_D6 164
#define GPIO_PAD_164 GPIO163
#ifndef BALL_AH13_IS_GPIO
#define BALL_AH13_IS_GPIO 0
#endif
#ifndef PAD_TS0_D6_IS_GPIO
#define PAD_TS0_D6_IS_GPIO BALL_AH13_IS_GPIO
#endif

#define BALL_AD15 PAD_PCM_CD_N
#define PAD_PCM_CD_N 136
#define GPIO_PAD_136 GPIO135
#ifndef BALL_AD15_IS_GPIO
#define BALL_AD15_IS_GPIO 0
#endif
#ifndef PAD_PCM_CD_N_IS_GPIO
#define PAD_PCM_CD_N_IS_GPIO BALL_AD15_IS_GPIO
#endif

#define BALL_AG13 PAD_TS0_D7
#define PAD_TS0_D7 165
#define GPIO_PAD_165 GPIO164
#ifndef BALL_AG13_IS_GPIO
#define BALL_AG13_IS_GPIO 0
#endif
#ifndef PAD_TS0_D7_IS_GPIO
#define PAD_TS0_D7_IS_GPIO BALL_AG13_IS_GPIO
#endif

#define BALL_AC16 PAD_PCM_RESET
#define PAD_PCM_RESET 135
#define GPIO_PAD_135 GPIO134
#ifndef BALL_AC16_IS_GPIO
#define BALL_AC16_IS_GPIO 0
#endif
#ifndef PAD_PCM_RESET_IS_GPIO
#define PAD_PCM_RESET_IS_GPIO BALL_AC16_IS_GPIO
#endif

#define BALL_AC20 PAD_TS1_D0
#define PAD_TS1_D0 179
#define GPIO_PAD_179 GPIO178
#ifndef BALL_AC20_IS_GPIO
#define BALL_AC20_IS_GPIO 0
#endif
#ifndef PAD_TS1_D0_IS_GPIO
#define PAD_TS1_D0_IS_GPIO BALL_AC20_IS_GPIO
#endif

#define BALL_AD16 PAD_PCM_WAIT_N
#define PAD_PCM_WAIT_N 125
#define GPIO_PAD_125 GPIO124
#ifndef BALL_AD16_IS_GPIO
#define BALL_AD16_IS_GPIO 0
#endif
#ifndef PAD_PCM_WAIT_N_IS_GPIO
#define PAD_PCM_WAIT_N_IS_GPIO BALL_AD16_IS_GPIO
#endif

#define BALL_AD20 PAD_TS1_D1
#define PAD_TS1_D1 178
#define GPIO_PAD_178 GPIO177
#ifndef BALL_AD20_IS_GPIO
#define BALL_AD20_IS_GPIO 0
#endif
#ifndef PAD_TS1_D1_IS_GPIO
#define PAD_TS1_D1_IS_GPIO BALL_AD20_IS_GPIO
#endif

#define BALL_AE16 PAD_PCM_REG_N
#define PAD_PCM_REG_N 129
#define GPIO_PAD_129 GPIO128
#ifndef BALL_AE16_IS_GPIO
#define BALL_AE16_IS_GPIO 0
#endif
#ifndef PAD_PCM_REG_N_IS_GPIO
#define PAD_PCM_REG_N_IS_GPIO BALL_AE16_IS_GPIO
#endif

#define BALL_AE20 PAD_TS1_D2
#define PAD_TS1_D2 177
#define GPIO_PAD_177 GPIO176
#ifndef BALL_AE20_IS_GPIO
#define BALL_AE20_IS_GPIO 0
#endif
#ifndef PAD_TS1_D2_IS_GPIO
#define PAD_TS1_D2_IS_GPIO BALL_AE20_IS_GPIO
#endif

#define BALL_AD19 PAD_PCM2_WAIT_N
#define PAD_PCM2_WAIT_N 101
#define GPIO_PAD_101 GPIO100
#ifndef BALL_AD19_IS_GPIO
#define BALL_AD19_IS_GPIO 0
#endif
#ifndef PAD_PCM2_WAIT_N_IS_GPIO
#define PAD_PCM2_WAIT_N_IS_GPIO BALL_AD19_IS_GPIO
#endif

#define BALL_AC19 PAD_PCM2_RESET
#define PAD_PCM2_RESET 102
#define GPIO_PAD_102 GPIO101
#ifndef BALL_AC19_IS_GPIO
#define BALL_AC19_IS_GPIO 0
#endif
#ifndef PAD_PCM2_RESET_IS_GPIO
#define PAD_PCM2_RESET_IS_GPIO BALL_AC19_IS_GPIO
#endif

#define BALL_AC21 PAD_TS1_D3
#define PAD_TS1_D3 176
#define GPIO_PAD_176 GPIO175
#ifndef BALL_AC21_IS_GPIO
#define BALL_AC21_IS_GPIO 0
#endif
#ifndef PAD_TS1_D3_IS_GPIO
#define PAD_TS1_D3_IS_GPIO BALL_AC21_IS_GPIO
#endif

#define BALL_AE18 PAD_PCM2_CE_N
#define PAD_PCM2_CE_N 99
#define GPIO_PAD_99 GPIO98
#ifndef BALL_AE18_IS_GPIO
#define BALL_AE18_IS_GPIO 0
#endif
#ifndef PAD_PCM2_CE_N_IS_GPIO
#define PAD_PCM2_CE_N_IS_GPIO BALL_AE18_IS_GPIO
#endif

#define BALL_AE21 PAD_TS1_D4
#define PAD_TS1_D4 175
#define GPIO_PAD_175 GPIO174
#ifndef BALL_AE21_IS_GPIO
#define BALL_AE21_IS_GPIO 0
#endif
#ifndef PAD_TS1_D4_IS_GPIO
#define PAD_TS1_D4_IS_GPIO BALL_AE21_IS_GPIO
#endif

#define BALL_AD21 PAD_TS1_D5
#define PAD_TS1_D5 174
#define GPIO_PAD_174 GPIO173
#ifndef BALL_AD21_IS_GPIO
#define BALL_AD21_IS_GPIO 0
#endif
#ifndef PAD_TS1_D5_IS_GPIO
#define PAD_TS1_D5_IS_GPIO BALL_AD21_IS_GPIO
#endif

#define BALL_AF15 PAD_NAND_RBZ
#define PAD_NAND_RBZ 98
#define GPIO_PAD_98 GPIO97
#ifndef BALL_AF15_IS_GPIO
#define BALL_AF15_IS_GPIO 0
#endif
#ifndef PAD_NAND_RBZ_IS_GPIO
#define PAD_NAND_RBZ_IS_GPIO BALL_AF15_IS_GPIO
#endif

#define BALL_AC22 PAD_TS1_D6
#define PAD_TS1_D6 173
#define GPIO_PAD_173 GPIO172
#ifndef BALL_AC22_IS_GPIO
#define BALL_AC22_IS_GPIO 0
#endif
#ifndef PAD_TS1_D6_IS_GPIO
#define PAD_TS1_D6_IS_GPIO BALL_AC22_IS_GPIO
#endif

#define BALL_AG15 PAD_NAND_ALE
#define PAD_NAND_ALE 97
#define GPIO_PAD_97 GPIO96
#ifndef BALL_AG15_IS_GPIO
#define BALL_AG15_IS_GPIO 0
#endif
#ifndef PAD_NAND_ALE_IS_GPIO
#define PAD_NAND_ALE_IS_GPIO BALL_AG15_IS_GPIO
#endif

#define BALL_AC23 PAD_TS1_D7
#define PAD_TS1_D7 172
#define GPIO_PAD_172 GPIO171
#ifndef BALL_AC23_IS_GPIO
#define BALL_AC23_IS_GPIO 0
#endif
#ifndef PAD_TS1_D7_IS_GPIO
#define PAD_TS1_D7_IS_GPIO BALL_AC23_IS_GPIO
#endif

#define BALL_AH16 PAD_NAND_WPZ
#define PAD_NAND_WPZ 96
#define GPIO_PAD_96 GPIO95
#ifndef BALL_AH16_IS_GPIO
#define BALL_AH16_IS_GPIO 0
#endif
#ifndef PAD_NAND_WPZ_IS_GPIO
#define PAD_NAND_WPZ_IS_GPIO BALL_AH16_IS_GPIO
#endif

#define BALL_AD22 PAD_TS1_CLK
#define PAD_TS1_CLK 169
#define GPIO_PAD_169 GPIO168
#ifndef BALL_AD22_IS_GPIO
#define BALL_AD22_IS_GPIO 0
#endif
#ifndef PAD_TS1_CLK_IS_GPIO
#define PAD_TS1_CLK_IS_GPIO BALL_AD22_IS_GPIO
#endif

#define BALL_AF14 PAD_NAND_WEZ
#define PAD_NAND_WEZ 95
#define GPIO_PAD_95 GPIO94
#ifndef BALL_AF14_IS_GPIO
#define BALL_AF14_IS_GPIO 0
#endif
#ifndef PAD_NAND_WEZ_IS_GPIO
#define PAD_NAND_WEZ_IS_GPIO BALL_AF14_IS_GPIO
#endif

#define BALL_AD23 PAD_TS1_SYNC
#define PAD_TS1_SYNC 170
#define GPIO_PAD_170 GPIO169
#ifndef BALL_AD23_IS_GPIO
#define BALL_AD23_IS_GPIO 0
#endif
#ifndef PAD_TS1_SYNC_IS_GPIO
#define PAD_TS1_SYNC_IS_GPIO BALL_AD23_IS_GPIO
#endif

#define BALL_AG14 PAD_NAND_REZ
#define PAD_NAND_REZ 94
#define GPIO_PAD_94 GPIO93
#ifndef BALL_AG14_IS_GPIO
#define BALL_AG14_IS_GPIO 0
#endif
#ifndef PAD_NAND_REZ_IS_GPIO
#define PAD_NAND_REZ_IS_GPIO BALL_AG14_IS_GPIO
#endif

#define BALL_AE23 PAD_TS1_VLD
#define PAD_TS1_VLD 171
#define GPIO_PAD_171 GPIO170
#ifndef BALL_AE23_IS_GPIO
#define BALL_AE23_IS_GPIO 0
#endif
#ifndef PAD_TS1_VLD_IS_GPIO
#define PAD_TS1_VLD_IS_GPIO BALL_AE23_IS_GPIO
#endif

#define BALL_AH14 PAD_NAND_CLE
#define PAD_NAND_CLE 93
#define GPIO_PAD_93 GPIO92
#ifndef BALL_AH14_IS_GPIO
#define BALL_AH14_IS_GPIO 0
#endif
#ifndef PAD_NAND_CLE_IS_GPIO
#define PAD_NAND_CLE_IS_GPIO BALL_AH14_IS_GPIO
#endif

#define BALL_R25 PAD_VSYNC_LIKE
#define PAD_VSYNC_LIKE 90
#define GPIO_PAD_90 GPIO89
#ifndef BALL_R25_IS_GPIO
#define BALL_R25_IS_GPIO 0
#endif
#ifndef PAD_VSYNC_LIKE_IS_GPIO
#define PAD_VSYNC_LIKE_IS_GPIO BALL_R25_IS_GPIO
#endif

#define BALL_AG16 PAD_NAND_CEZ
#define PAD_NAND_CEZ 91
#define GPIO_PAD_91 GPIO90
#ifndef BALL_AG16_IS_GPIO
#define BALL_AG16_IS_GPIO 0
#endif
#ifndef PAD_NAND_CEZ_IS_GPIO
#define PAD_NAND_CEZ_IS_GPIO BALL_AG16_IS_GPIO
#endif

#define BALL_M24 PAD_PWM5
#define PAD_PWM5 142
#define GPIO_PAD_142 GPIO141
#ifndef BALL_M24_IS_GPIO
#define BALL_M24_IS_GPIO 0
#endif
#ifndef PAD_PWM5_IS_GPIO
#define PAD_PWM5_IS_GPIO BALL_M24_IS_GPIO
#endif

#define BALL_AF16 PAD_NAND_CEZ1
#define PAD_NAND_CEZ1 92
#define GPIO_PAD_92 GPIO91
#ifndef BALL_AF16_IS_GPIO
#define BALL_AF16_IS_GPIO 0
#endif
#ifndef PAD_NAND_CEZ1_IS_GPIO
#define PAD_NAND_CEZ1_IS_GPIO BALL_AF16_IS_GPIO
#endif

#define BALL_M25 PAD_PWM4
#define PAD_PWM4 141
#define GPIO_PAD_141 GPIO140
#ifndef BALL_M25_IS_GPIO
#define BALL_M25_IS_GPIO 0
#endif
#ifndef PAD_PWM4_IS_GPIO
#define PAD_PWM4_IS_GPIO BALL_M25_IS_GPIO
#endif

#define BALL_AH17 PAD_EMMC_CMD
#define PAD_EMMC_CMD 145
#define GPIO_PAD_145 GPIO144
#ifndef BALL_AH17_IS_GPIO
#define BALL_AH17_IS_GPIO 0
#endif
#ifndef PAD_EMMC_CMD_IS_GPIO
#define PAD_EMMC_CMD_IS_GPIO BALL_AH17_IS_GPIO
#endif

#define BALL_AG21 PAD_PWM3
#define PAD_PWM3 140
#define GPIO_PAD_140 GPIO139
#ifndef BALL_AG21_IS_GPIO
#define BALL_AG21_IS_GPIO 0
#endif
#ifndef PAD_PWM3_IS_GPIO
#define PAD_PWM3_IS_GPIO BALL_AG21_IS_GPIO
#endif

#define BALL_AG17 PAD_EMMC_CLK
#define PAD_EMMC_CLK 144
#define GPIO_PAD_144 GPIO143
#ifndef BALL_AG17_IS_GPIO
#define BALL_AG17_IS_GPIO 0
#endif
#ifndef PAD_EMMC_CLK_IS_GPIO
#define PAD_EMMC_CLK_IS_GPIO BALL_AG17_IS_GPIO
#endif

#define BALL_AF21 PAD_PWM2
#define PAD_PWM2 139
#define GPIO_PAD_139 GPIO138
#ifndef BALL_AF21_IS_GPIO
#define BALL_AF21_IS_GPIO 0
#endif
#ifndef PAD_PWM2_IS_GPIO
#define PAD_PWM2_IS_GPIO BALL_AF21_IS_GPIO
#endif

#define BALL_AF17 PAD_EMMC_RSTN
#define PAD_EMMC_RSTN 143
#define GPIO_PAD_143 GPIO142
#ifndef BALL_AF17_IS_GPIO
#define BALL_AF17_IS_GPIO 0
#endif
#ifndef PAD_EMMC_RSTN_IS_GPIO
#define PAD_EMMC_RSTN_IS_GPIO BALL_AF17_IS_GPIO
#endif

#define BALL_AE24 PAD_PWM1
#define PAD_PWM1 138
#define GPIO_PAD_138 GPIO137
#ifndef BALL_AE24_IS_GPIO
#define BALL_AE24_IS_GPIO 0
#endif
#ifndef PAD_PWM1_IS_GPIO
#define PAD_PWM1_IS_GPIO BALL_AE24_IS_GPIO
#endif

#define BALL_AG20 PAD_PCM_A0
#define PAD_PCM_A0 131
#define GPIO_PAD_131 GPIO130
#ifndef BALL_AG20_IS_GPIO
#define BALL_AG20_IS_GPIO 0
#endif
#ifndef PAD_PCM_A0_IS_GPIO
#define PAD_PCM_A0_IS_GPIO BALL_AG20_IS_GPIO
#endif

#define BALL_AC18 PAD_PWM0
#define PAD_PWM0 137
#define GPIO_PAD_137 GPIO136
#ifndef BALL_AC18_IS_GPIO
#define BALL_AC18_IS_GPIO 0
#endif
#ifndef PAD_PWM0_IS_GPIO
#define PAD_PWM0_IS_GPIO BALL_AC18_IS_GPIO
#endif

#define BALL_AH20 PAD_PCM_A1
#define PAD_PCM_A1 130
#define GPIO_PAD_130 GPIO129
#ifndef BALL_AH20_IS_GPIO
#define BALL_AH20_IS_GPIO 0
#endif
#ifndef PAD_PCM_A1_IS_GPIO
#define PAD_PCM_A1_IS_GPIO BALL_AH20_IS_GPIO
#endif

#define BALL_AF22 PAD_DDCR_CK
#define PAD_DDCR_CK 45
#define GPIO_PAD_45 GPIO44
#ifndef BALL_AF22_IS_GPIO
#define BALL_AF22_IS_GPIO 0
#endif
#ifndef PAD_DDCR_CK_IS_GPIO
#define PAD_DDCR_CK_IS_GPIO BALL_AF22_IS_GPIO
#endif

#define BALL_AF20 PAD_PCM_A2
#define PAD_PCM_A2 128
#define GPIO_PAD_128 GPIO127
#ifndef BALL_AF20_IS_GPIO
#define BALL_AF20_IS_GPIO 0
#endif
#ifndef PAD_PCM_A2_IS_GPIO
#define PAD_PCM_A2_IS_GPIO BALL_AF20_IS_GPIO
#endif

#define BALL_AG22 PAD_DDCR_DA
#define PAD_DDCR_DA 44
#define GPIO_PAD_44 GPIO43
#ifndef BALL_AG22_IS_GPIO
#define BALL_AG22_IS_GPIO 0
#endif
#ifndef PAD_DDCR_DA_IS_GPIO
#define PAD_DDCR_DA_IS_GPIO BALL_AG22_IS_GPIO
#endif

#define BALL_AH19 PAD_PCM_A3
#define PAD_PCM_A3 127
#define GPIO_PAD_127 GPIO126
#ifndef BALL_AH19_IS_GPIO
#define BALL_AH19_IS_GPIO 0
#endif
#ifndef PAD_PCM_A3_IS_GPIO
#define PAD_PCM_A3_IS_GPIO BALL_AH19_IS_GPIO
#endif

#define BALL_AH22 PAD_TCON0
#define PAD_TCON0 146
#define GPIO_PAD_146 GPIO145
#ifndef BALL_AH22_IS_GPIO
#define BALL_AH22_IS_GPIO 0
#endif
#ifndef PAD_TCON0_IS_GPIO
#define PAD_TCON0_IS_GPIO BALL_AH22_IS_GPIO
#endif

#define BALL_AG19 PAD_PCM_A4
#define PAD_PCM_A4 126
#define GPIO_PAD_126 GPIO125
#ifndef BALL_AG19_IS_GPIO
#define BALL_AG19_IS_GPIO 0
#endif
#ifndef PAD_PCM_A4_IS_GPIO
#define PAD_PCM_A4_IS_GPIO BALL_AG19_IS_GPIO
#endif

#define BALL_AF23 PAD_TCON1
#define PAD_TCON1 147
#define GPIO_PAD_147 GPIO146
#ifndef BALL_AF23_IS_GPIO
#define BALL_AF23_IS_GPIO 0
#endif
#ifndef PAD_TCON1_IS_GPIO
#define PAD_TCON1_IS_GPIO BALL_AF23_IS_GPIO
#endif

#define BALL_AF19 PAD_PCM_A5
#define PAD_PCM_A5 124
#define GPIO_PAD_124 GPIO123
#ifndef BALL_AF19_IS_GPIO
#define BALL_AF19_IS_GPIO 0
#endif
#ifndef PAD_PCM_A5_IS_GPIO
#define PAD_PCM_A5_IS_GPIO BALL_AF19_IS_GPIO
#endif

#define BALL_AH23 PAD_TCON2
#define PAD_TCON2 148
#define GPIO_PAD_148 GPIO147
#ifndef BALL_AH23_IS_GPIO
#define BALL_AH23_IS_GPIO 0
#endif
#ifndef PAD_TCON2_IS_GPIO
#define PAD_TCON2_IS_GPIO BALL_AH23_IS_GPIO
#endif

#define BALL_AG18 PAD_PCM_A6
#define PAD_PCM_A6 123
#define GPIO_PAD_123 GPIO122
#ifndef BALL_AG18_IS_GPIO
#define BALL_AG18_IS_GPIO 0
#endif
#ifndef PAD_PCM_A6_IS_GPIO
#define PAD_PCM_A6_IS_GPIO BALL_AG18_IS_GPIO
#endif

#define BALL_AG23 PAD_TCON3
#define PAD_TCON3 149
#define GPIO_PAD_149 GPIO148
#ifndef BALL_AG23_IS_GPIO
#define BALL_AG23_IS_GPIO 0
#endif
#ifndef PAD_TCON3_IS_GPIO
#define PAD_TCON3_IS_GPIO BALL_AG23_IS_GPIO
#endif

#define BALL_AF18 PAD_PCM_A7
#define PAD_PCM_A7 122
#define GPIO_PAD_122 GPIO121
#ifndef BALL_AF18_IS_GPIO
#define BALL_AF18_IS_GPIO 0
#endif
#ifndef PAD_PCM_A7_IS_GPIO
#define PAD_PCM_A7_IS_GPIO BALL_AF18_IS_GPIO
#endif

#define BALL_AF24 PAD_TCON4
#define PAD_TCON4 150
#define GPIO_PAD_150 GPIO149
#ifndef BALL_AF24_IS_GPIO
#define BALL_AF24_IS_GPIO 0
#endif
#ifndef PAD_TCON4_IS_GPIO
#define PAD_TCON4_IS_GPIO BALL_AF24_IS_GPIO
#endif

#define BALL_AD25 PAD_UART_RX2
#define PAD_UART_RX2 181
#define GPIO_PAD_181 GPIO180
#ifndef BALL_AD25_IS_GPIO
#define BALL_AD25_IS_GPIO 0
#endif
#ifndef PAD_UART_RX2_IS_GPIO
#define PAD_UART_RX2_IS_GPIO BALL_AD25_IS_GPIO
#endif

#define BALL_AE25 PAD_UART_TX2
#define PAD_UART_TX2 180
#define GPIO_PAD_180 GPIO179
#ifndef BALL_AE25_IS_GPIO
#define BALL_AE25_IS_GPIO 0
#endif
#ifndef PAD_UART_TX2_IS_GPIO
#define PAD_UART_TX2_IS_GPIO BALL_AE25_IS_GPIO
#endif

#define BALL_AG24 PAD_TCON5
#define PAD_TCON5 151
#define GPIO_PAD_151 GPIO150
#ifndef BALL_AG24_IS_GPIO
#define BALL_AG24_IS_GPIO 0
#endif
#ifndef PAD_TCON5_IS_GPIO
#define PAD_TCON5_IS_GPIO BALL_AG24_IS_GPIO
#endif

#define BALL_AF25 PAD_TCON6
#define PAD_TCON6 152
#define GPIO_PAD_152 GPIO151
#ifndef BALL_AF25_IS_GPIO
#define BALL_AF25_IS_GPIO 0
#endif
#ifndef PAD_TCON6_IS_GPIO
#define PAD_TCON6_IS_GPIO BALL_AF25_IS_GPIO
#endif

#define BALL_AG25 PAD_TCON7
#define PAD_TCON7 153
#define GPIO_PAD_153 GPIO152
#ifndef BALL_AG25_IS_GPIO
#define BALL_AG25_IS_GPIO 0
#endif
#ifndef PAD_TCON7_IS_GPIO
#define PAD_TCON7_IS_GPIO BALL_AG25_IS_GPIO
#endif

#define BALL_R23 PAD_SPI2_DI
#define PAD_SPI2_DI 89
#define GPIO_PAD_89 GPIO88
#ifndef BALL_R23_IS_GPIO
#define BALL_R23_IS_GPIO 0
#endif
#ifndef PAD_SPI2_DI_IS_GPIO
#define PAD_SPI2_DI_IS_GPIO BALL_R23_IS_GPIO
#endif

#define BALL_R24 PAD_SPI2_CK
#define PAD_SPI2_CK 88
#define GPIO_PAD_88 GPIO87
#ifndef BALL_R24_IS_GPIO
#define BALL_R24_IS_GPIO 0
#endif
#ifndef PAD_SPI2_CK_IS_GPIO
#define PAD_SPI2_CK_IS_GPIO BALL_R24_IS_GPIO
#endif

#define BALL_P23 PAD_SPI1_DI
#define PAD_SPI1_DI 87
#define GPIO_PAD_87 GPIO86
#ifndef BALL_P23_IS_GPIO
#define BALL_P23_IS_GPIO 0
#endif
#ifndef PAD_SPI1_DI_IS_GPIO
#define PAD_SPI1_DI_IS_GPIO BALL_P23_IS_GPIO
#endif

#define BALL_P24 PAD_SPI1_CK
#define PAD_SPI1_CK 86
#define GPIO_PAD_86 GPIO85
#ifndef BALL_P24_IS_GPIO
#define BALL_P24_IS_GPIO 0
#endif
#ifndef PAD_SPI1_CK_IS_GPIO
#define PAD_SPI1_CK_IS_GPIO BALL_P24_IS_GPIO
#endif

#define BALL_K26 PAD_SPDIF_IN
#define PAD_SPDIF_IN 77
#define GPIO_PAD_77 GPIO76
#ifndef BALL_K26_IS_GPIO
#define BALL_K26_IS_GPIO 0
#endif
#ifndef PAD_SPDIF_IN_IS_GPIO
#define PAD_SPDIF_IN_IS_GPIO BALL_K26_IS_GPIO
#endif

#define BALL_L23 PAD_SPDIF_OUT
#define PAD_SPDIF_OUT 78
#define GPIO_PAD_78 GPIO77
#ifndef BALL_L23_IS_GPIO
#define BALL_L23_IS_GPIO 0
#endif
#ifndef PAD_SPDIF_OUT_IS_GPIO
#define PAD_SPDIF_OUT_IS_GPIO BALL_L23_IS_GPIO
#endif

#define BALL_K11 PAD_I2S_IN_WS
#define PAD_I2S_IN_WS 74
#define GPIO_PAD_74 GPIO73
#ifndef BALL_K11_IS_GPIO
#define BALL_K11_IS_GPIO 0
#endif
#ifndef PAD_I2S_IN_WS_IS_GPIO
#define PAD_I2S_IN_WS_IS_GPIO BALL_K11_IS_GPIO
#endif

#define BALL_L11 PAD_I2S_IN_BCK
#define PAD_I2S_IN_BCK 75
#define GPIO_PAD_75 GPIO74
#ifndef BALL_L11_IS_GPIO
#define BALL_L11_IS_GPIO 0
#endif
#ifndef PAD_I2S_IN_BCK_IS_GPIO
#define PAD_I2S_IN_BCK_IS_GPIO BALL_L11_IS_GPIO
#endif

#define PAD_GPIO0 9999
#ifndef PAD_GPIO0_IS_GPIO
#define PAD_GPIO0_IS_GPIO 0
#endif

#define BALL_J10 PAD_I2S_IN_SD
#define PAD_I2S_IN_SD 76
#define GPIO_PAD_76 GPIO75
#ifndef BALL_J10_IS_GPIO
#define BALL_J10_IS_GPIO 0
#endif
#ifndef PAD_I2S_IN_SD_IS_GPIO
#define PAD_I2S_IN_SD_IS_GPIO BALL_J10_IS_GPIO
#endif

#define PAD_GPIO1 9999
#ifndef PAD_GPIO1_IS_GPIO
#define PAD_GPIO1_IS_GPIO 0
#endif

#define BALL_K24 PAD_I2S_OUT_MCK
#define PAD_I2S_OUT_MCK 80
#define GPIO_PAD_80 GPIO79
#ifndef BALL_K24_IS_GPIO
#define BALL_K24_IS_GPIO 0
#endif
#ifndef PAD_I2S_OUT_MCK_IS_GPIO
#define PAD_I2S_OUT_MCK_IS_GPIO BALL_K24_IS_GPIO
#endif

#define PAD_GPIO9 9999
#ifndef PAD_GPIO9_IS_GPIO
#define PAD_GPIO9_IS_GPIO 0
#endif

#define PAD_GPIO10 9999
#ifndef PAD_GPIO10_IS_GPIO
#define PAD_GPIO10_IS_GPIO 0
#endif

#define BALL_K23 PAD_I2S_OUT_WS
#define PAD_I2S_OUT_WS 79
#define GPIO_PAD_79 GPIO78
#ifndef BALL_K23_IS_GPIO
#define BALL_K23_IS_GPIO 0
#endif
#ifndef PAD_I2S_OUT_WS_IS_GPIO
#define PAD_I2S_OUT_WS_IS_GPIO BALL_K23_IS_GPIO
#endif

#define PAD_GPIO11 9999
#ifndef PAD_GPIO11_IS_GPIO
#define PAD_GPIO11_IS_GPIO 0
#endif

#define PAD_I2S_OUT_SD1 9999
#ifndef PAD_I2S_OUT_SD1_IS_GPIO
#define PAD_I2S_OUT_SD1_IS_GPIO 0
#endif

#define PAD_GPIO12 9999
#ifndef PAD_GPIO12_IS_GPIO
#define PAD_GPIO12_IS_GPIO 0
#endif

#define BALL_L24 PAD_I2S_OUT_BCK
#define PAD_I2S_OUT_BCK 81
#define GPIO_PAD_81 GPIO80
#ifndef BALL_L24_IS_GPIO
#define BALL_L24_IS_GPIO 0
#endif
#ifndef PAD_I2S_OUT_BCK_IS_GPIO
#define PAD_I2S_OUT_BCK_IS_GPIO BALL_L24_IS_GPIO
#endif

#define PAD_GPIO13 9999
#ifndef PAD_GPIO13_IS_GPIO
#define PAD_GPIO13_IS_GPIO 0
#endif

#define BALL_K25 PAD_I2S_OUT_SD
#define PAD_I2S_OUT_SD 82
#define GPIO_PAD_82 GPIO81
#ifndef BALL_K25_IS_GPIO
#define BALL_K25_IS_GPIO 0
#endif
#ifndef PAD_I2S_OUT_SD_IS_GPIO
#define PAD_I2S_OUT_SD_IS_GPIO BALL_K25_IS_GPIO
#endif

#define PAD_GPIO14 9999
#ifndef PAD_GPIO14_IS_GPIO
#define PAD_GPIO14_IS_GPIO 0
#endif

#define PAD_I2S_OUT_SD2 9999
#ifndef PAD_I2S_OUT_SD2_IS_GPIO
#define PAD_I2S_OUT_SD2_IS_GPIO 0
#endif

#define PAD_I2S_OUT_SD3 9999
#ifndef PAD_I2S_OUT_SD3_IS_GPIO
#define PAD_I2S_OUT_SD3_IS_GPIO 0
#endif

#define BALL_M23 PAD_GPIO16
#define PAD_GPIO16 62
#define GPIO_PAD_62 GPIO61
#ifndef BALL_M23_IS_GPIO
#define BALL_M23_IS_GPIO 0
#endif
#ifndef PAD_GPIO16_IS_GPIO
#define PAD_GPIO16_IS_GPIO BALL_M23_IS_GPIO
#endif

#define PAD_GPIO15 9999
#ifndef PAD_GPIO15_IS_GPIO
#define PAD_GPIO15_IS_GPIO 0
#endif

#define PAD_GPIO2 9999
#ifndef PAD_GPIO2_IS_GPIO
#define PAD_GPIO2_IS_GPIO 0
#endif

#define BALL_AC24 PAD_GPIO3
#define PAD_GPIO3 49
#define GPIO_PAD_49 GPIO48
#ifndef BALL_AC24_IS_GPIO
#define BALL_AC24_IS_GPIO 0
#endif
#ifndef PAD_GPIO3_IS_GPIO
#define PAD_GPIO3_IS_GPIO BALL_AC24_IS_GPIO
#endif

#define BALL_AD24 PAD_GPIO4
#define PAD_GPIO4 50
#define GPIO_PAD_50 GPIO49
#ifndef BALL_AD24_IS_GPIO
#define BALL_AD24_IS_GPIO 0
#endif
#ifndef PAD_GPIO4_IS_GPIO
#define PAD_GPIO4_IS_GPIO BALL_AD24_IS_GPIO
#endif

#define PAD_GPIO5 9999
#ifndef PAD_GPIO5_IS_GPIO
#define PAD_GPIO5_IS_GPIO 0
#endif

#define PAD_GPIO6 9999
#ifndef PAD_GPIO6_IS_GPIO
#define PAD_GPIO6_IS_GPIO 0
#endif

#define PAD_GPIO7 9999
#ifndef PAD_GPIO7_IS_GPIO
#define PAD_GPIO7_IS_GPIO 0
#endif

#define PAD_GPIO8 9999
#ifndef PAD_GPIO8_IS_GPIO
#define PAD_GPIO8_IS_GPIO 0
#endif

#define PAD_GPIO26 9999
#ifndef PAD_GPIO26_IS_GPIO
#define PAD_GPIO26_IS_GPIO 0
#endif

#define PAD_GPIO25 9999
#ifndef PAD_GPIO25_IS_GPIO
#define PAD_GPIO25_IS_GPIO 0
#endif

#define PAD_GPIO23 9999
#ifndef PAD_GPIO23_IS_GPIO
#define PAD_GPIO23_IS_GPIO 0
#endif

#define PAD_GPIO17 9999
#ifndef PAD_GPIO17_IS_GPIO
#define PAD_GPIO17_IS_GPIO 0
#endif

#define PAD_GPIO18 9999
#ifndef PAD_GPIO18_IS_GPIO
#define PAD_GPIO18_IS_GPIO 0
#endif

#define BALL_K2 PAD_GPIO19
#define PAD_GPIO19 65
#define GPIO_PAD_65 GPIO64
#ifndef BALL_K2_IS_GPIO
#define BALL_K2_IS_GPIO 0
#endif
#ifndef PAD_GPIO19_IS_GPIO
#define PAD_GPIO19_IS_GPIO BALL_K2_IS_GPIO
#endif

#define PAD_GPIO22 9999
#ifndef PAD_GPIO22_IS_GPIO
#define PAD_GPIO22_IS_GPIO 0
#endif

#define BALL_K3 PAD_GPIO20
#define PAD_GPIO20 66
#define GPIO_PAD_66 GPIO65
#ifndef BALL_K3_IS_GPIO
#define BALL_K3_IS_GPIO 0
#endif
#ifndef PAD_GPIO20_IS_GPIO
#define PAD_GPIO20_IS_GPIO BALL_K3_IS_GPIO
#endif

#define PAD_GPIO24 9999
#ifndef PAD_GPIO24_IS_GPIO
#define PAD_GPIO24_IS_GPIO 0
#endif

#define PAD_GPIO27 9999
#ifndef PAD_GPIO27_IS_GPIO
#define PAD_GPIO27_IS_GPIO 0
#endif

#define PAD_GPIO21 9999
#ifndef PAD_GPIO21_IS_GPIO
#define PAD_GPIO21_IS_GPIO 0
#endif

#define BALL_G6 PAD_SAR0
#define PAD_SAR0 36
#define GPIO_PAD_36 GPIO35
#ifndef BALL_G6_IS_GPIO
#define BALL_G6_IS_GPIO 0
#endif
#ifndef PAD_SAR0_IS_GPIO
#define PAD_SAR0_IS_GPIO BALL_G6_IS_GPIO
#endif

#define BALL_H6 PAD_SAR1
#define PAD_SAR1 37
#define GPIO_PAD_37 GPIO36
#ifndef BALL_H6_IS_GPIO
#define BALL_H6_IS_GPIO 0
#endif
#ifndef PAD_SAR1_IS_GPIO
#define PAD_SAR1_IS_GPIO BALL_H6_IS_GPIO
#endif

#define BALL_J6 PAD_SAR2
#define PAD_SAR2 38
#define GPIO_PAD_38 GPIO37
#ifndef BALL_J6_IS_GPIO
#define BALL_J6_IS_GPIO 0
#endif
#ifndef PAD_SAR2_IS_GPIO
#define PAD_SAR2_IS_GPIO BALL_J6_IS_GPIO
#endif

#define BALL_K6 PAD_SAR3
#define PAD_SAR3 39
#define GPIO_PAD_39 GPIO38
#ifndef BALL_K6_IS_GPIO
#define BALL_K6_IS_GPIO 0
#endif
#ifndef PAD_SAR3_IS_GPIO
#define PAD_SAR3_IS_GPIO BALL_K6_IS_GPIO
#endif

#define PAD_SAR4 9999
#ifndef PAD_SAR4_IS_GPIO
#define PAD_SAR4_IS_GPIO 0
#endif

#define BALL_G5 PAD_VID0
#define PAD_VID0 41
#define GPIO_PAD_41 GPIO40
#ifndef BALL_G5_IS_GPIO
#define BALL_G5_IS_GPIO 0
#endif
#ifndef PAD_VID0_IS_GPIO
#define PAD_VID0_IS_GPIO BALL_G5_IS_GPIO
#endif

#define BALL_G4 PAD_VID1
#define PAD_VID1 42
#define GPIO_PAD_42 GPIO41
#ifndef BALL_G4_IS_GPIO
#define BALL_G4_IS_GPIO 0
#endif
#ifndef PAD_VID1_IS_GPIO
#define PAD_VID1_IS_GPIO BALL_G4_IS_GPIO
#endif

#define BALL_K1 PAD_GPIO_PM6
#define PAD_GPIO_PM6 17
#define GPIO_PAD_17 GPIO16
#ifndef BALL_K1_IS_GPIO
#define BALL_K1_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM6_IS_GPIO
#define PAD_GPIO_PM6_IS_GPIO BALL_K1_IS_GPIO
#endif

#define BALL_F2 PAD_GPIO_PM5
#define PAD_GPIO_PM5 16
#define GPIO_PAD_16 GPIO15
#ifndef BALL_F2_IS_GPIO
#define BALL_F2_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM5_IS_GPIO
#define PAD_GPIO_PM5_IS_GPIO BALL_F2_IS_GPIO
#endif

#define BALL_H5 PAD_GPIO_PM4
#define PAD_GPIO_PM4 15
#define GPIO_PAD_15 GPIO14
#ifndef BALL_H5_IS_GPIO
#define BALL_H5_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM4_IS_GPIO
#define PAD_GPIO_PM4_IS_GPIO BALL_H5_IS_GPIO
#endif

#define BALL_AD5 PAD_GPIO_PM3
#define PAD_GPIO_PM3 14
#define GPIO_PAD_14 GPIO13
#ifndef BALL_AD5_IS_GPIO
#define BALL_AD5_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM3_IS_GPIO
#define PAD_GPIO_PM3_IS_GPIO BALL_AD5_IS_GPIO
#endif

#define BALL_AC7 PAD_GPIO_PM2
#define PAD_GPIO_PM2 13
#define GPIO_PAD_13 GPIO12
#ifndef BALL_AC7_IS_GPIO
#define BALL_AC7_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM2_IS_GPIO
#define PAD_GPIO_PM2_IS_GPIO BALL_AC7_IS_GPIO
#endif

#define BALL_F3 PAD_GPIO_PM1
#define PAD_GPIO_PM1 12
#define GPIO_PAD_12 GPIO11
#ifndef BALL_F3_IS_GPIO
#define BALL_F3_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM1_IS_GPIO
#define PAD_GPIO_PM1_IS_GPIO BALL_F3_IS_GPIO
#endif

#define BALL_W6 PAD_GPIO_PM11
#define PAD_GPIO_PM11 22
#define GPIO_PAD_22 GPIO21
#ifndef BALL_W6_IS_GPIO
#define BALL_W6_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM11_IS_GPIO
#define PAD_GPIO_PM11_IS_GPIO BALL_W6_IS_GPIO
#endif

#define BALL_L6 PAD_GPIO_PM10
#define PAD_GPIO_PM10 21
#define GPIO_PAD_21 GPIO20
#ifndef BALL_L6_IS_GPIO
#define BALL_L6_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM10_IS_GPIO
#define PAD_GPIO_PM10_IS_GPIO BALL_L6_IS_GPIO
#endif

#define BALL_AB14 PAD_GPIO_PM9
#define PAD_GPIO_PM9 20
#define GPIO_PAD_20 GPIO19
#ifndef BALL_AB14_IS_GPIO
#define BALL_AB14_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM9_IS_GPIO
#define PAD_GPIO_PM9_IS_GPIO BALL_AB14_IS_GPIO
#endif

#define BALL_M6 PAD_GPIO_PM8
#define PAD_GPIO_PM8 19
#define GPIO_PAD_19 GPIO18
#ifndef BALL_M6_IS_GPIO
#define BALL_M6_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM8_IS_GPIO
#define PAD_GPIO_PM8_IS_GPIO BALL_M6_IS_GPIO
#endif

#define BALL_W5 PAD_GPIO_PM7
#define PAD_GPIO_PM7 18
#define GPIO_PAD_18 GPIO17
#ifndef BALL_W5_IS_GPIO
#define BALL_W5_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM7_IS_GPIO
#define PAD_GPIO_PM7_IS_GPIO BALL_W5_IS_GPIO
#endif

#define BALL_H3 PAD_PM_SPI_CK
#define PAD_PM_SPI_CK 2
#define GPIO_PAD_2 GPIO1
#ifndef BALL_H3_IS_GPIO
#define BALL_H3_IS_GPIO 0
#endif
#ifndef PAD_PM_SPI_CK_IS_GPIO
#define PAD_PM_SPI_CK_IS_GPIO BALL_H3_IS_GPIO
#endif

#define BALL_G3 PAD_PM_SPI_DI
#define PAD_PM_SPI_DI 3
#define GPIO_PAD_3 GPIO2
#ifndef BALL_G3_IS_GPIO
#define BALL_G3_IS_GPIO 0
#endif
#ifndef PAD_PM_SPI_DI_IS_GPIO
#define PAD_PM_SPI_DI_IS_GPIO BALL_G3_IS_GPIO
#endif

#define BALL_G2 PAD_PM_SPI_DO
#define PAD_PM_SPI_DO 4
#define GPIO_PAD_4 GPIO3
#ifndef BALL_G2_IS_GPIO
#define BALL_G2_IS_GPIO 0
#endif
#ifndef PAD_PM_SPI_DO_IS_GPIO
#define PAD_PM_SPI_DO_IS_GPIO BALL_G2_IS_GPIO
#endif

#define BALL_K10 PAD_PM_SPI_CZ
#define PAD_PM_SPI_CZ 1
#define GPIO_PAD_1 GPIO0
#ifndef BALL_K10_IS_GPIO
#define BALL_K10_IS_GPIO 0
#endif
#ifndef PAD_PM_SPI_CZ_IS_GPIO
#define PAD_PM_SPI_CZ_IS_GPIO BALL_K10_IS_GPIO
#endif

#define BALL_J5 PAD_PM_LED
#define PAD_PM_LED 23
#define GPIO_PAD_23 GPIO22
#ifndef BALL_J5_IS_GPIO
#define BALL_J5_IS_GPIO 0
#endif
#ifndef PAD_PM_LED_IS_GPIO
#define PAD_PM_LED_IS_GPIO BALL_J5_IS_GPIO
#endif

#define BALL_N6 PAD_GPIO_PM0
#define PAD_GPIO_PM0 11
#define GPIO_PAD_11 GPIO10
#ifndef BALL_N6_IS_GPIO
#define BALL_N6_IS_GPIO 0
#endif
#ifndef PAD_GPIO_PM0_IS_GPIO
#define PAD_GPIO_PM0_IS_GPIO BALL_N6_IS_GPIO
#endif

#define BALL_J4 PAD_PWM_PM
#define PAD_PWM_PM 8
#define GPIO_PAD_8 GPIO7
#ifndef BALL_J4_IS_GPIO
#define BALL_J4_IS_GPIO 0
#endif
#ifndef PAD_PWM_PM_IS_GPIO
#define PAD_PWM_PM_IS_GPIO BALL_J4_IS_GPIO
#endif

#define BALL_V5 PAD_DDCDA_DA
#define PAD_DDCDA_DA 29
#define GPIO_PAD_29 GPIO28
#ifndef BALL_V5_IS_GPIO
#define BALL_V5_IS_GPIO 0
#endif
#ifndef PAD_DDCDA_DA_IS_GPIO
#define PAD_DDCDA_DA_IS_GPIO BALL_V5_IS_GPIO
#endif

#define BALL_U5 PAD_DDCDA_CK
#define PAD_DDCDA_CK 28
#define GPIO_PAD_28 GPIO27
#ifndef BALL_U5_IS_GPIO
#define BALL_U5_IS_GPIO 0
#endif
#ifndef PAD_DDCDA_CK_IS_GPIO
#define PAD_DDCDA_CK_IS_GPIO BALL_U5_IS_GPIO
#endif

#define PAD_DDCDB_DA 9999
#ifndef PAD_DDCDB_DA_IS_GPIO
#define PAD_DDCDB_DA_IS_GPIO 0
#endif

#define PAD_DDCDB_CK 9999
#ifndef PAD_DDCDB_CK_IS_GPIO
#define PAD_DDCDB_CK_IS_GPIO 0
#endif


// PADS group name to index
#define PADS_PCMCONFIG_MODE1        1223
#define PADS_PCMCONFIG_MODE2        1224
#define PADS_PCMCONFIG1_MODE1       1225
#define PADS_PCMCONFIG1_MODE2       1226
#define PADS_PCMCONFIG1_MODE3       1227
#define PADS_PCM2CONFIG_MODE1       1228
#define PADS_PCM2CONFIG_MODE2       1229
#define PADS_PCM2CONFIG_MODE3       1230
#define PADS_PCM2CONFIG1_MODE1      1231
#define PADS_PCM2CONFIG1_MODE2      1232
#define PADS_ET_MODE1               1233
#define PADS_ET_MODE2               1234
#define PADS_DDCR                   1235
#define PADS_DDCR2                  1236
#define PADS_PCM                    1237

// chip capbilities
#define CHIP_HAS_BT656_IN           0
#define CHIP_HAS_TS0                1
#define CHIP_HAS_TS1                0
#define CHIP_HAS_LVDS_10BIT_X2      1
#define CHIP_HAS_LVDS_8BIT_X2       1
#define CHIP_HAS_LVDS_8BIT_X1       1
#define CHIP_HAS_CIMAX              0
#define CHIP_HAS_USB_P0             1
#define CHIP_HAS_USB_P1             1
#define CHIP_HAS_USBVBUS0           0
#define CHIP_HAS_USBVBUS1           0
#define CHIP_HAS_UART1_MODE1        1
#define CHIP_HAS_UART1_MODE2        1
#define CHIP_HAS_UART1_MODE3        1
#define CHIP_HAS_PCMCIA1            0
#define CHIP_HAS_PCMCIA2            0
#define CHIP_HAS_PCMCIA             0
#define CHIP_HAS_UART2_MODE1        1
#define CHIP_HAS_UART2_MODE2        1
#define CHIP_HAS_UART2_MODE3        1
#define CHIP_HAS_RGB_A              1
#define CHIP_HAS_RGB_B              1
#define CHIP_HAS_RGB_C              1
#define CHIP_HAS_HDMI_A             1
#define CHIP_HAS_HDMI_B             1
#define CHIP_HAS_HDMI_C             1
#define CHIP_HAS_SPI_CZ1            1
#define CHIP_HAS_SPI_CZ2            0
#define CHIP_HAS_SPI_CZ3            0
#define CHIP_HAS_DDCR               1
#define CHIP_HAS_DDCR2              1
#define CHIP_HAS_TCON               1
#define CHIP_HAS_ET_MODE0_MII       1
#define CHIP_HAS_ET_MODE0_RMII      1
#define CHIP_HAS_ET_MODE1_MII       1
#define CHIP_HAS_ET_MODE1_RMII      1
#define CHIP_HAS_ET_MODE2_MII       1
#define CHIP_HAS_ET_MODE2_RMII      1
#define CHIP_HAS_I2S_IN             0
#define CHIP_HAS_I2S_OUT            0
#define CHIP_HAS_SPDIF_IN           0
#define CHIP_HAS_SPDIF_OUT          0
#define CHIP_HAS_DDR_A_CMD          1
#define CHIP_HAS_DDR_A_DATA         1
#define CHIP_HAS_DDR_B_CMD          1
#define CHIP_HAS_DDR_B_DATA         1
#define CHIP_USE_PCM_CDN_IN_PCM2    0
#define CHIP_USE_I2S_IN_IN_PCM      0
#define CHIP_USE_I2S_OUT_IN_PCM     0
#define CHIP_USE_SPDIF_IN_IN_PCM    0
#define CHIP_USE_SPDIF_OUT_IN_PCM   0
#define CHIP_USE_IIC_IN_DDCR2       0
#define CHIP_USE_PWM2_IN_GPIO14     0
#define CHIP_USE_PWM3_IN_GPIO15     0

// chip additional information
#define CHIP_FAMILY_TYPE            CHIP_FAMILY_M7332

#endif /* _FPGA_M7332_H_ */
