#!/usr/bin/python

# This tool will convert symbol address to its symbol name which is generated during teeloader compiling process,
# and the goal of this tool is making the profiling information more readable.
# teeloader_sym.py usage
# python teeloader_sym.py INPUT.txt
# How to generate INPUT.txt
# Step1: Enable CONFIG_TEE_LOADER_SHOW_TIME_ELAPSE for teeloader compiling
# Step2: Please keep teeloader_sym.txt under sboot generated by teeloader compiling
# Step3: Copy the strings output by terminal that contain branckets and the text pattern of Enter or Exit (eg:[000000F5]Enter  2002xxxx) into INPUT.txt
# Step4: python teeloader_sym.py INPUT.txt which will convert all addresses into the corresponding symbol name referred to teeloader_sym.txt

import sys
import os
import re
from os.path import join
from subprocess import Popen, PIPE
import array

        
def get_nmap(path):
    out = open(path,'r').read();
    return dict([(m[0], (m[2]))
        for m in re.findall('([0-9a-zA-Z]{8})\s*(.)\s*(.+)', out)])
        
def get_txt(str):
    return dict([(m[0], (m[1],m[2]))
        #for m in re.findall('(\[[0-9a-zA-Z]{8}\]Enter)\s*(.)\s*(.+)', f)])
        for m in re.findall('(\[[0-9a-zA-Z]{8}\])(E....)\s*([0-9a-zA-Z]{8})', str)])
        
def get_type(str):
    return dict([(m[0],(m[1]))
        for m in re.findall('(\[[0-9a-zA-Z]{8}\])(E....)\s*', str)])
        
def get_address(str):
    return dict([(m[0],(m[2]))
        for m in re.findall('(\[[0-9a-zA-Z]{8}\])(E....)\s*([0-9a-zA-Z]{8})', str)])
        
def main(argv):
    input_f = sys.argv[1]
    
    sboot_nmap = get_nmap( "./teeloader_sym.txt")
    
    f = open(input_f,'rt')
    for x in f:
      address=''.join(get_address(x).values())
      if len(address)>0:
          print ''.join(get_type(x).keys())+' '+''.join(get_type(x).values())+' '+sboot_nmap[address.lower()]
    
    f.close()

if __name__ == '__main__':
    main(sys.argv)