#include <typedef.h>

/* tony add for polling mode */
#ifdef POLLING_MODE
#include <hal_usb_drc.h>
#include <ubootglue_udc.h>
#endif

/* tony include for uboot */
#include <common.h>
#include <stdio.h>

#include "drvSYS.h"
#include "fastboot.h"

/*
void Mstar_Count_Down(u8 x)
{
	u8 i = 0;

	for(i = 0;i < x; i++)
	{
		printf("\r%02d", (x-1)-i);

		MsSleep(1000);
	}

	printf("\n\r");
}
*/


extern int fastboot_init(void);
extern int fastboot_command_loop(void);
extern int do_getvar_serialno(const char *, const char *, unsigned int);


#ifdef USB_GET_ENV_SERIAL
int GetEnvSerialNum(void)
{
	char *sptr = NULL;
	uint16_t did[8];
	char sBuf[32];
	int  ret = 0, slen;

	memset(did, 0, 8 * sizeof(uint16_t));
	memset(sBuf, 0, 32);

	sptr = getenv("serialno");
	if (sptr) {
		slen = strlen(sptr);
		if (slen > 31)
			slen = 31;
		memcpy(sBuf, sptr, slen);
		printf("EvnSerial:%s\n", sBuf);
	} else {
		ret = MDrv_SYS_GetEfuseDid(did);
		if(ret != 1)
		{
			printf("MDrv_SYS_GetEfuseDid fail\n");
		}
		/* set default id */
		snprintf(sBuf, 10, "%02x%02x%02x%02x%02x", did[0], did[1], did[2], did[3], did[4]);
		printf("efuse id:%s\n", sBuf);
	}

	if (strlen(sBuf))
		usb_SetSerialDesc(sBuf);

	return 0;
}
#endif

/*
 *  Entry funciton for MStar USB test
 */
int mstar_usb_main(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	/*u8 select = 1;*/

	printf("==========Config Info========== \r\n");
	printf("[Info] EPCONTROL : EP%d \r\n", EPCONTROL);
	printf("[Info] EPBULKIN  : EP%d \r\n", EPBULKIN);
	printf("[Info] EPBULKOUT : EP%d \r\n", EPBULKOUT);
	printf("[Info] EPINTIN   : EP%d \r\n", EPINTIN);
	printf("[Info] EPISO     : EP%d \r\n", EPISO);
	

#ifdef USB_20
	printf("[Info] Device is working in High Speed Mode \r\n");
#else
	printf("[Info] Device is working in Full Speed Mode \r\n");
#endif

#ifdef DMA
	printf("[Info] Data movement in DMA mode \r\n");
#else
	printf("[Info] Data movement in FIFO mode \r\n");
#endif

#ifdef POLLING_MODE
	printf("[Info] Event is generated by POLLING \r\n");
#else
	printf("[Info] Event is generated by INTERRUPT \r\n");
#endif

/*
	printf("===========[ Count Down ]===========\n\r");

	Mstar_Count_Down(2);
*/
#ifdef FASTBOOT_INTERACTIVE

	printf("[Info] (4) MTK Fastboot Test fucntion \n\r");
	printf("[Info] Plz select: \n\r");

	select = getc() - '0';

	printf("\n\r");

	switch(select)
	{
#if 0
		case	1:
			/* USB SCSI Device fucntion start */
			DrvUsbUtilitySwitchOnUSB (USBFUN_USB_MassStorage);
			DrvUsbUtilitySelClass (USBFUN_USB_MassStorage);
			
			break;

		case	2:
			/* USB CDC Device fucntion start */
			DrvUsbUtilitySwitchOnUSB (USBFUN_USB_VirtCOM);
			DrvUsbUtilitySelClass (USBFUN_USB_VirtCOM);

			break;

		case	3:
			/* For Fastboot */
			DrvUsbUtilitySwitchOnUSB (USBFUN_USB_AndroidDevice);
			DrvUsbUtilitySelClass (USBFUN_USB_AndroidDevice);

			printf("Fastboot is comming soon \n\r");
#endif

		case	4:
			printf("MTK Fastboot..\n\r");

			// alloc desc, ep0 SW structure
			udc_init(/*&surf_udc_device*/);
			
			// init fastboot function driver

#ifdef MSTAR_USB_UDC_GLUE
			if (fastboot_init() == 0)
			{
				// fill desc, unmask int
				udc_start();
				
				if (fastboot_command_loop()) {
					//printf("Due to performance issue, USB Full Speed is not supported\n");
					printf("Device disconnected\n");
					USB_REG_WRITE8(M_REG_POWER, (USB_REG_READ8(M_REG_POWER) & ~M_POWER_SOFTCONN));
				}	
			}

#endif			
			break;
		default:
			printf("Wrong Selection \n\r");

			break;
	}

#else

		printf("MTK Fastboot..\n\r");

		// alloc desc, ep0 SW structure
		udc_init(/*&surf_udc_device*/);

		// init fastboot function driver

#ifdef MSTAR_USB_UDC_GLUE

	printf("[Info] MTK USB Fastboot Test fucntion \n\r");

	if (fastboot_init() == 0) {

		/* Get serial number */
#ifdef USB_GET_ENV_SERIAL
		GetEnvSerialNum();
#endif
		// fill desc, unmask int
		udc_start();

		if (fastboot_command_loop()) {
			//printf("Due to performance issue, USB Full Speed is not supported\n");
			printf("Device disconnected\n");
			USB_REG_WRITE8(M_REG_POWER, (USB_REG_READ8(M_REG_POWER) & ~M_POWER_SOFTCONN));
		}
	}
#endif

#endif

	return 0;
}

/*
 * Register entry fucntion into U-boot command
 */
U_BOOT_CMD(mstar_usb, 5, 1, mstar_usb_main, "MStar USB Driver Porting", "\n    - MStar USB Driver Porting \n");
