//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
//-------------------------------------------------------------------------------------------------
// Includes
//-------------------------------------------------------------------------------------------------
#include <common.h>
#include <MsTypes.h>
#include <CusUpgrade.h>
#include <CusUpgradeUtility.h>
#include <MsUpgrade.h>
#include <MsUpgradeUtility.h>
#include <MsSystem.h>
#include <MsUtility.h>
#include <MsVfs.h>
#include <MsDebug.h>
#include <fat.h>
#include <MsBoot.h>
#include <MsAppCB.h>
#include <MsOS.h>
#include <apiSWI2C.h>
#include <CusCastTV.h>
#include"mstar_string_emnu.h"
#include <ursa/ursa_common.h>
#include <ursa/ursa_20.h>

#if defined (CONFIG_MTK_BD_MT168B_TPV_PHILIPS_10AT_19133_MT5870_M7332)
#define TPV_LONG_FILE_NAME_UPGRADE_SUPPORT
#define TPV_FW_UPGRADE_FILTER
#elif defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
#define TPV_LONG_FILE_NAME_UPGRADE_SUPPORT
#define TPV_FW_UPGRADE_FILTER
#endif

#if defined(CONFIG_UPGRADE_URSA)
#include <bootlogo/MsPoolDB.h>
#endif
#if defined (CONFIG_URSA_6M60)
#include <ursa/ursa_6m60.h>
#endif

#if (ENABLE_MODULE_USB == 1)
#include <usb.h>
#if (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
#include <msAPI_Power.h>
#endif
#endif
#if (ENABLE_MODULE_DISPLAY_OSD==1)
int display_osd = 0;
#endif

#if defined(CONFIG_CMD_WRITE_DATA_TO_RAW_PARTITION_ENABLE) && (CONFIG_CMD_WRITE_DATA_TO_RAW_PARTITION_ENABLE==1)
#include <MsRawIO.h>
#endif

#ifndef MI_TPV_MODEL_T32_SOEM_PJ
#include <drvGPIO.h>
#endif

#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT) 
#include <MsApiFat.h>
#include "MsString.h"
#endif

#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT) || defined (TPV_FW_UPGRADE_FILTER)
#include <stdbool.h>
#endif

#if defined (TPV_FW_UPGRADE_FILTER) 
#include "eeprom_if.h"
#endif

MS_BOOL bIsUpgrade = FALSE;
//-------------------------------------------------------------------------------------------------
//  Debug Functions
//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
//  Local Defines
//-------------------------------------------------------------------------------------------------
#define GWIN_WIDTH              720
#define GWIN_HEIGHT             576
#define GRAPHIC_WIDTH           600
#define GRAPHIC_HEIGHT          400
#define GRAPHIC_X               60
#define GRAPHIC_Y               88
#define LINE_HEIGHT             50
#define RECT_LEFT_INTERVAL      50
#define UPGRADE_BUFFER_SIZE 0x4000000
#if ENABLE_DISPLAY_PICTURE_UPDATE
#define GWIN_PIC_WIDTH              1280
#define GWIN_PIC_HEIGHT             720
#define GRAPHIC_PIC_WIDTH           1280
#define GRAPHIC_PIC_HEIGHT          720
#define GRAPHIC_PIC_X               0
#define GRAPHIC_PIC_Y               0
#define EN_PIC_BASE_PATH            "updating_en_base.jpg"
#define EN_PIC_ERROR_PATH           "updating_en_unsuccessful.jpg"
#define EN_PIC_PROGRESS_X           560
#define EN_PIC_PROGRESS_Y           220
#define EN_PIC_PROGRESS_WIDTH       80
#define EN_PIC_PROGRESS_HEIGHT      60
#define EN_PIC_ERROR_X              570
#define EN_PIC_ERROR_Y              200
#define EN_PIC_ERROR_WIDTH          200
#define EN_PIC_ERROR_HEIGHT         112
#endif

//config update led Enable
#define CONFIG_GPIO_LED_ENABLE 0
#define CONFIG_PWM_LED_ENABLE  1

#if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
#define FORCE_AC_ON_AP_BIN_PATH "/ACUpgradeReset.bin"
#endif
#define AP_BIN_PATH             getenv("ForceUpgradePath")==NULL?"/MstarUpgrade.bin":getenv("ForceUpgradePath")
#define AP_PKG_PATH             getenv("ForceUpgradePath")==NULL?CONFIG_CUSTOM_PKG_NAME ".pkg":getenv("ForceUpgradePath")
#define AP_NO_TVCERF_PKG_PATH   getenv("ForceUpgradePath")==NULL?CONFIG_CUSTOM_PKG_NAME "_no_tvcertificate.pkg":getenv("ForceUpgradePath")
#define UL_BIN_PATH             getenv("UpdateLogicUpgradeFile")==NULL?"MstarUpgrade.bin":getenv("UpdateLogicUpgradeFile")
#define UL_PKG_PATH             getenv("UpdateLogicUpgradeFile")==NULL?"upgrade_image.pkg":getenv("UpdateLogicUpgradeFile")
#if(ENABLE_MODULE_ANDROID_BOOT == 1)
#define OAD_BIN_PATH            getenv("OadUpgradeFile")==NULL?"/upgrade/MTKUpgrade.bin":getenv("OadUpgradeFile")
#else
#define OAD_BIN_PATH            getenv("OadUpgradeFile")==NULL?CONFIG_CUSTOM_PKG_NAME "_oad.pkg":getenv("OadUpgradeFile")
#endif
#define NET_BIN_PATH            AP_BIN_PATH
#define MBOOT_BIN_PATH          "/MbootUpgrade.bin"
#define SBOOT_BIN_PATH          "/SbootUpgrade.bin"
#define URSA_BIN_PATH           getenv("UrsaUpgradePath")==NULL?"/UrsaUpgrade.bin":getenv("UrsaUpgradePath")
#define OTA_ZIP_PATH            "/update_signed.zip"

#if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
#define AP_BIN_PATH_CUSTOM_PREFIX             "Sony_dtv_braviatl"
#define UPDATE_FILE_NAME_LEN   128
char AP_Custom_UpgradeFile[UPDATE_FILE_NAME_LEN]="\0";
#endif

#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)

#if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)

#define AP_LONG_NAME_PKG_SAMPLE         "SY0M_TPM219E_EUR_MT9675_ALLPANEL_braviatl.00066_20201031_de34.pkg"
#define AP_LONG_NAME_PKG_SAMPLE_SIZE    strlen(AP_LONG_NAME_PKG_SAMPLE)
#define AP_LONG_NAME_VERSION_SIZE       14
#define AP_LONG_NAME_BUILD_DATE_SIZE    8
#define AP_LONG_NAME_CHECKSUM_SIZE      4
#define AP_LONG_NAME_EXT_NAME_SIZE      3
#define AP_LONG_NAME_TOKEN_LEN          40  //need larger then every token
#define UPDATE_FILE_NAME_LEN            128 //need larger then sample

#else

#define AP_LONG_NAME_PKG_SAMPLE         "PH_TPM215E_EUR_MT9675_ALLPANEL_R.001.000.060.088_20201031_de34.pkg"
#define AP_LONG_NAME_PKG_SAMPLE_SIZE    strlen(AP_LONG_NAME_PKG_SAMPLE)
#define AP_LONG_NAME_VERSION_SIZE       17
#define AP_LONG_NAME_BUILD_DATE_SIZE    8
#define AP_LONG_NAME_CHECKSUM_SIZE      4
#define AP_LONG_NAME_EXT_NAME_SIZE      3
#define AP_LONG_NAME_TOKEN_LEN          40  //need larger then every token
#define UPDATE_FILE_NAME_LEN            128 //need larger then sample

#endif
static char AP_LONG_NAME_PKG_PATH[UPDATE_FILE_NAME_LEN] = {0};
#endif //#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)

#define UPGRADE_STATE_URSA_BIN            (BIT0)
#define UPGRADE_STATE_SBOOT_BIN           (BIT1)
#define UPGRADE_STATE_MBOOT_BIN           (BIT2)
#define UPGRADE_STATE_AP_BIN              (BIT3)
#if defined (CONFIG_URSA_6M60)
#define UPGRADE_STATE_TERRA2_BIN          (BIT4)
#endif
#if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
#define UPGRADE_STATE_FORCE_AC_ON_AP_BIN (BIT5)
#endif
#define UPGRADE_STATE_AP_PKG              (BIT6)
#define UPGRADE_STATE_AP_NO_TVCERT_PKG    (BIT7)

#ifndef MI_TPV_MODEL_T32_SOEM_PJ
#define FRC_BIN_PATH    "/tpv_t32_nt333_2k21_isp.bin"
#define UPGRADE_STATE_FRC_BIN              (BIT8)
#endif

#if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
#define UPGRADE_STATE_AP_BIN_CUSTOM       (BIT9)
#endif
#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)
#define UPGRADE_STATE_AP_PKG_CUSTOM       (BIT9)
#endif

#define UPGRADE_STATE_OEM                 (BIT10)

//============for ISP Upgrade============
#if defined (CONFIG_UPGRADE_URSA)
#define URSA_UPGRADE_BIN_PATH  getenv("UrsaUpgradePath")==NULL?"/UrsaUpgrade.bin":getenv("UrsaUpgradePath")

#define URSA_ISP_I2C_BUS_SEL 0x0
#define BLOCK_ERASE_ERROR_MAX      2000

#define BANKSIZE    0x10000
#define BLOCKNUM    0xff
#define BLOCKSIZE   0x100
#define SYSBIN_SIZE 1024 // 1KB
#define ENTER_ISP_ERROR_MAX     20
#define GET_ID_ERROR_MAX        10

#define URSA_I2C_BUS_NUM        (1)

#define URSA_ISP_I2C_BUS_SEL 0x0
#define SPI_WRITE           0x10
#define SPI_READ            0x11
#define SPI_STOP            0x12
#define CMD_DATA_WRITE      0x10

#define  SW_IIC_READ             0
#define  SW_IIC_WRITE            1
#define URSA_RELATE_ADDR_BUF_SIZE (32)

MS_U8 g_ucFlashType;
MS_U8 g_ucBankDst;
MS_U8 g_ucBankNumber;
EN_MFC_UPGRADE_SEL_t g_eUrsaUpgradeSel = E_MFC_FIRMWARE; //upgrade MFC FW by default
SFlashType sFlash;

MS_U8 g_u8CurPercent;
MS_U32 g_u32ISPSrcAddr;
MS_U32 g_u32ISPCodeSize;
FlashProgErrorType ErrorFlag;
FlashProgStateType g_eFlashProgramState;

#endif
//========ISP END=================

//-------------------------------------------------------------------------------------------------
//  Global Variables
//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
//  Local Variables
//-------------------------------------------------------------------------------------------------
#if (CONFIG_DISPLAY_OSD)
static const U32 progress_max_value = 1000;

#if ((ENABLE_MODULE_USB == 1) || \
     (ENABLE_MODULE_NETUPDATE == 1) || \
     (ENABLE_MODULE_OAD == 1))
static U32 progress_cnt = 0;
static U32 progress_start_load_value = 10;
static U32 progress_finish_load_value = 200;
#endif
#if (ENABLE_DISPLAY_PICTURE_UPDATE)
static U32 progress_cnt_last = 0;
#endif
#endif

//-------------------------------------------------------------------------------------------------
//  Extern Functions
//-------------------------------------------------------------------------------------------------
extern int snprintf(char *str, size_t size, const char *fmt, ...);

#if defined(CONFIG_MMC)
extern int get_mmc_part_size_and_offset (char *puPartName, unsigned int *u32PartSize, unsigned int *u32PartOffset);
#endif

//-------------------------------------------------------------------------------------------------
//  Private Functions
//-------------------------------------------------------------------------------------------------
#if (ENABLE_MODULE_USB == 1)
static int check_bin_flag(void);
#endif

#if (((ENABLE_MODULE_USB == 1)||(ENABLE_MODULE_NETUPDATE == 1)||(ENABLE_MODULE_OAD == 1))&&(ENABLE_MODULE_DISPLAY_OSD==1))
static int show_LoadData(int var);
static int show_StartUpgrading(int var);
static int show_Upgrading(int current_cnt, int total_cnt);
static int show_Error(int var);
static int show_Finish(int var);
static int show_test_start(int var);
static int show_test(int var, char * string1, char * string2, int current_cnt, int total_cnt);
#endif

//CUS_PHI_FEATURE
extern int FW_Upgrade_Finish;
extern int UpdateKit_Hub_Detect;
extern void flib_SetUSB_ForceSpeed(MS_BOOL bForce);
extern int usb_stop(int p);
extern int usb_init_exhub_port(int port, int ext_hub_port);
#ifndef MI_TPV_MODEL_T32_SOEM_PJ
void _nvt_show_env_variable(void);
static void _nvt_save_env_variable(int8_t mode, int8_t state);
#endif

#define CUSTOM_UPGRADE_SCREEN_JPG  1
//-------------------------------------------------------------------------------------------------
//  Public Functions
//-------------------------------------------------------------------------------------------------
#if (((ENABLE_MODULE_USB == 1)||(ENABLE_MODULE_NETUPDATE == 1)||(ENABLE_MODULE_OAD == 1))&&(ENABLE_MODULE_DISPLAY_OSD==1))
static int show_LoadData(int var)
{
#if CUSTOM_UPGRADE_SCREEN_JPG

    if(run_command("panel_pre_init",0) != 0)
    {
        printf("Error : panel_pre_init fail!!\n");
        return -1;
    }

    #ifndef MI_TPV_MODEL_T32_SOEM_PJ
    mdelay(30);
    MApi_PNL_SetVideoHWTraining(TRUE);  // Enable HW training.
    mdelay(40);
    #endif
  
    bIsUpgrade = TRUE;
    run_command("bootlogo 0 0 1 1 /tvconfig/upgradelogo.jpg",0);

    if(run_command("panel_post_init",0) != 0)
    {
        printf("Error : panel_post_init fail!!\n");
        return -1;
    }

#else

    if (-1 == display_osd)
        return -1;
    char buffer[CMD_BUF]="\0";
    int ret = 0;
    UBOOT_TRACE("IN\n");

    if (1 == CONFIG_GPIO_LED_ENABLE)
    {
        char *p_str = NULL;
        if((p_str =getenv ("usb_upgradeing_flicker"))!=NULL)
        {
            UBOOT_DEBUG("usb_upgradeing_flicker=%s\n", p_str);
            snprintf(buffer, CMD_BUF, "led time %s", p_str);
            UBOOT_DEBUG("cmd=%s\n",buffer);
            run_command(buffer,0); //GPIO led Frequency
        }
        else
        {
            run_command("led time 0xFA",0);
        }
    }
    else if (1 == CONFIG_PWM_LED_ENABLE)
    {
        run_command("led pwm_start",0);
    }

    progress_cnt = 0;
    progress_start_load_value = 10;
    progress_finish_load_value = 200;
#if (ENABLE_DISPLAY_PICTURE_UPDATE)
    snprintf(buffer, CMD_BUF, "osd_create %d %d", GWIN_PIC_WIDTH, GWIN_PIC_HEIGHT);
#else
    snprintf(buffer, CMD_BUF, "osd_create %d %d", GWIN_WIDTH, GWIN_HEIGHT);
#endif
    UBOOT_DEBUG("cmd=%s\n",buffer);
    ret = run_command(buffer, 0);
    if (-1 == ret)
    {
        display_osd = -1;
        return -1;
    }
#if (ENABLE_DISPLAY_PICTURE_UPDATE)
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_jpg -fs %d %d %d %d %s",GRAPHIC_PIC_X, GRAPHIC_PIC_Y, GRAPHIC_PIC_WIDTH, GRAPHIC_PIC_HEIGHT, EN_PIC_BASE_PATH);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
#else
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_rect %d %d %d %d 0x800000ff", GRAPHIC_X, GRAPHIC_Y, GRAPHIC_WIDTH, GRAPHIC_HEIGHT);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 %x", GRAPHIC_X, GRAPHIC_Y + LINE_HEIGHT * 2,en_load_data);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_progress %d %d 0x3fffffff %d", GRAPHIC_X + RECT_LEFT_INTERVAL, GRAPHIC_Y + LINE_HEIGHT * 5, progress_start_load_value/10);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
#endif
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "osd_flush");
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    UBOOT_TRACE("OK\n");
#endif
    return 0;
}

static int show_StartUpgrading(int var)
{
    if (-1 == display_osd)
        return -1;
#if (ENABLE_DISPLAY_PICTURE_UPDATE)
    Spinner_Timer_ISR_Register();
#else
    char buffer[CMD_BUF]="\0";
    UBOOT_TRACE("IN\n");
    snprintf(buffer, CMD_BUF, "draw_rect %d %d %d %d 0x800000ff", GRAPHIC_X, GRAPHIC_Y, GRAPHIC_WIDTH, GRAPHIC_HEIGHT);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 %x", GRAPHIC_X, GRAPHIC_Y + LINE_HEIGHT * 2,en_upgrading_software);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 %x", GRAPHIC_X,  GRAPHIC_Y + LINE_HEIGHT * 3,en_not_turn_off);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_progress %d %d 0x3fffffff %d", GRAPHIC_X + RECT_LEFT_INTERVAL, GRAPHIC_Y + LINE_HEIGHT * 5, progress_finish_load_value/10);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "osd_flush");
    run_command(buffer, 0);
#endif
    UBOOT_TRACE("OK\n");
    return 0;
}

static int show_Upgrading(int current_cnt, int total_cnt)
{

#if CUSTOM_UPGRADE_SCREEN_JPG
        
            progress_cnt = (((progress_max_value - progress_finish_load_value)*1000)/total_cnt); //(1000-200)/cmd_cnt
            progress_cnt = (progress_cnt *current_cnt+progress_finish_load_value*1000)/(10*1000);
            printf("--%d %%\n", progress_cnt);
        
#else

    if (-1 == display_osd)
        return -1;

    char buffer[CMD_BUF]="\0";
    UBOOT_TRACE("IN\n");
    progress_cnt = (((progress_max_value - progress_finish_load_value)*1000)/total_cnt); //(1000-200)/cmd_cnt
    progress_cnt = (progress_cnt *current_cnt+progress_finish_load_value*1000)/(10*1000);
    printf("--%d %%\n", progress_cnt);
#if (ENABLE_DISPLAY_PICTURE_UPDATE)
    if( progress_cnt_last == progress_cnt)
    {
        return 0;
    }
    progress_cnt_last = progress_cnt;
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_jpg -fs %d %d %d %d updating_%d.jpg", EN_PIC_PROGRESS_X, EN_PIC_PROGRESS_Y, EN_PIC_PROGRESS_WIDTH, EN_PIC_PROGRESS_HEIGHT, progress_cnt);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
#else
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_rect %d %d %d %d 0x800000ff", GRAPHIC_X, GRAPHIC_Y + LINE_HEIGHT * 5, GRAPHIC_WIDTH, LINE_HEIGHT);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_progress %d %d 0x3fffffff %d", GRAPHIC_X + RECT_LEFT_INTERVAL,GRAPHIC_Y + LINE_HEIGHT * 5, progress_cnt);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
#endif
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "osd_flush");
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    UBOOT_TRACE("OK\n");
#endif
    return 0;
}

static int show_Error(int var)
{
    if (-1 == display_osd)
        return -1;
    char buffer[CMD_BUF]="\0";
    UBOOT_TRACE("IN\n");
#if (ENABLE_DISPLAY_PICTURE_UPDATE)
    stop_Spinner_Timer_ISR();
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_jpg -fs %d %d %d %d %s", EN_PIC_ERROR_X, EN_PIC_ERROR_Y, EN_PIC_ERROR_WIDTH, EN_PIC_ERROR_HEIGHT, EN_PIC_ERROR_PATH);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
#else
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_rect %d %d %d %d 0x800000ff", GRAPHIC_X, GRAPHIC_Y, GRAPHIC_WIDTH, GRAPHIC_HEIGHT);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 %x", GRAPHIC_X, GRAPHIC_Y + LINE_HEIGHT * 3,en_upgrade_error);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
#endif
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "osd_flush");
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    if (1 == CONFIG_GPIO_LED_ENABLE)
    {
        run_command("led stop",0);
    }
    UBOOT_TRACE("OK\n");

    char *p_str = getenv("usb_upgrade_auto_reset");
    int UsbUpgradeAutoReset = 1;
    if(p_str != NULL)
    {
        UsbUpgradeAutoReset = (int)simple_strtol(p_str, NULL, 10);
        UBOOT_DEBUG("UsbUpgradeAutoReset=%d\n",UsbUpgradeAutoReset);
    }
    if(UsbUpgradeAutoReset==0)
    {
        if((p_str =getenv ("usb_upgradeerror_flicker"))!=NULL)
        {
            UBOOT_DEBUG("usb_upgradeerror_flicker=%s\n", p_str);
            snprintf(buffer, CMD_BUF, "led time %s", p_str);
            UBOOT_DEBUG("cmd=%s\n",buffer);
            run_command(buffer,0); //GPIO led Frequency
        }
        else
        {
            run_command("led time 0xFA",0);
        }
        jump_to_console();
    }
    // Skip the reset flow and control by costar/custar
    //else
    //{
    //    run_command("reset",0);
    //}

    return 0;
}

static int show_Finish(int var)
{
    if (-1 == display_osd)
        return -1;

    char buffer[CMD_BUF]="\0";
    UBOOT_TRACE("IN\n");
#if (ENABLE_DISPLAY_PICTURE_UPDATE)
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_jpg -fs %d %d %d %d updating_%d.jpg", EN_PIC_PROGRESS_X, EN_PIC_PROGRESS_Y, EN_PIC_PROGRESS_WIDTH, EN_PIC_PROGRESS_HEIGHT, progress_cnt);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
#else
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_rect %d %d %d %d 0x800000ff", GRAPHIC_X, GRAPHIC_Y, GRAPHIC_WIDTH, GRAPHIC_HEIGHT);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 %x", GRAPHIC_X, GRAPHIC_Y + LINE_HEIGHT * 2,en_upgrade_complete);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_progress %d %d 0x3fffffff %d", GRAPHIC_X + RECT_LEFT_INTERVAL, GRAPHIC_Y + LINE_HEIGHT * 5, 100);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
#endif
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "osd_flush");
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    udelay(2000000);

    if (1 == CONFIG_GPIO_LED_ENABLE)
    {
        run_command("led stop",0);

        char *p_str = NULL;
        if((p_str =getenv ("usb_upgradefinish_flicker"))!=NULL)
        {
            UBOOT_DEBUG("usb_upgradefinish_flicker=%s\n", p_str);
            snprintf(buffer, CMD_BUF, "led time %s", p_str);
            UBOOT_DEBUG("cmd=%s\n",buffer);
            run_command(buffer,0); //GPIO led Frequency
        }
        else
        {
            run_command("led time 0xFA",0); //GPIO led Frequency
        }
    }
    else if (1 == CONFIG_PWM_LED_ENABLE)
    {
        run_command("led pwm_stop",0);
    }

    UBOOT_DEBUG("cmd=%s\n",buffer);
    UBOOT_TRACE("OK\n");
    return 0;
}


#if (ENABLE_UTEST == 1)
static int show_test_start(int var)
{
    if (-1 == display_osd)
    {
        return -1;
    }
    char buffer[CMD_BUF]="\0";
    int ret = 0;
    UBOOT_TRACE("IN\n");
    progress_cnt = 0;
    progress_start_load_value = 10;
    progress_finish_load_value = 200;
    snprintf(buffer, CMD_BUF, "osd_create %d %d", GWIN_WIDTH, GWIN_HEIGHT);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    ret = run_command(buffer, 0);
    if (-1 == ret)
    {
        display_osd = -1;
        return -1;
    }
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_rect %d %d %d %d 0x800000ff", GRAPHIC_X, GRAPHIC_Y, GRAPHIC_WIDTH, GRAPHIC_HEIGHT);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 USB TEST START...", GRAPHIC_X, GRAPHIC_Y + LINE_HEIGHT * 2);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);

    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 Remove usb device after test", GRAPHIC_X,  GRAPHIC_Y + LINE_HEIGHT * 4);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);

    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "osd_flush");
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    UBOOT_TRACE("OK\n");
    return 0;
}

static int show_test(int var, char * string1, char * string2, int current_cnt, int total_cnt)
{
    if (-1 == display_osd){
        return -1;
    }

    char buffer[CMD_BUF]="\0";
    UBOOT_TRACE("IN\n");
    progress_cnt = (((progress_max_value - progress_finish_load_value)*1000)/total_cnt);   //(1000-200)/cmd_cnt
    progress_cnt = (progress_cnt *current_cnt+progress_finish_load_value*1000)/(10*1000);
    printf("--%d %%\n", progress_cnt);

    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_rect %d %d %d %d 0x800000ff", GRAPHIC_X, GRAPHIC_Y, GRAPHIC_WIDTH, GRAPHIC_HEIGHT);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);

    if(string1 != NULL)
    {
        memset(buffer, 0 , CMD_BUF);
        snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 %s", GRAPHIC_X, GRAPHIC_Y + LINE_HEIGHT * 2, string1);
        UBOOT_DEBUG("cmd=%s\n",buffer);
        run_command(buffer, 0);
    }

    if(string2 != NULL)
    {
        memset(buffer, 0 , CMD_BUF);
        snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 %s", GRAPHIC_X,  GRAPHIC_Y + LINE_HEIGHT * 3, string2);
        UBOOT_DEBUG("cmd=%s\n",buffer);
        run_command(buffer, 0);
    }

    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_string %d %d 0x3fffffff 1 Remove usb device after test", GRAPHIC_X,  GRAPHIC_Y + LINE_HEIGHT * 4);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);

    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "draw_progress %d %d 0x3fffffff %d", GRAPHIC_X + RECT_LEFT_INTERVAL, GRAPHIC_Y + LINE_HEIGHT * 5, progress_cnt);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    memset(buffer, 0 , CMD_BUF);
    snprintf(buffer, CMD_BUF, "osd_flush");
    UBOOT_DEBUG("cmd=%s\n",buffer);
    run_command(buffer, 0);
    UBOOT_TRACE("OK\n");

    return 0;
}
#endif


#endif

#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)
static bool check_format_prefix(char* pc_in, char* pc_out) {
    char*           pEnvModelInfo = getenv("model_info");
    char            au8_prefix[AP_LONG_NAME_TOKEN_LEN] = {0};
    U8              u8Len = 0;
    if (pc_in == NULL) {
        return false;
    }
    if (pc_out == NULL) {
        return false;
    }
    if (pEnvModelInfo == NULL) {
        return false;
    }
    UBOOT_DEBUG("pEnvModelInfo == %s\n", pEnvModelInfo);
    #if defined (CONFIG_MTK_BD_MT168B_TPV_PHILIPS_10AT_19133_MT5870_M7332)
    if (strncmp(pEnvModelInfo, "EU", 2) == 0 ||
        strncmp(pEnvModelInfo, "AP", 2) == 0 ||
        strncmp(pEnvModelInfo, "TW", 2) == 0 ) {
        strcpy(au8_prefix, strlower("PH_TPM215E_EUR_MT9675_ALLPANEL"));
    }
    if (strncmp(pEnvModelInfo, "LT", 2) == 0) {
        strcpy(au8_prefix, strlower("PH_TPM215L_LAT_MT9675_ALLPANEL"));
    }
    if (strncmp(pEnvModelInfo, "HK", 2) == 0) {
        strcpy(au8_prefix, strlower("PH_TPM215HC_HK_MT9675_ALLPANEL"));
    }
    if (strncmp(pEnvModelInfo, "ODMPAN", 6) == 0) {
        strcpy(au8_prefix, strlower("ODM_TPM218E_EUR_MT9675_ALLPANEL"));
    }
    #endif
    #if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
    if (strncmp(pEnvModelInfo, "EU", 2) == 0) {
        strcpy(au8_prefix, strlower("SY0M_TPM219E_EUR_MT9675_ALLPANEL"));
    }
    #endif
    u8Len = strlen(au8_prefix);
    UBOOT_DEBUG("au8_prefix == %s\n", au8_prefix);
    UBOOT_DEBUG("pc_in == %s\n", pc_in);
    if (strncmp(pc_in, au8_prefix, u8Len) != 0) {
        return false;
    }
    strcpy(pc_out, au8_prefix);
    return true;
}

static bool check_format_isDigit(char ch) {
    return ((ch - '0') >= 0 && (ch - '0') <= 9) ? (true) : (false);
}
static bool check_format_version(char* pc_in) {
    if (pc_in == NULL) {
        return false;
    }
#if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
    //#define AP_LONG_NAME_PKG_SAMPLE         "SY0M_TPM219E_EUR_MT9675_ALLPANEL_braviatl.00066_20201031_de34.pkg"
    bool b_isB          = (pc_in[0] == 'b') ? (true) : (false);
    bool b_isR          = (pc_in[1] == 'r') ? (true) : (false);
	bool b_isA_0        = (pc_in[2] == 'a') ? (true) : (false);
    bool b_isV          = (pc_in[3] == 'v') ? (true) : (false);
    bool b_isI          = (pc_in[4] == 'i') ? (true) : (false);
    bool b_isA_1        = (pc_in[5] == 'a') ? (true) : (false);
    bool b_isT          = (pc_in[6] == 't') ? (true) : (false);
    bool b_isL          = (pc_in[7] == 'l') ? (true) : (false);
    bool b_isDot        = (pc_in[8] == '.') ? (true) : (false);
    bool b_isDigit_0    = check_format_isDigit(pc_in[9]);
    bool b_isDigit_1    = check_format_isDigit(pc_in[10]);
    bool b_isDigit_2    = check_format_isDigit(pc_in[11]);
    bool b_isDigit_3    = check_format_isDigit(pc_in[12]);
    bool b_isDigit_4    = check_format_isDigit(pc_in[13]);
    if (b_isB && b_isR && b_isA_0 && b_isV && b_isI && b_isA_1 && b_isT && b_isL &&
        b_isDot && b_isDigit_0 && b_isDigit_1 && b_isDigit_2 && b_isDigit_3 && b_isDigit_4) {
        return true;
    }
#else
    //#define AP_LONG_NAME_PKG_SAMPLE         "PH_TPM215E_EUR_MT9675_ALLPANEL_R.001.000.060.088_20201031_de34.pkg"
    bool b_isR          = (pc_in[0] == 'r') ? (true) : (false);
    bool b_isDot_0      = (pc_in[1] == '.') ? (true) : (false);
    bool b_isDigit_0    = check_format_isDigit(pc_in[2]);
    bool b_isDigit_1    = check_format_isDigit(pc_in[3]);
    bool b_isDigit_2    = check_format_isDigit(pc_in[4]);
    bool b_isDot_1      = (pc_in[5] == '.') ? (true) : (false);
    bool b_isDigit_3    = check_format_isDigit(pc_in[6]);
    bool b_isDigit_4    = check_format_isDigit(pc_in[7]);
    bool b_isDigit_5    = check_format_isDigit(pc_in[8]);
    bool b_isDot_2      = (pc_in[9] == '.') ? (true) : (false);
    bool b_isDigit_6    = check_format_isDigit(pc_in[10]);
    bool b_isDigit_7    = check_format_isDigit(pc_in[11]);
    bool b_isDigit_8    = check_format_isDigit(pc_in[12]);
    bool b_isDot_3      = (pc_in[13] == '.') ? (true) : (false);
    bool b_isDigit_9    = check_format_isDigit(pc_in[14]);
    bool b_isDigit_10   = check_format_isDigit(pc_in[15]);
    bool b_isDigit_11   = check_format_isDigit(pc_in[16]);
    if (b_isR && b_isDot_0 && b_isDigit_0 && b_isDigit_1 && b_isDigit_2 &&
        b_isDot_1 && b_isDigit_3 && b_isDigit_4 && b_isDigit_5 &&
        b_isDot_2 && b_isDigit_6 && b_isDigit_7 && b_isDigit_8 &&
        b_isDot_3 && b_isDigit_9 && b_isDigit_10 && b_isDigit_11) {
        return true;
    }
#endif
    return false;
}
static bool check_format_build_date(char* pc_in) {
    if (pc_in == NULL) {
        return false;
    }
    bool isDigit_1 = check_format_isDigit(pc_in[0]);
    bool isDigit_2 = check_format_isDigit(pc_in[1]);
    bool isDigit_3 = check_format_isDigit(pc_in[2]);
    bool isDigit_4 = check_format_isDigit(pc_in[3]);
    bool isDigit_5 = check_format_isDigit(pc_in[4]);
    bool isDigit_6 = check_format_isDigit(pc_in[5]);
    bool isDigit_7 = check_format_isDigit(pc_in[6]);
    bool isDigit_8 = check_format_isDigit(pc_in[7]);
    if (isDigit_1 && isDigit_2 && isDigit_3 && isDigit_4 &&
        isDigit_5 && isDigit_6 && isDigit_7 && isDigit_8) {
        return true;
    }
    return false;
}
static bool check_format_isHex(char ch) {
    bool isDigit = ((ch - '0') >= 0 && (ch - '0') <= 9) ? (true) : (false);
    bool isAlphaBig = ((ch - 'A') >= 0 && (ch - 'A') <= 5) ? (true) : (false);
    bool isAlphaLittle = ((ch - 'a') >= 0 && (ch - 'a') <= 5) ? (true) : (false);
    if (isDigit || isAlphaBig || isAlphaLittle) {
        return true;
    }
    return false;
}
static bool check_format_checksum(char* pc_in) {
    if (pc_in == NULL) {
        return false;
    }
    bool b_isHex_0 = check_format_isHex(pc_in[0]);
    bool b_isHex_1 = check_format_isHex(pc_in[1]);
    bool b_isHex_2 = check_format_isHex(pc_in[2]);
    bool b_isHex_3 = check_format_isHex(pc_in[3]);
    if (b_isHex_0 && b_isHex_1 && b_isHex_2 && b_isHex_3) {
        return true;
    }
    return false;
}
static bool check_format_ext_name(char* pc_in) {
    if (pc_in == NULL) {
        return false;
    }
    if (strncmp(pc_in, "pkg", 3) == 0) {
        return true;
    }
    return false;
}

static void find_long_name_pkg_in_usb(void) {
    ST_FILE_INFO    curr, ptr;
    char            au8_prefix[AP_LONG_NAME_TOKEN_LEN] = {0};
    char            au8_version[AP_LONG_NAME_TOKEN_LEN] = {0};
    char            au8_build_date[AP_LONG_NAME_TOKEN_LEN] = {0};
    char            au8_checksum[AP_LONG_NAME_TOKEN_LEN] = {0};
    char            au8_ext_name[AP_LONG_NAME_TOKEN_LEN] = {0};
    U8              u8_version_offset = 0;
    U8              u8_build_date_offset = 0;
    U8              u8_checksum_offset = 0;
    U8              u8_ext_name_offset = 0;
    //
    UBOOT_INFO("find_long_name_pkg_in_usb call start\n");
	memset(AP_LONG_NAME_PKG_PATH, 0, UPDATE_FILE_NAME_LEN);
    memset(&curr, 0, sizeof(curr));
    createfileList("/", &curr);
    ptr = curr;
    do {
        UBOOT_DEBUG("ptr.name == %s\n", ptr.name);
        /*
        if (strncmp(ptr.name, strlower(AP_LONG_NAME_PKG_SAMPLE), AP_LONG_NAME_PKG_SAMPLE_SIZE) == 0) {
            UBOOT_INFO("\033[0;32mFOUND UpgradeFile == %s\033[0m\n",ptr.name);
            memcpy(AP_LONG_NAME_PKG_PATH, ptr.name, strlen(ptr.name)+1);
            break;
        }*/
        if (!check_format_prefix(ptr.name, au8_prefix)) {
            UBOOT_DEBUG("check_format_prefix return false\n");
            continue;
        }
        UBOOT_DEBUG("au8_prefix == %s\n", au8_prefix);
        //
        u8_version_offset = strlen(au8_prefix) + 1;
        strncpy(au8_version,     ptr.name + u8_version_offset,    AP_LONG_NAME_VERSION_SIZE);
        UBOOT_DEBUG("au8_version == %s\n", au8_version);
        if (!check_format_version(au8_version)) {
            UBOOT_DEBUG("check_format_version return false\n");
            continue;
        }
        //
        u8_build_date_offset = u8_version_offset + strlen(au8_version) + 1;
        strncpy(au8_build_date,  ptr.name + u8_build_date_offset, AP_LONG_NAME_BUILD_DATE_SIZE);
        UBOOT_DEBUG("au8_build_date == %s\n", au8_build_date);
        if (!check_format_build_date(au8_build_date)) {
            UBOOT_DEBUG("check_format_build_date return false\n");
            continue;
        }
        //
        u8_checksum_offset = u8_build_date_offset + strlen(au8_build_date) + 1;
        strncpy(au8_checksum,  ptr.name + u8_checksum_offset, AP_LONG_NAME_CHECKSUM_SIZE);
        UBOOT_DEBUG("au8_checksum == %s\n", au8_checksum);
        if (!check_format_checksum(au8_checksum)) {
            UBOOT_DEBUG("check_format_checksum return false\n");
            continue;
        }
        //
        u8_ext_name_offset = u8_checksum_offset + strlen(au8_checksum) + 1;
        strncpy(au8_ext_name,  ptr.name + u8_ext_name_offset, AP_LONG_NAME_EXT_NAME_SIZE);
        UBOOT_DEBUG("au8_ext_name == %s\n", au8_ext_name);
        if (!check_format_ext_name(au8_ext_name)) {
            UBOOT_DEBUG("check_format_ext_name return false\n");
            continue;
        }
        strncpy(AP_LONG_NAME_PKG_PATH, ptr.name, strlen(ptr.name));
        break;
    } while (getNextFile(&ptr) == 0);
    UBOOT_INFO("\033[0;32mAP_LONG_NAME_PKG_PATH == %s\033[0m\n", AP_LONG_NAME_PKG_PATH);
}
#endif //TPV_LONG_FILE_NAME_UPGRADE_SUPPORT

#if defined (TPV_FW_UPGRADE_FILTER)

#define UPGRADE_FILTER_ENABLE_ADDR                      0xA2
#define UPGRADE_FILTER_DISABLED                         0x00
#define UPGRADE_FILTER_ENABLED                          0x01
#define UPGRADE_FILTER_ENABLE_DEFAULT                   UPGRADE_FILTER_DISABLED

#define UPGRADE_FILTER_TYPE_ADDR                        0xA3
#define UPGRADE_FILTER_TYPE_ALL                         0xFF
#define UPGRADE_FILTER_TYPE_MAIN                        0x00
#define UPGRADE_FILTER_TYPE_NVM                         0x01
#define UPGRADE_FILTER_TYPE_FRC                         0x02
#define UPGRADE_FILTER_TYPE_DEMO                        0x03
#define UPGRADE_FILTER_TYPE_MEMC                        0x04
#define UPGRADE_FILTER_TYPE_DEFAULT                     UPGRADE_FILTER_TYPE_ALL
#define TPV_FORCE_UPGRADE_NAME                          "upgrade_image.pkg"

static bool g_b_tpv_force_upgrade_enable = false;
static U8 g_u8_nvm_upgrade_filter_enable = UPGRADE_FILTER_ENABLE_DEFAULT;
static U8 g_u8_nvm_upgrade_filter_type = UPGRADE_FILTER_TYPE_DEFAULT;
static void tpv_upgrade_filter_initialize(void) {
    U8 uOp0 = 0;
    U32 u32OpcodeOffset0 = 0;
    U32 u32Ret = 0;
    U8 au8_buffer1[1] = {0};
    U8 au8_buffer2[1] = {0};
    bool b_need_reset = false;
    UBOOT_DEBUG("tpv_upgrade_filter_initialize call start\n");
	u32Ret  = Read_NVM_OptionByte(0, &uOp0, &u32OpcodeOffset0);
    UBOOT_DEBUG("u32OpcodeOffset0 == %d\n", u32OpcodeOffset0);
    UBOOT_DEBUG("u32Ret == %d\n", u32Ret);
    if (EEPROM_Read((unsigned long long)(u32OpcodeOffset0 + UPGRADE_FILTER_ENABLE_ADDR), (unsigned long)au8_buffer1, 1) != 0) {
        b_need_reset = true;
    } else {
        switch (au8_buffer1[0]) {
            case UPGRADE_FILTER_DISABLED:
            case UPGRADE_FILTER_ENABLED:
                break;
            default:
                b_need_reset = true;
                break;
        }
    }
    if (EEPROM_Read((unsigned long long)(u32OpcodeOffset0 + UPGRADE_FILTER_TYPE_ADDR), (unsigned long)au8_buffer2, 1) != 0) {
        b_need_reset = true;
    } else {
        switch (au8_buffer2[0]) {
            case UPGRADE_FILTER_TYPE_ALL:
            case UPGRADE_FILTER_TYPE_MAIN:
            case UPGRADE_FILTER_TYPE_NVM:
            case UPGRADE_FILTER_TYPE_FRC:
            case UPGRADE_FILTER_TYPE_DEMO:
            case UPGRADE_FILTER_TYPE_MEMC:
                break;
            default:
                b_need_reset = true;
                break;
        }
    }
    UBOOT_DEBUG("b_need_reset == %d\n", b_need_reset);
    if (b_need_reset) {
        //*
        au8_buffer1[0] = UPGRADE_FILTER_ENABLE_DEFAULT;
        if (EEPROM_Write((unsigned long long)(u32OpcodeOffset0 + UPGRADE_FILTER_ENABLE_ADDR), (unsigned long)au8_buffer1, 1) != 0) {
            UBOOT_DEBUG("EEPROM_Write fail 01\n");
        }
        au8_buffer2[0] = UPGRADE_FILTER_TYPE_DEFAULT;
        if (EEPROM_Write((unsigned long long)(u32OpcodeOffset0 + UPGRADE_FILTER_TYPE_ADDR), (unsigned long)au8_buffer2, 1) != 0) {
            UBOOT_DEBUG("EEPROM_Write fail 02\n");
        }
        //*/
    }
    g_u8_nvm_upgrade_filter_enable = au8_buffer1[0];
    g_u8_nvm_upgrade_filter_type = au8_buffer2[0];
    UBOOT_DEBUG("g_u8_nvm_upgrade_filter_enable == %d , g_u8_nvm_upgrade_filter_type == %d\n", g_u8_nvm_upgrade_filter_enable, g_u8_nvm_upgrade_filter_type);
}
static bool tpv_upgrade_filter_check_need_skip(U8 u8_check_type) {
    bool b_need_skip = false;
    UBOOT_DEBUG("tpv_upgrade_filter_check_need_skip call start\n");
    if (!g_u8_nvm_upgrade_filter_enable) {
        b_need_skip = false;
    } else {
        switch (g_u8_nvm_upgrade_filter_type) {
            case UPGRADE_FILTER_TYPE_ALL:
                b_need_skip = true;
                break;
            case UPGRADE_FILTER_TYPE_MAIN:
            case UPGRADE_FILTER_TYPE_NVM:
            case UPGRADE_FILTER_TYPE_FRC:
            case UPGRADE_FILTER_TYPE_DEMO:
            case UPGRADE_FILTER_TYPE_MEMC:
                b_need_skip = (u8_check_type != g_u8_nvm_upgrade_filter_type);
                break;
            default:
                b_need_skip = false;
                break;
        }
    }
    UBOOT_DEBUG("u8_check_type == %d , b_need_skip == %d\n", u8_check_type, b_need_skip);
    return b_need_skip;
}

#endif //TPV_FW_UPGRADE_FILTER

#if (ENABLE_MODULE_USB == 1)
static int check_bin_flag(void)
{
    int stage = 0;
    UBOOT_TRACE("IN\n");

#if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
    ST_FILE_INFO curr, ptr;

    memset(&curr,0,sizeof(curr));
    createfileList("/",&curr);
    ptr=curr;

    char AP_BinPathNameCustomPrefix[UPDATE_FILE_NAME_LEN] = {'\0'};
    U8 u8Len = 0;

    strncpy(AP_BinPathNameCustomPrefix, AP_BIN_PATH_CUSTOM_PREFIX, strlen(AP_BIN_PATH_CUSTOM_PREFIX));
    strlower(AP_BinPathNameCustomPrefix);

    UBOOT_TRACE("\033[0;32mAP_BinPathNameCustomPrefix = %s*.bin\033[0m\n",AP_BinPathNameCustomPrefix);
	do
    {
        u8Len = strlen(ptr.name);

        if (((strncmp(AP_BinPathNameCustomPrefix, ptr.name, strlen(AP_BIN_PATH_CUSTOM_PREFIX))==0)) &&
            ((ptr.name[u8Len-4] == '.') && (ptr.name[u8Len-3] == 'b') && (ptr.name[u8Len-2] == 'i') && (ptr.name[u8Len-1] == 'n')))
        {
            UBOOT_INFO("\033[0;32mAP File =%s\033[0m\n",ptr.name);
            printf("\033[0;32m FOUND UpgradeFile[%s] \033[0m \n", ptr.name);
            memcpy(AP_Custom_UpgradeFile, ptr.name, strlen(ptr.name)+1);
            printf("Start to upgrade main FW\n");
            break;
        }
    }while(getNextFile(&ptr)==0);
#endif

#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)
    find_long_name_pkg_in_usb();
#endif

    if(check_file_partition(AP_PKG_PATH,NULL,NULL)==0)//check upgrade_image.bin
    {
        stage |= UPGRADE_STATE_AP_PKG;
        UBOOT_DEBUG("has app upgrade package\n");
        #if defined (TPV_FW_UPGRADE_FILTER)
        g_b_tpv_force_upgrade_enable = true;
        #endif
    }
    else if(check_file_partition(AP_NO_TVCERF_PKG_PATH,NULL,NULL)==0)//check upgrade_image_no_tvcertificate.pkg
    {
        stage |= UPGRADE_STATE_AP_NO_TVCERT_PKG;
        UBOOT_DEBUG("has no tvcert app upgrade package\n");
    }
    else if(check_file_partition(AP_BIN_PATH,NULL,NULL)==0)//check Supernova file
    {
      stage |= UPGRADE_STATE_AP_BIN;
      UBOOT_DEBUG("has app upgrade bin\n");
    }
#if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
	else if(check_file_partition(AP_Custom_UpgradeFile,NULL,NULL)==0)//check Custom Upgrade file
	{
		stage |= (UPGRADE_STATE_AP_BIN | UPGRADE_STATE_AP_BIN_CUSTOM);
		UBOOT_DEBUG("has Custom app upgrade bin\n");
	}
#endif
#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)
	else if(check_file_partition(AP_LONG_NAME_PKG_PATH,NULL,NULL)==0)//check Custom Upgrade file
	{
		stage |= (UPGRADE_STATE_AP_PKG | UPGRADE_STATE_AP_PKG_CUSTOM);
		UBOOT_DEBUG("has Custom upgrade pkg TPV_PHI\n");
	}
#endif

    if(check_file_partition(SBOOT_BIN_PATH,NULL,NULL)==0)//check sboot file
    {
      stage |= UPGRADE_STATE_SBOOT_BIN;
      UBOOT_DEBUG("has sboot upgrade bin\n");
    }

    if(check_file_partition(MBOOT_BIN_PATH,NULL,NULL)==0)//check mboot file
    {
      stage |= UPGRADE_STATE_MBOOT_BIN;
      UBOOT_DEBUG("has mboot upgrade bin\n");
    }
#if defined (CONFIG_UPGRADE_URSA)
    if(check_file_partition(URSA_UPGRADE_BIN_PATH,NULL,NULL)==0)//check mboot file
    {
        stage |= UPGRADE_STATE_URSA_BIN;
        UBOOT_DEBUG("has mboot upgrade bin\n");
    }
#else
    if(check_file_partition(URSA_BIN_PATH,NULL,NULL)==0)//check ursa file
    {
      stage |= UPGRADE_STATE_URSA_BIN;
      UBOOT_DEBUG("has ursa upgrade bin\n");
    }
#endif

#if defined (CONFIG_URSA_6M60)
    if(check_file_partition(TERRA2_UPGRADE_BIN_PATH, NULL, NULL)==0)//check terra2 file
    {
        stage |= UPGRADE_STATE_TERRA2_BIN;
        UBOOT_DEBUG("has terra2 upgrade bin\n");
    }
#endif
#if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
    if(check_file_partition(FORCE_AC_ON_AP_BIN_PATH, NULL, NULL)==0)
    {
        stage |= UPGRADE_STATE_FORCE_AC_ON_AP_BIN;
        UBOOT_DEBUG("has Fource AC on upgrade bin\n");
    }
#endif

#ifndef MI_TPV_MODEL_T32_SOEM_PJ
	// add, NVM option checks, 
	if (0 /* NVT_OK */ == _has_frc_nt333()) {
		if(check_file_partition(FRC_BIN_PATH, NULL, NULL)==0)
		{
			stage |= UPGRADE_STATE_FRC_BIN;
			UBOOT_DEBUG("has Fource AC on FRC bin\n");
		}
	}
#endif

    if(check_file_partition("/oem.img",NULL,NULL)==0)
    {
        stage |= UPGRADE_STATE_OEM;
        UBOOT_DEBUG("has oem.img\n");
    }
    UBOOT_TRACE("OK\n");

    return stage;
}

int do_custar(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    int USBInit;
    char cmd[128];
    char upgrade_state_flag[] = "0x00";
    char* env_state = NULL;
    int state=0;
    char *cUpgradeStatus = NULL;
    UBOOT_TRACE("IN\n");
    open_console_log();
    //CUS_PHI_FEATURE
    FW_Upgrade_Finish = 0;
    UpdateKit_Hub_Detect =0;

    #if defined(CONFIG_UPGRADE_V1)
    UBOOT_INFO("\n\nUpgrade Version: 1.0\n\n");
    #elif defined(CONFIG_UPGRADE_V2)
    UBOOT_INFO("\n\nUpgrade Version: 2.0\n\n");
    #else
    // reserved
    #endif

    //clean the env  upgrade_status
    setenv("upgrade_status", "ongoing");

    // 3867071 & 3867195 set 0 but default_environment[] use 0x14 at before
    // Some old TV set's env keep in 0x14
    // Force set to 0 in some version to clear incorrect env in old TV set
    setenv("ursa_type", "0");
    saveenv();
    //usb init
    if (-1 == appInitUsbDisk())
    {
        printf("FAIL : can not init usb!! \n");
        run_command("setenv force_upgrade", 0);
        setenv("upgrade_status", "ERROR");
        saveenv();
        close_console_log();
        return -1;
    }

    // TPV add start
    xprintf("USB DETECT\n");
    // TPV add end
    #if (ENABLE_MODULE_DISPLAY_OSD==1)

    #if CUSTOM_UPGRADE_SCREEN_JPG
    UnRegisterShowCb();
    //RegisterCBShowError((show_Error_cb)show_Error);
    //RegisterCBShowFinish((show_Finish_cb)show_Finish);
    RegisterCBShowLoadData((show_LoadData_cb)show_LoadData);
    //RegisterCBShowStartUpgrading((show_StartUpgrading_cb)show_StartUpgrading);
    RegisterCBShowUpgrading((show_Upgrading_cb)show_Upgrading);
    #else
    UnRegisterShowCb();
    RegisterCBShowError((show_Error_cb)show_Error);
    RegisterCBShowFinish((show_Finish_cb)show_Finish);
    RegisterCBShowLoadData((show_LoadData_cb)show_LoadData);
    RegisterCBShowStartUpgrading((show_StartUpgrading_cb)show_StartUpgrading);
    RegisterCBShowUpgrading((show_Upgrading_cb)show_Upgrading);
    #endif
    
    #endif

    //check upgrade file content
    env_state = getenv(ENV_FORCEUPGRADE);
    if(env_state != NULL )
    {
         state = (int)simple_strtoul(env_state, NULL, 16);
    }
    else
    {
#if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
		memset(AP_Custom_UpgradeFile, 0, UPDATE_FILE_NAME_LEN);
#endif
        state=check_bin_flag();
#if defined (TPV_FW_UPGRADE_FILTER)
        UBOOT_INFO("Before filter, state ->[0x%x]\n", state);
        tpv_upgrade_filter_initialize();
        if (g_b_tpv_force_upgrade_enable) {
            g_u8_nvm_upgrade_filter_enable = false;
        }
        if (tpv_upgrade_filter_check_need_skip(UPGRADE_FILTER_TYPE_ALL)) {
            state = 0;
        } else if (tpv_upgrade_filter_check_need_skip(UPGRADE_FILTER_TYPE_MAIN)) {
    #if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
            state = state&(~UPGRADE_STATE_FORCE_AC_ON_AP_BIN);
    #endif
            state = state&(~UPGRADE_STATE_AP_PKG);
            state = state&(~UPGRADE_STATE_AP_NO_TVCERT_PKG);
    #if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)
            state = state&(~UPGRADE_STATE_AP_PKG_CUSTOM);
    #endif
            state = state&(~UPGRADE_STATE_AP_BIN);
    #if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
            state = state&(~UPGRADE_STATE_AP_BIN_CUSTOM);
    #endif
        } else if (tpv_upgrade_filter_check_need_skip(UPGRADE_FILTER_TYPE_FRC)) {
    #ifndef MI_TPV_MODEL_T32_SOEM_PJ
            state = state&(~UPGRADE_STATE_FRC_BIN);
    #endif
        }
        UBOOT_INFO("After filter, state ->[0x%x]\n", state);
#endif
        if(state == 0 )
        {
            UBOOT_INFO("warn!! no upgrade file in usb. \n");
            UBOOT_TRACE("OK\n");
            run_command("setenv force_upgrade", 0);
            setenv("upgrade_status", "ERROR");
            saveenv();
            close_console_log();
            return -1;
        }

        if(state & 0xFF)
        {
            snprintf(upgrade_state_flag, sizeof(upgrade_state_flag)-1, "0x%02x",state);
            setenv(ENV_FORCEUPGRADE,upgrade_state_flag);
            saveenv();
        }
    }

    // TPV add start
    xprintf("Start to upgrade main FW\n");
    if(0 != (state & (
        UPGRADE_STATE_AP_PKG
        | UPGRADE_STATE_AP_NO_TVCERT_PKG
#if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
        | UPGRADE_STATE_AP_NO_TVCERT_PKG
#endif
#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)
        | UPGRADE_STATE_AP_PKG_CUSTOM
#endif
    ))) {
        state = state&(~UPGRADE_STATE_MBOOT_BIN);
        UBOOT_INFO("warn!! skip mboot upgrade bin becasue some PKG file exists. \n");
    }
    // TPV add end
    //
    UBOOT_INFO("Current state ->[0x%x]\n",state);
#if defined (CONFIG_UPGRADE_URSA)
    if(state&UPGRADE_STATE_URSA_BIN) // upgrade Ursa
    {
        UBOOT_DEBUG("cmd= ursa_upgrade usb \n");
        if(-1 == run_command("ursa_upgrade usb", 0))
        {
            UBOOT_ERROR("Upgrade Ursa error!\n");
            setenv(ENV_FORCEUPGRADE,NULL);
            setenv("upgrade_status", "ERROR");
            saveenv();
            return -1;
        }
        state = state&(~UPGRADE_STATE_URSA_BIN);
        UBOOT_INFO("Ursa upgrade OK!~\n");
    }
#else
    if(state&UPGRADE_STATE_URSA_BIN) // upgrade Ursa
    {
        memset(cmd, 0, 128);
        snprintf(cmd, sizeof(cmd)-1, "ustar %s",URSA_BIN_PATH);
        UBOOT_DEBUG("cmd=%s\n",cmd);
        if(-1 == run_command(cmd, 0))
        {
            UBOOT_ERROR("Upgrade Ursa error!\n");
            setenv(ENV_FORCEUPGRADE,NULL);
            setenv("upgrade_status", "ERROR");
            saveenv();
            return -1;
        }
        state = state&(~UPGRADE_STATE_URSA_BIN);
        UBOOT_INFO("Ursa upgrade OK!~\n");
    }
#endif
    else if(state&UPGRADE_STATE_SBOOT_BIN)//upgrade Sboot
    {
        memset(cmd, 0, 128);
        snprintf(cmd, sizeof(cmd)-1, "ustar %s",SBOOT_BIN_PATH);
        UBOOT_DEBUG("cmd=%s\n",cmd);
        if(-1 == run_command(cmd, 0))
        {
            UBOOT_ERROR("Upgrade Sboot error!\n");
            setenv(ENV_FORCEUPGRADE,NULL);
            setenv("upgrade_status", "ERROR");
            saveenv();
            //return -1;
        }
        state = state&(~UPGRADE_STATE_SBOOT_BIN);
        UBOOT_INFO("Sboot upgrade OK!~\n");
    }

    else if(state&UPGRADE_STATE_MBOOT_BIN)//upgrade Mboot
    {
        memset(cmd, 0, 128);
        snprintf(cmd, sizeof(cmd)-1, "ustar %s",MBOOT_BIN_PATH);
        UBOOT_DEBUG("cmd=%s\n",cmd);
        if(-1 == run_command(cmd, 0))
        {
            UBOOT_ERROR("Upgrade Mboot error!\n");
            setenv(ENV_FORCEUPGRADE,NULL);
            setenv("upgrade_status", "ERROR");
            saveenv();
            //return -1;
        }
        state = state&(~UPGRADE_STATE_MBOOT_BIN);
        UBOOT_INFO("Mboot upgrade OK!~\n");
    }
    else if(state&UPGRADE_STATE_OEM)
    {
        setenv("upgrade_mode","usb");
        run_command("fatload usb 0 0x20200000 oem.img", 0);
        run_command("mmc write.p 0x20200000 oem 0x500000", 0);
        state = state&(~UPGRADE_STATE_OEM);
        setenv("usb_auto_upgrade","enable");
        setenv("MstarUpgrade_complete","1");
        saveenv();
    }
    else if(state&UPGRADE_STATE_AP_PKG || state&UPGRADE_STATE_AP_NO_TVCERT_PKG)//upgrade upgrade_image.pkg||upgrade_image_no_tvcertificate.pkg
    {
#if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
        char *cUpgradeMode = getenv("upgrade_mode");
        if((cUpgradeMode != NULL) && (0 != strcmp(cUpgradeMode, "null")) && (0 != strcmp(cUpgradeMode, "factory_reset")))
#endif
        {
            setenv("upgrade_mode","usb");
            memset(cmd, 0, 128);
            if(state&UPGRADE_STATE_AP_NO_TVCERT_PKG)
            snprintf(cmd, sizeof(cmd)-1, "ustar %s",AP_NO_TVCERF_PKG_PATH);
            else
            snprintf(cmd, sizeof(cmd)-1, "ustar %s",AP_PKG_PATH);
#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)
            if (state & UPGRADE_STATE_AP_PKG_CUSTOM) {
                snprintf(cmd, sizeof(cmd)-1, "ustar %s",AP_LONG_NAME_PKG_PATH);//overwrite cmd
            }
#endif
#if defined (TPV_FW_UPGRADE_FILTER)
            if (g_b_tpv_force_upgrade_enable) {
                snprintf(cmd, sizeof(cmd)-1, "ustar %s",TPV_FORCE_UPGRADE_NAME);//overwrite cmd
            }
#endif
            UBOOT_DEBUG("cmd=%s\n",cmd);
            if(-1 == run_command(cmd, 0))
            {
                UBOOT_ERROR("Upgrade Application error!\n");
                //UBOOT_ERROR("\n-- Upgrade ERROR\n");
                 setenv(ENV_FORCEUPGRADE,NULL);
                 setenv("upgrade_status", "ERROR");
                 saveenv();
                //return -1;
            }
        }
#if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
       else
       {
           state = state&(~UPGRADE_STATE_AP_PKG);
           snprintf(upgrade_state_flag, sizeof(upgrade_state_flag)-1, "0x%02x",state);
           UBOOT_DEBUG("upgrade_state_flag=%s\n",upgrade_state_flag);
           setenv(ENV_FORCEUPGRADE,upgrade_state_flag);
           saveenv();
           if(state != 0) //need upgrade other
           {
               #ifdef CONFIG_BOOTCOUNT_LIMIT
               setenv ("bootcount", "0");
               #endif
               setenv ("sync_mmap", "1");
               setenv("upgrade_status", NULL);
               setenv("USBUpgrade_complete", "1");
               saveenv();
               run_command("reset",0);
           }
           else
           {
               run_command("setenv force_upgrade", 0);
               saveenv();
               close_console_log();
               return 0;
           }
       }

        state = state&(~UPGRADE_STATE_FORCE_AC_ON_AP_BIN);//run upgrade AP .... ignore AC bin file
#endif
        state = state&(~UPGRADE_STATE_AP_PKG);
        state = state&(~UPGRADE_STATE_AP_NO_TVCERT_PKG);
#if defined (TPV_LONG_FILE_NAME_UPGRADE_SUPPORT)
        state = state&(~UPGRADE_STATE_AP_PKG_CUSTOM);
#endif
        UBOOT_INFO("AP upgrade OK!~\n");
    }
    else if(state&UPGRADE_STATE_AP_BIN)//upgrade Supernova
    {
#if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
       char *cUpgradeMode = getenv("upgrade_mode");
      if((cUpgradeMode != NULL) && (0 != strcmp(cUpgradeMode, "null")) && (0 != strcmp(cUpgradeMode, "factory_reset")))
#endif
      {
            setenv("upgrade_mode","usb");
            memset(cmd, 0, 128);
#if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
			if(state&UPGRADE_STATE_AP_BIN_CUSTOM)
				snprintf(cmd, sizeof(cmd)-1, "ustar %s",AP_Custom_UpgradeFile);
			else
            snprintf(cmd, sizeof(cmd)-1, "ustar %s",AP_BIN_PATH);
#else
            snprintf(cmd, sizeof(cmd)-1, "ustar %s",AP_BIN_PATH);
#endif
            UBOOT_DEBUG("cmd=%s\n",cmd);
            if(-1 == run_command(cmd, 0))
            {
                UBOOT_ERROR("Upgrade Application error!\n");
                //UBOOT_ERROR("\n-- Upgrade ERROR\n");
                 setenv(ENV_FORCEUPGRADE,NULL);
                 setenv("upgrade_status", "ERROR");
                 saveenv();
                //return -1;
            }
       }
#if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
       else
       {
           state = state&(~UPGRADE_STATE_AP_BIN);
           snprintf(upgrade_state_flag, sizeof(upgrade_state_flag)-1, "0x%02x",state);
           UBOOT_DEBUG("upgrade_state_flag=%s\n",upgrade_state_flag);
           setenv(ENV_FORCEUPGRADE,upgrade_state_flag);
           saveenv();
           if(state != 0) //need upgrade other
           {
               #ifdef CONFIG_BOOTCOUNT_LIMIT
               setenv ("bootcount", "0");
               #endif
               setenv ("sync_mmap", "1");
               setenv("upgrade_status", NULL);
               setenv("USBUpgrade_complete", "1");
               saveenv();
               run_command("reset",0);
           }
           else
           {
               run_command("setenv force_upgrade", 0);
               saveenv();
               close_console_log();
               return 0;
           }
       }

        state = state&(~UPGRADE_STATE_FORCE_AC_ON_AP_BIN);//run upgrade AP .... ignore AC bin file
#endif
        state = state&(~UPGRADE_STATE_AP_BIN);
#if defined (CONFIG_MTK_BD_MT168B_TPV_SONY_10AT_19133_MT5870_M7332)
        state = state&(~UPGRADE_STATE_AP_BIN_CUSTOM);
#endif

        UBOOT_INFO("AP upgrade OK!~\n");
    }
#if (ENABLE_AUTO_USB_UPGRADE == 1) && (ENABLE_AUTO_USB_UPGRADE_AC == 1) && (ENABLE_FORCE_AC_ON_BIN_PATH == 1)
    else if(state&UPGRADE_STATE_FORCE_AC_ON_AP_BIN)//AC on upgrade
    {
        char *cUpgradeMode = getenv("upgrade_mode");
        if (msAPI_Power_QueryPowerOnMode() == EN_POWER_AC_BOOT &&(cUpgradeMode == NULL? TRUE : (0 == strcmp(cUpgradeMode, "null"))))
        {
             memset(cmd, 0, 128);
             snprintf(cmd, sizeof(cmd)-1, "ustar %s",FORCE_AC_ON_AP_BIN_PATH);
             UBOOT_DEBUG("cmd=%s\n",cmd);
             if(-1 == run_command(cmd, 0))
             {
                 UBOOT_ERROR("AC on Upgrade Application error!\n");
                 setenv(ENV_FORCEUPGRADE,NULL);
                 setenv("upgrade_status", "ERROR");
                 saveenv();
             }
        }

        state = state&(~UPGRADE_STATE_FORCE_AC_ON_AP_BIN);
        UBOOT_INFO("AC on AP upgrade OK!~\n");
    }
#endif
#ifndef MI_TPV_MODEL_T32_SOEM_PJ
    else if (state&UPGRADE_STATE_FRC_BIN)
    {
    	int32_t	rVal = 0;
		
        UBOOT_DEBUG("[FRC] cmd= USB_FRC_upgrade usb \n");
		_nvt_show_env_variable();

		rVal = run_command("USB_FRC_upgrade usb", 0);	/* -1, no trigger, 0, frc same, 1 do frc upgrade ok, 2: do frc upgrade error */

        UBOOT_DEBUG("[FRC] after USB_FRC_upgrade done, rVal =%d \n", rVal);
		_nvt_show_env_variable();

		/* run_command() only return -1 or 0 , -1: booting continue, FRC upgrade do not triggered, may be no FRC, version same, */
		/* 0: Done FRC FW upgrade both success or error, need to reboot TV */
		if (0 /* FRC_UPGRADE_POST_REBOOT */ == rVal) {
			/* post check after FRC FW upgraded, to check upgrade error */
			char *pEnv = NULL;
			uint32_t errCnt = 0;
			uint32_t DBG_reset_f = 0;		/* DBG reset f: not exist, original flow, exist: force reset */
			
			if (NULL != getenv("frc_DBG_reset_f"))
				DBG_reset_f = 1;

			// #define	FRC_ENV_UPG_ERR_CNT			"frc_upg_err_cnt"
			if	(NULL != (pEnv=getenv("frc_upg_err_cnt"))) {
				errCnt = (int)simple_strtoul(pEnv, NULL, 10);
				if (errCnt >= 5) {
					UBOOT_TRACE("[FRC] tried 5 times, no more retry\n");
					return -1;
				}
				else {
					if (DBG_reset_f) {
						UBOOT_TRACE("[FRC] TV reboot casued by frc fw upgrade error \n");
						run_command("reset",0);
					}
				}
			}
			else {
				UBOOT_INFO("[FRC] FRC upgrade success !~\n");
				if (DBG_reset_f) {
					UBOOT_TRACE("[FRC] TV reboot casued by frc fw upgrade success \n");
					run_command("reset",0);
				}
			}
		}
		else {
			UBOOT_TRACE("[FRC] no FRC FW upgrade triggered, please check: have valid FRC image ?, version same ? \n");
			return -1;
		}
		
		UBOOT_INFO("original FRC upgrade done !~\n");
        state = state&(~UPGRADE_STATE_FRC_BIN);
    }
#endif
#if defined (CONFIG_URSA_6M60)
    if(state & UPGRADE_STATE_TERRA2_BIN) // upgrade Terra2
    {
        UBOOT_DEBUG("cmd= terra2_fast_upgrade \n");
        if(-1 == run_command("terra2_fast_upgrade", 0))
        {
            UBOOT_ERROR("Upgrade terra2 fail!\n");
            //setenv(ENV_FORCEUPGRADE,NULL);
            setenv("upgrade_status", "ERROR");
            saveenv();
        }
        else
        {
            UBOOT_INFO("terra2 upgrade OK!~\n");
        }
        state = state&(~UPGRADE_STATE_TERRA2_BIN);
    }
#endif

    cUpgradeStatus = getenv("upgrade_status");
    printf("getenv upgrade_status\n");
    if( cUpgradeStatus != NULL )
    {
        printf("cUpgradeStatus=%s\n", cUpgradeStatus);
        if( strncmp(cUpgradeStatus, "ERROR", 5) == 0 )
        {
            UBOOT_ERROR("USB Upgrade Fail !!!!\n");
        #if defined(CONFIG_ANDROID_BOOT)
            jump_to_console();
        #else
            mdelay(5000);
            char *p_str = getenv("usb_upgrade_auto_reset");
            int UsbUpgradeAutoReset = 1;
            if(p_str != NULL)
            {
                UsbUpgradeAutoReset = (int)simple_strtol(p_str, NULL, 10);
                UBOOT_DEBUG("UsbUpgradeAutoReset=%d\n",UsbUpgradeAutoReset);
            }

            printf("UsbUpgradeAutoReset=%d\n",UsbUpgradeAutoReset);

            if(UsbUpgradeAutoReset==0)
            {
                if((p_str =getenv ("usb_upgradeerror_flicker"))!=NULL)
                {
                    UBOOT_DEBUG("usb_upgradeerror_flicker=%s\n", p_str);
                    char buffer[CMD_BUF]="\0";
                    memset(buffer, 0 , CMD_BUF);
                    snprintf(buffer, CMD_BUF, "led time %s", p_str);
                    UBOOT_DEBUG("cmd=%s\n",buffer);
                    run_command(buffer,0); //GPIO led Frequency
                }
                else
                {
                    run_command("led time 0xFA",0);
                }
                jump_to_console();
            }
            else
            {
		  //CUS_PHI_FEATURE
		  FW_Upgrade_Finish = 1;
		  if(UpdateKit_Hub_Detect == 1)
		  {
		      printf("UpdateKit Detect and Upgrade finish, force speed and send OK to pl2303\n");
		      flib_SetUSB_ForceSpeed(TRUE);
		      usb_stop(USB_PORT0);
		      USBInit = usb_init_exhub_port(USB_PORT0, 3);
		      if (-1 == USBInit)
		      {
		         printf("FAIL : can not init usb0!! \n");
		         usb_stop(USB_PORT1);
		         USBInit = usb_init_exhub_port(USB_PORT1, 3);
		         if (-1 == USBInit)
		             printf("FAIL : can not init usb1!! \n");
		      }
		      flib_SetUSB_ForceSpeed(FALSE);
		   }

                run_command("reset",0);
            }
        #endif
        }
	 else//CUS_PHI_FEATURE
	 {
           printf("USB Upgrade Success ! cUpgradeStatus compare result=%d UpdateKit_Hub_Detect=%d\n", strncmp(cUpgradeStatus, "ongoing", 7), UpdateKit_Hub_Detect);
           if( strncmp(cUpgradeStatus, "ongoing", 7) == 0 )
           {
               printf("USB to force speed !\n");//200821
		  FW_Upgrade_Finish = 1;
		  if(UpdateKit_Hub_Detect == 1)
		  {
		      printf("UpdateKit Detect and Upgrade finish, force speed and send OK to pl2303\n");
		      flib_SetUSB_ForceSpeed(TRUE);
		      usb_stop(USB_PORT0);
		      USBInit = usb_init_exhub_port(USB_PORT0, 3);
		      if (-1 == USBInit)
		      {
		         printf("FAIL : can not init usb0!! \n");
		         usb_stop(USB_PORT1);
		         USBInit = usb_init_exhub_port(USB_PORT1, 3);
		         if (-1 == USBInit)
		             printf("FAIL : can not init usb1!! \n");
		      }
		      flib_SetUSB_ForceSpeed(FALSE);
		   }

                //run_command("reset",0);
           }
	 }
    }

    if(state == 0)
    {
        UBOOT_INFO("All Upgrade File Had Finished !!\n");
        // TPV add start
        xprintf("Finish to upgrade main FW\n");
        setenv("PKG_UPGRADED", "1");
        // TPV add end        
        setenv(ENV_FORCEUPGRADE,NULL);
    }
    else
    {
        snprintf(upgrade_state_flag, sizeof(upgrade_state_flag)-1, "0x%02x",state);
        UBOOT_DEBUG("upgrade_state_flag=%s\n",upgrade_state_flag);
        setenv(ENV_FORCEUPGRADE,upgrade_state_flag);
    }
#ifdef CONFIG_BOOTCOUNT_LIMIT
    setenv ("bootcount", "0");
#endif
    setenv ("sync_mmap", "1");
    setenv("upgrade_status", NULL);
    setenv("USBUpgrade_complete", "1");
    saveenv();
    UBOOT_TRACE("OK\n");
    UBOOT_INFO("\n\n-- Upgrade Succeed!\n\n");
    close_console_log();
    char *p_str = getenv("usb_upgrade_auto_reset");
    int UsbUpgradeAutoReset = 1;
    if(p_str != NULL)
    {
        UsbUpgradeAutoReset = (int)simple_strtol(p_str, NULL, 10);
        UBOOT_DEBUG("UsbUpgradeAutoReset=%d\n",UsbUpgradeAutoReset);
    }
    if(UsbUpgradeAutoReset==0)
    {
        jump_to_console();
    }
    else
    {
        run_command("reset",0);
    }
    return 0;
}

#if defined(CONFIG_MMC)
int do_usb_partial_upgrade_to_emmc(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
   char cmd[CMD_BUF] = "\0";
   char *env =NULL, *path;
   int partition = 0;
   int device = 0;
   MS_U8 u8Percent= 0;
   long unsigned int u32FileSize = 0, offset = 0, remain = 0, partial_size = 0;
   unsigned int u32PartSize, u32PartOffset;

   UBOOT_DEBUG("cyli argv[1]=%s,argv[2]=%s,argv[3]=%s,argv[4]=%s,argv[5]=%s\n",argv[1],argv[2],argv[3],argv[4],argv[5]);
   if (argc < 3) {
       UBOOT_ERROR ("usage: %s <filename> <partition_name>\n", argv[0]);
       return 1;
   }
#if 0
   if (-1 == appInitUsbDisk()) {
       UBOOT_ERROR("FAIL : can not init usb!! \n");
       return -1;
   }
#endif

   path = argv[1];
   if (!check_file_partition(path ,&device,&partition)) {
       if (get_mmc_part_size_and_offset(argv[2], &u32PartSize, &u32PartOffset)) {
           UBOOT_ERROR("get emmc part size and offset fail\n");
           return -1;
       }
       UBOOT_DEBUG("Get %s partition: size = 0x%x , offset = 0x%x\n", argv[2], u32PartSize, u32PartOffset);

       UBOOT_DEBUG("Geting usb file size of %s\n", path);
       snprintf(cmd, CMD_BUF, "fatfilesize usb %d:%d %s", device, partition, path);
       UBOOT_DEBUG("cmd => %s\n",cmd);
       if (run_command(cmd, 0)) {
           UBOOT_ERROR("get script file's size fail\n");
           return -1;
       } else {
           env = getenv("filesize");
           if (NULL == env) {
               UBOOT_ERROR("get env 'filesize' fail\n");
               return -1;
           }
           u32FileSize = simple_strtol(env, NULL, 16);
           printf("Size 0x%lx\n", u32FileSize);
           remain = u32FileSize;
       }

       if (u32FileSize > (u32PartSize << 9)) {
           UBOOT_ERROR("file size (0x%x) is bigger than partition size (0x%x)\n", u32FileSize, u32PartSize << 9);
           return -1;
       }

       //      snprintf(cmd, CMD_BUF, "fatload usb %d:%d %X %s %X", device, partition, UPGRADE_BUFFER_ADDR, path, u32FileSize);
       while (remain > 0) {
           if (remain > UPGRADE_BUFFER_SIZE)
               partial_size = UPGRADE_BUFFER_SIZE;
           else
               partial_size = remain;

           snprintf(cmd, CMD_BUF, "fatpartload usb %d:%d 0x%X %s 0x%X 0x%X", device, partition, (unsigned int)UPGRADE_BUFFER_ADDR, path, (unsigned int)offset, (unsigned int)partial_size);
           UBOOT_DEBUG("cmd => %s\n",cmd);
           if (run_command(cmd, 0)) {
               UBOOT_ERROR("Load Upgrade File fail!\n");
               return -1;
           }

           flush_cache(UPGRADE_BUFFER_ADDR, partial_size);

           snprintf(cmd, CMD_BUF, "mmc write 0x%X 0x%X 0x%X", UPGRADE_BUFFER_ADDR, u32PartOffset + (offset >> 9), partial_size);
           UBOOT_DEBUG("cmd => %s\n",cmd);
           if (run_command(cmd, 0)) {
               UBOOT_ERROR("Write Upgrade File fail!\n");
               return -1;
           }

           remain -= partial_size;
           offset += partial_size;
       }

   } else {
       UBOOT_DEBUG("no %s in usb disk\n", path);
       return -1;
   }

   return 0;
}
#endif

#if defined(CONFIG_CMD_CUSTOMER_UDSTAR) && (CONFIG_CMD_CUSTOMER_UDSTAR == 1)
#define DEFAULT_DEBUG_SCRIPT_PATH             "/MstarDebug.script"
#define ARG_NUM_SCRIPT_FILE         1
#define IS_ARG_AVAILABLE_SCRIPT_FILE(x) ((x) > ARG_NUM_SCRIPT_FILE)
#define ARG_SCRIPT_FILE(x)              (x)[ARG_NUM_SCRIPT_FILE]
#define MAX_SCRIPT_SIZE 0x20000

int do_cudstar (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    char *cmdBuf=NULL;
    char *script_buf=NULL;
    char *pBuf=NULL;
    char *next_line=NULL;
    char *upgradeFile=NULL;
    char *env=NULL;
    int ret=0;
    unsigned int u32FileSize=0;
    int partition = 0;
    int device = 0;
    UBOOT_TRACE("IN\n");

    upgradeFile = IS_ARG_AVAILABLE_SCRIPT_FILE(argc) ? ARG_SCRIPT_FILE(argv) : DEFAULT_DEBUG_SCRIPT_PATH;

    if(check_file_partition(upgradeFile,&device,&partition)!=0)
    {
        UBOOT_ERROR("no file in usb\n");
        return -1;
    }

    UBOOT_DEBUG("upgradeFile=%s\n",upgradeFile);

    cmdBuf=malloc(CMD_BUF);
    if(cmdBuf==NULL)
    {
        UBOOT_ERROR("malloc fail\n");
        return -1;
    }
    memset(cmdBuf, 0 , CMD_BUF);
    snprintf(cmdBuf, CMD_BUF, "fatload usb %d:%d %X %s 1", device,partition,cmdBuf, upgradeFile);
    UBOOT_DEBUG("cmd=%s\n",cmdBuf);
    ret=run_command(cmdBuf, 0);
    if(ret!=0)
    {
        free(cmdBuf);
        UBOOT_ERROR("No script file exist\n");
        return -1;
    }

    memset(cmdBuf, 0, CMD_BUF);
    snprintf(cmdBuf, CMD_BUF, "fatfilesize usb %d:%d %s", device,partition, upgradeFile);
    UBOOT_DEBUG("cmd=%s\n",cmdBuf);
    ret = run_command(cmdBuf, 0);
    if(ret!=0)
    {
        free(cmdBuf);
        UBOOT_ERROR("get script file's size fail\n");
        return -1;
    }
    // Get file size. If larger then DRAM, don't load the whole. Just load its script.
    env=getenv("filesize");
    if(env==NULL)
    {
       free(cmdBuf);
       UBOOT_ERROR("get env 'filesize' fail\n");
       return -1;
    }
    u32FileSize = simple_strtol(env, NULL, 16);
    pBuf=malloc(u32FileSize);
    if(pBuf==NULL)
    {
        free(cmdBuf);
        UBOOT_ERROR("malloc for script file fail\n");
        return -1;
    }
    script_buf=pBuf;
    memset(script_buf,0,u32FileSize);

    memset(cmdBuf, 0, CMD_BUF);
    snprintf(cmdBuf, CMD_BUF, "fatload usb %d:%d %X %s %X",device,partition,script_buf,upgradeFile,u32FileSize);
    UBOOT_DEBUG("cmd=%s\n",cmdBuf);
    ret = run_command(cmdBuf, 0);
    if(ret!=0)
    {
        free(pBuf);
        free(cmdBuf);
        return -1;
    }

    while ((next_line = get_script_next_line(&script_buf)) != NULL)
    {
        UBOOT_INFO ("\n>>1 %s \n", next_line);

        ret=run_command(next_line, 0);
        if(ret!=0)
        {
            free(pBuf);
            free(cmdBuf);
            UBOOT_ERROR("run cmd '%s' fail\n",next_line);
            return -1;
        }
    }

    free(cmdBuf);
    free(pBuf);
    UBOOT_TRACE("OK\n");
    return 0;
}

#endif
#endif

#if (ENABLE_MODULE_OAD == 1)
int do_costar(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    char buffer[CMD_BUF] = "\0";
    int ret=0;
    char *oad_state = NULL;

    UBOOT_TRACE("IN\n");

    #if defined(CONFIG_UPGRADE_V1)
    UBOOT_INFO("\n\nUpgrade Version: 1.0\n\n");
    #elif defined(CONFIG_UPGRADE_V2)
    UBOOT_INFO("\n\nUpgrade Version: 2.0\n\n");
    #else
    // reserved
    #endif

    #if (ENABLE_MODULE_DISPLAY_OSD==1)
        UnRegisterShowCb();
        RegisterCBShowError((show_Error_cb)show_Error);
        RegisterCBShowFinish((show_Finish_cb)show_Finish);
        RegisterCBShowLoadData((show_LoadData_cb)show_LoadData);
        RegisterCBShowStartUpgrading((show_StartUpgrading_cb)show_StartUpgrading);
        RegisterCBShowUpgrading((show_Upgrading_cb)show_Upgrading);
    #endif

    oad_state = getenv("OadUpgradeStatus");
    if(oad_state != NULL )
    {
        if( strcmp(oad_state, "finish") == 0 )
        {
            UBOOT_ERROR("do ostar fail, OadUpgradeStatus is not vaild\n");
            #if (ENABLE_MODULE_DISPLAY_OSD==1)
			show_LoadData(0);
            show_Error(0);
            #endif
            MsOS_DelayTask(3000);
            setenv("upgrade_mode","null");
            setenv("OadUpgradeStatus",NULL);
            setenv("MstarUpgrade_complete","1");
            saveenv();
            run_command("reset", 0);
            return -1;
        }
    }



    if(argc == 2)
    {
        if(strcmp(argv[1], "updatelogic")==0)
            snprintf(buffer,CMD_BUF,"ostar %s",UL_PKG_PATH);
        else
            return -1;
    }
    else
    {
        snprintf(buffer,CMD_BUF,"ostar %s",OAD_BIN_PATH);
    }

    UBOOT_DEBUG("cmd=%s\n",buffer);
    ret=run_command(buffer,0);
    if(ret==-1)
    {
        UBOOT_ERROR("do ostar fail\n");
        #if (ENABLE_MODULE_DISPLAY_OSD==1)
        show_Error(0);
        #endif
        MsOS_DelayTask(3000);
        setenv("upgrade_mode","null");
        setenv("OadUpgradeStatus",NULL);
        setenv("MstarUpgrade_complete","1");
        saveenv();
        UBOOT_TRACE("OK\n");
        run_command("reset", 0);
        return -1;
    }

    setenv("OadUpgradeStatus","finish");
    setenv("MstarUpgrade_complete","1");
    setenv("upgrade_status", NULL);
    saveenv();

#if defined(CONFIG_QUIET_HOT_BOOT)
    if(!EEPRON_ClearOADMode())
    {
       UBOOT_ERROR("OAD sets finish flag is not successful\n");
    }
#endif

    UBOOT_INFO("\n\nOAD -- Upgrade Succeed\n\n");

    MsOS_DelayTask(3000);
    run_command("reset",0);
    UBOOT_TRACE("OK\n");
    return 0;
}
#endif

#if (ENABLE_MODULE_NETUPDATE == 1)
int do_cnstar(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    char buffer[CMD_BUF] = "\0";
    int ret=0;

    UBOOT_TRACE("IN\n");

    #if (ENABLE_MODULE_DISPLAY_OSD==1)
        UnRegisterShowCb();
        RegisterCBShowError((show_Error_cb)show_Error);
        RegisterCBShowFinish((show_Finish_cb)show_Finish);
        RegisterCBShowLoadData((show_LoadData_cb)show_LoadData);
        RegisterCBShowStartUpgrading((show_StartUpgrading_cb)show_StartUpgrading);
        RegisterCBShowUpgrading((show_Upgrading_cb)show_Upgrading);
    #endif
    snprintf(buffer,CMD_BUF,"nstar %s",NET_BIN_PATH);
    UBOOT_DEBUG("cmd=%s\n",buffer);
    ret=run_command(buffer,0);
    if(ret==-1)
    {
        UBOOT_ERROR("do nstar fail\n");
        return -1;
    }

    UBOOT_TRACE("OK\n");
    return 0;
}


#endif

#if (ENABLE_MODULE_USB == 1)
#if (ENABLE_MINIUBOOT==0)
int do_usb_bin_check(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    char cmd[128];
    int ret = -1;
    UBOOT_TRACE("IN\n");
    //usb init
    if (-1 == appInitUsbDisk())
    {
       printf("FAIL : can not init usb!! \n");
       return -1;
    }
    //we try usb upgrade first
    ret = check_file_partition(AP_BIN_PATH,NULL,NULL);
    if(ret == 0)
    {
        UBOOT_DEBUG("has app upgrade bin\n");
        memset(cmd, 0, 128);
        snprintf(cmd, sizeof(cmd)-1, "ustar %s",AP_BIN_PATH);
        UBOOT_DEBUG("cmd=%s\n",cmd);
        if(-1 == run_command(cmd, 0))
        {
            UBOOT_ERROR("Upgrade Application error!\n");
            return -1;
        }
        else
        {
            UBOOT_INFO("AP upgrade OK!~\n");
            UBOOT_TRACE("OK\n");
            run_command("reset",0);
            return 0;
        }
    }
    else
    {
        UBOOT_DEBUG("no %s in usb disk\n",AP_BIN_PATH);
    }
    return -1;
}


static int ota_zip_check_usb(void)
{
    int ret;
    char cmd[128];

    UBOOT_TRACE("IN\n");
    //usb init
    if (-1 == appInitUsbDisk())
    {
       printf("FAIL : can not init usb!! \n");
       return -1;
    }
    char label[128] = "\0";
    char raw_uuid[128] = "\0";
    char uuid[128] = "\0";
    struct bootloader_message p_msg;

    ret = check_file_partition(OTA_ZIP_PATH,NULL,NULL);
    if(ret == 0)//OTA upgrade
    {
        getFatVolumeLabel(label,raw_uuid);
        snprintf(uuid, sizeof(uuid)-1, "%02x%02x-%02x%02x", raw_uuid[3], raw_uuid[2], raw_uuid[1], raw_uuid[0]);
        UBOOT_DEBUG("label:%s\nuuid:%s\n",label,uuid);
        memset(cmd,0,128);
        memset(&p_msg,0,sizeof(struct bootloader_message));
        strncpy(p_msg.command,BOOT_MODE_RECOVERY_STR,sizeof(p_msg.command)-1);
        strncpy(p_msg.recovery,"recovery\n",sizeof(p_msg.recovery)-1);
        strncat(p_msg.recovery,"--update_package=/mnt/usb/sda1/update_signed.zip\n",(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
        strncat(p_msg.recovery,"--label=",(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
        strncat(p_msg.recovery,label,(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
        strncat(p_msg.recovery,"\n",(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
        strncat(p_msg.recovery,"--uuid=",(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
        strncat(p_msg.recovery,uuid,(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
        strncat(p_msg.recovery,"\n",(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
        UBOOT_DEBUG("command:%s\n",p_msg.recovery);
        #if (ENABLE_MODULE_MMC == 1)
        snprintf(cmd, sizeof(cmd)-1, "mmc write.p 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
        #else
            #if !CONFIG_MSTAR_FTL
        snprintf(cmd, sizeof(cmd)-1, "nand write.e 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
            #else
        snprintf(cmd, sizeof(cmd)-1, "ftl write.p 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
            #endif
        #endif
        if(-1 == run_command(cmd,0))
        {
            UBOOT_ERROR("cmd:%s error\n",cmd);
            return -1;
        }
        UBOOT_INFO("OTA upgrade OK!~\n");
        UBOOT_TRACE("OK\n");
        return 0;
    }
    else
    {
        UBOOT_DEBUG("no %s in usb disk\n",OTA_ZIP_PATH);
        UBOOT_TRACE("OK\n");
        return -1;
    }
}
#endif
 #if defined(CONFIG_MMC)
static int ota_zip_check_emmc(char *abspath)
{
    int ret;
    U32 fsize;
    char cmd[256];
    char subdir[512];
    struct bootloader_message p_msg;

    UBOOT_TRACE("IN\n");
    ret = vfs_mount_by_abspath(abspath, subdir, sizeof(subdir));
    if (ret != 0)
    {
        UBOOT_ERROR("vfs_mount_by_abspath failed\n");
        return -1;
    }
    fsize = vfs_getsize(subdir);
    if (fsize <= 0)
    {
        UBOOT_DEBUG("file(%s) do not exist !\n", abspath);
        return -1;
    }

    memset(&p_msg,0,sizeof(struct bootloader_message));
    strcpy(p_msg.command,BOOT_MODE_RECOVERY_STR);
    strcpy(p_msg.recovery,"recovery\n");

    memset(cmd, 0, 128);
    snprintf(cmd, sizeof(cmd), "--update_package=%s\n", abspath);
    strcat(p_msg.recovery, cmd);
    UBOOT_DEBUG("command:%s\n", p_msg.recovery);
    memset(cmd, 0, 128);
    #if (ENABLE_MODULE_MMC == 1)
    snprintf(cmd, sizeof(cmd)-1, "mmc write.p 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
    #else
        #if !CONFIG_MSTAR_FTL
    snprintf(cmd, sizeof(cmd)-1, "nand write.e 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
        #else
    snprintf(cmd, sizeof(cmd)-1, "ftl write.p 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
        #endif
    #endif
    if(-1 == run_command(cmd,0))
    {
        UBOOT_ERROR("cmd:%s error\n",cmd);
        return -1;
    }

    UBOOT_TRACE("OK\n");
    return 0;
}
#endif

int do_ota_zip_check(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    int ret = -1;
    UBOOT_TRACE("IN\n");
 #if defined(CONFIG_MMC)
    if ((argc >= 2) && (strcmp(argv[1], "emmc") == 0))
    {
        char *abspath = argv[2];
        UBOOT_DEBUG("check otapackage(%s) in emmc\n", abspath);
        ret = ota_zip_check_emmc(abspath);
    }
    else
#endif
    {
        UBOOT_DEBUG("check otapackage(update_signed.zip) in usb_disk\n");
        ret = ota_zip_check_usb();
    }
    UBOOT_TRACE("OK\n");
    return ret;
}


#if (ENABLE_UTEST == 1)

static char* load_script_by_path(char *script_path, char *script_buf, unsigned int script_max_size)
{
    char cmd[CONFIG_SYS_CBSIZE];
    unsigned int iFilesize = 0;

    memset(script_buf, 0, script_max_size);
    sprintf(cmd, "fatload usb 0 %X %s %X", (unsigned int)script_buf, script_path, script_max_size);
    UBOOT_INFO("%s\n", cmd);
    if (run_command (cmd, 0) != 0)
    {
        UBOOT_ERROR("cmd %s failed\n", cmd);
        return NULL;
    }

    iFilesize = (unsigned int)simple_strtoul(getenv("filesize"), NULL, 16);
    UBOOT_DEBUG("iFilesize=0x%x\n", iFilesize);
    if (iFilesize >= (script_max_size-2))
    {
        UBOOT_ERROR("script_max_size(0x%x) is too small !\n", script_max_size);
        UBOOT_INFO("Filesize = 0x%x\n", iFilesize);
        return NULL;
    }

    script_buf[iFilesize]='\n';
    script_buf[iFilesize+1]='%';
    return script_buf;
}


int do_utest(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    #define USB_TEST_PATH "/auto_test.txt"
    #define DEFAULT_SCRIPT_SIZE 0x4000

    char *next_line = NULL;
    char *penv = NULL;
    char *script_buf = NULL;
    char *tmp_script_buf = NULL;
    char *script_path = NULL;
    char * test_cmd = NULL;
    unsigned int total_cnt_num=0;
    unsigned int current_cnt_num=0;
    UBOOT_TRACE("IN\n");
    if (((penv = getenv("enable_utest")) == NULL) || (strcmp(penv,"1") != 0))
    {
        UBOOT_INFO("env(enable_utest) != 1, skip utest ...\n");
        UBOOT_TRACE("OK\n");
        return 0;
    }
    tmp_script_buf = (char *)malloc(DEFAULT_SCRIPT_SIZE);
    if (tmp_script_buf == NULL)
    {
        UBOOT_ERROR("malloc 0x%x byte failed\n", DEFAULT_SCRIPT_SIZE);
        return -1;
    }

    printf("[AT][MB][do_bootm][%lu]\n", MsSystemGetBootTime());
    //usb init
    if (-1 == appInitUsbDisk_Single(CONFIG_UTEST_SCAN_USB_PORT))
    {
        printf("FAIL : can not init usb %d!! \n", CONFIG_UTEST_SCAN_USB_PORT);
        printf("[AT][MB][do_bootm][%lu]\n", MsSystemGetBootTime());
        free(tmp_script_buf);
        return -1;
    }

    show_test_start(0);
    if(check_file_partition(USB_TEST_PATH,NULL,NULL) != 0)
    {
        UBOOT_ERROR("Can not find %s in Udisk\n", USB_TEST_PATH);
        free(tmp_script_buf);
        return -1;
    }

    script_buf = load_script_by_path(USB_TEST_PATH, tmp_script_buf, DEFAULT_SCRIPT_SIZE);
    if(script_buf == NULL)
    {
        UBOOT_ERROR("Load %s failed\n", USB_TEST_PATH);
        free(tmp_script_buf);
        return -1;
    }

    next_line = get_script_next_line(&script_buf);
    test_cmd = (char *)malloc(strlen(next_line));
    if (test_cmd == NULL)
    {
        UBOOT_ERROR("malloc 0x%x bytes failed !\n", strlen(next_line));
        goto utest_error;
    }

    strcpy(test_cmd, next_line);
    if ((script_path = strstr(next_line, "utest ")) != NULL)
    {
        UBOOT_INFO("\n>> %s \n", next_line);
        script_path = malloc(strlen(next_line) - strlen("utest "));
        if (script_path == NULL)
        {
            UBOOT_ERROR("malloc 0x%x bytes failed !\n", strlen(next_line));
            goto utest_error;
        }

        strcpy(script_path, next_line + strlen("utest "));
        script_buf = load_script_by_path(script_path, tmp_script_buf, DEFAULT_SCRIPT_SIZE);
        if(script_buf == NULL)
        {
            goto utest_error;
        }
        total_cnt_num = check_script_cmd_count(script_buf);
        UBOOT_INFO("total_cnt_num = %d \n", total_cnt_num);

        script_buf = load_script_by_path(script_path, tmp_script_buf,  DEFAULT_SCRIPT_SIZE);
        if(script_buf == NULL)
        {
            goto utest_error;
        }
        while ((next_line = get_script_next_line(&script_buf)) != NULL)
        {
            UBOOT_INFO("\n>> %s \n", next_line);
            if(-1 == run_command(next_line, 0))
            {
                const char * write_cmd = "mmc write.p";
                UBOOT_ERROR("command error!\n");
                printf("write_cmd = %s\n", write_cmd);
                printf("next_line = %s\n", next_line);
                if(strncmp(next_line, write_cmd, 11) == 0)
                {
                    show_test(0, "TEST ABORT", get_utest_err_msg(), 1, 1);
                }
                else
                {
                    show_test(0, "TEST ABORT", "Unknown command, check script!", 1, 1);
                }
                goto utest_error;
            }
            else
            {
                current_cnt_num ++;
                show_test(0, "TESTING...", test_cmd, current_cnt_num, total_cnt_num);
            }
        }
        show_test(0, "TEST FINISH", test_cmd, 1, 1);
    } else{
        UBOOT_ERROR("can not find command 'utest' in %s\n", USB_TEST_PATH);
        goto utest_error;
    }
    UBOOT_TRACE("OK\n");
    free(tmp_script_buf);
    free(script_path);
    free(test_cmd);
    test_cmd = NULL;
    script_path = NULL;
    setenv ("sync_mmap", "1");
    jump_to_console();
    return 0;
utest_error:
    free(tmp_script_buf);
    free(script_path);
    free(test_cmd);
    test_cmd = NULL;
    script_path = NULL;
    jump_to_console();
    return -1;
}
#endif


#endif

int do_wipe_datacache_check(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    char cmd[128];
    UBOOT_TRACE("IN\n");

    struct bootloader_message p_msg;
    memset(cmd,0,128);
    memset(&p_msg,0,sizeof(struct bootloader_message));
    strncpy(p_msg.command,BOOT_MODE_RECOVERY_STR,sizeof(p_msg.command)-1);
    strncpy(p_msg.recovery,"recovery\n",sizeof(p_msg.recovery)-1);
    if(0 == strcmp(argv[1],"data"))
    {
        strncat(p_msg.recovery,"--wipe_data\n",(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
    }
    if(0 == strcmp(argv[1],"cache"))
    {
        strncat(p_msg.recovery,"--wipe_cache\n",(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
    }
    UBOOT_DEBUG("command:%s\n",p_msg.recovery);
    #if (ENABLE_MODULE_MMC == 1)
        snprintf(cmd, sizeof(cmd)-1, "mmc write.p 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
    #else
        #if !CONFIG_MSTAR_FTL
        snprintf(cmd, sizeof(cmd)-1, "nand write.e 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
        #else
		snprintf(cmd, sizeof(cmd)-1, "ftl write.p 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
        #endif
    #endif
    if(-1 == run_command(cmd,0))
    {
        UBOOT_ERROR("cmd:%s error\n",cmd);
        return -1;
    }
    UBOOT_INFO(" OK!~\n");
    UBOOT_TRACE("OK\n");
    return 0;
 }

#if (ENABLE_MODULE_SYSTEM_RESTORE == 1)
int do_systemrestore(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    char cmd[128];
    UBOOT_TRACE("IN\n");

    struct bootloader_message p_msg;
    memset(cmd,0,128);
    memset(&p_msg,0,sizeof(struct bootloader_message));
    strncpy(p_msg.command,BOOT_MODE_RECOVERY_STR,strlen(BOOT_MODE_RECOVERY_STR)+1);
    strncpy(p_msg.recovery,"recovery\n",strlen("recovery\n")+1);
    strncat(p_msg.recovery,"--update_package=/systembackup/update_signed.zip\n",(sizeof(p_msg.recovery)-strlen(p_msg.recovery)));
    UBOOT_DEBUG("command:%s\n",p_msg.recovery);
    #if (ENABLE_MODULE_MMC == 1)
    snprintf(cmd, sizeof(cmd)-1, "mmc write.p 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
    #else
        #if !CONFIG_MSTAR_FTL
    snprintf(cmd, sizeof(cmd)-1, "nand write.e 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
        #else
    snprintf(cmd, sizeof(cmd)-1, "ftl write.p 0x%X misc 0x%x", &p_msg,sizeof(struct bootloader_message));
        #endif
    #endif
    if(-1 == run_command(cmd,0))
    {
       UBOOT_ERROR("cmd:%s error\n",cmd);
       return -1;
    }
    UBOOT_INFO(" OK!~\n");
    UBOOT_TRACE("OK\n");
    return 0;
}
#endif
//==============ISP functions for Upgrade===================
#if defined (CONFIG_UPGRADE_URSA)
//------------------------------------------------------------------------------
SFlashType SupportSFlash[Flash_NUMS]=
{
// 1-4:size ,5:manufacturer_id,6:device_id,7:WREN,8:WRDI,9:RDSR,10:WRSR,11:READ,12:FAST_READ,
// 13:PG_PROG,14:SECTOR_ERASE,15:BLOCK_ERASE,16:CHIP_ERASE,17:RDID,18:LOCK,19-20: ChipEraseMaxTime

//                    1-4    ,5   ,6   ,7   ,8   ,9   ,10  ,11  ,12  ,13  ,14  ,15  ,16  ,17  ,18  ,19-20
//PMC
{/*"PMC25LV512A", */  0x20000,0x9D,0x7B,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD7,0xD8,0xC7,0xAB,0x0C,40  },
{/*" PMC25LV010", */  0x20000,0x9D,0x7C,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD7,0xD8,0xC7,0xAB,0x0C,40  },
{/*" PMC25LV020", */  0x40000,0x9D,0x7D,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD7,0xD8,0xC7,0xAB,0x0C,40  },
{/*" PMC25LV040", */  0x80000,0x9D,0x7E,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD7,0xD8,0xC7,0xAB,0x1C,40  },
//EON
{/*"    EN25P10", */  0x20000,0x1C,0x10,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x0C,80  },
{/*"    EN25P20", */  0x40000,0x1C,0x11,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x0C,80  },
{/*"    EN25P40", */  0x80000,0x1C,0x12,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,80  },
{/*"    EN25P80", */  0x100000,0x1C,0x13,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,80  },
{/*"    EN25F40", */  0x80000,0x1C,0x12,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,80  },
{/*"    EN25F80", */  0x100000,0x1C,0x13,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,220  },
{/*"    EN25F16", */  0x200000,0x1C,0x14,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,440  },
{/*"    EN25P16", */  0x80000,0x1C,0x14,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,220 },
{/*"    EN25B20", */  0x40000,0x1C,0x41,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x0C,80  },
{/*"    EN25B40", */  0x80000,0x1C,0x42,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,80  },
{/*"   EN25B40T", */  0x80000,0x1C,0x42,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,80  },
{/*"    EN25B16", */  0x80000,0x1C,0x34,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,220 },
{/*"   EN25B16T", */  0x80000,0x1C,0x34,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,220 },
{/*"    EN25B32", */  0x80000,0x1C,0x35,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,440 },
//                    1-4    ,5   ,6   ,7   ,8   ,9   ,10  ,11  ,12  ,13  ,14  ,15  ,16  ,17  ,18  ,19-20
//SPANSION
{/*"  S25FL004A", */  0x80000,0x01,0x12,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,260 },
{/*"  S25FL016A", */0x1000000,0x01,0x14,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,1000},
{/*"  S25FL040A", */  0x80000,0x01,0x25,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,260 },
//Winbond & NX
{/*"    NX25P16", */0x1000000,0xEF,0x15,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,250 },
{/*"     W25X10", */  0x20000,0xEF,0x10,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x0C,70  },
{/*"     W25X20", */  0x40000,0xEF,0x51,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,250 },
{/*"     W25X40", */  0x80000,0xEF,0x52,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,250 },
{/*"     W25P20", */  0x40000,0xEF,0x11,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,250 },
{/*"     W25P40", */  0x80000,0xEF,0x12,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,250 },
{/*"     W25X16", */  0x20000,0xEF,0x14,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x0C,256  },
{/*"     W25X32", */  0x40000,0xEF,0x15,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,512 },
{/*"     W25X64", */  0x80000,0xEF,0x16,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,1000 },
{/*"     W25Q32", */  0x40000,0xEF,0x16,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,512 },
//SST
{/*"SST25VF016B", */0x1000000,0xBF,0x41,0x06,0x04,0x05,0x01,0x03,NULL,0xAD,0xD8,0xD8,0xC7,0xAB,0x1C,40  },
{/*"SST25VF040B", */  0x80000,0xBF,0x8D,0x06,0x04,0x05,0x01,0x03,NULL,0xAD,0xD8,0xD8,0xC7,0xAB,0x1C,40  },
//MX
{/*" MX25L4005A", */  0x80000,0xC2,0x12,0x06,0x04,0x05,0x01,0x03,0x0B,0x02,0x20,0xD8,0xC7,0xAB,0x1C,80  },
{/*" MX25L8005", */  0x100000,0xC2,0x13,0x06,0x04,0x05,0x01,0x03,0x0B,0x02,0x20,0xD8,0xC7,0xAB,0x1C,160  },
{/*"  MX25L2005", */  0x40000,0xC2,0x11,0x06,0x04,0x05,0x01,0x03,0x0B,0x02,0x20,0xD8,0xC7,0xAB,0x1C,50  },
{/*"  MX25L1605", */0x200000,0xC2,0x14,0x06,0x04,0x05,0x01,0x03,0x0B,0x02,0x20,0xD8,0xC7,0xAB,0x1C,550 },
{/*"  MX25L3205", */0x400000,0xC2,0x15,0x06,0x04,0x05,0x01,0x03,0x0B,0x02,0x20,0xD8,0xC7,0xAB,0x1C,750 },
{/*"  MX25L6405", */0x800000,0xC2,0x16,0x06,0x04,0x05,0x01,0x03,0x0B,0x02,0x20,0xD8,0xC7,0xAB,0x1C,1000 },
//INTEL
{/*"QB25F160S33B8", */  0x20000,0x89,0x11,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD7,0xD8,0xC7,0xAB,0x0C,128  },
{/*"QB25F320S33B8", */  0x40000,0x89,0x12,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD7,0xD8,0xC7,0xAB,0x0C,256  },
{/*"QB25F640S33B8", */  0x80000,0x89,0x13,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD7,0xD8,0xC7,0xAB,0x1C,512  },
//AMIC
{/*" A25L40P", */  0x80000,0x37,0x13,0x06,0x04,0x05,0x01,0x03,0x0B,0x02,0x20,0xD8,0xC7,0xAB,0x1C,128  },
{/*" GD25Q32", */  0x40000,0xC8,0x16,0x06,0x04,0x05,0x01,0x03,0x0B,0x02,0x20,0xD8,0xC7,0xAB,0x1C,512  },
{/*" EN25Q32A", */  0x40000,0x1C,0x15,0x06,0x04,0x05,0x01,0x03,NULL,0x02,0xD8,0xD8,0xC7,0xAB,0x1C,256  },
};

static SWI2C_BusCfg Ursa_I2cBusCfg[URSA_I2C_BUS_NUM]=
{
    // Bus-0
    {PAD_DDCR_CK, PAD_DDCR_DA, 100}, //IS_SW_I2C  /SCL_PAD /SDA_PAD /Delay

    // Bus-1
    //{PAD_GPIO28, PAD_GPIO29, 100}, //IS_SW_I2C  /SCL_PAD /SDA_PAD /Delay

    // Others, add other bus here
};

//default ursa20 i2c addr
MS_U8 g_slave_addr = 0x98;
MS_U8 g_serial_debug_addr = 0xB4;


static void Ursa_SWI2C_Init(void)
{
    char * p_slave_addr = NULL;
    char slave_addr[URSA_RELATE_ADDR_BUF_SIZE+1];
    char * p_serial_debug_addr = NULL;
    char * p_pad_scl = NULL;
    char * p_pad_sda = NULL;
    st_board_para board_data;
    memset(&board_data, 0, sizeof(st_board_para));

    //get slave addr from "slave_addr" & "serial_debug_addr" env
    if((p_slave_addr = getenv ("slave_addr")) != NULL)
    {
        memset(slave_addr, 0, URSA_RELATE_ADDR_BUF_SIZE+1);
        if(strlen(p_slave_addr) < 1)
        {
            UBOOT_INFO("p_slave_addr size is 0\n");
        }
        else if(strlen(p_slave_addr) > URSA_RELATE_ADDR_BUF_SIZE)
        {
            UBOOT_INFO("p_slave_addr size is bigger than %d\n",(int)URSA_RELATE_ADDR_BUF_SIZE);
        }
        else
        {
            memcpy(slave_addr, p_slave_addr, strlen(p_slave_addr));
            g_slave_addr = (int)simple_strtol(slave_addr, NULL, 16);
        }
    }
    if((p_serial_debug_addr = getenv ("serial_debug_addr")) != NULL)
    {
        memset(slave_addr, 0, URSA_RELATE_ADDR_BUF_SIZE+1);
        if(strlen(p_serial_debug_addr) < 1)
        {
            UBOOT_INFO("p_serial_debug_addr size is 0\n");
        }
        else if(strlen(p_serial_debug_addr) > URSA_RELATE_ADDR_BUF_SIZE)
        {
            UBOOT_INFO("p_serial_debug_addr size is bigger than %d\n",(int)URSA_RELATE_ADDR_BUF_SIZE);
        }
        else
        {
            memcpy(slave_addr, p_serial_debug_addr, strlen(p_serial_debug_addr));
            g_serial_debug_addr = (int)simple_strtol(slave_addr, NULL, 16);
        }
    }
    if(Read_BoardParaFromflash(&board_data) == 0)
    {
        Ursa_I2cBusCfg[0].padSCL = board_data.m_u16I2cSCLPad;
        Ursa_I2cBusCfg[0].padSDA = board_data.m_u16I2cSDAPad;
    }

    UBOOT_INFO("Ursa_SWI2C_Init() - g_slave_addr=0x%x, g_serial_debug_addr=0x%x \n", g_slave_addr, g_serial_debug_addr);
    UBOOT_INFO("Ursa_I2cBusCfg: padSCL=%d, padSDA=%d \n", Ursa_I2cBusCfg[0].padSCL, Ursa_I2cBusCfg[0].padSDA );
    MApi_SWI2C_Init(Ursa_I2cBusCfg, URSA_I2C_BUS_NUM);
}


static void Ursa_SWI2C_ReadDatas(MS_U8  * paddr, MS_U8 addrSize, MS_U8 * pdatabuf, MS_U8 dataSize)
{
    MS_U8 k;
    MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);

    if(MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_WRITE)==FALSE)
    {
    printf("\n I2cReadDatas->IIC_AccessStart Error");
    }

    for(k=0;k<addrSize;k++)
    {
        if(MApi_SWI2C_SendByte(paddr[k])==FALSE)
        {
            printf("\n I2cReadDatas paddr Error");
        }
    }

    if(MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_READ)==FALSE)
    {
        printf("\n I2cReadDatas->IIC_AccessReStart Error");
    }

    for(k=0;k<dataSize-1;k++)
    {
        pdatabuf[k]=MApi_SWI2C_GetByte(1);
    }
    //last byte
    pdatabuf[k]=MApi_SWI2C_GetByte(0);

    MApi_SWI2C_Stop();
}

static void Ursa_SWI2C_WriteDatas(MS_U8 * paddr, MS_U8 addrSize, MS_U8  * pdatabuf, MS_U8 dataSize)
{
     MS_U8 k;
     MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);

    if(MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_WRITE)==FALSE)
    {
        printf("\n I2cWriteDatas->IIC_AccessStart Error");
    }

    for(k=0;k<addrSize;k++)
    {
        if(MApi_SWI2C_SendByte(paddr[k])==FALSE)
        {
            printf("\n paddr Error");
        }
    }

    for(k=0;k<dataSize;k++)
    {
        if(MApi_SWI2C_SendByte(pdatabuf[k])==FALSE)
        {
            printf("\n pdatabuf Error");
        }
    }

    MApi_SWI2C_Stop();
}

static void Ursa_SWI2C_WriteDatas2(MS_U8 * paddr, MS_U8 addrSize, MS_U8 * pdatabuf, MS_U8 dataSize)
{
    MS_U8 k;
    MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);
    MApi_SWI2C_AccessStart(g_serial_debug_addr, SW_IIC_WRITE);

    for(k=0;k<addrSize;k++)
        MApi_SWI2C_SendByte(paddr[k]);

    for(k=0;k<dataSize;k++)
    {
        MApi_SWI2C_SendByte(pdatabuf[k]);
    }

    MApi_SWI2C_Stop();
}
static void Ursa_SerialFlash_WriteReg(MS_U8 bBank, MS_U8 bAddr, MS_U8 bData)
{
    MS_U8 bWriteData[4];

    bWriteData[0] = CMD_DATA_WRITE;
    bWriteData[1] = bBank;
    bWriteData[2] = bAddr;
    bWriteData[3] = bData;

    Ursa_SWI2C_WriteDatas2(bWriteData, sizeof(bWriteData),NULL,0);
}

static void Ursa_SWI2C_WriteStop(void)
{
    MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);

    if(MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_WRITE)==FALSE)
    {
        printf("\n I2cWriteStop->IIC_AccessStart Error");
    }

    if(MApi_SWI2C_SendByte(SPI_STOP)==FALSE)
    {
        printf("\n I2cWriteStop-> Error");
    }

    MApi_SWI2C_Stop();
}
static void Ursa_SWI2C_CommandRead(void)
{
    MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);

    if(MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_WRITE)==FALSE)
    {
        printf("\n I2cCommondRead Error");
    }
    if(MApi_SWI2C_SendByte(SPI_READ)==FALSE)
    {
        printf("\n I2cCommondRead-> SPI_READ");
    }
}

static MS_U8 Ursa_ReadChipID(void)
{
    MS_U8 ReadIDCommand[]={SPI_WRITE,0xAB,0x00,0x00,0x00};
    MS_U8 buf;

    Ursa_SWI2C_WriteDatas(ReadIDCommand,sizeof(ReadIDCommand),NULL,0);

    buf=SPI_READ; //Manufacture ID
    Ursa_SWI2C_ReadDatas(&buf,1,&buf,1);

    buf=SPI_READ; //Device ID1
    Ursa_SWI2C_ReadDatas(&buf,1,&buf,1);

    buf=SPI_READ; //Device ID2
    Ursa_SWI2C_ReadDatas(&buf,1,&buf,1);

    Ursa_SWI2C_WriteStop();
    return buf;
}

static MS_U8 Ursa__ReadChipJEDEC_ID(MS_U8 *ReadIDBuf)
{
    MS_U8 ReadIDCommand[]={SPI_WRITE,0x9f};

    MS_U8 buf;

    Ursa_SWI2C_WriteDatas(ReadIDCommand,sizeof(ReadIDCommand),NULL,0);

    buf=SPI_READ;
    Ursa_SWI2C_ReadDatas(&buf, 1, &ReadIDBuf[0], 3); //Manufacture ID, Device ID1[15-8], Device ID2[7-0]

    Ursa_SWI2C_WriteStop();
    return buf;
}

static MS_U8 Ursa_ReadChipIDBuffer(MS_U8 *ReadIDBuf)
{
    MS_U8 ReadIDCommand[]={SPI_WRITE,0xAB,0x00,0x00,0x00};
    MS_U8 buf;

    Ursa_SWI2C_WriteDatas(ReadIDCommand,sizeof(ReadIDCommand),NULL,0);
    buf=SPI_READ; //Manufacture ID
    Ursa_SWI2C_ReadDatas(&buf,1,&ReadIDBuf[0],1);

    buf=SPI_READ; //Device ID1
    Ursa_SWI2C_ReadDatas(&buf,1,&ReadIDBuf[1],1);

    buf=SPI_READ; //Device ID2
    Ursa_SWI2C_ReadDatas(&buf,1,&ReadIDBuf[2],1);

    Ursa_SWI2C_WriteStop();
    return buf;
}
static MS_BOOL Ursa_EnterIspMode(void)
{
    // 0x4D,0x53,0x54,0x41,0x52
    MS_U8 enterISPdata[]="MSTAR";
    MS_U8 addr=0x20;

    // enter isp mode

    Ursa_SWI2C_WriteDatas(enterISPdata,sizeof(enterISPdata)-1,NULL,0);
    Ursa_SWI2C_ReadDatas(&addr,1,&addr,1);

    if(addr==0xC0)
    {
        printf("\nEnterIspMode->OK\n");
        return TRUE; // enter ok
    }
    else
    {
        printf("\nEnterIspMode->fail\n");
        return FALSE; // enter fail
    }
}
static void Ursa_ExitIspMode(void)
{
    MS_U8 tdata=0x24;

    // exit isp mode
    printf("\n1.ExitIspMode");
    Ursa_SWI2C_WriteDatas(&tdata,1,NULL,0);
}

static void Ursa_EnterSerialDebug(void)
{
    MS_U8 EnterSerialDebug[]={0x53, 0x45, 0x52, 0x44, 0x42};

    Ursa_SWI2C_WriteDatas2(EnterSerialDebug,sizeof(EnterSerialDebug),NULL,0);
}

static void Ursa_EnterSingleStep(void)
{
    MS_U8 EnterSingleStep[]={CMD_DATA_WRITE, 0xC0, 0xC1, 0x53};

    Ursa_SWI2C_WriteDatas2(EnterSingleStep,sizeof(EnterSingleStep),NULL,0);
}

static void Ursa_ExitSingleStep(void)
{
    MS_U8 ExitSingleStep[]={CMD_DATA_WRITE, 0xC0, 0xC1, 0xFF};

    Ursa_SWI2C_WriteDatas2(ExitSingleStep,sizeof(ExitSingleStep),NULL,0);
}

static void Ursa_ExitSerialDebug(void)
{
    MS_U8 ExitSerialDebug[]={0x45};

    Ursa_SWI2C_WriteDatas2(ExitSerialDebug,sizeof(ExitSerialDebug),NULL,0);
}

static void Ursa_WP_PullHigh(void)
{
    Ursa_EnterSerialDebug();
    Ursa_EnterSingleStep();

    // Set chip to power up for register setting
    Ursa_SerialFlash_WriteReg(0x00, 0, 0);
    Ursa_SerialFlash_WriteReg(0x00, 0xF0, 0x02);

    // Only for GIPO P2.4
    Ursa_SerialFlash_WriteReg(0x00, 0x00, 0x01);    // BK1_50[7] = 1
    Ursa_SerialFlash_WriteReg(0x00, 0x50, 0x80);    // Enable register clock for gaultier

    Ursa_SerialFlash_WriteReg(0x00, 0x00, 0x00);
    Ursa_SerialFlash_WriteReg(0x00, 0x63, 0x3D);    // Adjust P2.4 and P2.7
                                               // TSUM chip p2.4 at 0x63[4], p2.7 at 0x63[3]
                                               // TSUMO chip p2.4 at 0x63[5],p2.7 at 0x63[2]
    Ursa_SerialFlash_WriteReg(0x00, 0xc5, 0xFF);    // PWM 1 set to high (P2.7)
    Ursa_SerialFlash_WriteReg(0x00, 0xc7, 0xFF);    // PWM 2 set to high (P2.4)

    // Paulo series chip
    // MCU config pin PWM0~3 default resistor setting = 1001
    Ursa_SerialFlash_WriteReg(0x00, 0x00, 0x0A);
    Ursa_SerialFlash_WriteReg(0x00, 0xED, 0x3F);    // PWM1 pin set to PWM BK0A_ED[7:6]=00
                                               // the other pin set to input mode
    // Lopez series chip
    // MCU config pin PWM2
    Ursa_SerialFlash_WriteReg(0x1E, 0xE5, 0xC8);
    Ursa_SerialFlash_WriteReg(0x1E, 0x8A, 0xC0);

    Ursa_ExitSingleStep();
    Ursa_ExitSerialDebug();
}

MS_BOOL GetsFlashType(void)
{
    MS_U8 temp;
    MS_U8 ucTmpBuf[4];

    Ursa__ReadChipJEDEC_ID(ucTmpBuf);
    printf("\n***ReadChipJEDEC_ID[%x]",ucTmpBuf[0]);
    printf("\n***ReadChipJEDEC_ID[%x]",ucTmpBuf[1]);
    printf("\n***ReadChipJEDEC_ID[%x]",ucTmpBuf[2]);
    switch(ucTmpBuf[0])
    {
         //AL
        case 0x37:
            printf("\n  AL or AMIC");
            temp=Ursa_ReadChipID();
            printf("\n  AL or AMIC ChipID=%x",temp);
            if (temp == 0x12)
            {
                g_ucFlashType=Flash_A25L40P;
                g_ucBankNumber=8;
                printf("\n   A25L40P");
            }
            else
            {
              return FALSE;
            }
            break;
    ///////////////////////////////////////////////

        //PMC
        case 0x7F:
            printf("\n  PMC or AMIC");
            temp=Ursa_ReadChipID();
            printf("\n  PMC or AMIC ChipID=%x",temp);
            if (temp == 0x7C)
            {
                g_ucFlashType=Flash_PMC010;
                g_ucBankNumber=2;
            }
            else if (temp == 0x7D)
            {
                g_ucFlashType=Flash_PMC020;
                g_ucBankNumber=4;
            }
            else if (temp == 0x7E)
            {
                g_ucFlashType=Flash_PMC040;
                g_ucBankNumber=8;
            }
            else if (temp == 0x12)
            {
                g_ucFlashType=Flash_A25L40P;
                g_ucBankNumber=8;
                printf("\n   A25L40P");
            }
            else
            {
                return FALSE;
            }
            break;
        //EON
        case 0x1C:
            printf("\n  EON");
            temp=Ursa_ReadChipID();
            printf("\n  EON ChipID=%x",temp);
            if (ucTmpBuf[2] == 0x20)
            {
                if (ucTmpBuf[1] == 0x11 && temp == 0x10)
                {
                    g_ucFlashType = Flash_EN25P10;
                    g_ucBankNumber=2;
                    printf("\n   EN25P10");
                }
                else if (ucTmpBuf[1] == 0x12 && temp == 0x11)
                {
                    g_ucFlashType = Flash_EN25P20;
                    g_ucBankNumber=4;
                    printf("\n   EN25P20");
                }
                else if (ucTmpBuf[1] == 0x13 && temp == 0x12)
                {
                    g_ucFlashType = Flash_EN25P40;
                    g_ucBankNumber=8;
                    printf("\n   EN25P40");
                }
                else if (ucTmpBuf[1] == 0x14 && temp == 0x13)
                {
                    g_ucFlashType = Flash_EN25P80;
                    g_ucBankNumber=16;
                    printf("\n   EN25P80");
                }
                else if (ucTmpBuf[1] == 0x12 && temp == 0x41)
                {
                    g_ucFlashType = Flash_EN25B20;
                    g_ucBankNumber=4;
                    printf("\n   EN25B20");
                }
                else if (ucTmpBuf[1] == 0x13 && temp == 0x32)
                {
                    g_ucFlashType = Flash_EN25B40;
                    g_ucBankNumber=8;
                    printf("\n   EN25B40");
                }
                else if (ucTmpBuf[1] == 0x13 && temp == 0x42)
                {
                    g_ucFlashType = Flash_EN25B40T;
                    g_ucBankNumber=8;
                    printf("\n   EN25B40T");
                }
                else if (ucTmpBuf[1] == 0x15 && temp == 0x14)
                {
                    g_ucFlashType = Flash_EN25P16;
                    g_ucBankNumber = 32;
                    printf("\n   EN25P16");
                }
                else if (ucTmpBuf[1] == 0x15 && temp == 0x34)
                {
                    g_ucFlashType = Flash_EN25B16;
                    g_ucBankNumber = 32;
                    printf("\n   EN25B16");
                }
                else if (ucTmpBuf[1] == 0x15 && temp == 0x44)
                {
                    g_ucFlashType = Flash_EN25B16T;
                    g_ucBankNumber = 32;
                    printf("\n   EN25B16T");
                }
                else if (ucTmpBuf[1] == 0x16 && temp == 0x35)
                {
                    g_ucFlashType = Flash_EN25B32;
                    g_ucBankNumber = 64;
                    printf("\n   EN25B32");
                }
                else
                {
                    return FALSE;
                }
            }
            else if (ucTmpBuf[2] == 0x31)
            {
                if (ucTmpBuf[1] == 0x13 && temp == 0x12)
                {
                    g_ucFlashType = Flash_EN25F40;
                    g_ucBankNumber=8;
                    printf("\n   EN25F40");
                }
                else if (ucTmpBuf[1] == 0x14 && temp == 0x13)
                {
                    g_ucFlashType = Flash_EN25F80;
                    g_ucBankNumber=16;
                    printf("\n   EN25F80");
                }
                else if (ucTmpBuf[1] == 0x15 && temp == 0x14)
                {
                    g_ucFlashType = Flash_EN25F16;
                    g_ucBankNumber=32;
                    printf("\n   EN25F16");
                }
            }
            else if (ucTmpBuf[2] == 0x30)
            {
                if (ucTmpBuf[1] == 0x16 && temp == 0x15)
                {
                    g_ucFlashType = Flash_EN25Q32A;
                    g_ucBankNumber = 64;
                    printf("\n   EN25Q32A");
                }
            }
            else
                {
                    return FALSE;
                }
            break;
        case 0x01:
            printf("\n  SPANSION");
            printf("\n   chip ID=%x",ucTmpBuf[2]);
            if (ucTmpBuf[2] == 0x14)
            {
                g_ucFlashType = Flash_S25FL016A;
                g_ucBankNumber = 32;
                printf("\n   S25FL016A");
            }
            else if (ucTmpBuf[2] == 0x12)
            {
                g_ucFlashType = Flash_S25FL004A;
                g_ucBankNumber = 8;
                printf("\n   S25FL004A");
            }
            else if (ucTmpBuf[2] == 0x25)
            {
                g_ucFlashType = Flash_S25FL040A;
                g_ucBankNumber = 8;
                printf("\n   S25FL040A");
            }
            else
            {
                return FALSE;
            }
            break;
        case 0xEF:
            printf("\n  WINBOND & NX");
            if (ucTmpBuf[1] == 0x20 && ucTmpBuf[2] == 0x15)
            {
                g_ucFlashType = Flash_NX25P16;
                g_ucBankNumber = 32;
                printf("\n   NX25P16 or W25P16");
            }
            else if (ucTmpBuf[1] == 0x30 && ucTmpBuf[2] == 0x11)
            {
                g_ucFlashType = Flash_W25X10;
                g_ucBankNumber = 2;
                printf("\n   W25X10");
            }
            else if (ucTmpBuf[1] == 0x30 && ucTmpBuf[2] == 0x12)
            {
                g_ucFlashType = Flash_W25X20;
                g_ucBankNumber = 4;
                printf("\n   W25X20");
            }
            else if (ucTmpBuf[1] == 0x30 && ucTmpBuf[2] == 0x13)
            {
                g_ucFlashType = Flash_W25X40;
                g_ucBankNumber = 8;
                printf("\n   W25X40");
            }
            else if (ucTmpBuf[1] == 0x00 && ucTmpBuf[2] == 0x15)
            {
                g_ucFlashType = Flash_W25X16;
                g_ucBankNumber = 32;
                printf("\n   W25X16");
            }
            else if (ucTmpBuf[1] == 0x00 && ucTmpBuf[2] == 0x16)
            {
                g_ucFlashType = Flash_W25X32;
                g_ucBankNumber = 64;
                printf("\n   W25X32");
            }
            else if (ucTmpBuf[1] == 0x00 && ucTmpBuf[2] == 0x17)
            {
                g_ucFlashType = Flash_W25X64;
                g_ucBankNumber = 128;
                printf("\n   W25X64");
            }
            else if (ucTmpBuf[1] == 0x40 && ucTmpBuf[2] == 0x16)
            {
                g_ucFlashType = Flash_W25Q32;
                g_ucBankNumber = 64;
                printf("\n   W25Q32");
            }
            else
            {
                temp=Ursa_ReadChipID();
                printf("\n ID 2:%x",temp);
                if (temp == 0x51)
                {//because some W25X20 have no ucTmpBuf[2](=0x00)
                    g_ucFlashType = Flash_W25X20;
                    g_ucBankNumber = 4;
                    printf("\n   W25X20-0");
                }
                else if(temp == 0x10)
                {
                    g_ucFlashType = Flash_W25X10;
                    g_ucBankNumber = 2;
                    printf("\n   W25X10-0");
                }
                else if(temp == 0x52)
                {//because some W25X40 have no ucTmpBuf[2](=0x00)
                    g_ucFlashType = Flash_W25X40;
                    g_ucBankNumber = 8;
                    printf("\n   W25X40-0");
                }
                else if(temp == 0x11)
                {//because some W25X40 have no ucTmpBuf[2](=0x00)
                    g_ucFlashType = Flash_W25P20;
                    g_ucBankNumber = 4;
                    printf("\n   W25P20");
                }
                else if(temp == 0x12)
                {//because some W25X40 have no ucTmpBuf[2](=0x00)
                    g_ucFlashType = Flash_W25P40;
                    g_ucBankNumber = 8;
                    printf("\n   W25P40");
                }
                else if(temp == 0x14)
                {
                    g_ucFlashType = Flash_NX25P16;
                    g_ucBankNumber = 32;
                    printf("\n   W25P16");
                }
                else
                {
                   return FALSE;
                }
            }
            break;
        case 0xBF:
            printf("\n  SST");
            if ((ucTmpBuf[1] == 0x25) & (ucTmpBuf[2] == 0x41))
            {
                g_ucFlashType = Flash_SST25VF016B;
                g_ucBankNumber = 32;
                printf("\n   SST25VF016B");
            }
            else if ((ucTmpBuf[1] == 0x25) & (ucTmpBuf[2] == 0x8D))
            {
                g_ucFlashType = Flash_SST25VF040B;
                g_ucBankNumber = 8;
                printf("\n   SST25VF040B");
            }
            else
            {
                 return FALSE;
            }
            break;
        case 0xC2:
            printf("\n MX");

            printf("\n JEDEC_ID1 0:%x",ucTmpBuf[0]);
            printf("\n JEDEC_ID1 1:%x",ucTmpBuf[1]);
            printf("\n JEDEC_ID1 2:%x",ucTmpBuf[2]);

            if ((ucTmpBuf[1] == 0x20) & (ucTmpBuf[2] == 0x13))
            {
                g_ucFlashType = Flash_MX25L4005A;
                g_ucBankNumber = 8;
                printf("\n   MX25L4005A");
            }
            else if ((ucTmpBuf[1] == 0x20) & (ucTmpBuf[2] == 0x14))
            {
                g_ucFlashType = Flash_MX25L8005;
                g_ucBankNumber = 16;
                printf("\n   MX25L8005");
            }
            else if ((ucTmpBuf[1] == 0x20) & (ucTmpBuf[2] == 0x12))
            {
                g_ucFlashType = Flash_MX25L2005;
                g_ucBankNumber = 4;
                printf("\n   MX25L2005");
            }
            else if((ucTmpBuf[1] == 0x20) & (ucTmpBuf[2] == 0x15))
            {
                g_ucFlashType = Flash_MX25L1605;
                g_ucBankNumber = 32;
                printf("\n   MX25L1605");
            }
            else if((ucTmpBuf[1] == 0x20) & (ucTmpBuf[2] == 0x16))
            {
                g_ucFlashType = Flash_MX25L3205;
                g_ucBankNumber = 32;
                printf("\n   MX25L3205");
            }
            else if((ucTmpBuf[1] == 0x20) & (ucTmpBuf[2] == 0x17))
            {
                g_ucFlashType = Flash_MX25L6405;
                g_ucBankNumber = 128;
                printf("\n   MX25L6405");
            }
            else
            {
                 return FALSE;
            }
            break;
        //intel
        case 0x89:
            printf("\n  INTEL");
            temp=Ursa_ReadChipID();
            printf("\n  INTEL ChipID=%x",temp);
            if (ucTmpBuf[1] == 0x11)
            {
                g_ucFlashType=Flash_QB25F160S;
                g_ucBankNumber=32;
                printf("\n   INTS33_16");
            }
            else if (ucTmpBuf[1] == 0x12)
            {
                g_ucFlashType=Flash_QB25F320S;
                g_ucBankNumber=64;
                printf("\n   INTS33_32");
            }
            else if (ucTmpBuf[1] == 0x13)
            {
                g_ucFlashType=Flash_QB25F640S;
                g_ucBankNumber=128;
                printf("\n   INTS33_64");
            }
            else
            {
                return FALSE;
            }
            break;
            //GD
        case 0xC8:
            printf("\n  GD");
            if ((ucTmpBuf[1] == 0x40) && (ucTmpBuf[2] == 0x16))
            {
                g_ucFlashType = Flash_GD25Q32;
                g_ucBankNumber = 32;
                printf("\n  GD25Q32");
            }
            else
            {
                 return FALSE;
            }
            break;
        default:
            printf("\n JEDEC_ID 0:%x",ucTmpBuf[0]);
            printf("\n JEDEC_ID 1:%x",ucTmpBuf[1]);
            printf("\n JEDEC_ID 2:%x",ucTmpBuf[2]);
            Ursa_ReadChipIDBuffer(ucTmpBuf);
            printf("\n RDID 0:%x",ucTmpBuf[0]);
            printf("\n RDID 1:%x",ucTmpBuf[1]);
            printf("\n RDID 2:%x",ucTmpBuf[2]);
            if ((ucTmpBuf[0] == 0x9D) && (ucTmpBuf[1] == 0x7F) && (ucTmpBuf[2] == 0x7B))
            {
                printf("\n  PMC-RDID");
                printf("\n   PM25LV512A/PM25LV512");
                g_ucFlashType=Flash_PMC512;
                g_ucBankNumber=1;
            }
            else
            {
                 return FALSE;
            }
            break;
    }
    Ursa_ReadChipIDBuffer(ucTmpBuf);
    printf("\n RDID1 0:%x",ucTmpBuf[0]);
    printf("\n RDID1 1:%x",ucTmpBuf[1]);
    printf("\n RDID1 2:%x",ucTmpBuf[2]);
    return TRUE;
}

MS_U8 SrcReadFlash(MS_U16 pcount , MS_U8 BankNum)
{
    MS_U8 u8Data;
    if(g_eUrsaUpgradeSel == E_MFC_SYSTEM_BIN)
    {
        memcpy(&u8Data,(void *)(g_u32ISPSrcAddr+(MS_U32)pcount + (MS_U32)(BankNum - g_ucBankDst)*0x10000), 1);
    }
    else // Upgrade MFC FW by default
    {
        memcpy(&u8Data,(void *)(g_u32ISPSrcAddr+(MS_U32)pcount + (MS_U32)BankNum*0x10000), 1);
    }
    return u8Data;
}


MS_U8 SFlashRdsr(void)
{
    MS_U8 buffer[2];

    buffer[0]=SPI_WRITE;
    buffer[1]=sFlash.RDSR;
    Ursa_SWI2C_WriteDatas(buffer,2,NULL,0);

    buffer[0]=SPI_READ;
    Ursa_SWI2C_ReadDatas(buffer,1,&buffer[1],1);

    Ursa_SWI2C_WriteStop();

    return buffer[1];
}

MS_U16 SFlashRdsr_1_2(void)
{
    MS_U8 buffer[2];
    MS_U16 u16value = 0x00;

    /* read status register 1 */
    buffer[0]=SPI_WRITE;
    buffer[1]=sFlash.RDSR;
    Ursa_SWI2C_WriteDatas(buffer,2,NULL,0);

    buffer[0]=SPI_READ;
    Ursa_SWI2C_ReadDatas(buffer,1,&buffer[1],1);
    Ursa_SWI2C_WriteStop();
    u16value = (MS_U16)buffer[1];

    /* read status register 2 */
    buffer[0]=SPI_WRITE;
    buffer[1]=0x35;
    Ursa_SWI2C_WriteDatas(buffer,2,NULL,0);

    buffer[0]=SPI_READ;
    Ursa_SWI2C_ReadDatas(buffer,1,&buffer[1],1);
    Ursa_SWI2C_WriteStop();
    u16value = ((buffer[1] << 8) | u16value);

    return u16value;
}

MS_BOOL SFlashChecksr(void)
{
    MS_U8 ucdelay = 10;
    MS_U32 count=1000;

    while(count--)
    {
        if((SFlashRdsr()&0x01)==0x00)
            return TRUE;
        while(ucdelay--);
    }
    return FALSE;
}


void SFlashWrsr(MS_U8 tdata)
{
    MS_U8 buffer[3];

    SFlashChecksr();

    // for sst sflash (sst manufacturer id=0xBF )
    if(sFlash.manufacturer_id==0xBF)
    {
        buffer[0]=SPI_WRITE;
        buffer[1]=0x50;
        Ursa_SWI2C_WriteDatas(buffer,2,NULL,0);

        Ursa_SWI2C_WriteStop();
    }

    buffer[0]=SPI_WRITE;
    buffer[1]=sFlash.WRSR;
    buffer[2]=tdata;
    Ursa_SWI2C_WriteDatas(buffer,sizeof(buffer),NULL,0);

    Ursa_SWI2C_WriteStop();
}

void SFlashWrsr_1_2(MS_U16 tdata)
{
    MS_U8 buffer[4];

    SFlashChecksr();

    buffer[0]=SPI_WRITE;
    buffer[1]=sFlash.WRSR;
    buffer[2]=(tdata & 0x00FF); //status register 1
    buffer[3]=((tdata & 0xFF00) >> 8); //status register 2

    Ursa_SWI2C_WriteDatas(buffer,sizeof(buffer),NULL,0);

    Ursa_SWI2C_WriteStop();
}

void SFlashWren(void)
{
    MS_U8 buffer[2];

    buffer[0]=SPI_WRITE;
    buffer[1]=sFlash.WREN;

    SFlashChecksr();
    Ursa_SWI2C_WriteDatas(buffer,2,NULL,0);

    Ursa_SWI2C_WriteStop();
}
void SFlashWrdi(void)
{
    MS_U8 buffer[2];

    buffer[0]=SPI_WRITE;
    buffer[1]=sFlash.WRDI;

    SFlashChecksr();
    Ursa_SWI2C_WriteDatas(buffer,2,NULL,0);

    buffer[0]=SPI_STOP;
    Ursa_SWI2C_WriteDatas(buffer,1,NULL,0);
}

MS_BOOL VerifyPMC64K(U8 BankNum)
{
    MS_U8 tdata[]={SPI_WRITE,0x03,0x00,0x00,0x00};
    MS_BOOL VerifyOk=TRUE;
    MS_U16 PcCounter=0;
    MS_U8 FlashReadData;
    MS_U16 u16PcCounterEnd = 0;

    tdata[1]=sFlash.READS;
    tdata[2]=BankNum;
    tdata[3]=0;
    tdata[4]=0;

    Ursa_SWI2C_WriteDatas(tdata,sizeof(tdata),NULL,0);
    udelay(60*1000);
    {
        Ursa_SWI2C_CommandRead();
           udelay(60*1000);
        MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);

    if(MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_READ)==FALSE)
    {
        printf("\n VerifyPMC64K Error");
    }

        if(g_eUrsaUpgradeSel == E_MFC_SYSTEM_BIN)
        {
            u16PcCounterEnd = SYSBIN_SIZE - 2; // system bin only 1KB needed (0 ~ 3).
        }
        else // Upgrade MFC FW by default
        {
            u16PcCounterEnd = BANKSIZE - 2;
        }

        for(PcCounter=0;PcCounter<=u16PcCounterEnd;PcCounter++)
        {
            FlashReadData=MApi_SWI2C_GetByte(1);
            if(FlashReadData!=SrcReadFlash(PcCounter,BankNum))
            {
                VerifyOk=FALSE;
                printf("\n flash read date error[%x],[%x],[%x]",PcCounter,FlashReadData,SrcReadFlash(PcCounter,BankNum));
                break;
            }
        }

        //last byte
        {
            FlashReadData=MApi_SWI2C_GetByte(0);
            //PcCounter++;

            if(FlashReadData!=SrcReadFlash(PcCounter,BankNum))
                VerifyOk=FALSE;
        }

        // 1 bank program end
        MApi_SWI2C_Stop();
    }

    Ursa_SWI2C_WriteStop();

    return VerifyOk;
}

void ProgSST64K(MS_U8 BankNum)
{
    MS_U8 k;
    MS_U8 tdata[7];
    MS_U16 PcCounter=0;

    SFlashWrsr(0x00);

    SFlashWren();
    SFlashChecksr();

    //AAI send the address
    tdata[0]=SPI_WRITE;
    tdata[1]=sFlash.PG_PROG;
    tdata[2]=BankNum;
    tdata[3]=0;
    tdata[4]=0;
    tdata[5]=SrcReadFlash(PcCounter,BankNum);
    PcCounter++;
    tdata[6]=SrcReadFlash(PcCounter,BankNum);
    PcCounter++;

    MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);
    MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_WRITE);

    for(k=0;k<sizeof(tdata);k++)
        MApi_SWI2C_SendByte(tdata[k]);
    Ursa_SWI2C_WriteStop();
    SFlashChecksr();

    //AAI send the datas
    tdata[0]=SPI_WRITE;
    tdata[1]=sFlash.PG_PROG;
    for (;PcCounter<0xFFFE;)
    {
        tdata[2]=SrcReadFlash(PcCounter,BankNum);
        PcCounter++;
        tdata[3]=SrcReadFlash(PcCounter,BankNum);
        PcCounter++;

        MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);
        MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_WRITE);
        for(k=0;k<4;k++)
            MApi_SWI2C_SendByte(tdata[k]);
        Ursa_SWI2C_WriteStop();
        //SFlashChecksr();
    }
    //AAI send the remain 2 bytes
    tdata[2]=SrcReadFlash(PcCounter,BankNum);
    PcCounter++;
    tdata[3]=SrcReadFlash(PcCounter,BankNum);

    MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);
    MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_WRITE);
    for(k=0;k<4;k++)
        MApi_SWI2C_SendByte(tdata[k]);
    Ursa_SWI2C_WriteStop();
    SFlashChecksr();
    //AAI stop
    SFlashWrdi();
    SFlashChecksr();
}

void ProgPMC64K(MS_U8 BankNum)
{
    MS_U8 k;
    MS_U16 i;
    MS_U8 tdata[5];
    MS_U8 count;
    MS_U16 PcCounter=0;
    MS_U16 u16BlockEnd = 0;

    if(sFlash.manufacturer_id==0xEF) /* WINBOND & NX */
    {
        MS_U16 u16StatusReg = SFlashRdsr_1_2();
        SFlashWrsr_1_2(u16StatusReg & ~(BIT14 | BIT4 | BIT3 | BIT2)); // unprotected => CMP(BIT14) = 0; BP2(BIT4) = 0, BP1(BIT3) = 0, and BP0(BIT2) = 0.
    }
    else
    {
        SFlashWrsr(0x00);
    }

    if(g_eUrsaUpgradeSel == E_MFC_SYSTEM_BIN)
    {
        u16BlockEnd = (SYSBIN_SIZE / BLOCKSIZE) - 1; // system bin only 1KB needed (0 ~ 3).
    }
    else // Upgrade MFC FW by default
    {
        u16BlockEnd = BLOCKNUM;
    }

    for(i=0;i<=u16BlockEnd;i++)
    {
        SFlashWren();
        SFlashChecksr();

        count=BLOCKSIZE-1;

        tdata[0]=SPI_WRITE;
        tdata[1]=sFlash.PG_PROG;
        tdata[2]=BankNum;
        tdata[3]=i;
        tdata[4]=0;

        MApi_SWI2C_UseBus(URSA_ISP_I2C_BUS_SEL);
        MApi_SWI2C_AccessStart(g_slave_addr, SW_IIC_WRITE);

        for(k=0;k<sizeof(tdata);k++)
            MApi_SWI2C_SendByte(tdata[k]);

        while(count--)
        {
            MApi_SWI2C_SendByte(SrcReadFlash(PcCounter,BankNum));

            PcCounter++;
        }

        // 1 byte more
        MApi_SWI2C_SendByte(SrcReadFlash(PcCounter,BankNum));
        PcCounter++;

        //block program end
        Ursa_SWI2C_WriteStop();
        //printf("*");
    }

    Ursa_SWI2C_WriteDatas(tdata,2,NULL,0);
    SFlashWrdi();
    SFlashChecksr();
}

void SFlashChip_Erase(void)
{
    //U8 tdata[5]={SPI_WRITE,0x00,0x00,0x00,0x00};
    MS_U8 addr[2];

    SFlashWrsr(0x00);
    SFlashWren();
    SFlashChecksr();

    addr[0]=SPI_WRITE;
    addr[1]=sFlash.CHIP_ERASE;
    Ursa_SWI2C_WriteDatas(addr,2,NULL,0);

    Ursa_SWI2C_WriteStop();

    SFlashChecksr();//Vick Add
}

void SFlashBlock_Erase(MS_U32 bank_num)
{
    //U8 tdata[5]={SPI_WRITE,0x00,0x00,0x00,0x00};
    MS_U8 addr[5] = {0};

    SFlashWren();

    if(sFlash.manufacturer_id==0xEF) /* WINBOND & NX */
    {
        MS_U16 u16StatusReg = SFlashRdsr_1_2();
        SFlashWrsr_1_2(u16StatusReg & ~(BIT14 | BIT4 | BIT3 | BIT2)); // unprotected => CMP(BIT14) = 0; BP2(BIT4) = 0, BP1(BIT3) = 0, and BP0(BIT2) = 0.
    }
    else
    {
        SFlashWrsr(0x00);
    }

    SFlashWren();
    SFlashChecksr();

    addr[0]=SPI_WRITE;
    addr[1]=sFlash.BLOCK_ERASE;
    addr[2] = bank_num;
    addr[3] = bank_num << 8;
    addr[4] = bank_num << 16;

    Ursa_SWI2C_WriteDatas(addr, sizeof(addr), NULL, 0);

    Ursa_SWI2C_WriteStop();

    SFlashChecksr();
}

void SFlashProgram(void)
{
    MS_U16    num;
    MS_U8 u8BankStart;
    MS_U8 u8BankEnd;

    if(g_eUrsaUpgradeSel == E_MFC_SYSTEM_BIN)
    {
        u8BankStart = g_ucBankDst;
        u8BankEnd =  g_ucBankDst + g_ucBankNumber;
    }
    else // Upgrade MFC FW by default
    {
        u8BankStart = 0;
        u8BankEnd = g_ucBankNumber;
    }

    UBOOT_INFO("u8BankStart %x\n", u8BankStart);
    UBOOT_INFO("u8BankEnd %x\n", u8BankEnd);

    for(num = u8BankStart; num < u8BankEnd; num++)
    {
        printf("\n Write Bank %x",num);
        if (g_ucFlashType==Flash_SST25VF016B||g_ucFlashType==Flash_SST25VF040B)
            ProgSST64K(num);
        else
            ProgPMC64K(num);

        g_u8CurPercent = 80 - 40*(num+1)/u8BankEnd;
    }
}

MS_BOOL SFlashVerify(void)
{
    MS_U8    num;
    MS_U8 u8BankStart;
    MS_U8 u8BankEnd;

    if(g_eUrsaUpgradeSel == E_MFC_SYSTEM_BIN)
    {
        u8BankStart = g_ucBankDst;
        u8BankEnd =  g_ucBankDst + g_ucBankNumber;
    }
    else // Upgrade MFC FW by default
    {
        u8BankStart = 0;
        u8BankEnd = g_ucBankNumber;
    }

    UBOOT_INFO("u8BankStart %x\n", u8BankStart);
    UBOOT_INFO("u8BankEnd %x\n", u8BankEnd);

    for(num = u8BankStart; num < u8BankEnd; num++)
    {
        printf("\n Verify Bank %x",num);
        if(VerifyPMC64K(num)==FALSE)
            return FALSE;

        g_u8CurPercent = 40 - 40*(num+1)/u8BankEnd;
    }
    return TRUE;
}

void Ursa_ISP_Init(MS_U32 u32Addr, MS_U32 u32Size, MS_U8 u8UpgradeSel)
{
    ErrorFlag = FlashProgOK;
    g_eFlashProgramState = FlashProgStateInit;
    g_u32ISPSrcAddr = u32Addr;
    g_u32ISPCodeSize = u32Size;
    g_eUrsaUpgradeSel = (EN_MFC_UPGRADE_SEL_t)u8UpgradeSel;
}

int Ursa_ISP_Program(void)
{
    MS_U16 wErrCounter = 0;
    MS_U8 Bank_Num = 0;

    if (ErrorFlag != FlashProgOK)
    {
        return (0xF0+ErrorFlag);
    }

    switch (g_eFlashProgramState)
    {
        case FlashProgStateInit:
            g_u8CurPercent = 100;
            g_eFlashProgramState = FlashProgStateEnterIsp;
            break;

        case FlashProgStateEnterIsp:
            printf("\n1:ISP Enter\n");

            for(wErrCounter = 0;wErrCounter<ENTER_ISP_ERROR_MAX;)
            {//for arcing
                Ursa_WP_PullHigh();
                if (!Ursa_EnterIspMode())
                {
                    wErrCounter++;
                    udelay(10*1000);
                    Ursa_ExitIspMode();
                    udelay(80*1000);
                }
                else
                    break;
            }

            if (wErrCounter>=ENTER_ISP_ERROR_MAX)
            {
                ErrorFlag=FlashEnterIspModeErr;
                printf("\nCan not enter ISP\n");
                goto ProgEnd;
            }
            else
            {
                printf("\nEnter ISP Successful[%x]\n",wErrCounter);
            }
            udelay(50*1000);//Wait the Protect pin to hight.
            for(wErrCounter=0;wErrCounter<GET_ID_ERROR_MAX;)
            {
                if (!GetsFlashType())
                {
                    wErrCounter++;
                    udelay(50*1000);
                }
                else
                    break;
            }

            if (wErrCounter>=GET_ID_ERROR_MAX)
            {
                printf("\n Detect SPI Flash Failed");
                g_ucFlashType=Flash_A25L40P;
                g_ucBankNumber=8;
            }
            sFlash=SupportSFlash[g_ucFlashType];

            printf("\n Bank Number=%d",g_ucBankNumber);
            //-------------------------
            g_ucBankNumber = g_u32ISPCodeSize/0x10000;
            if (0 != (g_u32ISPCodeSize%0x10000))
            {
                g_ucBankNumber = g_ucBankNumber + 1;
            }
            //-------------------------
            printf("\n Program Banks=%d",g_ucBankNumber);

            //------------------------
            //disable write protect and set status 0x00
            SFlashWren();
            SFlashWrsr(0x00);
            g_u8CurPercent = 95;
            g_eFlashProgramState = FlashProgStateErase;
            break;

        case FlashProgStateErase:
            //Step2:Block Erase
            printf("\n2:Block Erase \n");

            MS_U8 u8BankStart;
            MS_U8 u8BankEnd;

            if(g_eUrsaUpgradeSel == E_MFC_SYSTEM_BIN)
            {
                u8BankStart = g_ucBankDst;
                u8BankEnd =  g_ucBankDst + g_ucBankNumber;
            }
            else // Upgrade MFC FW by default
            {
                u8BankStart = 0;
                u8BankEnd = g_ucBankNumber;
            }

            UBOOT_INFO("u8BankStart %x\n", u8BankStart);
            UBOOT_INFO("u8BankEnd %x\n", u8BankEnd);


            for (Bank_Num = u8BankStart; Bank_Num < u8BankEnd; Bank_Num++)
            {
                printf("Erase Bank %x\n", Bank_Num);
                SFlashBlock_Erase(Bank_Num);

                 //wait the flash erase finished.
                 for (wErrCounter = 0; wErrCounter < BLOCK_ERASE_ERROR_MAX; wErrCounter++)
                 {
                    if (SFlashRdsr()&0x01)
                    {
                         udelay(100*1000);
                         wErrCounter++;
                         udelay(100*1000);
                         wErrCounter++;
                         udelay(100*1000);
                         wErrCounter++;
                         udelay(100*1000);
                         wErrCounter++;
                         udelay(100*1000);
                         wErrCounter++;
                         udelay(100*1000);
                         wErrCounter++;
                         udelay(100*1000);
                         wErrCounter++;
                         udelay(100*1000);
                         wErrCounter++;
                         udelay(100*1000);
                         wErrCounter++;
                         udelay(100*1000);
                     }
                     else
                     {
                         break;
                     }
                 }
             }

            if (wErrCounter >= BLOCK_ERASE_ERROR_MAX)
            {
                printf("Block Erase fail!!\n");
                goto ProgEnd;
            }
            else
            {
                printf("Block Erase Success\n");
            }

            printf("\n Wait Count:%d",wErrCounter);
            g_u8CurPercent = 80;
            g_eFlashProgramState = FlashProgStateBlank;
            break;

        case FlashProgStateBlank:
        #if 0
                //Step3:Blanking Check
                printf("\n3:Blanking");
                if(!SFlashBlanking(0,sFlash.size))
                {
                    ErrorFlag=FlashBlankingErr;
                    goto ProgEnd;
                }
        #endif
            g_u8CurPercent = 40;
            g_eFlashProgramState = FlashProgStateProgram;
            break;

        case FlashProgStateProgram:
            //Step4:Prog Flash
            printf("\n4:Prog... ");
            SFlashProgram();
            g_u8CurPercent = 20;
            g_eFlashProgramState = FlashProgStateVerify;
            break;

        case FlashProgStateVerify:
            //Step5:Verify
            printf("\n5:Verify");
            SFlashWren();
            SFlashWrsr(sFlash.LOCK);
            SFlashWrdi();

            if(!SFlashVerify())
            {
                ErrorFlag=FlashVerifyErr;
                goto ProgEnd;
            }
            printf("\nVerify->OK!");
            g_u8CurPercent = 10;
            g_eFlashProgramState = FlashProgStateExit;
            break;

        case FlashProgStateExit:
            //Step6:Exit ISP
            printf("\n6:Exit ISP");
            Ursa_ExitIspMode();

            g_u8CurPercent = 0;
            g_eFlashProgramState = FlashProgStateIdle;
            break;

       case FlashProgStateIdle:
        break;
    }

ProgEnd:
    if (ErrorFlag != FlashProgOK)
    {
        Ursa_ExitIspMode();
#if (ENABLE_WATCH_DOG == ENABLE)
        MDrv_Sys_EnableWatchDog();
#endif
        return (0xF0+ErrorFlag);
    }
    else
    {
        return g_u8CurPercent;
    }
    return 0;
}

int do_ursa_upgrade(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    char cmd[CMD_BUF] = "\0";
    char *env =NULL;
    int partition = 0;
    int device = 0;
    int ret = 0;
    MS_U8 u8Percent= 0;
    long unsigned  int u32FileSize = 0;
    MS_U32 u32FileAddr = 0;
    URSA_COMMON_TYPE ursaType;
    ursa_img_header_t stUrsaImageHeader = {};
    MS_U32 u32CurrentUrsaVersion = 0;
    MS_U32 u32UpgradeUrsaVersion = 0;

    if ((argc != 2) || ((strcmp(argv[1], "tftp") != 0) && (strcmp(argv[1], "usb") != 0))) {
        UBOOT_ERROR ("usage: %s <tftp or usb>\n", argv[0]);
        return (-1);
    }

    ursaType = MDrv_URSA_COM_Get_URSA_Type();
    if(ursaType != URSA_COMMON_U20)
    {
        UBOOT_DEBUG("doesn't detect ursa20, skipping ursa upgrade. \n");
        return (0);
    }

    if(strcmp(argv[1], "tftp") == 0)
    {
        UBOOT_TRACE(" Upgrade Ursa from tftp...\n");

        env=getenv("filesize");
        if(env==NULL)
        {
            UBOOT_ERROR("get env 'filesize' fail\n");
        }
        u32FileSize = simple_strtol(env, NULL, 16);
        printf("Size 0x%lx \n",u32FileSize);

        env=getenv("UrsaFileAddr");
        if(env==NULL)
        {
            UBOOT_ERROR("get env 'UrsaFileAddr' fail\n");
        }
        u32FileAddr = simple_strtol(env, NULL, 16);
        printf("UrsaFileAddr 0x%lx \n",u32FileAddr);
    }
    else if(strcmp(argv[1], "usb") == 0)
    {
        UBOOT_TRACE(" Upgrade Ursa from usb...\n");

        if (-1 == appInitUsbDisk())
        {
            UBOOT_ERROR("FAIL : can not init usb!! \n");
            return -1;
        }

        ret = check_file_partition(URSA_UPGRADE_BIN_PATH,&device,&partition);
        if(ret == 0)
        {
            UBOOT_DEBUG("has Ursa upgrade bin\n");


            UBOOT_DEBUG("Geting file size\n");
            snprintf(cmd, CMD_BUF, "fatfilesize usb %d:%d %s", device,partition, URSA_UPGRADE_BIN_PATH);
            UBOOT_DEBUG("cmd=%s\n",cmd);
            ret = run_command(cmd, 0);
            if(ret!=0)
            {
                UBOOT_ERROR("get script file's size fail\n");
                return -1;
            }
            else
            {
                env=getenv("filesize");
                if(env==NULL)
                {
                    UBOOT_ERROR("get env 'filesize' fail\n");
                }
                u32FileSize = simple_strtol(env, NULL, 16);
                printf("Size 0x%lx \n",u32FileSize);

            }

            u32FileAddr = UPGRADE_BUFFER_ADDR;
            snprintf(cmd, CMD_BUF, "fatload usb %d:%d  %X %s %ul",device, partition, u32FileAddr, URSA_UPGRADE_BIN_PATH,u32FileSize);

            UBOOT_DEBUG("cmd=%s\n",cmd);
            if(-1 == run_command(cmd, 0))
            {
                UBOOT_ERROR("Load Upgrade File fail!\n");
                return -1;
            }
        }
        else
        {
            UBOOT_DEBUG("no %s in usb disk\n",URSA_UPGRADE_BIN_PATH);
        }
    }


    /* check the upgrade image is valid or not.
     * compare the version between upgrade image and current firmware on ursa board. No need to upgrade if the version is the same.
     */
    if(TRUE == ReadUrsaImageHeader((const uint8_t*)u32FileAddr, u32FileSize, &stUrsaImageHeader))
    {
        u32CurrentUrsaVersion = GetUrsa20VersionInfo();
        u32UpgradeUrsaVersion = ((MS_U32)stUrsaImageHeader.au8SCM_Version[0] << 16) | ((MS_U32)stUrsaImageHeader.au8SCM_Version[1] << 8) | (MS_U32)stUrsaImageHeader.au8SCM_Version[2];
        if(u32CurrentUrsaVersion == u32UpgradeUrsaVersion)
        {
            UBOOT_INFO("the version between upgrade image and current firmware on ursa board is the same, skipping ursa upgrade. \n");
            return (0);
        }
    }
    else
    {
        UBOOT_ERROR("FAIL : the image of ursa is not valid\n");
        return -1;
    }

    UBOOT_INFO("Load upgrade file OK!~\n");
    UBOOT_INFO("Start Upgrade Ursa!~\n");
    Ursa_ISP_Init(u32FileAddr,u32FileSize, (MS_U8)E_MFC_FIRMWARE);
    Ursa_SWI2C_Init();
    Ursa_ISP_Program();
    do
    {
        u8Percent =  Ursa_ISP_Program();
    }while ((u8Percent < 0xF0) && (u8Percent != 0));

    UBOOT_TRACE("OK\n");
    if(0 == u8Percent)
    {
       return 0;
    }

    return -1;
}


#if defined(CONFIG_URSA20_SYSBIN) && defined(CONFIG_URSA_TXRX_SUPPORT)
int Ursa_20_Upgrade_SysBin()
{
    MS_U16 u32FileSize = 0;
    MS_U32 u32FileAddr = 0;
    MS_U8 u8Percent= 0;
    MS_U32 u32SysBinAddr = 0;
    MS_U8 *pData = NULL;
    UBOOT_TRACE("Ursa_20_Upgrade_SysBin............\n");

    //return 0; //@@debug
    u32FileSize = MDrv_Ursa_20_GetMFCSysBinLen();

    if(u32FileSize > BANKSIZE)
    {
        UBOOT_ERROR("the size of system bin shouldn't exceed a flash block size\n");
        return -1;
    }

    UBOOT_TRACE("u32FileSize-0=%x\n",u32FileSize);

    //return 0; //@@debug

    pData = (MS_U8*)malloc(sizeof(MS_U8) * SYSBIN_SIZE); // align to 1kB size
    if(pData == NULL)
    {
        UBOOT_ERROR("malloc Failed\n");
        return -1;
    }

    memset(pData, 0, SYSBIN_SIZE);
    MDrv_Ursa_20_GenMFCSysBin(pData);

    // Get sys bin address in Ursa FW
    u32SysBinAddr = MDrv_Ursa_20_GetMFCBinAddress(0x02); // 0x02:System Bin
    UBOOT_INFO("sys bin address in Ursa FW = 0x%lx\n", u32SysBinAddr);
    if((u32SysBinAddr == 0)||(u32SysBinAddr > 0x400000))
    {
        UBOOT_ERROR("system.bin is not exist in MFC SPI flash\n");
        free(pData);
        return -1;
    }

    g_ucBankDst = (MS_U8)(u32SysBinAddr / BANKSIZE); // one MFC bank size : 64KB

    UBOOT_TRACE("g_ucBankDst=%d\n",g_ucBankDst);
    UBOOT_TRACE("u32FileSize=%x\n",u32FileSize);

    //return 0;  //@@debug

    u32FileAddr = (MS_U32)pData;

    UBOOT_INFO("Load Ursa System Bin OK!~\n");
    UBOOT_INFO("Start Upgrade Ursa System Bin!~\n");
    Ursa_ISP_Init(u32FileAddr,u32FileSize, (MS_U8)E_MFC_SYSTEM_BIN);
    Ursa_SWI2C_Init();
    Ursa_ISP_Program();
    do
    {
        u8Percent =  Ursa_ISP_Program();;
    }while ((u8Percent < 0xF0) && (u8Percent != 0));

    free(pData);
    UBOOT_TRACE("OK\n");
    if(0 == u8Percent)
    {
        return 0;
    }

    return -1;
}

int do_Ursa_20_Upgrade_SysBin(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    Ursa_20_Upgrade_SysBin();
    return 0;
}

U_BOOT_CMD(Ursa_20_Upgrade_SysBin, CONFIG_SYS_MAXARGS, 1, do_Ursa_20_Upgrade_SysBin,
    "Ursa_20_Upgrade_SysBin\n",    NULL);

#endif



int do_ursa_reset(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
   MS_U16 wErrCounter;
   Ursa_SWI2C_Init();
   for(wErrCounter = 0;wErrCounter<ENTER_ISP_ERROR_MAX;)
   {
       if (!Ursa_EnterIspMode())
       {
           wErrCounter++;
           udelay(10*1000);
           Ursa_ExitIspMode();
           udelay(80*1000);
       }
       else
           break;
   }
   Ursa_ExitIspMode();
   return 0;
}
#endif

#if defined(CONFIG_CMD_WRITE_DATA_TO_RAW_PARTITION_ENABLE) && (CONFIG_CMD_WRITE_DATA_TO_RAW_PARTITION_ENABLE==1)
int do_crc32check(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    MS_U32 u32DataStartAddr=0, u32CrcStartAddr=0, u32CrcCalResult=0, u32DataSize=0;
    char *pStrDataStartAddr=NULL, *pStrCrcStartAddr=NULL, *pStrDataSize=NULL;
    void *pDataBuffer=NULL;
    MS_U32 u32CrcLoadedResult=0;
    U8 *pu8CrcValue=NULL, *pu8DataStartAddr=NULL;

    UBOOT_TRACE("IN\n");
    pStrDataStartAddr = getenv("dataStartAddr");
    pStrCrcStartAddr = getenv("crcStartAddr");
    pStrDataSize = getenv("filesize");

    if ((pStrDataStartAddr == NULL) || (pStrCrcStartAddr == NULL) || (pStrDataSize==NULL))
    {
        UBOOT_ERROR("The environment variables: dataStartAddr, crcStartAddr or filesize is not configured yet. \n");
        return (-1);
    }

    u32DataStartAddr = simple_strtol(pStrDataStartAddr, NULL, 16);
    u32CrcStartAddr = simple_strtol(pStrCrcStartAddr, NULL, 16);
    u32DataSize = simple_strtol(pStrDataSize, NULL, 16);

    UBOOT_DEBUG("u32DataStartAddr=0x%lx, u32CrcStartAddr=0x%lx, u32DataSize=%lu \n", u32DataStartAddr, u32CrcStartAddr, u32DataSize);

    pu8CrcValue = (U8*) (u32CrcStartAddr);
    u32CrcLoadedResult = ((pu8CrcValue[0] << 24) |  (pu8CrcValue[1] << 16) |  (pu8CrcValue[2] << 8) | (pu8CrcValue[3]));
    printf("u32CrcLoadedResult=0x%lx \n", u32CrcLoadedResult);

    pDataBuffer = malloc(u32DataSize);
    if (pDataBuffer == NULL)
    {
        UBOOT_ERROR("pDataBuffer is null. \n");
        return (-1);
    }

    pu8DataStartAddr = ((U8 *) u32DataStartAddr);
    memcpy(pDataBuffer, pu8DataStartAddr, u32DataSize);

    u32CrcCalResult = crc32(u32CrcCalResult, (U8 *)pDataBuffer, u32DataSize);
    printf("u32CrcCalResult=0x%lx \n", u32CrcCalResult);

    if (u32CrcCalResult == u32CrcLoadedResult)
    {
        setenv ("crcTestResult", "1");
    }
    else
    {
        setenv ("crcTestResult", "0");
    }
    free(pDataBuffer);

    UBOOT_TRACE("OUT\n");

    return 0;
}

int do_writeDataToRawPartition(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
#define __ENV_BUF_SIZE__ (128)
    static MS_U32 u32TotalSize=0;
    MS_U32 u32DataStartAddr=0, u32DataSize=0, u32MainIdx=0, u32SubIdx=0, u32BlockSize=0, u32UpgradeBitmap=0;
    char *pStrDataStartAddr=NULL, *pStrDataSize=NULL, *pStrPartName=NULL, *pStrVolName=NULL, *pStrUpgradeBitmap=NULL;
    U8 *pu8DataStartAddr=NULL;
    char strEnvUpgradeBitmap[(__ENV_BUF_SIZE__)]={};
    int s32RtnVal=0;

    UBOOT_TRACE("IN\n");
    setenv("writeResult", "-1");
    /***************************************************************
     *  Check and set the arguments
     ***************************************************************/
    if (argc < 4)
    {
        UBOOT_ERROR("Command Usage: writeDataToRawPartition <main_idx> <sub_idx> <block_size> <partition_name> [volume_name] \n");
        UBOOT_ERROR("main_idx - The installation main_idx-index to the raw partition. \n");
        UBOOT_ERROR("sub_idx - The installation sub-index to the raw partition. \n");
        UBOOT_ERROR("block_size - The block sizeo of the raw partition. \n");
        UBOOT_ERROR("partition_name - The name of raw partition. \n");
        UBOOT_ERROR("volume_name - The volume name of raw partition for NAND flash.\n");
        return (-1);
    }
    UBOOT_DEBUG(" argv[1]=%s,argv[2]=%s,argv[3]=%s,argv[4]=%s, argv[5]=%s\n",argv[1],argv[2],argv[3],argv[4], argv[5]);
    u32MainIdx = simple_strtol(argv[1], NULL, 16);
    u32SubIdx = simple_strtol(argv[2], NULL, 16);
    u32BlockSize = simple_strtol(argv[3], NULL, 16);
    pStrPartName = argv[4];
    pStrVolName  = argv[5];

    UBOOT_DEBUG("u32MainIdx=0x%lx, u32SubIdx=0x%lx, u32BlockSize=0x%lx, pStrPartName=%s, pStrVolName=%s \n",
                 u32MainIdx, u32SubIdx, u32BlockSize, pStrPartName, pStrVolName);
    /***************************************************************
    * Check and set the mboot environment variables.
    ****************************************************************/
    pStrDataStartAddr = getenv("dataStartAddr");
    pStrDataSize = getenv("filesize");
    pStrUpgradeBitmap = getenv("FactoryUpgradeBitmap");

    if ((pStrDataStartAddr==NULL) || (pStrDataSize==NULL) || (pStrPartName==NULL) )
    {
        UBOOT_ERROR("The environment variables: dataStartAddr, filesize or partition_name is not configured yet. \n");
        return (-1);
    }
    UBOOT_DEBUG("pStrDataStartAddr=0x%s, pStrDataSize=0x%s, pStrUpgradeBitmap=%s \n", pStrDataStartAddr, pStrDataSize, pStrUpgradeBitmap);
    u32DataStartAddr = simple_strtol(pStrDataStartAddr, NULL, 16);
    u32DataSize = simple_strtol(pStrDataSize, NULL, 16);
    u32UpgradeBitmap = simple_strtol(pStrUpgradeBitmap, NULL, 16);

    UBOOT_DEBUG("u32DataStartAddr=0x%lx, u32DataSize=0x%lx, u32UpgradeBitmap=0x%lx\n", u32DataStartAddr, u32DataSize, u32UpgradeBitmap);
    if (u32DataSize > u32BlockSize)
    {
        UBOOT_ERROR("u32DataSize(%lu) is greater than u32BlockSize(%lu). \n", u32DataSize, u32BlockSize);
        return (-1);
    }

    /* Reset the total size. */
    if (u32SubIdx == 0)
    {
        u32TotalSize = 0;
    }

    pu8DataStartAddr = ((U8 *) u32DataStartAddr);
    if (pu8DataStartAddr != NULL)
    {
#if CONFIG_MSTAR_ROM_BOOT_WITH_EMMC_FLASH
        if(raw_io_config(E_RAW_DATA_IN_MMC, pStrPartName ,pStrVolName) == 0)
#else
        if(raw_io_config(E_RAW_DATA_IN_NAND, pStrPartName, pStrVolName) == 0)
#endif
        {
            UBOOT_DEBUG("RAW IO config is OK for key transfer.\n");
        }
        else
        {
            UBOOT_ERROR("RAW IO config is NOK for key transfer. \n");
            return -1;
        }

        UBOOT_DEBUG("pu8DataStartAddr=0x%lx \n", pu8DataStartAddr);

        s32RtnVal = raw_write((unsigned int) pu8DataStartAddr, (u32MainIdx * u32BlockSize) + (u32TotalSize), u32DataSize);
        if (s32RtnVal == 0)
        {
            u32TotalSize += u32DataSize;
            u32UpgradeBitmap |= (1<<(u32MainIdx));
            memset(strEnvUpgradeBitmap, 0x0, (sizeof(char)*(__ENV_BUF_SIZE__)));
            sprintf(strEnvUpgradeBitmap, "0x%x", u32UpgradeBitmap);
            UBOOT_DEBUG("u32UpgradeBitmap=0x%lx, strEnvUpgradeBitmap=%s", u32UpgradeBitmap, strEnvUpgradeBitmap);
            setenv("FactoryUpgradeBitmap", strEnvUpgradeBitmap);
            setenv("writeResult", "0");
            saveenv();
        }
        else
        {
            UBOOT_ERROR("Failed to writhe data the raw partition. \n");
        }
    }

    UBOOT_TRACE("OUT\n");
    return 0;
}
#endif

#if defined(CONFIG_INSTALL_CHECK_ENABLE) && (CONFIG_INSTALL_CHECK_ENABLE==1)
int do_installcheck(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    int s32GpioStartInstall=0, s32GpioInstallType=0, s32ReadCnt=0, idx=0;
    char *pStrInstallationDone=NULL;
    unsigned int u32InstallationDone=0;

    UBOOT_TRACE("IN\n");

    s32GpioStartInstall = mdrv_gpio_get_level(GPIO_START_INSTALLATION);
    if (s32GpioStartInstall == 0)
    {
        for(idx = 0; idx < 4; idx++)
        {
            s32GpioStartInstall = mdrv_gpio_get_level(GPIO_START_INSTALLATION);
            if(s32GpioStartInstall == 0)
            {
                s32ReadCnt++;
            }
            MsOS_DelayTask(100); //100ms
        }

        s32GpioInstallType = mdrv_gpio_get_level(GPIO_INSTALLATION_TYPE);
        UBOOT_DEBUG("\n BEFORE START INSTALL KEYS: GPIO_INSTALLATION_TYPE LEVEL = %d \n", mdrv_gpio_get_level(GPIO_INSTALLATION_TYPE));

        if ((s32GpioStartInstall == 0) && (s32ReadCnt > 3) && (s32GpioInstallType == 1))
        {
            if ( -1 == appInitUsbDisk() )
            {
                UBOOT_ERROR("FAIL : can not init usb!! \n");
            }
            else
            {
                printf("Start USB installation................ \n");

                /* Set GPIO GPIO_INSTALLATION_RESULT high to indicate the installation will be started. */
                mdrv_gpio_set_high(GPIO_INSTALLATION_RESULT);

                run_command("setenv installation_done 0", 0);
                mdelay(500);
                run_command("cudstar /usb_scripts/factory_install.txt", 0);

                pStrInstallationDone = getenv("installation_done");
                u32InstallationDone = simple_strtol(pStrInstallationDone, NULL, 16);
                if (u32InstallationDone == 1)
                {
                    /* Set GPIO GPIO_INSTALLATION_RESULT low to indicate the installation is done. */
                    printf("USB installation is done................ \n");
                    mdrv_gpio_set_low(GPIO_INSTALLATION_RESULT);
                    mdelay(4000);
                    run_command("reset", 0);
                }
                else
                {
                    UBOOT_ERROR("\n The installation process is failed!!!!!\n");
                }
            }
        }

        else if ((s32GpioStartInstall == 0) && (s32ReadCnt > 3) && (s32GpioInstallType == 0))
        {
            printf("Start TFTP installation................ \n");

            /* Set GPIO GPIO_INSTALLATION_RESULT high to indicate the installation will be started. */
            mdrv_gpio_set_high(GPIO_INSTALLATION_RESULT);

            run_command("setenv installation_done 0", 0);
            mdelay(500);
            run_command("mstar /tftp_scripts/factory_install.txt", 0);

            pStrInstallationDone = getenv("installation_done");
            u32InstallationDone = simple_strtol(pStrInstallationDone, NULL, 16);
            if (u32InstallationDone == 1)
            {
                /* Set GPIO GPIO_INSTALLATION_RESULT low to indicate the installation is done. */
                printf("TFTP installation is done................ \n");
                mdrv_gpio_set_low(GPIO_INSTALLATION_RESULT);
                mdelay(4000);
                run_command("reset", 0);
            }
            else
            {
                UBOOT_ERROR("\n The installation process is failed!!!!!\n");
            }

        }
    }

    UBOOT_TRACE("OUT\n");
    return 0;
}
#endif

#define ENV_FIRST_BOOT_UP  "first_bootup"

int save_first_boot_status(void)
{
    int ret = 0;
    UBOOT_TRACE("IN\n");

    char *sync_mmap = getenv("sync_mmap");
    char *db_table  = getenv("db_table");

    if ((sync_mmap != NULL) && (strcmp(sync_mmap, "1") == 0)
         && (db_table != NULL) && (strcmp(db_table, "0") == 0))
    {
        UBOOT_DEBUG("It is the first boot up case\n");
        setenv(ENV_FIRST_BOOT_UP, "1");
        saveenv();
        ret = 1;
    }

    UBOOT_TRACE("OK\n");
    return ret;
}


int get_first_boot_status(void)
{
    UBOOT_TRACE("IN\n");
    char *status = getenv(ENV_FIRST_BOOT_UP);
    if ((status != NULL) && (strcmp(status, "1") == 0))
    {
        UBOOT_TRACE("OK\n");
        return 1;
    }
    UBOOT_TRACE("OK\n");
    return 0;
}


void clear_first_boot_status(void)
{
    char cmdBuf[256];
    UBOOT_TRACE("IN\n");

    memset(cmdBuf, 0, 256);
    snprintf(cmdBuf,CMD_BUF,"setenv %s;saveenv", ENV_FIRST_BOOT_UP);
    if (run_command(cmdBuf, 0) != 0)
    {
        UBOOT_ERROR("run command error : %s\n", cmdBuf);
    }

    UBOOT_TRACE("OK\n");
}

#ifndef MI_TPV_MODEL_T32_SOEM_PJ
#define FRC_POWER   PAD_GPIO1_PM	/* gpio8, M0C, Change to PAD_GPIO1_PM from PAD_GPIO8_PM */
#define SPLASH_ON   PAD_PWM1		/* gpio144 */

static SWI2C_BusCfg FRC_I2cBusCfg[1]=
{
    // Bus-0
    {PAD_TGPIO2, PAD_TGPIO3, 100}, //IS_SW_I2C  /SCL_PAD /SDA_PAD /Delay
};
MS_U8 g_FRC_slave_addr = 0x30;
#define FRC_BUSID     (0 | g_FRC_slave_addr)


int FRC_GetGPIO_Level(MS_GPIO_NUM gpio)
{
    //gpio use FRC_POWER, SPLASH_ON
    return mdrv_gpio_get_level(gpio);
}

void FRC_SetGPIO(MS_GPIO_NUM gpio, MS_BOOL output)
{
    //gpio use FRC_POWER, SPLASH_ON
    if (output)
        mdrv_gpio_set_high(gpio);
    else
        mdrv_gpio_set_low(gpio);
}

static void FRC_SWI2C_Init(void)
{
    char * p_slave_addr = NULL;
    st_board_para board_data;
    memset(&board_data, 0, sizeof(st_board_para));

    //get slave addr from "slave_addr" & "serial_debug_addr" env
    if((p_slave_addr = getenv ("slave_addr")) != NULL)
    {
        g_FRC_slave_addr = (int)simple_strtol(p_slave_addr, NULL, 16);
    }
    if(Read_BoardParaFromflash(&board_data) == 0)
    {
        FRC_I2cBusCfg[0].padSCL = board_data.m_u16I2cSCLPad;
        FRC_I2cBusCfg[0].padSDA = board_data.m_u16I2cSDAPad;
    }

    UBOOT_INFO("FRC_SWI2C_Init() - g_FRC_slave_addr=0x%x\n", g_FRC_slave_addr);
    UBOOT_INFO("FRC_I2cBusCfg: padSCL=%d, padSDA=%d \n", FRC_I2cBusCfg[0].padSCL, FRC_I2cBusCfg[0].padSDA );
    MApi_SWI2C_Init(FRC_I2cBusCfg, 1);
}

/* return : TRUE OK, FALSE: FAIL */
MS_BOOL FRC_I2C_Read(MS_U8 u8AddrNum, MS_U32 addr, MS_U16 ucBufLen, MS_U8* pBuf)
{
	// MS_BOOL MApi_SWI2C_ReadBytes(MS_U16 u16BusNumSlaveID, MS_U8 u8AddrNum, MS_U8* paddr, MS_U16 u16size, MS_U8* pu8data);
    return MApi_SWI2C_ReadBytes(FRC_BUSID, u8AddrNum, (MS_U8 *)&addr, ucBufLen, pBuf);
}

/* return : TRUE OK, FALSE: FAIL */
MS_BOOL FRC_I2C_Write(MS_U8 u8AddrNum, MS_U32 addr, MS_U16 ucBufLen, MS_U8* pBuf)
{
	MS_U32 regAddr = addr;
	//	MS_BOOL MApi_SWI2C_ReadBytes(MS_U16 u16BusNumSlaveID, MS_U8 u8AddrNum, MS_U8* paddr, MS_U16 u16size, MS_U8* pu8data);
    return MApi_SWI2C_WriteBytes(FRC_BUSID, u8AddrNum, (MS_U8 *)&regAddr, ucBufLen, pBuf);
}

#define	FRC_LOADER_UPGRADE
#ifdef FRC_LOADER_UPGRADE
#define	FRC_UPGRADE_NOT_ALLOW		(-1)
#define	FRC_UPGRADE_VER_SAME		(0)
#define	FRC_UPGRADE_SUCCESS			(1)
#define	FRC_UPGRADE_FAIL			(2)
#define	FRC_UPGRADE_POST_REBOOT		(0)
#define FRC_UPGRADE_POST_IGNORE		(-1)

#define	UPG_FW_RAW_PART 	(0)		/* to be open 1: OTA FRC FW vendor/tvconfig/2020_21_Philips_UHD_Android_TV/config/frc */
#define FW_FROM_USB			(0)
#define FW_FROM_FLASH_RAW	(1)
#define FW_UPG_333ISP	(0x04)
//#define NVT_DEBUG
//#define NVT_TPV_MISC_DEBUG

/* Command */
#define NVT_READ_VER_333    (0x8F930000)
#define NVT_READ_VER        (0x8F0A0000)    
#define NVT_READ_LDC_VER    (0x8E320000)    
#define NVT_ENTER_ISP       (0x0FF00000)
#define NVT_START_UPGRADE   (0x0FF10000)
#define NVT_GET_DUMP_ADDR   (0x8FF20000)
#define NVT_ISP_STATUS      (0x8FF30000)
#define NVT_RDY_POLL_ADDR   (0x9F0A01BC)
#define NVT_RDY_POLL_BUSY   (      0x00) // - Before while loop is entered------------- it is 0x00.
#define NVT_RDY_POLL_READY  (      0x55) // - After while loop is entered-------------- it is 0x55.

/* Option code */
#define NVM_SIELENT_UPG     (0x097D)
#define NVM_FRC_UPG         (0x317C)
#define FRC_OP_CFG          (0x461)
#define BLTYPE_OP_CFG       (0x467)
#define DISPTECH_OP_CFG     (0x462)
// #define	FRC_OP_BACKEND		((uint64_t)0x461)
#define FRC_NONE            (0)
#define FRC_NT72334         (1)
#define FRC_NT72333         (2)

/* HW configuration */    
#define NVT_I2C_ADDR_333    (0x30)	/* NT333 */

//#define NVT_CLK_DIV         (0x46)	/* 400Khz */
//#define NVT_I2C_BUS         (SIF_BUS_PDWNC_I2C_1)
#define NVT_333_PWR_PIN     (8)		/* T32 2K21 715GB607-MOC SSB GPIO1_PM gpio8, GPIO8_PM gpio14, FRC NT333 Power-Pin  */
#define NVT_333_SPLASH_PIN  (132)	/* PWM1 gpio132, FRC NT333 Splash-Pin */

/* Constant definition */
#define NVT_CR              (0x9F0A0120)
#define NVT_SR              (0x9F0A0124)
#define NVT_RR              (0x9F0A0128)

#define NVT_DUMP_ADDR       (0x9F0A0140)
#define NVT_DUMP_SIZE       (0x9F0A0144)
#define NVT_DUMP_CHKSUM     (0x9F0A0148)
#define NVT_DUMP_NOT_CHKSUM (0x9F0A014C)

#define NVT_UNLOCK_LEN      (2)

#define NVT_OK              (0)
#define NVT_ERR             (-1)
                            
#define NVT_W_ADDR          (0x00)
#define NVT_R_ADDR          (0x08)
#define NVT_R_DATA          (0x0C)
#define NVT_B_ADDR          (0x10)
#define NVT_B_CTL           (0x15)
#define NVT_B_INDEX         (0x20)
#define NVT_B_W             (0x21)
#define NVT_B_R             (0x22)

#define NVT_BURST_R         (0x02)
#define NVT_BURST_W         (0x01)

#define NVT_DATA_BUF        (257)
#define NVT_BURST_LEN       (7)
#define NVT_W_LEN           (8)
#define NVT_R_LEN           (4)
#define NVT_REG_LEN         (1)

#define NVT_32BITS_ALIGN    (4)
#define NVT_BURST_MULTIPLE  (32)
#define NVT_BURST_32        (32)
#define NVT_BURST_ID_32     (0x1F)
#define NVT_BURST_64        (64)
#define NVT_BURST_ID_64     (0x3F)
#define NVT_BURST_96        (96)
#define NVT_BURST_ID_96     (0x5F)
#define NVT_BURST_128       (128)
#define NVT_BURST_ID_128    (0x7F)
#define NVT_BURST_160       (160)
#define NVT_BURST_ID_160    (0x9F)
#define NVT_BURST_192       (192)
#define NVT_BURST_ID_192    (0xBF)
#define NVT_BURST_224       (224)
#define NVT_BURST_ID_224    (0xDF)

#define NVT_CMD_CHK         (0xFFFFFFFF)
#define NVT_CMD_STATUS      (0x01)
#define NVT_UPGRADE_OK      (0x55AA55AA)
#define NVT_UPGRADE_FAIL    (0xFFFFFFFF)

#define NVT_RETRY           (500)       /* 5 seconds */
#define NVT_STATUS_RETRY    (20)
#define NVT_DELAY           (10)

#define BUF_SIZE            256

#define NVT_INVERT_SIZE     (4)

#define NVT_LOW             (0)
#define NVT_HIGH            (1)

#define NVT_RST_TIME        (50)
#define NVT_INIT_TIME       (3000)
#define NVT_CHK_DELAY_TIME  (3000)
#define NVT_CHK_TIME        (2000)

#define NVT_FW_MAX_SIZE     (1024 * 1024)

#define NVT_ID_SIZE         (16)
#define NVT_PADDING_SIZE    (16)

//#define	NVT_ISP_NT334_FW	(0)
//#define	NVT_ISP_NT334_DATA	(1)
//#define	NVT_ISP_NT315_FW	(2)
#define	NVT_ISP_NT333_FW	(3)

/* Marco */
#define NVT_RET_ERR(result, x)                                                          \
    if(result != x)                                                                     \
    {                                                                                   \
        printf("[FRC][ERROR] %s() on %d, value = %d\n", __func__, __LINE__, result);    \
        return NVT_ERR;                                                                 \
    }

#define NVT_INV(a) ( ((a & 0xFF000000) >> 24) | ((a & 0x00FF0000) >> 8) | ((a & 0x0000FF00) << 8) | ((a & 0x000000FF) << 24) )

/* Data structure */
typedef struct _FRC_ISP_HDR_T
{
    uint8_t   acId[NVT_ID_SIZE];
    uint8_t   acPadding[NVT_PADDING_SIZE];
    uint32_t  u4Addr;
    uint32_t  u4Size;
    uint32_t  u4Chksum;
} FRC_ISP_HDR_T;

typedef struct _FrcVersion_t
{
    uint32_t novatekBranch;
    uint32_t novatekMajor ;
    uint32_t novatekMinor ;
    uint32_t pluginBranch ;
    uint32_t pluginMajor  ;
    uint32_t pluginMinor  ;
    uint32_t interface    ;
    uint32_t dataVersion  ;
} FrcVersion_t, *p_FrcVersion_t;

/* Global variables */
static uint8_t            _u1I2cAddr = NVT_I2C_ADDR_333;
static uint8_t            _u1OpFrc = 0;
static uint8_t            _u1OpPanelId = 0;
static uint8_t            _u1IfNewFrcChk = 0;
static uint8_t            _u1UpgSilent = 0;
//static uint8_t			_u1OpBackEnd = 0;
//static uint8_t            _u1OpBLType = 0;
static uint8_t*           _pu1FrcBuffer = NULL;
static uint32_t           _u4FrcBinSize = 0;
static FRC_ISP_HDR_T    _tFrcHdr;
static uint8_t			_u1FRCpower = 0;
static uint8_t			_u1FRC333Unlocked = 0;
//static uint8_t			_u1FRC334Unlocked = 0;
//static uint8_t			_u1FRC315Unlocked = 0;
//static uint8_t			_u1BootSlot = 0;

static FrcVersion_t _tUsbFrcNt333Version = { 0 };			/* usb frc fw version */
//static FrcVersion_t _tUpgFrcNt334Version = { 0 };
static FrcVersion_t _tFlashFrcNt333Version = { 0 };			/* running frc fw version */
//static FrcVersion_t _tFlashFrcNt334Version = { 0 };
//static uint8_t		_u1FrcUpgradeStart = 0;

/* 1: env variable changed, 0: env variable no change */
static int32_t _nvt_env_variable_update(char *envVariable, char *envStr)
{
	char *pEnv = NULL;
	pEnv = getenv(envVariable);
	if (NULL == pEnv) {
		if (NULL == envStr) return 0;	/* both NULL, no action  */
		setenv(envVariable, envStr);	/* set env variable */
	}
	else {
		if (NULL == envStr) setenv(envVariable, NULL);	/* clear env variable */
		if (0 == strcmp(pEnv, envStr)) return 0;
		setenv(envVariable, envStr);
	}
	return 1;
}

#define	FRC_ENV_CHECK_VERSION		"frc_check_version"
#define	FRC_ENV_LAST_USB_VERSION	"frc_last_Usb_version"
#define	FRC_ENV_LAST_UPG_VERSION	"frc_last_Upg_version"
#define	FRC_ENV_UPG_FLAG_FILE		"frc_upg_flag_file"
#define	FRC_ENV_UPG_ERR_CNT			"frc_upg_err_cnt"
#define	FRC_ENV_DBG_NVM_ABS_ADDR	"frc_DBG_NVM_absAddr"
#define	FRC_ENV_DBG_SILENT_UPG		"frc_DBG_silent_upg"
#define FRC_ENV_DBG_CHECK_UPG		"frc_DBG_check_upg"
#define FRC_ENV_DBG_RESET_FLAG		"frc_DBG_reset_f"

/* mode: 	USB or FLASH upgrade */
/* state:	SUCCESS or FAIL */
void _nvt_show_env_variable(void)
{
	char *pEnv = NULL;
	if (NULL != (pEnv = getenv(FRC_ENV_CHECK_VERSION)))
		UBOOT_INFO("[FRC] 1. FRC_ENV_CHECK_VERSION is %s\n", pEnv);
	else
		UBOOT_INFO("[FRC] 1. no FRC_ENV_CHECK_VERSION\n");
	
	if (NULL != (pEnv = getenv(FRC_ENV_LAST_USB_VERSION)))
		UBOOT_INFO("[FRC] 2. FRC_ENV_LAST_USB_VERSION is %s\n", pEnv);
	else
		UBOOT_INFO("[FRC] 2. no FRC_ENV_LAST_USB_VERSION\n");
	
	if (NULL != (pEnv = getenv(FRC_ENV_LAST_UPG_VERSION)))
		UBOOT_INFO("[FRC] 3. FRC_ENV_LAST_UPG_VERSION is %s\n", pEnv);
	else
		UBOOT_INFO("[FRC] 3. no FRC_ENV_LAST_UPG_VERSION\n");

	if (NULL != (pEnv = getenv(FRC_ENV_UPG_FLAG_FILE)))
		UBOOT_INFO("[FRC] 4. FRC_ENV_UPG_FLAG_FILE is %s\n", pEnv);
	else
		UBOOT_INFO("[FRC] 4. no FRC_ENV_UPG_FLAG_FILE\n");
	
	if (NULL != (pEnv = getenv(FRC_ENV_UPG_ERR_CNT)))
		UBOOT_INFO("[FRC] 5. FRC_ENV_UPG_ERR_CNT is %s\n", pEnv);
	else
		UBOOT_INFO("[FRC] 5. no FRC_ENV_UPG_ERR_CNT\n");

	if (NULL != (pEnv = getenv(FRC_ENV_DBG_NVM_ABS_ADDR)))
		UBOOT_INFO("[FRC] 6. FRC_ENV_DBG_NVM_ABS_ADDR is %s\n", pEnv);
	else
		UBOOT_INFO("[FRC] 6. no FRC_ENV_DBG_NVM_ABS_ADDR\n");

	if (NULL != (pEnv = getenv(FRC_ENV_DBG_SILENT_UPG)))
		UBOOT_INFO("[FRC] 7. FRC_ENV_DBG_SILENT_UPG is %s\n", pEnv);
	else
		UBOOT_INFO("[FRC] 7. no FRC_ENV_DBG_SILENT_UPG\n");

	if (NULL != (pEnv = getenv(FRC_ENV_DBG_CHECK_UPG)))
		UBOOT_INFO("[FRC] 8. FRC_ENV_DBG_CHECK_UPG is %s\n", pEnv);
	else
		UBOOT_INFO("[FRC] 8. no FRC_ENV_DBG_CHECK_UPG\n");

	if (NULL != (pEnv = getenv(FRC_ENV_DBG_RESET_FLAG)))
		UBOOT_INFO("[FRC] 9. FRC_ENV_DBG_RESET_FLAG is %s\n", pEnv);
	else
		UBOOT_INFO("[FRC] 9. no FRC_ENV_DBG_RESET_FLAG\n");

	return;
}

// dbgLevel=DEBUG, dbgLevel=0
#define	DBG_LEVEL_ENV		"dbgLevel"
#define TMP_SAVE_DBG_LEVEL_ENV	"savedbgLevel"
void _nvt_enable_dbgLevel(void)
{
	char *pEnv = NULL;
	//char debug = 0;
	char tmpSave[16] = { 0 };

	// save dbgLevel to savedbglevel
	pEnv = getenv(DBG_LEVEL_ENV);
	if (NULL != pEnv) {
		strncpy(tmpSave, pEnv, 15);
	}
	else
		tmpSave[0] = '\0';
	if (_nvt_env_variable_update(TMP_SAVE_DBG_LEVEL_ENV, &tmpSave[0])) {	/* clear */
		saveenv();
	}

	// to enable log
	run_command("dbg DEBUG", 0);
	
	// log dbgLevel
	if (NULL != (pEnv = getenv(TMP_SAVE_DBG_LEVEL_ENV)))
		UBOOT_INFO("dbgLevel is %s\n", pEnv);
	else
		UBOOT_INFO("no dbgLevel\n");
}

void _nvt_restore_dbgLevel(void)
{
	char *pEnv = NULL;
	//char debug = 0;
	char tmpSave[16] = { 0 };

	run_command("dbg 0", 0);

	// restore dbgLevel from savedbglevel
	pEnv = getenv(TMP_SAVE_DBG_LEVEL_ENV);
	if (NULL != pEnv) {
		strncpy(tmpSave, pEnv, 15);
	}
	if (_nvt_env_variable_update(DBG_LEVEL_ENV, &tmpSave[0])) {	/* clear */
		saveenv();
	}
}

/* mode, 0: usb, 1, upg, -1: none of usb/upg */
static void _nvt_save_env_variable(int8_t mode, int8_t state)
{
	uint8_t envSave = 0;
	uint32_t errCnt;
	char *pEnv = NULL;
	char errCntString[4] = {0};
	char strFrcVersion[16] = { 0 };	/* max format 0xff.0xfff.0xfff -- xxx.xxxx.xxxx */

	if (mode == 0)  { /* USB */
		if (NVT_OK == state)	{	/* Success */
			snprintf(strFrcVersion, 16, "%u.%u.%u", _tUsbFrcNt333Version.novatekBranch, _tUsbFrcNt333Version.novatekMajor, _tUsbFrcNt333Version.novatekMinor );
			envSave += _nvt_env_variable_update(FRC_ENV_LAST_USB_VERSION, strFrcVersion);
			envSave = _nvt_env_variable_update(FRC_ENV_CHECK_VERSION, "YES");
			//envSave += _nvt_env_variable_update(FRC_ENV_LAST_UPG_VERSION, strFrcVersion);
			envSave += _nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, "0");
			//envSave += _nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, NULL);
		}
		else { /* USB FAIL */
			/* clear FRC_ENV_CHECK_VERSION, next time will do not check version */
			envSave = _nvt_env_variable_update(FRC_ENV_CHECK_VERSION, NULL);
			if (NULL != (pEnv = getenv(FRC_ENV_UPG_ERR_CNT))) {
				errCnt = (int)simple_strtoul(pEnv, NULL, 10);
				if (++errCnt > 999)
				snprintf(errCntString, 4, "%u", errCnt);
				envSave += _nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, errCntString);
			}
			else
				envSave += _nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, "1");
		}
	}
	else if (mode == 1) {	/* UPG */
		if (NVT_OK == state) {	/* UPG OK */
			snprintf(strFrcVersion, 16, "%u.%u.%u", _tUsbFrcNt333Version.novatekBranch, _tUsbFrcNt333Version.novatekMajor, _tUsbFrcNt333Version.novatekMinor );
			envSave += _nvt_env_variable_update(FRC_ENV_LAST_UPG_VERSION, strFrcVersion);
			envSave += _nvt_env_variable_update(FRC_ENV_LAST_USB_VERSION, NULL);	/* clear FRC_ENV_LAST_USB_VERSION */
			//envSave = _nvt_env_variable_update(FRC_ENV_CHECK_VERSION, "YES");
			//envSave += _nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, NULL);
			envSave += _nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, "0");
		}
		else {
			/* clear FRC_ENV_CHECK_VERSION, next time will do not check version */
			//envSave = _nvt_env_variable_update(FRC_ENV_CHECK_VERSION, NULL);
			envSave += _nvt_env_variable_update(FRC_ENV_DBG_SILENT_UPG, NULL);	/* for DBG_frc_silent_upg */
			if (NULL != (pEnv = getenv(FRC_ENV_UPG_ERR_CNT))) {
				errCnt = (int)simple_strtoul(pEnv, NULL, 10);
				if (errCnt < 999) errCnt++;
				snprintf(errCntString, 4, "%u", errCnt);
				envSave += _nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, errCntString);
			}
			else
				envSave += _nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, "1");
		}
	}

	if (envSave) saveenv();
	if (NVT_OK != state) {
		if (NULL != (pEnv = getenv(FRC_ENV_UPG_ERR_CNT))) {
			UBOOT_INFO("FRC_ENV_UPG_ERR_CNT %s\n", pEnv);
		}
		else
			UBOOT_INFO("no FRC_ENV_UPG_ERR_CNT\n");
	}
    UBOOT_INFO("[FRC] Exit mode=0x%x, state=0x%x \n", mode, state);
	return;
}

// workaround to set NVM Optiont code, as Read_NVM_OptionByte() doesn't ready yet 
// TV Model format EU_7906_70, EU_7956_70
static int32_t _Get_ModelInfo(uint16_t *TV_model, uint8_t *TV_size)
{
	uint32_t rRet = NVT_ERR;
	char TV_REGION[16] = { 0 };
	char TV_MODEL[16] = { 0 };
	char TV_SIZE[16] = { 0 };
	uint8_t i,j, infoSize = 0;
	char *pEnv = NULL;
	char *destPtr = NULL;
	uint8_t _mSize = 0;
	uint16_t _mModel = 0;
	#define TV_MODEL_INFO	"model_info"
	
    pEnv = getenv(TV_MODEL_INFO);
	UBOOT_INFO("TV_MODEL_INFO is %s, \n", (pEnv == NULL) ? "null" : pEnv);

	if (NULL == pEnv)
		return NVT_ERR;
	
	infoSize = (uint32_t)strlen(pEnv);
	if (infoSize >= 128) infoSize = 128;
	j=0;
	destPtr = &TV_REGION[0];
	for (i=0; i<infoSize; i++) {
		if ( '_' != *pEnv ) {
		   if (j<15) destPtr[j] = *pEnv;
		   j++;
		   pEnv++;
		}
		else {
		   pEnv++;
		   break;
		}
	}
	infoSize = strlen(pEnv);
	if (infoSize >= 128) infoSize = 128;
	j=0;
	destPtr = &TV_MODEL[0];
	for (i=0; i<infoSize; i++) {
		if ( '_' != *pEnv ) {
		   if (j<15) destPtr[j] = *pEnv;
		   j++;
		   pEnv++;
		}
		else {
		   pEnv++;
		   break;
		}
	}
	infoSize = strlen(pEnv);
	if (infoSize >= 15) infoSize = 15;
	strncat(&TV_SIZE[0], pEnv, infoSize);

	if ( (0 != strlen(&TV_SIZE[0])) && (0 != strlen(&TV_MODEL[0])) && (0 != strlen(&TV_REGION[0])) ){
		_mModel = (uint16_t)simple_strtoul(&TV_SIZE[0], NULL, 10);
		if ( (_mModel >= 7000) && (_mModel <= 9999) ) {
			_mSize = (uint8_t)simple_strtoul(&TV_SIZE[0], NULL, 10);
			if ( (_mSize >= 29) && (_mSize <= 100) ) {	/* reasonable size, 29 to 100 */
				*TV_model = _mModel;
				*TV_size = _mSize; 
				rRet = NVT_OK;
			}
		}
	}
	UBOOT_INFO("%s region=%s, model=%s, size=%s, *TV_model=%d, *TV_size=%d rRet=%d\n", __FUNCTION__, TV_REGION, TV_MODEL, TV_SIZE, *TV_model, *TV_size, rRet );
	return rRet;
}

#define 	OPFRC_ADDR		(5)		/* min offset , 0x19FE5 */
#define 	OPDISPID_ADDR	(7)		/* 0x19FE7 */
#define 	OPFRCCHK_ADDR	(8)		/* 0x19FE8 */
#define 	OPSILENT_ADDR	(9)		/* max offset, 0x19FE9 */
static int32_t _nvt_NVM_init(void)
{
	static U8 _NVM_initf = 0;
	char NVMabsAddrStr[16] = { 0 };
	U32 _acfgoffset0 = 0;
	U32 uRet = 0;

	if (0 == _NVM_initf) {
		U16 _tmpTvModel = 0;
		U8 _tmpTvSize = 0;
		
		/* read Option code , but not ready yet */
		uRet  = Read_NVM_OptionByte(OPFRC_ADDR, &_u1OpFrc, &_acfgoffset0);
		if (NVT_OK != uRet) 
			_u1OpFrc = 0;
		else {
			if (1 == _u1OpFrc) _u1OpFrc = FRC_NT72333;
			snprintf(&NVMabsAddrStr[0], 16, "0x%08X", _acfgoffset0);
			if (_nvt_env_variable_update(FRC_ENV_DBG_NVM_ABS_ADDR, NVMabsAddrStr)) saveenv();
		}
		
		uRet += Read_NVM_OptionByte(OPDISPID_ADDR, &_u1OpPanelId, &_acfgoffset0);
		if (NVT_OK != uRet) _u1OpPanelId = 0;
		uRet += Read_NVM_OptionByte(OPFRCCHK_ADDR, &_u1IfNewFrcChk, &_acfgoffset0);
		if (NVT_OK != uRet) _u1IfNewFrcChk = 0;
		uRet += Read_NVM_OptionByte(OPSILENT_ADDR, &_u1UpgSilent, &_acfgoffset0);
		if (NVT_OK != uRet) _u1UpgSilent = 0;
		UBOOT_INFO("[FRC] NVM OFFSET0=0x%08X OPFRC: 0x%02x, PanelID=%d IfNewFrcChku=%d, UpgSilent=%d, Ret=0x%x\n", _acfgoffset0, _u1OpFrc, _u1OpPanelId, _u1IfNewFrcChk, _u1UpgSilent, uRet);

		/* alternative way to config NVM option code, as read NVM option doesn't ready yet */
		if ( NVT_OK == (uRet = _Get_ModelInfo(&_tmpTvModel, &_tmpTvSize)) ) {
			// UBOOT_INFO("[FRC] _Get_ModelInfo(), TvModel=%d, tmpTvSize=%d\n", _tmpTvModel, _tmpTvSize);
			if ( (_tmpTvSize >= 70) && ((7906 == _tmpTvModel) || (7956 == _tmpTvModel)) ) {
				_u1OpFrc = FRC_NT72333;
			}
		}
		UBOOT_INFO("[FRC] OPFRC=0x%02x PanelID=%d Model=%d Size=%d uRet=0x%x\n", _u1OpFrc, _u1OpPanelId, _tmpTvModel, _tmpTvSize, uRet);
		_NVM_initf = 1;
	}

	// UBOOT_INFO("[FRC] OPFRC: 0x%02x, PanelID=%d uRet=0x%x\n", _u1OpFrc, _u1OpPanelId, uRet);
	return NVT_OK;	// uRet
}

int32_t _has_frc_nt333(void)
{
	if ( (NVT_OK == _nvt_NVM_init()) && (FRC_NT72333 == _u1OpFrc) )
		return NVT_OK;
	return NVT_ERR;
}

static int32_t _nvt_pwron(VOID)
{
    int32_t i4Gpio;
    int32_t i4Set;

	if (_u1FRCpower == 0) {
		i4Gpio = NVT_333_PWR_PIN;
		i4Set = NVT_HIGH;
		//GPIO_Output(i4Gpio, &i4Set);
		FRC_SetGPIO(i4Gpio, i4Set);
		//x_thread_delay(NVT_RST_TIME);
		mdelay(1000);	/* delay 1 second for frc internal initialization */
		
		_u1FRCpower = 1;
	}
    return NVT_OK;
}

static int32_t _nvt_pwroff(VOID)
{
    int32_t i4Gpio;
    int32_t i4Set;

	// if (_u1FRCpower == 1) 
	{
		i4Gpio = NVT_333_PWR_PIN;
		i4Set = NVT_LOW;
		//GPIO_Output(i4Gpio, &i4Set);
		FRC_SetGPIO(i4Gpio, i4Set);
		
		_u1FRCpower = 0;

		mdelay(2000);
	}
    return NVT_OK;
}

static void _nvt_PowerRst(VOID)
{
    int32_t i4Gpio;
    int32_t i4Set;

	i4Gpio = NVT_333_PWR_PIN;
	i4Set = NVT_LOW;
	//GPIO_Output(i4Gpio, &i4Set);
	FRC_SetGPIO(i4Gpio, i4Set);
	//x_thread_delay(NVT_RST_TIME);
	mdelay(200);	/* 200ms */

    printf("[FRC] gpio%d, %s \n", NVT_333_PWR_PIN, (FRC_GetGPIO_Level(NVT_333_PWR_PIN))?"High":"Low");
    printf("[FRC] gpio%d, %s \n", NVT_333_SPLASH_PIN, (FRC_GetGPIO_Level(NVT_333_SPLASH_PIN))?"High":"Low");
	
	i4Gpio = NVT_333_PWR_PIN;
	i4Set = NVT_HIGH;
	//GPIO_Output(i4Gpio, &i4Set);
	FRC_SetGPIO(i4Gpio, i4Set);
	mdelay(200 /* NVT_RST_TIME */ );

    printf("[FRC] gpio%d, %s \n", NVT_333_PWR_PIN, (FRC_GetGPIO_Level(NVT_333_PWR_PIN))?"High":"Low");
    printf("[FRC] gpio%d, %s \n", NVT_333_SPLASH_PIN, (FRC_GetGPIO_Level(NVT_333_SPLASH_PIN))?"High":"Low");
	
	_u1FRCpower = 1;
}

static int32_t _nvt_checksum(uint32_t u4Chksum, uint32_t u4Addr, uint32_t u4Size)
{
    uint32_t u4ClacChksum = 0;
    uint8_t *pu1Data = _pu1FrcBuffer;
    pu1Data += u4Addr;
    
    printf("[FRC] size: %d, 0x%08x\n", u4Size, u4Size);

    while(u4Size--)
    {
        u4ClacChksum += *pu1Data++;
    }

    printf("[FRC] u4ClacChksum: 0x%08x, u4Chksum: 0x%08x\n", u4ClacChksum, u4Chksum);

    if(u4Chksum == u4ClacChksum)
    {
        return NVT_OK;
    }

    return NVT_ERR;
}

static int32_t _nvt_clac_chksum(VOID)
{
    uint32_t u4Size;
    uint32_t u4Addr;
    uint32_t u4Chksum;

    memcpy(&_tFrcHdr, _pu1FrcBuffer, sizeof(FRC_ISP_HDR_T));

    /* Big endian to little endian */
    u4Chksum = NVT_INV(_tFrcHdr.u4Chksum);
    u4Addr = NVT_INV(_tFrcHdr.u4Addr);
    u4Size = NVT_INV(_tFrcHdr.u4Size);

    /* sub program */
    return _nvt_checksum(u4Chksum, u4Addr, u4Size);
}

static int32_t _nvt_unlock(VOID)
{
    MS_BOOL   result = FALSE;
    //int32_t   i;
    uint8_t   cmd[] = {0xFE, 0x31, 0x72};

    //result = SIF_X_Write(NVT_I2C_BUS, NVT_CLK_DIV, _u1I2cAddr, 0, 0, cmd, sizeof(cmd));
	result = FRC_I2C_Write(0, 0, sizeof(cmd), &cmd[0]);
    
    if ( FALSE == result )
    {
        printf("[FRC][ERROR] %s() on %d, Fail\n", __func__, __LINE__);
        return NVT_ERR;
    }

    //x_thread_delay(NVT_DELAY);
	mdelay(NVT_DELAY);

#ifdef NVT_DEBUG
    if (FRC_NT72334 == _u1OpFrc)
    {
        cmd[1] = 0x00;
        cmd[2] = 0x00;
        
        //result = SIF_X_Read(NVT_I2C_BUS, NVT_CLK_DIV, _u1I2cAddr, 1, cmd[0], &cmd[1], 2);
		result = FRC_I2C_Read(1, cmd[0], 2, &cmd[1]);

        if((TRUE == result) && (cmd[1] == 0x31) && (cmd[2] == 0x72)) 
        {
            printf("[FRC][UnLock OK] \n");
        }
        else
        {
            printf("[FRC][ERROR] %s() on %d, value = %d, cmd[1]=[0x%x],cmd[2]=[0x%x]\n", __func__, __LINE__, result, cmd[1],cmd[2]);        
        }
    }
#endif

    return NVT_OK;
}

static int32_t _nvt_write_reg(uint32_t reg, uint32_t data)
{
    MS_BOOL   result = NVT_OK;
    uint8_t   buf[NVT_W_LEN];
#ifdef NVT_DEBUG
    int32_t   i;    
#endif

    memcpy(buf, &reg, 4);
    memcpy(&buf[4], &data, 4);

#ifdef NVT_DEBUG
    for(i = 0; i < NVT_W_LEN; i++)
    {
        printf("[FRC] %s(), buf[%d]: 0x%02x\n", __func__, i, buf[i]);
    }
#endif

    //result = SIF_X_Write(NVT_I2C_BUS, NVT_CLK_DIV, _u1I2cAddr, 1, NVT_W_ADDR, buf, NVT_W_LEN);
	result = FRC_I2C_Write(1, NVT_W_ADDR, NVT_W_LEN, &buf[0]);
    NVT_RET_ERR(result, TRUE);

    return NVT_OK;
}

static int32_t _nvt_write_data(uint8_t *data, uint32_t len)
{
    MS_BOOL   result = NVT_OK;

    if(NULL == data)
    {
        return NVT_ERR;
    }

    //result = SIF_X_Write(NVT_I2C_BUS, NVT_CLK_DIV, _u1I2cAddr, 0, 0, data, len);
	result = FRC_I2C_Write(0, 0, len, data);
    NVT_RET_ERR(result, TRUE);

    return NVT_OK;
}

static int32_t _nvt_read_reg(uint32_t reg, uint32_t *data)
{
    MS_BOOL   result = NVT_OK;
    uint8_t   buffer[NVT_R_LEN];
#ifdef NVT_DEBUG
    int32_t   i;    
#endif

    if(NULL == data)
    {
        return NVT_ERR;
    }

    memcpy(buffer, &reg, 4);

#ifdef NVT_DEBUG
    for(i = 0; i < NVT_R_LEN; i++)
    {
        printf("[FRC] %s(), register buffer[%d]: 0x%02x\n", __func__, i, buffer[i]);
    }
#endif

    //result = SIF_X_Write(NVT_I2C_BUS, NVT_CLK_DIV, _u1I2cAddr, 1, NVT_R_ADDR, buffer, NVT_R_LEN);
	result = FRC_I2C_Write(1, NVT_R_ADDR, NVT_R_LEN, buffer);
    NVT_RET_ERR(result, TRUE);

    //result = SIF_X_Read(NVT_I2C_BUS, NVT_CLK_DIV, _u1I2cAddr, 1, NVT_R_DATA, buffer, NVT_R_LEN);
	result = FRC_I2C_Read(1, NVT_R_DATA, NVT_R_LEN, buffer);
    NVT_RET_ERR(result, TRUE);

    memcpy(data, buffer, NVT_R_LEN);

#ifdef NVT_DEBUG
        for(i = 0; i < NVT_R_LEN; i++)
        {
            printf("[FRC] %s(), read value[%d]: 0x%02x\n", __func__, i, buffer[i]);
        }
#endif

    return NVT_OK;
}

static int32_t _nvt_read_data(uint8_t reg, uint8_t *data, uint8_t len)
{
    int32_t   result = NVT_OK;

    if(NULL == data)
    {
        return NVT_ERR;
    }

    //result = SIF_X_Read(NVT_I2C_BUS, NVT_CLK_DIV, _u1I2cAddr, 1, reg, data, len);
	result = FRC_I2C_Read(1, reg, len, data);
    NVT_RET_ERR(result, TRUE);

    return NVT_OK;
}

static int32_t _nvt_write_cmd(uint32_t cmd)
{
    int32_t result = NVT_OK;
    uint32_t cnt = NVT_RETRY;
    uint32_t status = 0;

#ifdef NVT_DEBUG
    printf("%s(), cmd: 0x%x\n", __func__, cmd);
#endif

	/* check command register empty or not */
    do
    {
        //x_thread_delay(NVT_DELAY);
		mdelay(NVT_DELAY);
        result = _nvt_read_reg(NVT_CR, &status);
        NVT_RET_ERR(result, NVT_OK);
        cnt--;

#ifdef NVT_DEBUG
        printf("status: 0x%x, cnt: %d\n", status, cnt);
#endif
    } while((NVT_CMD_CHK != status) && (0 < cnt));
    NVT_RET_ERR(status, NVT_CMD_CHK);

    /* Send command */
    result = _nvt_write_reg(NVT_CR, cmd);
    NVT_RET_ERR(result, NVT_OK);

    /* Check status */
    cnt = NVT_RETRY;
    do
    {
        //x_thread_delay(NVT_DELAY);
		mdelay(NVT_DELAY);
        result = _nvt_read_reg(NVT_SR, &status);
        NVT_RET_ERR(result, NVT_OK);
        cnt--;
    } while((NVT_CMD_STATUS != status) && (0 < cnt));

    NVT_RET_ERR(status, NVT_CMD_STATUS);

    return NVT_OK;
}

static int32_t _nvt_read_cmd(uint32_t cmd, uint32_t *data)
{
    int32_t result = NVT_OK;
    uint32_t cnt = NVT_RETRY;         /* 5 seconds */
    uint32_t status = 0;

#ifdef NVT_DEBUG
    printf("%s(), cmd: 0x%x\n", __func__, cmd);
#endif

    if(NULL == data)
    {
        return NVT_ERR;
    }

	/* check command register empty or not */
    do
    {
        //x_thread_delay(NVT_DELAY);
		mdelay(NVT_DELAY);

        result = _nvt_read_reg(NVT_CR, &status);
        NVT_RET_ERR(result, NVT_OK);

        cnt--;

#ifdef NVT_DEBUG
        printf("status: 0x%x, cnt: %d\n", status, cnt);
#endif
    } while((NVT_CMD_CHK != status) && (0 < cnt));
    NVT_RET_ERR(status, NVT_CMD_CHK);

    /* Send command */
    result = _nvt_write_reg(NVT_CR, cmd);
    NVT_RET_ERR(result, NVT_OK);

    /* Check status , timeout 5 seconds*/
    cnt = NVT_RETRY;
    do
    {
        //x_thread_delay(NVT_DELAY);
		mdelay(NVT_DELAY);
        result = _nvt_read_reg(NVT_SR, &status);
        NVT_RET_ERR(result, NVT_OK);
        cnt--;
    } while((NVT_CMD_STATUS != status) && (0 < cnt));

    NVT_RET_ERR(status, NVT_CMD_STATUS);

    /* Get result */
    result = _nvt_read_reg(NVT_RR, data);
    NVT_RET_ERR(result, NVT_OK);

    return NVT_OK;
}

static int32_t _nvt_burst_write_data(uint8_t *pu1Data, uint8_t u1LenID, uint32_t u4Addr)
{
    int32_t   i4Result = NVT_OK;
    int32_t   u4TotalData = 0;
    uint32_t  u4Cnt = NVT_RETRY;
    uint8_t   acBuf[NVT_DATA_BUF];
    uint32_t  u4BurstData = u1LenID + 1;

    if(NULL == pu1Data)
    {
        return NVT_ERR;
    }

    /* Set index to 0 */
    acBuf[0] = NVT_B_INDEX;
    acBuf[1] = 0;

    i4Result = _nvt_write_data(acBuf, 2);
    NVT_RET_ERR(i4Result, NVT_OK);

    /* Send data */
    acBuf[0] = NVT_B_W;
    u4TotalData++;

    memcpy(&acBuf[1], pu1Data, u4BurstData);
    u4TotalData += u4BurstData;

    i4Result = _nvt_write_data(acBuf, u4TotalData);
    NVT_RET_ERR(i4Result, NVT_OK);

    /* Send burst command */
    acBuf[0] = NVT_B_ADDR;
    acBuf[1] = (uint8_t)(u4Addr & 0x000000FF);
    acBuf[2] = (uint8_t)((u4Addr & 0x0000FF00) >> 8);
    acBuf[3] = (uint8_t)((u4Addr & 0x00FF0000) >> 16);
    acBuf[4] = (uint8_t)((u4Addr & 0xFF000000) >> 24);
    acBuf[5] = u1LenID;
    acBuf[6] = NVT_BURST_W;
    
    i4Result = _nvt_write_data(acBuf, NVT_BURST_LEN);
    NVT_RET_ERR(i4Result, NVT_OK);

    /* Check if command is finished */
    do
    {
        //x_thread_delay(NVT_DELAY);
		mdelay(NVT_DELAY);

        i4Result = _nvt_read_data(NVT_B_CTL, acBuf, NVT_REG_LEN);
        NVT_RET_ERR(i4Result, NVT_OK);

        u4Cnt--;

    } while((0 != (acBuf[0] & NVT_BURST_W)) && (0 < u4Cnt));

    NVT_RET_ERR((acBuf[0] & NVT_BURST_W), 0);

    return NVT_OK;
}

static int32_t _nvt_invert_data(VOID *pvData, uint32_t  u4Size)
{
    uint32_t  *pu4Data = (uint32_t*)pvData;

    if(NULL == pu4Data)
    {
        return NVT_ERR;
    }

    if(u4Size < NVT_INVERT_SIZE)
    {
        return NVT_ERR;
    }

    if(0 != (u4Size % NVT_INVERT_SIZE))
    {
        return NVT_ERR;
    }

    do
    {
        *pu4Data = NVT_INV((*pu4Data));
        pu4Data++;
    } while(0 != (u4Size -= NVT_INVERT_SIZE));

    return NVT_OK;
}

static VOID _nvt_frc_unlock(void)
{
//    int32_t       i4Ret = NVT_OK;
//    uint32_t      u4Status = 0;
	
	if ( (_u1FRC333Unlocked == 0) && (FRC_NT72333 == _u1OpFrc) ) {

		// SIF_Init();		
		FRC_SWI2C_Init();
		
		//x_thread_delay(NVT_INIT_TIME);
		mdelay(1000);

		_u1I2cAddr = NVT_I2C_ADDR_333;
		if (NVT_OK == _nvt_unlock()) {
			_u1FRC333Unlocked = 1;
		} 
	}
}

// silent trun on frc 333
static void _nvt_silentOnFrc333(void)
{
	int i, j;	
	//uint8_t bklight_off[] = 	{ 0x00, 0x20, 0x01, 0x0A, 0x9F, 0x10, 0x2f, 0x70, 0x0e };
	//uint8_t v12_off[] = { 0x00, 0x20, 0x01, 0x0A, 0x9F, 0x10, 0x39, 0x70, 0x0e };
	//uint8_t video_mute[] = { 0x00, 0x20, 0x01, 0x0A, 0x9F, 0x01, 0x00, 0x00, 0x00 };
	//uint8_t video_unmute[] = { 0x00, 0x20, 0x01, 0x0A, 0x9F, 0x00, 0x00, 0x00, 0x00 };
	uint8_t unlock[]={ 0xFE, 0x31, 0x72 };								
	MS_BOOL i2cerror = FALSE;
  
	uint8_t msgw2[]={ 0x0C };
	
	uint8_t msgw7[] = { 0x08, 0xBC, 0x01, 0x0A, 0x9F }; // register 0x9F 0A 01 BC
	uint8_t msgw8[] = { 0x08, 0xC0, 0x41, 0x00, 0xE0 }; // register E000_41C0
	uint8_t msgw9[] = { 0x00, 0xC0, 0x41, 0x00, 0xE0, 0x01, 0x00, 0x00, 0xFF }; // register E000_41C0 <== 0xff000001, skip tcon12v & backlight on
	
	uint8_t msgr[0x10];
	uint32_t cmd_register = 0;
	uint8_t done_ok = 0;
	
	printf("\nSilent turnOnFrc33() START: set GPIO(14) to OUTPUT HIGH, Power on FRC NT333\n");
	// 1. PIN 256 is FRC nt333 power-pin , high is on
	
	// PIN 14 was FRC nt333 reset-pin, high is on
	FRC_SetGPIO(NVT_333_PWR_PIN, NVT_HIGH);
	
	// for H/W and nt333 internal initialization
	udelay(800000); // 600ms
	
	// 2. unlock nt333
	for (i=0; i<300; i++) { 	// 300 * 5ms => 1.5 seconds
	
		udelay(5000);	// 5ms
		// i2cerror = TPAPIinfraI2C_Write( FRC_NT333_I2C_ADDR, unlock, sizeof(unlock) );
		i2cerror = FRC_I2C_Write(0, 0, sizeof(unlock), &unlock[0]);
		if (i2cerror == TRUE) {
			unlock[1] = 0x00;
			unlock[2] = 0x00;
			//i2cerror = TPAPIinfraI2C_WriteRead( FRC_NT333_I2C_ADDR, &unlock[0], 1, &unlock[1], 2);
			i2cerror = FRC_I2C_Read(1, unlock[0], 2, &unlock[1]);
			if ((i2cerror == TRUE) && (unlock[1] == 0x31) && (unlock[2] == 0x72) ) {
				done_ok = 1;
				printf("\nfrc nt333 unlock done [%d]!!!\n", i );
				break;
			}
		}
	}
	printf("quit from loop of i2C unlock [%d] !!!\n", i );
	
	udelay(5000);	// 5ms

	// 2.1. write breakin command and read back 0x9F0A01BC
	// breakin command supporting from fw v80.1.34,
	done_ok = 0;
	for (i=0; i<300; i++) { 	// 300 * 5ms => 1.5 seconds
		{	// read back register 0xE000_41C0 value
			udelay(1000);	// 1ms
			//i2cerror = TPAPIinfraI2C_Write( FRC_NT333_I2C_ADDR, msgw8, sizeof(msgw8) );
			i2cerror = FRC_I2C_Write(0, 0, sizeof(msgw8), &msgw8[0]);
			if (i2cerror == TRUE) {
				//i2cerror = TPAPIinfraI2C_WriteRead( FRC_NT333_I2C_ADDR, msgw2 , sizeof(msgw2), msgr, 4 );
				i2cerror = FRC_I2C_Read(sizeof(msgw2), msgw2[0], 4, &msgr[0]);
				cmd_register = (msgr[3] << 24) | (msgr[2] << 16) | (msgr[1] << 8) | msgr[0];
				if (i2cerror == TRUE) {
					printf("frc nt333 read back 0xE000_41C0 [%d 0x%x]!!!\n", i, cmd_register );
				}
			}
		}
		
		// write breakin command, 0xE000_41C0 <= 0xfd000001, skip power sequence,
		udelay(1000);	// 1ms
		//i2cerror = TPAPIinfraI2C_Write( FRC_NT333_I2C_ADDR, msgw9, sizeof(msgw9) );
		i2cerror = FRC_I2C_Write(0, 0, sizeof(msgw9), &msgw9[0]);

		udelay(3000);	// 3ms
		//i2cerror = TPAPIinfraI2C_Write( FRC_NT333_I2C_ADDR, msgw7, sizeof(msgw7) );
		i2cerror &= FRC_I2C_Write(0, 0, sizeof(msgw7), &msgw7[0]);
		if (i2cerror == TRUE) {
			//i2cerror = TPAPIinfraI2C_WriteRead( FRC_NT333_I2C_ADDR, msgw2 , sizeof(msgw2), msgr, 4 );
			i2cerror = FRC_I2C_Read(sizeof(msgw2), msgw2[0], 4, &msgr[0]);
			cmd_register = (msgr[3] << 24) | (msgr[2] << 16) | (msgr[1] << 8) | msgr[0];
			if ((i2cerror == TRUE) && ((cmd_register & 0x000000ff) == 0x55) ) {
				done_ok = 1;
				printf("\nfrc nt333 read back 0x9F0A01BC is 0x55 [%d]!!!\n", i );
				break;
			}
		}
	}
	printf("[2.1] from read back 0x9F0A01BC [%d %d 0x%x] !!!\n", i, done_ok, cmd_register );

	// for silent on frc nt333 before fw 80.1.34.
	// 3. keep send video mute & backlight off for around 1 seconds,
	for (j=0; j < 50; j++) { // adjust 50--200

	  // 3.1. write backlight off, 0x0E702F10
	  // nt333_write_cmd( bklight_off, sizeof(bklight_off) );
	  i2cerror = _nvt_write_cmd(0x0E702F10);	/* GPIOB15 off */
	  printf("loop-%d-[3.1] write backlight off\n", j);
	  
	  udelay(5000);   // 5ms
	  
	  // 3.2. write video mute
	  // nt333_write_cmd( video_mute, sizeof(video_mute) );
	  i2cerror = _nvt_write_cmd(0x00000001);	/* video mute */
	  printf("loop-%d-[3.2] write video mute\n", j);
	  
	  udelay(5000);   // 5ms
	}

	// 4. tcon12v off
	// nt333_write_cmd( v12_off, sizeof(v12_off) );
	i2cerror = _nvt_write_cmd(0x0E703910);	  /* tcon 12v off */
	printf("[4] write tcon12v off\n");
	
	udelay(100000); // delay 100ms

	// 5. for reliable reason, turn off backlight again.
	// backlight off again
	// nt333_write_cmd( bklight_off, sizeof(bklight_off) );
	i2cerror = _nvt_write_cmd(0x0E702F10);	  /* GPIOB15 off */
	printf("[5] write backlight off again\n");
	
	// 5.1. write video mute
	i2cerror = _nvt_write_cmd(0x00000001);	  /* video mute */
	printf("[5.2] write video mute\n");
	
	printf("Silent Power up nt333 Done\n");
}

/* data buffer: _pu1FrcBuffer , size: _u4FrcBinSize */
/* return : success 1, error -1 */
static int32_t _nvt_upgarde_fw(void)
{
    int32_t       i4Ret = NVT_OK;
    uint32_t      u4Ver = 0;
    uint32_t      u4DumpAddr = 0;
    uint32_t      u4Downlaod = 0;
    uint32_t      u4Status = 0;
    uint32_t      u4Remaining = _u4FrcBinSize;
    uint8_t       u1LenID = 0;
    uint8_t       u1Cnt = 0;
    uint8_t       *pu1Data = _pu1FrcBuffer;
    // HAL_TIME_T  time1;
    // HAL_TIME_T  time2;
    // HAL_TIME_T  delta;

    /* Show upgrade logo */
    printf("====================================================\n");
    //LDR_LogoDisplay(prLdrData, 1);
	show_LoadData(0);
	_nvt_enable_dbgLevel();
    printf("====================================================\n");

	/* if frc doesn't unlock, unlock it */
	_nvt_frc_unlock();

	if (FRC_NT72333 == _u1OpFrc) {
		if (_u1FRC333Unlocked)			
			_u1I2cAddr = NVT_I2C_ADDR_333;
		else
			NVT_RET_ERR(NVT_ERR, NVT_OK);
	}

	/* Read version Read 0x0f 0x93 0x0000 */
	i4Ret = _nvt_read_cmd(NVT_READ_VER_333, &u4Ver);
	NVT_RET_ERR(i4Ret, NVT_OK);
    printf("[FRC] Current FW version: V%u.%u.%u \n", (u4Ver & 0xff000000)>>24,  (u4Ver & 0x00fff000)>>12, (u4Ver & 0x00fff) );

	if (FRC_NT72333 == _u1OpFrc) {	// NT333, GPIOC-06 is write-protect pin
#define NVT_NT333_READ_GPIO   (0x0E710046)
#define NVT_NT333_WRITE_GPIO   (0x0E704611)
		i4Ret = _nvt_write_cmd(NVT_NT333_READ_GPIO);		
		//x_thread_delay(10); // 10ms
		mdelay(10);
		i4Ret = _nvt_read_cmd(NVT_NT333_READ_GPIO | 0x80000000, &u4Ver);	
		printf("[FRC] After Power on, read NT333 default SPI_WP value=[0x%x], i4Ret=%d\n", u4Ver, i4Ret);
		//x_thread_delay(10); // 10ms
		mdelay(10);
		
		// gpioc_06 to high
		i4Ret = _nvt_write_cmd(NVT_NT333_WRITE_GPIO);		
		//x_thread_delay(10); // 10ms
		mdelay(10);
		
		i4Ret = _nvt_write_cmd(NVT_NT333_READ_GPIO);		
		//x_thread_delay(10); // 10ms
		mdelay(10);
		i4Ret = _nvt_read_cmd(NVT_NT333_READ_GPIO | 0x80000000, &u4Ver);	
		printf("[FRC] After force SPI_WP GPIOC-06 to High, write-unprotect, read back SPI_WP value=[0x%x], i4Ret=%d\n", u4Ver, i4Ret);		
		//x_thread_delay(10); // 10ms
		mdelay(10);
	}
		
    // to be done version check, read the version.txt to get binary file version
    
    /* Enter ISP mode 0f f0 0000*/
    i4Ret = _nvt_write_cmd(NVT_ENTER_ISP);
    NVT_RET_ERR(i4Ret, NVT_OK);

    /* Get dump address Read 0x0f 0xf2 0000*/
    i4Ret = _nvt_read_cmd(NVT_GET_DUMP_ADDR, &u4DumpAddr);
    NVT_RET_ERR(i4Ret, NVT_OK);

    printf("[FRC] Dump address: 0x%08x , size: 0x%08x (%u), checksum: 0x%08x\n", u4DumpAddr, NVT_INV(_tFrcHdr.u4Size), NVT_INV(_tFrcHdr.u4Size), NVT_INV(_tFrcHdr.u4Chksum));

    /* Set metadata */
    i4Ret = _nvt_write_reg(NVT_DUMP_ADDR, u4DumpAddr);
    NVT_RET_ERR(i4Ret, NVT_OK);
    i4Ret = _nvt_write_reg(NVT_DUMP_SIZE, NVT_INV(_tFrcHdr.u4Size));
    NVT_RET_ERR(i4Ret, NVT_OK);
    i4Ret = _nvt_write_reg(NVT_DUMP_CHKSUM, NVT_INV(_tFrcHdr.u4Chksum));
    NVT_RET_ERR(i4Ret, NVT_OK);

    i4Ret = _nvt_write_reg(NVT_DUMP_NOT_CHKSUM, ~NVT_INV(_tFrcHdr.u4Chksum));
    NVT_RET_ERR(i4Ret, NVT_OK);

    /* Invert data by WORD */
    i4Ret = _nvt_invert_data(_pu1FrcBuffer, _u4FrcBinSize);
    NVT_RET_ERR(i4Ret, NVT_OK);

    // HAL_GetTime(&time1);

    /* Start to download data */
    while(0 < u4Remaining) 
    {
        if(NVT_BURST_224 <= u4Remaining)
        {
            u4Downlaod = NVT_BURST_224;
            u1LenID = NVT_BURST_ID_224;
        }
        else {
            u4Downlaod = u4Remaining;
            u1LenID = u4Remaining - 1;          
        }       
    
//    printf("[FRC] Downloading , %d\n", u4Remaining);
#ifdef NVT_DEBUG
        {
            int i;
            
            printf("[FRC] %s(), Write [%d] Bytes from: 0x%x to 0x%x, remaining=[%d]\n", __func__, u1LenID, (uint32_t)pu1Data, u4DumpAddr, u4Remaining);
            for(i = 0; i < 8; i++)
            {
                printf("Byte%d[0x%x] ", i, *(pu1Data+i));
            }
            printf("\n");           
        }       
#endif

        i4Ret = _nvt_burst_write_data(pu1Data, u1LenID, u4DumpAddr);
        NVT_RET_ERR(i4Ret, NVT_OK);
        
        u4DumpAddr += u4Downlaod;
        pu1Data += u4Downlaod;
        u4Remaining -= u4Downlaod; 

        u1Cnt++;

        if(10 < u1Cnt)
        {
            u1Cnt = 0;
            printf(".");
        }
    }

    printf("\n");

    // HAL_GetTime(&time2);
    // HAL_GetDeltaTime(&delta, &time1, &time2);
    // printf("[FRC] Download time: %d.%d seconds\n", delta.u4Seconds, delta.u4Micros);

    /* Trigger FRC to upgrade FW */
    printf("[FRC] Trigger FRC to upgrade FW\n");

    // 0x0f 0xf1 0x0000
    i4Ret = _nvt_write_cmd(NVT_START_UPGRADE);
    NVT_RET_ERR(i4Ret, NVT_OK);

    // x_thread_delay(NVT_CHK_DELAY_TIME);	
	mdelay(NVT_CHK_DELAY_TIME);

    /* Check the result */
    u1Cnt = NVT_STATUS_RETRY;   /* 60 Seconds */

    do
    {
        //x_thread_delay(NVT_CHK_TIME);
		mdelay(NVT_CHK_TIME);
        // Read 0x0f 0xf3 0x0000
        i4Ret = _nvt_read_cmd(NVT_ISP_STATUS, &u4Status);

#ifdef NVT_DEBUG        
        printf("[FRC][NVT_ISP_STATUS] on Line %d, value = %d, ret=%d\n", __LINE__, u4Status, i4Ret);
#else
        NVT_RET_ERR(i4Ret, NVT_OK);
#endif

        u1Cnt--;

        printf("[FRC] Status: 0x%08x\n", u4Status);

    } while((NVT_UPGRADE_OK != u4Status) && (NVT_UPGRADE_FAIL != u4Status) && (0 < u1Cnt));
    
#ifdef NVT_DEBUG
    printf("[FRC] Status: 0x%08x, [%s], delay 3000ms\n", u4Status, (NVT_UPGRADE_OK == u4Status)?"UPGRADE_OK":"UPGRADE_FAIL");
    //x_thread_delay(NVT_CHK_DELAY_TIME);
	mdelay(NVT_CHK_DELAY_TIME);
#endif

    if(NVT_UPGRADE_OK == u4Status)
    {
        return NVT_OK;
    }
    else
    {
        return NVT_ERR;
    }
}

// return same NVT_OK, not same NVT_NOK
static int32_t _nvt_cmp_frc_version(void)
{
	FrcVersion_t *src_ptr  = &_tFlashFrcNt333Version;
	FrcVersion_t *dest_ptr  = &_tUsbFrcNt333Version;

	printf("[FRC] %s FW Version [%d:%d:%d <- %d:%d:%d]\n", "NT333", dest_ptr->novatekBranch, dest_ptr->novatekMajor, 	\
		dest_ptr->novatekMinor, src_ptr->novatekBranch, src_ptr->novatekMajor, src_ptr->novatekMinor);
	
	if ( (src_ptr->novatekBranch != dest_ptr->novatekBranch) || (src_ptr->novatekMajor != dest_ptr->novatekMajor) || (src_ptr->novatekMinor != dest_ptr->novatekMinor) ) {
		return NVT_ERR;	/* not same */
	}
	return NVT_OK;	/* same */
}

/* read FRC version from TV or FRC flash */
static int32_t _nvt_read_frc_version(uint32_t *pBranch, uint32_t *pMajor, uint32_t *pMinor)
{
    int32_t       i4Ret = NVT_OK;
    uint32_t      u4Ver = 0;
	
	_nvt_frc_unlock();

	if (FRC_NT72333 == _u1OpFrc) {
		if (_u1FRC333Unlocked)				
			_u1I2cAddr = NVT_I2C_ADDR_333;
		else
			NVT_RET_ERR(NVT_ERR, NVT_OK);
	}

    /* Read version Read 0x0f 0x93 0x0000 */
	i4Ret = _nvt_read_cmd(NVT_READ_VER_333, &u4Ver);
	
	if (i4Ret == NVT_OK) {
		*pMinor = (u4Ver & 0x00000FFF) >> 0;
		*pMajor = (u4Ver & 0x00FFF000) >> 12;
		*pBranch = (u4Ver & 0xFF000000) >> 24;
	}

    NVT_RET_ERR(i4Ret, NVT_OK);
    printf("[FRC] Flash NT%s FW version: V%u.%u.%u \n", "333", (u4Ver & 0xff000000)>>24,  (u4Ver & 0x00fff000)>>12, u4Ver & 0x0fff );
	
    // printf("[UFRC] Exit %s, i4Ret=%d\n", __FUNCTION__, i4Ret);
	return i4Ret;
}

/* get FRC version from a 32 bytes version packet */
static int32_t _nvt_get_frcVer_infile(uint8_t *srcstr, uint32_t *pBranch, uint32_t *pMajor, uint32_t *pMinor)
{
	uint32_t *fchksum = NULL;
	uint32_t vchksum = 0;
	uint32_t tBrach, tMajor, tMinor;
	uint32_t i;

	if ( (NULL==srcstr)||(NULL==pBranch)||(NULL==pMajor)||(NULL==pMinor) )
		return NVT_ERR;	/* NULL pointer */
	
	fchksum = (uint32_t *)&srcstr[28];
	for (i=0; i<28; i++) {
		vchksum += srcstr[i];
	}

    UBOOT_INFO(" vchksum = 0x%x fchksum = 0x%x ...\n", vchksum, *fchksum);
	if (*fchksum != vchksum)
		return NVT_ERR;

	if (3 != sscanf((const char *)srcstr, "%u.%u.%u", &tBrach, &tMajor, &tMinor)) {
		return NVT_ERR;
	}

	*pBranch = tBrach;
	*pMajor  = tMajor;
	*pMinor  = tMinor;
    UBOOT_INFO(" V%u.%u.%u\n", tBrach, tMajor, tMinor);
	return NVT_OK;
}

/* return : -1 trigger condition doesn't meat, for ex. no FRC, no flagfile, no valid fw file under /vendor/tvconfig/... */
/* 0, FRC version same no need FRC FW upgrade, */
/* 1, do FRC FW upgrade success, 2, do FRC FW upg with error */
/* redefine return as API run_command() only return 0 or -1, */
/* -1, no need TV reboot, 0, need TV reboot */
//if (0 == do_UPG_FRC_upgrade("frcupgchk_flag_file", "2020_21_Philips_UHD_Android_TV/config/frc/tpv_t32_nt333_2k21_isp.bin")) {
/* return : 0, no need FRC FW upgrade, 1, do FRC FW upgrade success, -1, error */
/* do frc fw upgrade after UPG, OTA and PKG, frc file located under TV /vendor/tvconfig folder */
//int32_t do_UPG_FRC_upgrade(char *flagfile, char *frcfwfilename)
int do_UPG_FRC_upgrade(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	int i4Ret = FRC_UPGRADE_POST_IGNORE; 	// FRC_UPGRADE_NOT_ALLOW;
    char cmd[CMD_BUF] = "\0";
	char frc_check_flagfile[128] = { 0 };
	char frc_fw_file[128] = { 0 };
	uint8_t *frcbuffer = NULL;
	uint32_t vfileSize = 0;
	char *pEnv = NULL;
	//uint8_t envSave = 0;
	//char strFrcVersion[16] = { 0 };	/* max format 0xff.0xfff.0xfff -- xxx.xxxx.xxxx */
    int ret = 0;

    UBOOT_INFO("[UFRC] Enter argc=%d \n", argc);
	{
		int i = argc;
		if (i >= 4) i=4;
		while (i) {
			UBOOT_INFO("[UFRC] argv[%d]=%s \n", (4-i), argv[4-i]);
			i--;
		}
    }
	
	if (NVT_OK != _has_frc_nt333()) {
        UBOOT_INFO("[UFRC] no NT333 FRC \n");
		return FRC_UPGRADE_POST_IGNORE; 	// FRC_UPGRADE_NOT_ALLOW;
	}

	strcpy(frc_fw_file, "2020_21_Philips_UHD_Android_TV/config/frc/tpv_t32_nt333_2k21_isp.bin");
	if (argc <= 2) { /* default */
		strcpy(frc_check_flagfile, "2020_21_Philips_UHD_Android_TV/ifnewfrcfw");
	}
	else if (argc <= 3) {
		strcpy(frc_check_flagfile, argv[1]);
		strcat(frc_check_flagfile, argv[2]);
	}
	else {
		strcpy(frc_check_flagfile, argv[1]);
		strcat(frc_check_flagfile, argv[2]);
		strcpy(frc_fw_file, argv[1]);
		strcat(frc_fw_file, argv[3]);
	}
    UBOOT_INFO("[UFRC] %s %s\n", frc_check_flagfile, frc_fw_file);

	// UBOOT_DEBUG("check if flag file %s exist \n", flagfile);
	snprintf(cmd, CMD_BUF, "ext4filesize mmc 0:%s %s %x", "tvconfig", &frc_check_flagfile[0], (uint32_t )&vfileSize);
	UBOOT_DEBUG("cmd=%s\n",cmd);
	ret = run_command(cmd, 0);
	if(ret!=0) {
		UBOOT_INFO("[UFRC] %s doesn't exist\n", frc_check_flagfile);
		if (_nvt_env_variable_update(FRC_ENV_UPG_FLAG_FILE, NULL)) saveenv();	/* clear FRC_ENV_UPG_FLAG_FILE */
		return FRC_UPGRADE_POST_IGNORE;		// FRC_UPGRADE_NOT_ALLOW;
	}

	UBOOT_INFO("[UFRC] %s Size %d\n", frc_check_flagfile, vfileSize);
	if (_nvt_env_variable_update(FRC_ENV_UPG_FLAG_FILE, frc_check_flagfile)) saveenv();	/* set FRC_ENV_UPG_FLAG_FILE */
	
	// UBOOT_DEBUG("check %s size\n", frc_fw_file);
	snprintf(cmd, CMD_BUF, "ext4filesize mmc 0:%s %s %x", "tvconfig", frc_fw_file, (uint32_t )&vfileSize);
	UBOOT_DEBUG("[UFRC] cmd=%s\n",cmd);
	ret = run_command(cmd, 0);
	if(ret!=0) {
		UBOOT_ERROR("[UFRC] get %s size fail\n", frc_fw_file);
		return FRC_UPGRADE_POST_IGNORE;		// FRC_UPGRADE_NOT_ALLOW;
	}
	
	UBOOT_INFO("[UFRC] %s Size %d\n", frc_fw_file, vfileSize);
	if (vfileSize <= 32)	return FRC_UPGRADE_POST_IGNORE; // FRC_UPGRADE_NOT_ALLOW ;		/* FRC FW size is around 200k */

	if (vfileSize > 512*1024) {
		UBOOT_ERROR("[UFRC] file size is too big, limited to 512k\n");
		vfileSize = 512*1024;
	}
	frcbuffer = (uint8_t *)malloc(vfileSize);
	if (NULL == frcbuffer) {
		UBOOT_ERROR("[UFRC] malloc error\n");
		return FRC_UPGRADE_POST_IGNORE; 	// FRC_UPGRADE_NOT_ALLOW;
	}
	snprintf(cmd, CMD_BUF, "ext4partload mmc 0:%s %x %s %x %x","tvconfig", frcbuffer, frc_fw_file, 0, vfileSize);
	
	UBOOT_DEBUG("[UFRC] cmd=%s\n",cmd);
	if(-1 == run_command(cmd, 0))
	{
		UBOOT_ERROR("[UFRC] Load FRC File fail!\n");
		if (frcbuffer) free(frcbuffer);
		return FRC_UPGRADE_POST_IGNORE; 	// FRC_UPGRADE_NOT_ALLOW;
	}
	UBOOT_INFO("[UFRC] Load %s upgrade file OK!~\n", frc_fw_file);
	
	_pu1FrcBuffer = (uint8_t *)frcbuffer;
	_u4FrcBinSize = vfileSize;

	if (NVT_OK == _nvt_get_frcVer_infile(_pu1FrcBuffer+vfileSize-32, &_tUsbFrcNt333Version.novatekBranch, &_tUsbFrcNt333Version.novatekMajor, &_tUsbFrcNt333Version.novatekMinor)) {
		_u4FrcBinSize -= 32;
	}
	UBOOT_INFO("[UFRC] Load %s upgrade file OK!, size is %d %d, version is V%d.%d.%d ~\n", FRC_BIN_PATH, vfileSize, _u4FrcBinSize,	\
		_tUsbFrcNt333Version.novatekBranch, _tUsbFrcNt333Version.novatekMajor, _tUsbFrcNt333Version.novatekMinor);
	
	do {
		if(NVT_OK != _nvt_clac_chksum()) {
			UBOOT_ERROR("[UFRC] Checksum is wrong\n");
			break;
		}
		
		// disable watchdog
		// vIO32Write4B(PDWNC_WDTCTL, 0);// PDWNC_WRITE32(REG_RW_WATCHDOG_EN, 0);
		// disable_watchdog = 1;

		// if silent power on support
		// to test silent on
		if (NULL != getenv(FRC_ENV_DBG_SILENT_UPG)) {
			ret = FRC_GetGPIO_Level(NVT_333_PWR_PIN);
			UBOOT_INFO("[UFRC] NVT_333_PWR_PIN %d : %d %s\n", NVT_333_PWR_PIN, ret, (ret) ? "High":"Low");
			if (0 != ret) {
				UBOOT_INFO("[UFRC] NG...Warning: NVT_333_PWR_PIN low, Silent Upgrade, expecting High\n");
			}
			
			UBOOT_INFO("[UFRC] Silent On FRC testing\n");
			_nvt_pwroff();

			ret = FRC_GetGPIO_Level(NVT_333_PWR_PIN);
			UBOOT_INFO("[UFRC] NVT_333_PWR_PIN %d : %d %s\n", NVT_333_PWR_PIN, ret, (ret) ? "High":"Low");
			if (0 != ret) {
				UBOOT_INFO("[UFRC] NG...Warning: NVT_333_PWR_PIN low, Silent Upgrade, expecting High\n");
			}
			_nvt_silentOnFrc333();
			UBOOT_INFO("[UFRC] _nvt_silentOnFrc333() done\n");
		}
		
		if(NVT_OK != _nvt_pwron()) {
			UBOOT_ERROR("[UFRC] Fail to reset FRC\n");
			break;
		}

		if (NVT_OK != _nvt_read_frc_version(&_tFlashFrcNt333Version.novatekBranch, &_tFlashFrcNt333Version.novatekMajor, &_tFlashFrcNt333Version.novatekMinor)) {
			UBOOT_ERROR("[UFRC] Fail to read version\n");
			_nvt_save_env_variable(FW_FROM_FLASH_RAW, NVT_ERR);	/* UPG, FAIL */
			i4Ret = FRC_UPGRADE_POST_REBOOT;	// FRC_UPGRADE_FAIL;
			break;
		}

		/* UPG upgrade, always check version */
		if (NVT_OK == _nvt_cmp_frc_version()) { 	/* version same */
			_nvt_enable_dbgLevel();
			UBOOT_INFO("Start to upgrade FRC\n");			// TF421PHIEUMTK04-4674(928457)
			UBOOT_INFO("[UFRC] FRC version same, V%d.%d.%d!\n", _tFlashFrcNt333Version.novatekBranch, _tFlashFrcNt333Version.novatekMajor, _tFlashFrcNt333Version.novatekMinor);
			UBOOT_INFO("Finish to upgrade FRC\n");			// TF421PHIEUMTK04-4674(928457)
			_nvt_restore_dbgLevel();
			pEnv = getenv(FRC_ENV_LAST_USB_VERSION);
			if (NULL == (pEnv = getenv(FRC_ENV_LAST_USB_VERSION))) {
				/* clear FRC_ENV_UPG_ERR_CNT */
				if (_nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, "0")) saveenv();
				i4Ret = FRC_UPGRADE_POST_IGNORE;	// FRC_UPGRADE_VER_SAME;
				break;	/* return 0 , no fw upgrade */
			}
			else {
				if (NVT_OK != strcmp(pEnv, "0.0.0")) { /* last usb/isp program is third part or old format */
					/* clear FRC_ENV_UPG_ERR_CNT */
					if (_nvt_env_variable_update(FRC_ENV_UPG_ERR_CNT, "0")) saveenv();
					i4Ret = FRC_UPGRADE_POST_IGNORE;	// FRC_UPGRADE_VER_SAME;
					break;	/* return 0 , no fw upgrade */
				}
				else {
					UBOOT_INFO("[UFRC] version is 0.0.0, force frc upgrade!\n");
				}
			}
		}

		_nvt_enable_dbgLevel();
		UBOOT_INFO("Start to upgrade FRC\n");			// TF421PHIEUMTK04-4674(928457)
		_nvt_restore_dbgLevel();
		if(NVT_OK != _nvt_upgarde_fw()) {
			_nvt_save_env_variable(FW_FROM_FLASH_RAW, NVT_ERR);	/* UPG, FAIL */
			i4Ret = FRC_UPGRADE_POST_REBOOT;	// FRC_UPGRADE_FAIL;
			UBOOT_ERROR("[UFRC] Fail to upgrade FRC FWn");
		}
		else {
			_nvt_save_env_variable(FW_FROM_FLASH_RAW, NVT_OK);	/* UPG, SUCCESS */
			i4Ret = FRC_UPGRADE_POST_REBOOT; 	// FRC_UPGRADE_SUCCESS;	/* sucess */
			UBOOT_INFO("[UFRC] Success FRC FW ISP upgrading !\n");
		}
		UBOOT_INFO("Finish to upgrade FRC\n");			// TF421PHIEUMTK04-4674(928457)
		_nvt_restore_dbgLevel();

		UBOOT_INFO("[UFRC] Power Reset After UPG FW ISP upgrade %d !\n", i4Ret);
		_nvt_PowerRst();
		
	} while(0);

	if (NULL != frcbuffer) {
		free(frcbuffer);
		_pu1FrcBuffer = NULL;
	}
	
	UBOOT_INFO("[UFRC] Exit %d !\n", i4Ret);
	return i4Ret;
}
#endif

/* return : -1 trigger condition doesn't meat, for ex. no FRC, no valid USB/ISP file, */
/* 0, FRC version same no need FRC FW upgrade, */
/* 1, do FRC FW upgrade success, 2, do FRC FW upg with error */
int do_USB_FRC_upgrade(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	int i4Ret = FRC_UPGRADE_POST_IGNORE; 	// FRC_UPGRADE_NOT_ALLOW;
    char cmd[CMD_BUF] = "\0";
    char *env =NULL;
    int partition = 0;
    int device = 0;
    int ret = 0;
    // MS_U8 u8Percent= 0;
    long unsigned  int u32FileSize = 0;
    MS_U32 u32FileAddr = 0;
	//uint8_t triggerFrcIsp = 0;
	char *pEnv = NULL;
	//uint8_t envSave = 0;
	//char strFrcVersion[16] = { 0 };	/* max format 0xff.0xfff.0xfff -- xxx.xxxx.xxxx */
	
    UBOOT_TRACE("[FRC] V1.2 Upgrade FRC from usb... build at: [%s %s]\n", __DATE__, __TIME__);

	if (NVT_OK != _has_frc_nt333()) {
        UBOOT_INFO("[FRC] no NT333 FRC \n");
		return FRC_UPGRADE_POST_IGNORE; 	// FRC_UPGRADE_NOT_ALLOW;
	}

    if (-1 == appInitUsbDisk())
    {
        UBOOT_ERROR("[FRC] FAIL : can not init usb!! \n");
        return FRC_UPGRADE_POST_IGNORE; 	// FRC_UPGRADE_NOT_ALLOW;
    }

    ret = check_file_partition(FRC_BIN_PATH,&device,&partition);
    if(ret == 0)
    {
        UBOOT_DEBUG("[FRC] has FRC upgrade bin\n");

        UBOOT_DEBUG("[FRC] Geting file size\n");
        snprintf(cmd, CMD_BUF, "fatfilesize usb %d:%d %s", device,partition, FRC_BIN_PATH);
        UBOOT_DEBUG("cmd=%s\n",cmd);
        ret = run_command(cmd, 0);
        if(ret!=0)
        {
            UBOOT_ERROR("[FRC] get script file's size fail\n");
            return FRC_UPGRADE_POST_IGNORE; 	// FRC_UPGRADE_NOT_ALLOW;
        }
        else
        {
            env=getenv("filesize");
            if(env==NULL)
            {
                UBOOT_ERROR("[FRC] get env 'filesize' fail\n");
            }
            u32FileSize = simple_strtol(env, NULL, 16);
            printf("[FRC] Size 0x%lx \n",u32FileSize);

        }

        u32FileAddr = UPGRADE_BUFFER_ADDR;
        snprintf(cmd, CMD_BUF, "fatload usb %d:%d  %X %s %ul",device, partition, u32FileAddr, FRC_BIN_PATH,u32FileSize);

        UBOOT_DEBUG("[FRC] cmd=%s\n",cmd);
        if(-1 == run_command(cmd, 0))
        {
            UBOOT_ERROR("[FRC] Load FRC File fail!\n");
            return FRC_UPGRADE_POST_IGNORE; 	// FRC_UPGRADE_NOT_ALLOW;
        }
		// according MTK Penny, FRC FW image is in UPGRADE_BUFFER_ADDR and filesize is u32FileSize
		_pu1FrcBuffer = (uint8_t *)UPGRADE_BUFFER_ADDR;
		_u4FrcBinSize = u32FileSize;

		if (u32FileSize > 32) { /* FRC Version Packet size is 32 Bytes */
			if (NVT_OK == _nvt_get_frcVer_infile(&_pu1FrcBuffer[u32FileSize-32], &_tUsbFrcNt333Version.novatekBranch, &_tUsbFrcNt333Version.novatekMajor, &_tUsbFrcNt333Version.novatekMinor))
				_u4FrcBinSize -= 32;
		}
        UBOOT_INFO("[FRC] Load %s upgrade file OK!, size %d %d, version V%u.%u.%u ~\n", FRC_BIN_PATH, (int)u32FileSize, _u4FrcBinSize, 	\
			_tUsbFrcNt333Version.novatekBranch, _tUsbFrcNt333Version.novatekMajor, _tUsbFrcNt333Version.novatekMinor);

		do {
			if(NVT_OK != _nvt_clac_chksum()) {
				UBOOT_ERROR("[FRC] Checksum is wrong\n");
				break;
			}
			
			// disable watchdog
			// vIO32Write4B(PDWNC_WDTCTL, 0);// PDWNC_WRITE32(REG_RW_WATCHDOG_EN, 0);
			// disable_watchdog = 1;
			
			if(NVT_OK != _nvt_pwron()) {
				UBOOT_ERROR("[FRC] Fail to reset FRC\n");
				break;
			}
			
			// UBOOT_INFO("[FRC] Starting FRC FW ISP upgrading !\n");
			if (NVT_OK != _nvt_read_frc_version(&_tFlashFrcNt333Version.novatekBranch, &_tFlashFrcNt333Version.novatekMajor, &_tFlashFrcNt333Version.novatekMinor)) {
				_nvt_save_env_variable(FW_FROM_USB, NVT_ERR);	/* USB, FAIL */
				i4Ret = FRC_UPGRADE_POST_REBOOT;	// FRC_UPGRADE_FAIL;	/* FAIL */
				UBOOT_ERROR("[FRC] Fail to read version\n");
				break;
			}
			
			/* frc version check */ 
			if (NULL != (pEnv=getenv(FRC_ENV_CHECK_VERSION))) {
				if (NVT_OK == _nvt_cmp_frc_version())  {/* Image file FW version same as TV flash FW version */
					char strFrcVersion[16] = { 0 };
					snprintf(&strFrcVersion[0], 16, "%u.%u.%u", _tUsbFrcNt333Version.novatekBranch, _tUsbFrcNt333Version.novatekMajor, _tUsbFrcNt333Version.novatekMinor);
					if ( (NULL != (pEnv=getenv(FRC_ENV_LAST_USB_VERSION))) && (0 != strcmp(pEnv, strFrcVersion)) ) { /* last usb frc version is 0.0.0, third party, or null */
						UBOOT_INFO("[FRC] FRC_ENV_LAST_USB_VERSION is %s %s, USB FW version is %s, do fw upgrade\n", FRC_ENV_LAST_USB_VERSION, pEnv, strFrcVersion);
					}
					else {
						i4Ret = FRC_UPGRADE_POST_IGNORE;	// FRC_UPGRADE_VER_SAME;
						// if (frcbuffer) free(frcbuffer);	/* note: if use malloc, must free it here */
						return FRC_UPGRADE_POST_IGNORE; 	/* version same, ignore */
					}
				}
				else {
					UBOOT_INFO("[FRC] version doesn't same, do fw upgrade\n");
				}
			}
			else {
				UBOOT_INFO("[FRC] FRC_ENV_CHECK_VERSION is NULL, do fw upgrade !\n");
			}

			_nvt_enable_dbgLevel();
			UBOOT_INFO("Start to upgrade FRC\n");			// TF421PHIEUMTK04-4674(928457)
			_nvt_restore_dbgLevel();
			//UBOOT_INFO("[FRC] Starting FRC FW ISP upgrading !\n");
			if(NVT_OK != _nvt_upgarde_fw()) {
				_nvt_save_env_variable(FW_FROM_USB, NVT_ERR);	/* USB, FAIL */
				i4Ret = FRC_UPGRADE_POST_REBOOT; 	// FRC_UPGRADE_FAIL;	/* fail */
				UBOOT_ERROR("[FRC] Fail to upgrade FRC FW\n");
			}
			else {
				_nvt_save_env_variable(FW_FROM_USB, NVT_OK);	/* USB, SUCCESS */
				i4Ret = FRC_UPGRADE_POST_REBOOT; 	// FRC_UPGRADE_SUCCESS;	/* sucess */
				UBOOT_INFO("[FRC] Success FRC FW ISP upgrading !\n");
			}
			UBOOT_INFO("Finish to upgrade FRC\n");			// TF421PHIEUMTK04-4674(928457)
			_nvt_restore_dbgLevel();

			UBOOT_INFO("[FRC] Power Reset After FW ISP upgrade %d !\n", i4Ret);
			_nvt_PowerRst();

			// UBOOT_INFO("[FRC] done with i4Ret=%d !\n", i4Ret);
			// return FRC_UPGRADE_POST_REBOOT; 	// FRC_UPGRADE_SUCCESS; /* do FRC fw upgrade successfully */
		} while(0);
    }
    else {
        UBOOT_DEBUG("no %s in usb disk\n",FRC_BIN_PATH);
    }

	UBOOT_INFO("[FRC] done with i4Ret = %d!\n", i4Ret);
    return i4Ret;
}
#endif
